package com.bocloud.cmp.provider.aliyunconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.slb20140515.models.DescribeAccessControlListAttributeResponse;
import com.aliyun.slb20140515.models.DescribeAccessControlListAttributeResponseBody;
import com.bocloud.cmp.model.AccessControlModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * @author lyy
 * @version 1.0
 * @date 2021/1/14 9:37
 */
public class AccessControlConvertor
		implements BeanConvertor<AccessControlModel, DescribeAccessControlListAttributeResponse> {
	@Override
	public List<AccessControlModel> convertList(List<? extends DescribeAccessControlListAttributeResponse> list) {
		List<AccessControlModel> acls = new ArrayList<>();
		for (DescribeAccessControlListAttributeResponse response : list) {
			acls.add(convertModel(response));
		}
		return acls;
	}

	@Override
	public AccessControlModel convertModel(DescribeAccessControlListAttributeResponse response) {
		AccessControlModel model = new AccessControlModel();
		if (null != response) {
			model.setName(response.getBody().getAclName());
			model.setAclUuId(response.getBody().getAclId());
			model.setIPVersion(response.getBody().getAddressIPVersion());
			model.setResourceGroupUuid(response.getBody().getResourceGroupId());
			JSONArray list = new JSONArray();
            List<DescribeAccessControlListAttributeResponseBody.DescribeAccessControlListAttributeResponseBodyRelatedListenersRelatedListener> listeners = response.getBody().getRelatedListeners().getRelatedListener();
            for (DescribeAccessControlListAttributeResponseBody.DescribeAccessControlListAttributeResponseBodyRelatedListenersRelatedListener listener : listeners) {
				JSONObject object = new JSONObject();
				object.put("aclType", listener.getAclType());
				object.put("loadBalancerId", listener.getLoadBalancerId());
				object.put("protocol", listener.getProtocol());
				object.put("listenerPort", listener.getListenerPort());
				list.add(object);
			}
			model.setListenerModels(list);
		}
		return model;
	}
}
