package com.bocloud.cmp.provider.aliyunconvertor;

import com.aliyun.oss.model.Bucket;
import com.aliyun.oss.model.BucketInfo;
import com.aliyun.oss.model.CannedAccessControlList;
import com.bocloud.cmp.model.BucketModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * 对象存储转换类
 * 
 * @date 2021/09/03
 */
public class AliyunBucketConvertor implements BeanConvertor<BucketModel, BucketInfo> {
	@Override
	public List<BucketModel> convertList(List<? extends BucketInfo> list) {
		List<BucketModel> bucketModels = new ArrayList<>();
		for (BucketInfo response : list) {
			bucketModels.add(convertModel(response));
		}
		return bucketModels;
	}

	@Override
	public BucketModel convertModel(BucketInfo bucketInfo) {
		BucketModel model = new BucketModel();
		if (null != bucketInfo) {
			Bucket bucket = bucketInfo.getBucket();
			if (null != bucketInfo) {
				model.setName(bucket.getName());
				model.setActualName(bucket.getName());
				model.setRegionId(bucket.getRegion());
				model.setCreateTime(bucket.getCreationDate());
				model.setLocation(bucket.getLocation());
				model.setIntranetEndpoint(bucket.getIntranetEndpoint());
				model.setExtranetEndpoint(bucket.getExtranetEndpoint());
				model.setStorageClass(bucket.getStorageClass().name());
				model.setProps(bucket.getStorageClass().name());
			}
			model.setBucketAcl(bucketInfo.getCannedACL().name());
		}
		return model;
	}
}
