package com.bocloud.cmp.provider.aliyunconvertor;

import com.aliyun.oss.model.OSSObjectSummary;
import com.bocloud.cmp.model.BucketObjectModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * 对象存储转换类
 * 
 * @date 2021/09/03
 */
public class AliyunBucketObjectConvertor implements BeanConvertor<BucketObjectModel, OSSObjectSummary> {
	@Override
	public List<BucketObjectModel> convertList(List<? extends OSSObjectSummary> list) {
		List<BucketObjectModel> bucketObjectModels = new ArrayList<>();
		for (OSSObjectSummary response : list) {
			bucketObjectModels.add(convertModel(response));
		}
		return bucketObjectModels;
	}

	@Override
	public BucketObjectModel convertModel(OSSObjectSummary ossObjectSummary) {
		BucketObjectModel model = new BucketObjectModel();
		if (null != ossObjectSummary) {
			model.setBucketName(ossObjectSummary.getBucketName());
			model.setKey(ossObjectSummary.getKey());
			model.setLastModified(ossObjectSummary.getLastModified());
			model.setSize(ossObjectSummary.getSize());
			model.setBucketObjectTag(ossObjectSummary.getETag());
			model.setType(ossObjectSummary.getType());
		}
		return model;
	}
}
