package com.bocloud.cmp.provider.aliyunconvertor;

import com.aliyun.bssopenapi20171214.models.QueryInstanceBillResponseBody;
import com.bocloud.cmp.model.AliCostModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/***
 * 账单数据转换
 */
public class CostConvertor implements BeanConvertor<AliCostModel, QueryInstanceBillResponseBody.QueryInstanceBillResponseBodyDataItemsItem> {

    @Override
    public List<AliCostModel> convertList(List<? extends QueryInstanceBillResponseBody.QueryInstanceBillResponseBodyDataItemsItem> objects) {
        List<AliCostModel> costModels = new ArrayList<>();
        for (QueryInstanceBillResponseBody.QueryInstanceBillResponseBodyDataItemsItem object : objects) {
            costModels.add(convertModel(object));
        }
        return costModels;
    }

    @Override
    public AliCostModel convertModel(QueryInstanceBillResponseBody.QueryInstanceBillResponseBodyDataItemsItem item) {
        AliCostModel model = null;
        if (null != item) {
            model = new AliCostModel();
            model.setRegion(item.getRegion());
            model.setZone(item.getZone());
            model.setInstanceId(item.getInstanceID());
            model.setNickName(item.getNickName());
            model.setInstanceConfig(item.getInstanceConfig());
            model.setInstanceSpec(item.getInstanceSpec());
            model.setInternetIp(item.getInternetIP());
            model.setIntranetIp(item.getIntranetIP());
            model.setTag(item.getTag());
            model.setResourceGroup(item.getResourceGroup());

            model.setProductCode(item.getProductCode());
            model.setProductType(item.getProductType());
            model.setProductName(item.getProductName());
            model.setProductDetail(item.getProductDetail());

            model.setBillingDate(item.getBillingDate());
            model.setBillingType(item.getBillingType());
            model.setBillingItem(item.getBillingItem());
            model.setListPrice(item.getListPrice());
            model.setListPriceUnit(item.getListPriceUnit());
            model.setUsages(item.getUsage());
            model.setUsageUnit(item.getUsageUnit());

            model.setPretaxGrossAmount(item.getPretaxGrossAmount());
            model.setInvoiceDiscount(item.getInvoiceDiscount());
            model.setPretaxAmount(item.getPretaxAmount());

            model.setDeductedByCashCoupons(item.getDeductedByCashCoupons());
            model.setDeductedByCoupons(item.getDeductedByCoupons());
            model.setDeductedByPrepaidCard(item.getDeductedByPrepaidCard());
            model.setDeductedByResourcePackage(item.getDeductedByResourcePackage());
            model.setPaymentAmount(item.getPaymentAmount());
            model.setOutstandingAmount(item.getOutstandingAmount());
            model.setCurrency(item.getCurrency());
            model.setCostUnit(item.getCostUnit());
            model.setOwnerId(item.getOwnerID());

            model.setSubscriptionType(item.getSubscriptionType());
            model.setItem(item.getItem());
            model.setServicePeriod(item.getServicePeriod());
            model.setServicePeriodUnit(item.getServicePeriodUnit());
        }
        return model;
    }

}
