package com.bocloud.cmp.provider.aliyunconvertor;

import com.aliyun.rds20140815.models.DescribeDBInstanceAttributeResponse;
import com.aliyun.rds20140815.models.DescribeDBInstanceAttributeResponseBody;
import com.bocloud.cmp.model.database.DbInstanceModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.ArrayList;
import java.util.List;

/**
 * @author lyy
 * @version 1.0
 * @date 2021/5/12 14:51
 */
public class DBInstanceConvertor implements BeanConvertor<DbInstanceModel, DescribeDBInstanceAttributeResponse> {

    private String regionId;

    public DBInstanceConvertor(String regionId) {
        this.regionId = regionId;
    }

    @Override
    public List<DbInstanceModel> convertList(List<? extends DescribeDBInstanceAttributeResponse> list) {
        List<DbInstanceModel> dbInstanceModels = new ArrayList<>();
        for (DescribeDBInstanceAttributeResponse dbInstance : list) {
            dbInstanceModels.add(convertModel(dbInstance));
        }
        return dbInstanceModels;
    }

    @Override
    public DbInstanceModel convertModel(DescribeDBInstanceAttributeResponse dbInstance) {
        DbInstanceModel dbInstanceModel = new DbInstanceModel();
        if (null != dbInstance) {
            DescribeDBInstanceAttributeResponseBody.DescribeDBInstanceAttributeResponseBodyItemsDBInstanceAttribute instance = dbInstance.getBody().
                    items.getDBInstanceAttribute().get(0);
            dbInstanceModel.setRegionId(regionId);
            dbInstanceModel.setAvailabilityValue(instance.getAvailabilityValue());
            dbInstanceModel.setAutoUpgradeMinorVersion(instance.getAutoUpgradeMinorVersion());
            dbInstanceModel.setName(null != instance.getDBInstanceDescription() ? instance.getDBInstanceDescription() : instance.getDBInstanceId());
            dbInstanceModel.setMaintainTime(instance.getMaintainTime());
            dbInstanceModel.setMaxAccount(instance.getAccountMaxQuantity());
            dbInstanceModel.setConnectionMode(instance.getConnectionMode());
            dbInstanceModel.setConnectionString(instance.getConnectionString());
            dbInstanceModel.setGmtCreate(DateTools.transfer("yyyy-MM-dd'T'HH:mmZ", instance.getCreationTime(), "Z"));
            dbInstanceModel.setCpu(Integer.parseInt(instance.getDBInstanceCPU()));
            dbInstanceModel.setInstanceClass(instance.getDBInstanceClass());
            dbInstanceModel.setInstanceId(instance.getDBInstanceId());
            dbInstanceModel.setMemory(instance.getDBInstanceMemory().intValue());
            dbInstanceModel.setNetType(instance.getDBInstanceNetType());
            if (null == instance.getDBInstanceStatus()) {
                dbInstanceModel.setStatus("Creating");
            } else {
                dbInstanceModel.setStatus(instance.getDBInstanceStatus());
            }
            dbInstanceModel.setdBInstanceClassType(instance.getDBInstanceClassType());
            dbInstanceModel.setDisk(instance.getDBInstanceStorage());
            dbInstanceModel.setInstanceType(instance.getDBInstanceType());
            dbInstanceModel.setMaxDB(instance.getDBMaxQuantity());
            dbInstanceModel.setEngine(instance.getEngine());
            dbInstanceModel.setVersion(instance.getEngineVersion());
            dbInstanceModel.setExpireTime(instance.getExpireTime());
            dbInstanceModel.setNetworkType(instance.getInstanceNetworkType());
            dbInstanceModel.setLockMode(instance.getLockMode());
            dbInstanceModel.setLockReason(instance.getLockReason());
            dbInstanceModel.setMaxConnection(instance.getMaxConnections());
            dbInstanceModel.setMaxIOPS(instance.getMaxIOPS());
            dbInstanceModel.setPayType(instance.getPayType());
            dbInstanceModel.setPort(Integer.parseInt(instance.getPort()));
            dbInstanceModel.setRegionId(instance.getRegionId());
            dbInstanceModel.setZoneId(instance.getZoneId());
            dbInstanceModel.setVpcId(instance.getVpcId());
            dbInstanceModel.setNetworkType(instance.getInstanceNetworkType());
            dbInstanceModel.setCategory(instance.getCategory());
            dbInstanceModel.setNetType(instance.getDBInstanceNetType());
            dbInstanceModel.setDbInstanceStorageType(instance.getDBInstanceStorageType());
            dbInstanceModel.setVpcCloudInstanceId(instance.getVpcCloudInstanceId());
            dbInstanceModel.setResourceId(instance.getResourceGroupId());
            dbInstanceModel.setAutoRenew(instance.getAutoUpgradeMinorVersion());
            dbInstanceModel.setDBTimeZone(instance.getTimeZone());
        }
        return dbInstanceModel;
    }
}
