package com.bocloud.cmp.provider.aliyunconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.rds20140815.models.DescribeParameterGroupResponse;
import com.aliyun.rds20140815.models.DescribeParameterGroupResponseBody;
import com.bocloud.cmp.model.database.DbInstanceParameterGroupModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * @author lyy
 * @version 1.0
 * @date 2021/5/14 18:47
 */
public class DBInstanceParameterGroupConvertor implements BeanConvertor<DbInstanceParameterGroupModel, DescribeParameterGroupResponse> {

    @Override
    public List<DbInstanceParameterGroupModel> convertList(List<? extends DescribeParameterGroupResponse> list) {
        List<DbInstanceParameterGroupModel> groupModels = new ArrayList<>();
        for (DescribeParameterGroupResponse group : list) {
            groupModels.add(convertModel(group));
        }
        return groupModels;
    }

    @Override
    public DbInstanceParameterGroupModel convertModel(DescribeParameterGroupResponse group) {
        DbInstanceParameterGroupModel groupModel = new DbInstanceParameterGroupModel();
        DescribeParameterGroupResponseBody.DescribeParameterGroupResponseBodyParamGroupParameterGroup parameterGroup = group.getBody().getParamGroup().getParameterGroup().get(0);
        if (null != parameterGroup) {
            groupModel.setName(parameterGroup.getParameterGroupName());
            groupModel.setEngine(parameterGroup.getEngine());
            groupModel.setEngineVersion(parameterGroup.getEngineVersion());
            groupModel.setCreateTime(parameterGroup.getCreateTime());
            groupModel.setUpdateTime(parameterGroup.getUpdateTime());
            JSONArray params = new JSONArray();
            for (DescribeParameterGroupResponseBody.DescribeParameterGroupResponseBodyParamGroupParameterGroupParamDetailParameterDetail param : parameterGroup.getParamDetail().getParameterDetail()) {
                JSONObject paramData = new JSONObject();
                paramData.put(param.getParamName(), param.getParamValue());
                params.add(paramData);
            }
            groupModel.setParamDetail(params);
            groupModel.setParameterGroupType(parameterGroup.getParameterGroupType());
            groupModel.setParamCounts(parameterGroup.getParamCounts());
            groupModel.setParameterGroupId(parameterGroup.getParameterGroupId());
            groupModel.setForceRestart(parameterGroup.getForceRestart());
            groupModel.setParameterGroupDesc(parameterGroup.getParameterGroupDesc());
            return groupModel;
        } else {
            return null;
        }
    }
}
