package com.bocloud.cmp.provider.aliyunconvertor;

import com.aliyun.vpc20160428.models.DescribeEipAddressesResponseBody;
import com.bocloud.cmp.model.ElasticIpModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @Date: 2020/12/14 15:21
 * @Description: 弹性公网IP
 */
public class ElasticIpConvertor implements BeanConvertor<ElasticIpModel, DescribeEipAddressesResponseBody.DescribeEipAddressesResponseBodyEipAddressesEipAddress> {

	@Override
	public List<ElasticIpModel> convertList(List<? extends DescribeEipAddressesResponseBody.DescribeEipAddressesResponseBodyEipAddressesEipAddress> objects) {
		List<ElasticIpModel> elasticIpModels = new ArrayList<>();
		for (DescribeEipAddressesResponseBody.DescribeEipAddressesResponseBodyEipAddressesEipAddress object : objects) {
			elasticIpModels.add(convertModel(object));
		}
		return elasticIpModels;
	}

	@Override
	public ElasticIpModel convertModel(DescribeEipAddressesResponseBody.DescribeEipAddressesResponseBodyEipAddressesEipAddress eipAddress) {
		ElasticIpModel model = null;
		if (null != eipAddress) {
			model = new ElasticIpModel();
			if (StringUtils.isEmpty(eipAddress.getName())) {
				model.setName(eipAddress.getAllocationId());
			} else {
				model.setName(eipAddress.getName());
			}
			model.setElasticIpUuid(eipAddress.getAllocationId());
//            model.setAssociationId(eipAddress.getAllocationId());
			model.setBandwidth(eipAddress.getBandwidth());
			if (!StringUtils.isEmpty(eipAddress.getInstanceId())) {
				model.setInstanceId(eipAddress.getInstanceId());
				model.setInstanceType(eipAddress.getInstanceType());
			}
			model.setPublicIp(eipAddress.getIpAddress());
			//PrivateIpAddress
//			model.setPrivateIpAddress(eipAddress.getPrivateIpAddress());
			model.setStatus(eipAddress.getStatus());
			model.setResourceGroupUuid(eipAddress.getResourceGroupId());
//			List<DescribeEipAddressesResponse.EipAddress.Tag> tags = eipAddress.getTags();
//			List<TagModel> tagModels = Lists.newArrayList();
//			if (!ListTool.isEmpty(tags)) {
//				for (DescribeEipAddressesResponse.EipAddress.Tag tag : tags) {
//					TagModel tagModel = new TagModel();
//					tagModel.setKey(tag.getKey());
//					tagModel.setValue(tag.getValue());
//					tagModel.setResourceId(eipAddress.getAllocationId());
//					tagModel.setResourceType(TagType.VPC.name());
//					tagModels.add(tagModel);
//				}
//				model.setTagModels(tagModels);
//			}
		}
		return model;
	}

}
