package com.bocloud.cmp.provider.aliyunconvertor;

import com.aliyun.ecs20140526.models.DescribeKeyPairsResponseBody;
import com.bocloud.cmp.entity.enums.TagType;
import com.bocloud.cmp.model.KeypairModel;
import com.bocloud.cmp.model.TagModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.ListTool;
import com.google.api.client.util.Lists;

import java.util.ArrayList;
import java.util.List;

/**
 * 云主机数据转换器
 */
public class KeypairConvertor implements BeanConvertor<KeypairModel, DescribeKeyPairsResponseBody.DescribeKeyPairsResponseBodyKeyPairsKeyPair> {

    @Override
    public List<KeypairModel> convertList(List<? extends DescribeKeyPairsResponseBody.DescribeKeyPairsResponseBodyKeyPairsKeyPair> objects) {
        List<KeypairModel> keypairModels = new ArrayList<>();
        for (DescribeKeyPairsResponseBody.DescribeKeyPairsResponseBodyKeyPairsKeyPair object : objects) {
            keypairModels.add(convertModel(object));
        }
        return keypairModels;
    }

    @Override
    public KeypairModel convertModel(DescribeKeyPairsResponseBody.DescribeKeyPairsResponseBodyKeyPairsKeyPair info) {
        KeypairModel model = null;
        if (null != info) {
            model = new KeypairModel();
            model.setFingerprint(info.getKeyPairFingerPrint());
            model.setKeyId(info.getKeyPairFingerPrint());
            model.setName(info.getKeyPairName());
            model.setResourceGroupUuid(info.getResourceGroupId());
            List<DescribeKeyPairsResponseBody.DescribeKeyPairsResponseBodyKeyPairsKeyPairTagsTag> tags = new ArrayList<>();
            if (info.getTags() != null) {
                tags = info.getTags().getTag();
            }
            List<TagModel> tagModels = Lists.newArrayList();
            if (!ListTool.isEmpty(tags)) {
                for (DescribeKeyPairsResponseBody.DescribeKeyPairsResponseBodyKeyPairsKeyPairTagsTag tag: tags) {
                    TagModel tagModel = new TagModel();
                    tagModel.setKey(tag.getTagKey());
                    tagModel.setValue(tag.getTagValue());
                    tagModel.setResourceId(info.getKeyPairFingerPrint());
                    tagModel.setResourceType(TagType.keypair.name());
                    tagModels.add(tagModel);
                }
                model.setTagModels(tagModels);
            }
        }
        return model;
    }

}
