package com.bocloud.cmp.provider.aliyunconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.slb20140515.models.DescribeLoadBalancerAttributeResponse;
import com.bocloud.cmp.model.LbModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName LoadBalancerConvertor
 * @Description
 * @Date 2020/12/16 14:14
 * @Version V1.0
 **/
public class LoadBalancerConvertor implements BeanConvertor<LbModel, DescribeLoadBalancerAttributeResponse> {

	@Override
	public List<LbModel> convertList(List<? extends DescribeLoadBalancerAttributeResponse> list) {
		List<LbModel> lbModels = new ArrayList<>();
		for (DescribeLoadBalancerAttributeResponse loadBalancer : list) {
			lbModels.add(convertModel(loadBalancer));
		}
		return lbModels;
	}

	@Override
	public LbModel convertModel(DescribeLoadBalancerAttributeResponse loadBalancer) {
		LbModel lbModel = new LbModel();
		if (loadBalancer != null) {
			if (StringUtils.isEmpty(loadBalancer.getBody().getLoadBalancerName())) {
				lbModel.setName(loadBalancer.getBody().getLoadBalancerId());
			} else {
				lbModel.setName(loadBalancer.getBody().getLoadBalancerName());
			}
			JSONArray availabilityZones = new JSONArray();
			JSONObject zones = new JSONObject();
			zones.put("master", loadBalancer.getBody().getMasterZoneId());
			zones.put("slave", loadBalancer.getBody().getSlaveZoneId());
			availabilityZones.add(zones);
			lbModel.setAvailabilityZones(availabilityZones);
			lbModel.setDeleteProtection(loadBalancer.getBody().getDeleteProtection());
			lbModel.setModificationProtection(loadBalancer.getBody().getModificationProtectionStatus());
			lbModel.setModificationProtectionReason(loadBalancer.getBody().getModificationProtectionReason());
			lbModel.setLoadBalancerType(loadBalancer.getBody().getAddressType());
			lbModel.setInternetChargeType(loadBalancer.getBody().getInternetChargeType());
			lbModel.setLbUuid(loadBalancer.getBody().getLoadBalancerId());
			lbModel.setStatus(loadBalancer.getBody().getLoadBalancerStatus());
			lbModel.setScheme(loadBalancer.getBody().getAddressType());
			lbModel.setVipAddress(loadBalancer.getBody().getAddress());// 服务地址
			lbModel.setRegionId(loadBalancer.getBody().getRegionId());
			lbModel.setVpcUuid(loadBalancer.getBody().getVpcId());
			lbModel.setSubnetUuid(loadBalancer.getBody().getVSwitchId());
			lbModel.setNetworkType(loadBalancer.getBody().getNetworkType());
			lbModel.setResourceGroupUuid(loadBalancer.getBody().getResourceGroupId());
			lbModel.setIpAddressType(loadBalancer.getBody().getAddressIPVersion());
			lbModel.setSpec(loadBalancer.getBody().getLoadBalancerSpec());
			lbModel.setDeleteProtection(loadBalancer.getBody().getDeleteProtection());
			loadBalancer.getBody().getListenerPortsAndProtocal();
			loadBalancer.getBody().getListenerPortsAndProtocol();
		}
		return lbModel;
	}
}
