package com.bocloud.cmp.provider.aliyunconvertor;

import com.aliyun.slb20140515.models.DescribeVServerGroupAttributeResponseBody;
import com.bocloud.cmp.model.LbMemberModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * 后端服务器
 *
 * @author lyy
 * @version 1.0
 * @date 2020/12/28 15:49
 */
public class MemberConvertor implements BeanConvertor<LbMemberModel, DescribeVServerGroupAttributeResponseBody.DescribeVServerGroupAttributeResponseBodyBackendServersBackendServer> {
    private String vServerGroupId;

    public MemberConvertor(String vServerGroupId) {
        this.vServerGroupId = vServerGroupId;
    }

    @Override
    public List<LbMemberModel> convertList(List<? extends DescribeVServerGroupAttributeResponseBody.DescribeVServerGroupAttributeResponseBodyBackendServersBackendServer> list) {
        List<LbMemberModel> lbMembers = new ArrayList<>();
        for (DescribeVServerGroupAttributeResponseBody.DescribeVServerGroupAttributeResponseBodyBackendServersBackendServer member : list) {
            lbMembers.add(convertModel(member));
        }
        return lbMembers;
    }

    @Override
    public LbMemberModel convertModel(DescribeVServerGroupAttributeResponseBody.DescribeVServerGroupAttributeResponseBodyBackendServersBackendServer backendServer) {
        LbMemberModel memberModel = new LbMemberModel();
        if (null != backendServer) {
            memberModel.setMemberUuid(backendServer.getServerId());
            memberModel.setPort(backendServer.getPort());
            memberModel.setWeight(backendServer.getWeight());
            memberModel.setType(backendServer.getType());
            memberModel.setPoolUuid(vServerGroupId);
        }
        return memberModel;
    }
}
