package com.bocloud.cmp.provider.aliyunconvertor;

import com.aliyun.vpc20160428.models.DescribeNatGatewaysResponseBody;
import com.bocloud.cmp.model.NatGatewayModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @author: yangzhenrong
 * @Date: 2020/12/17 11:05
 * @Description: NAT网关
 */
public class NatGatewayConvertor implements BeanConvertor<NatGatewayModel, DescribeNatGatewaysResponseBody.DescribeNatGatewaysResponseBodyNatGatewaysNatGateway> {

	@Override
	public List<NatGatewayModel> convertList(List<? extends DescribeNatGatewaysResponseBody.DescribeNatGatewaysResponseBodyNatGatewaysNatGateway> objects) {
		List<NatGatewayModel> gatewayModels = new ArrayList<>();
		for (DescribeNatGatewaysResponseBody.DescribeNatGatewaysResponseBodyNatGatewaysNatGateway object : objects) {
			gatewayModels.add(convertModel(object));
		}
		return gatewayModels;
	}

	@Override
	public NatGatewayModel convertModel(DescribeNatGatewaysResponseBody.DescribeNatGatewaysResponseBodyNatGatewaysNatGateway natGateway) {
		NatGatewayModel model = null;
		if (null != natGateway) {
			model = new NatGatewayModel();
			if (StringUtils.isEmpty(natGateway.getName())) {
				model.setName(natGateway.getNatGatewayId());
			} else {
				model.setName(natGateway.getName());
			}
			model.setUuid(natGateway.getNatGatewayId());
			model.setVpcUuid(natGateway.getVpcId());
			model.setSpec(natGateway.getSpec());
			model.setType(natGateway.getNatType());
			model.setResourceGroupUuid(natGateway.getResourceGroupId());
			model.setStatus(natGateway.getStatus());
			model.setRemark(natGateway.getDescription());
            DescribeNatGatewaysResponseBody.DescribeNatGatewaysResponseBodyNatGatewaysNatGatewayNatGatewayPrivateInfo info = natGateway.getNatGatewayPrivateInfo();
            if (null != info) {
				model.setSubnetUuid(info.getVswitchId());
			}
		}
		return model;
	}

}
