package com.bocloud.cmp.provider.aliyunconvertor;

import com.aliyun.vpc20160428.models.DescribeNetworkAclsResponseBody;
import com.bocloud.cmp.model.NetworkAclModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.google.api.client.util.Lists;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @author: yangzhenrong
 * @Date: 2020/12/15 16:32
 * @Description: 网络ACL转换
 */
public class NetworkAclConvertor implements BeanConvertor<NetworkAclModel, DescribeNetworkAclsResponseBody.DescribeNetworkAclsResponseBodyNetworkAclsNetworkAcl> {
	@Override
	public List<NetworkAclModel> convertList(List<? extends DescribeNetworkAclsResponseBody.DescribeNetworkAclsResponseBodyNetworkAclsNetworkAcl> list) {
		List<NetworkAclModel> networkAclModels = new ArrayList<>();
		for (DescribeNetworkAclsResponseBody.DescribeNetworkAclsResponseBodyNetworkAclsNetworkAcl networkAcl : list) {
			networkAclModels.add(convertModel(networkAcl));
		}
		return networkAclModels;
	}

	@Override
	public NetworkAclModel convertModel(DescribeNetworkAclsResponseBody.DescribeNetworkAclsResponseBodyNetworkAclsNetworkAcl networkAcl) {
		NetworkAclModel networkAclModel = new NetworkAclModel();
		if (networkAcl != null) {
			if (StringUtils.isEmpty(networkAcl.getNetworkAclName())) {
				networkAclModel.setName(networkAcl.getNetworkAclId());
			} else {
				networkAclModel.setName(networkAcl.getNetworkAclName());
			}
			networkAclModel.setNetworkACLUuid(networkAcl.getNetworkAclId());
			networkAclModel.setRemark(networkAcl.getDescription());
			networkAclModel.setVpcUuid(networkAcl.getVpcId());
			networkAclModel.setRegionId(networkAcl.getRegionId());
            List<DescribeNetworkAclsResponseBody.DescribeNetworkAclsResponseBodyNetworkAclsNetworkAclResourcesResource> resources
					= new ArrayList<>();
            if (networkAcl.getResources() != null) {
            	resources = networkAcl.getResources().getResource();
			}
            List<NetworkAclModel.Resource> resourceList = Lists.newArrayList();
			for (DescribeNetworkAclsResponseBody.DescribeNetworkAclsResponseBodyNetworkAclsNetworkAclResourcesResource resource : resources) {
				NetworkAclModel.Resource resource1 = new NetworkAclModel.Resource();
				resource1.setResourceId(resource.getResourceId());
				resource1.setResourceType(resource.getResourceType());
				resource1.setStatus(resource.getStatus());
				resourceList.add(resource1);
			}
			networkAclModel.setResources(resourceList);

			List<NetworkAclModel.aclEntry> aclEntryList = Lists.newArrayList();
            List<DescribeNetworkAclsResponseBody.DescribeNetworkAclsResponseBodyNetworkAclsNetworkAclEgressAclEntriesEgressAclEntry> egressAclEntries
					= new ArrayList<>();
            if (networkAcl.getEgressAclEntries() != null) {
				egressAclEntries = networkAcl.getEgressAclEntries().getEgressAclEntry();
			}
            for (DescribeNetworkAclsResponseBody.DescribeNetworkAclsResponseBodyNetworkAclsNetworkAclEgressAclEntriesEgressAclEntry egressAclEntry : egressAclEntries) {
				NetworkAclModel.aclEntry egressAcl = new NetworkAclModel.aclEntry();
				egressAcl.setType("egress");
				egressAcl.setDescription(egressAclEntry.getDescription());
				egressAcl.setDestinationCidrIp(egressAclEntry.getDestinationCidrIp());
				egressAcl.setEntryType(egressAclEntry.getEntryType());
				egressAcl.setNetworkAclEntryId(egressAclEntry.getNetworkAclEntryId());
				egressAcl.setNetworkAclEntryName(egressAclEntry.getNetworkAclEntryName());
				egressAcl.setPolicy(egressAclEntry.getPolicy());
				egressAcl.setPort(egressAclEntry.getPort());
				egressAcl.setProtocol(egressAclEntry.getProtocol());
				aclEntryList.add(egressAcl);
			}

            List<DescribeNetworkAclsResponseBody.DescribeNetworkAclsResponseBodyNetworkAclsNetworkAclIngressAclEntriesIngressAclEntry> ingressAclEntries
					= new ArrayList<>();
            if (networkAcl.getIngressAclEntries() != null) {
				ingressAclEntries = networkAcl.getIngressAclEntries().getIngressAclEntry();
			}
            for (DescribeNetworkAclsResponseBody.DescribeNetworkAclsResponseBodyNetworkAclsNetworkAclIngressAclEntriesIngressAclEntry ingressAclEntry : ingressAclEntries) {
				NetworkAclModel.aclEntry egressAcl = new NetworkAclModel.aclEntry();
				egressAcl.setType("ingress");
				egressAcl.setDescription(ingressAclEntry.getDescription());
				egressAcl.setDestinationCidrIp(ingressAclEntry.getSourceCidrIp());
				egressAcl.setEntryType(ingressAclEntry.getEntryType());
				egressAcl.setNetworkAclEntryId(ingressAclEntry.getNetworkAclEntryId());
				egressAcl.setNetworkAclEntryName(ingressAclEntry.getNetworkAclEntryName());
				egressAcl.setPolicy(ingressAclEntry.getPolicy());
				egressAcl.setPort(ingressAclEntry.getPort());
				egressAcl.setProtocol(ingressAclEntry.getProtocol());
				aclEntryList.add(egressAcl);
			}
		}
		return networkAclModel;
	}
}
