package com.bocloud.cmp.provider.aliyunconvertor;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.aliyun.slb20140515.models.DescribeVServerGroupsResponseBody;
import com.bocloud.cmp.model.LbPoolModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * 服务器组
 *
 * @author lyy
 * @version 1.0
 * @date 2020/12/28 14:41
 */
public class PoolConvertor implements BeanConvertor<LbPoolModel, DescribeVServerGroupsResponseBody.DescribeVServerGroupsResponseBodyVServerGroupsVServerGroup> {
    private String loadBalancerId;

    public PoolConvertor(String loadBalancerId) {
        this.loadBalancerId = loadBalancerId;
    }

    @Override
    public List<LbPoolModel> convertList(List<? extends DescribeVServerGroupsResponseBody.DescribeVServerGroupsResponseBodyVServerGroupsVServerGroup> list) {
        List<LbPoolModel> lbPools = new ArrayList<>();
        for (DescribeVServerGroupsResponseBody.DescribeVServerGroupsResponseBodyVServerGroupsVServerGroup pool : list) {
            lbPools.add(convertModel(pool));
        }
        return lbPools;
    }

    @Override
    public LbPoolModel convertModel(DescribeVServerGroupsResponseBody.DescribeVServerGroupsResponseBodyVServerGroupsVServerGroup lbPool) {
        LbPoolModel poolModel = new LbPoolModel();
        if (lbPool != null) {
            poolModel.setName(lbPool.getVServerGroupName());
            poolModel.setPoolUuid(lbPool.getVServerGroupId());
            poolModel.setLbId(loadBalancerId);
            DescribeVServerGroupsResponseBody.DescribeVServerGroupsResponseBodyVServerGroupsVServerGroupAssociatedObjects objects = lbPool.getAssociatedObjects();
            if (null != objects) {
                List<DescribeVServerGroupsResponseBody.DescribeVServerGroupsResponseBodyVServerGroupsVServerGroupAssociatedObjectsListenersListener> listeners
                        = new ArrayList<>();
                if (objects.getListeners() != null) {
                    listeners = objects.getListeners().getListener();
                }
                if (!listeners.isEmpty()) {
                    JSONArray list = JSONArray.parseArray(JSON.toJSONString(listeners));
                    poolModel.setListeners(list);
                }
            }
        }
        return poolModel;
    }
}
