package com.bocloud.cmp.provider.aliyunconvertor;

import com.aliyun.credentials.utils.StringUtils;
import com.aliyun.ecs20140526.models.DescribeRegionsResponseBody;
import com.bocloud.cmp.model.RegionModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 云主机数据转换器
 */
public class RegionConvertor
		implements BeanConvertor<RegionModel, DescribeRegionsResponseBody.DescribeRegionsResponseBodyRegionsRegion> {

	private static Map<String, String> regionName = new HashMap<>();

	// 返回值没有对一下区域进行汉化 ==== 后续可优化
	static {
		regionName.put("cn-qingdao", "青岛");
		regionName.put("cn-beijing", "北京");
		regionName.put("cn-zhangjiakou", "张家口");
		regionName.put("cn-huhehaote", "呼和浩特");
		regionName.put("cn-hangzhou", "杭州");
		regionName.put("cn-shanghai", "上海");
		regionName.put("cn-shenzhen", "深圳");
	}

	@Override
	public List<RegionModel> convertList(
			List<? extends DescribeRegionsResponseBody.DescribeRegionsResponseBodyRegionsRegion> objects) {
		List<RegionModel> models = new ArrayList<>();
		for (DescribeRegionsResponseBody.DescribeRegionsResponseBodyRegionsRegion object : objects) {
			models.add(convertModel(object));
		}
		return models;
	}

	@Override
	public RegionModel convertModel(DescribeRegionsResponseBody.DescribeRegionsResponseBodyRegionsRegion object) {
		RegionModel model = null;
		if (null != object) {
			model = new RegionModel();
			String regionCode = object.getRegionId();
			model.setCode(regionCode);
			String localName = object.getLocalName();
			if (regionName.containsKey(regionCode)) {
				if (!localName.contains(regionName.get(regionCode))) {
					localName = localName + " (" + regionName.get(regionCode) + ")";
				}

			}
			if (StringUtils.isEmpty(localName)) {
				localName = regionCode;
			}
			model.setName(localName);
			model.setRegionId(regionCode);
		}
		return model;
	}

}
