package com.bocloud.cmp.provider.aliyunconvertor;

import com.aliyun.resourcemanager20200331.models.ListResourceGroupsResponseBody;
import com.bocloud.cmp.model.ResourceGroupModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import org.apache.commons.lang3.StringUtils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

/**
 * 云主机数据转换器
 */
public class ResourceGroupsConvertor implements
		BeanConvertor<ResourceGroupModel, ListResourceGroupsResponseBody.ListResourceGroupsResponseBodyResourceGroupsResourceGroup> {

	@Override
	public List<ResourceGroupModel> convertList(List<? extends ListResourceGroupsResponseBody.ListResourceGroupsResponseBodyResourceGroupsResourceGroup> objects) {
		List<ResourceGroupModel> resourceGroupModels = new ArrayList<>();
		for (ListResourceGroupsResponseBody.ListResourceGroupsResponseBodyResourceGroupsResourceGroup object : objects) {
			String status = object.getStatus();
			if (!"PendingDelete".equalsIgnoreCase(status)) {
				resourceGroupModels.add(convertModel(object));
			}
		}
		return resourceGroupModels;
	}

	@Override
	public ResourceGroupModel convertModel(ListResourceGroupsResponseBody.ListResourceGroupsResponseBodyResourceGroupsResourceGroup resourceGroup) {
		ResourceGroupModel resourceGroupModel = null;
		if (null != resourceGroup) {
			resourceGroupModel = new ResourceGroupModel();
			resourceGroupModel.setResourceGroupUuid(resourceGroup.getId());
			resourceGroupModel.setName(resourceGroup.getName());
			resourceGroupModel.setStatus(resourceGroup.getStatus());
			resourceGroupModel.setDisplayName(resourceGroup.getDisplayName());
			try {
				String createDate = resourceGroup.getCreateDate();
				if (!StringUtils.isEmpty(createDate)) {
					SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
					resourceGroupModel.setCreateTime(format1.parse(createDate));
				}
			} catch (ParseException e) {
			}
		}
		return resourceGroupModel;
	}

}
