package com.bocloud.cmp.provider.aliyunconvertor;

import java.util.ArrayList;
import java.util.List;
import org.apache.commons.lang3.StringUtils;
import com.aliyun.ecs20140526.models.DescribeVRoutersResponseBody.DescribeVRoutersResponseBodyVRoutersVRouter;
import com.aliyun.ecs20140526.models.DescribeVRoutersResponseBody.DescribeVRoutersResponseBodyVRoutersVRouterRouteTableIds;
import com.bocloud.cmp.model.RouterModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

/**
 * 路由器
 * 
 * @ClassName: RouterConvertor.java
 * @Description:
 *
 * @author: ymh
 * @date: 2021年5月9日 下午12:39:50
 */
public class RouterConvertor implements BeanConvertor<RouterModel, DescribeVRoutersResponseBodyVRoutersVRouter> {

	@Override
	public List<RouterModel> convertList(List<? extends DescribeVRoutersResponseBodyVRoutersVRouter> objects) {
		List<RouterModel> routerModels = new ArrayList<>();
		for (DescribeVRoutersResponseBodyVRoutersVRouter object : objects) {
			routerModels.add(convertModel(object));
		}
		return routerModels;
	}

	@Override
	public RouterModel convertModel(DescribeVRoutersResponseBodyVRoutersVRouter vRouter) {
		RouterModel model = null;
		if (null != vRouter) {
			model = new RouterModel();
			if (StringUtils.isEmpty(vRouter.getVRouterName())) {
				model.setName(vRouter.getVRouterId());
			} else {
				model.setName(vRouter.getVRouterName());
			}
			model.setRouterUuid(vRouter.getVRouterId());
			model.setRemark(vRouter.getDescription());
			model.setVpcUuid(vRouter.getVpcId());
			model.setRegionId(vRouter.getRegionId());
			DescribeVRoutersResponseBodyVRoutersVRouterRouteTableIds routeTableIds = vRouter.getRouteTableIds();
			if (null != routeTableIds) {
				model.setRouteTableIds(routeTableIds.getRouteTableId());
			}
		}
		return model;
	}

}
