package com.bocloud.cmp.provider.aliyunconvertor;

import com.aliyun.ecs20140526.models.DescribeLaunchTemplatesResponseBody;
import com.bocloud.cmp.model.ServerTemplateModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.ArrayList;
import java.util.List;

/**
 * 云主机模板数据转换器
 */
public class ServerTemplateConvertor implements BeanConvertor<ServerTemplateModel, DescribeLaunchTemplatesResponseBody.DescribeLaunchTemplatesResponseBodyLaunchTemplateSetsLaunchTemplateSet> {

    @Override
    public List<ServerTemplateModel> convertList(List<? extends DescribeLaunchTemplatesResponseBody.DescribeLaunchTemplatesResponseBodyLaunchTemplateSetsLaunchTemplateSet> objects) {
        List<ServerTemplateModel> serverTemplateModels = new ArrayList<>();
        for (DescribeLaunchTemplatesResponseBody.DescribeLaunchTemplatesResponseBodyLaunchTemplateSetsLaunchTemplateSet object : objects) {
            serverTemplateModels.add(convertModel(object));
        }
        return serverTemplateModels;
    }

    @Override
    public ServerTemplateModel convertModel(DescribeLaunchTemplatesResponseBody.DescribeLaunchTemplatesResponseBodyLaunchTemplateSetsLaunchTemplateSet launchTemplateSet) {
        ServerTemplateModel serverTemplateModel = null;
        if (null != launchTemplateSet) {
            serverTemplateModel = new ServerTemplateModel();
            serverTemplateModel.setDefaultVersionNumber(launchTemplateSet.getDefaultVersionNumber());
            serverTemplateModel.setLatestVersionNumber(launchTemplateSet.getLatestVersionNumber());
            serverTemplateModel.setTemplateUuid(launchTemplateSet.getLaunchTemplateId());
            serverTemplateModel.setName(launchTemplateSet.getLaunchTemplateName());
            String createTime = launchTemplateSet.getCreateTime();
            if (null != createTime && !"".equals(createTime)) {
                serverTemplateModel.setCreateTime(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createTime, "Z"));
            }
            String modifiedTime = launchTemplateSet.getModifiedTime();
            if (null != modifiedTime && !"".equals(modifiedTime)) {
                serverTemplateModel.setModifyTime(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", modifiedTime, "Z"));
            }
        }
        return serverTemplateModel;
    }

}
