package com.bocloud.cmp.provider.aliyunconvertor;

import com.alibaba.fastjson.JSON;
import com.aliyun.ecs20140526.models.DescribeLaunchTemplateVersionsResponseBody;
import com.bocloud.cmp.model.ServerTemplateVersionModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.ArrayList;
import java.util.List;

/**
 * 云主机模板数据转换器
 */
public class ServerTemplateVersionConvertor
        implements BeanConvertor<ServerTemplateVersionModel, DescribeLaunchTemplateVersionsResponseBody.DescribeLaunchTemplateVersionsResponseBodyLaunchTemplateVersionSetsLaunchTemplateVersionSet> {

    @Override
    public List<ServerTemplateVersionModel> convertList(List<? extends DescribeLaunchTemplateVersionsResponseBody.DescribeLaunchTemplateVersionsResponseBodyLaunchTemplateVersionSetsLaunchTemplateVersionSet> objects) {
        List<ServerTemplateVersionModel> versionModels = new ArrayList<>();
        for (DescribeLaunchTemplateVersionsResponseBody.DescribeLaunchTemplateVersionsResponseBodyLaunchTemplateVersionSetsLaunchTemplateVersionSet object : objects) {
            versionModels.add(convertModel(object));
        }
        return versionModels;
    }

    @Override
    public ServerTemplateVersionModel convertModel(DescribeLaunchTemplateVersionsResponseBody.DescribeLaunchTemplateVersionsResponseBodyLaunchTemplateVersionSetsLaunchTemplateVersionSet launchTemplateVersionSet) {
        ServerTemplateVersionModel tempalteVersionModel = null;
        if (null != launchTemplateVersionSet) {
            tempalteVersionModel = new ServerTemplateVersionModel();
            String createTime = launchTemplateVersionSet.getCreateTime();
            if (null != createTime && !"".equals(createTime)) {
                tempalteVersionModel.setCreateTime(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createTime, "Z"));
            }
            String modifiedTime = launchTemplateVersionSet.getModifiedTime();
            if (null != modifiedTime && !"".equals(modifiedTime)) {
                tempalteVersionModel.setModifyTime(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", modifiedTime, "Z"));
            }
            tempalteVersionModel.setDefaultVersion(launchTemplateVersionSet.getDefaultVersion());
            tempalteVersionModel.setTemplateUuid(launchTemplateVersionSet.getLaunchTemplateId());
            tempalteVersionModel.setTemplateName(launchTemplateVersionSet.getLaunchTemplateName());
            tempalteVersionModel.setName(launchTemplateVersionSet.getLaunchTemplateName());
            tempalteVersionModel.setVersionDescription(launchTemplateVersionSet.getVersionDescription());
            tempalteVersionModel.setVersionNumber(launchTemplateVersionSet.getVersionNumber());

            DescribeLaunchTemplateVersionsResponseBody.DescribeLaunchTemplateVersionsResponseBodyLaunchTemplateVersionSetsLaunchTemplateVersionSetLaunchTemplateData launchTemplateData = launchTemplateVersionSet.getLaunchTemplateData();
            tempalteVersionModel.setDataDisks(JSON.toJSONString(launchTemplateData.getDataDisks()));
            tempalteVersionModel.setRemark(launchTemplateData.getDescription());
            tempalteVersionModel.setHostName(launchTemplateData.getHostName());
            tempalteVersionModel.setImageUuid(launchTemplateData.getImageId());
            tempalteVersionModel.setImageOwnerAlias(launchTemplateData.getImageOwnerAlias());
            tempalteVersionModel.setInstanceChargeType(launchTemplateData.getInstanceChargeType());
            tempalteVersionModel.setInstanceName(launchTemplateData.getInstanceName());
            tempalteVersionModel.setFlavorUuid(launchTemplateData.getInstanceType());
            tempalteVersionModel.setInternetChargeType(launchTemplateData.getInternetChargeType());
            tempalteVersionModel.setInternetMaxBandwidthOut(launchTemplateData.getInternetMaxBandwidthOut());
            tempalteVersionModel.setIoOptimized(launchTemplateData.getIoOptimized());
            tempalteVersionModel.setKeypairName(launchTemplateData.getKeyPairName());
            tempalteVersionModel.setNetworkInterfaces(JSON.toJSONString(launchTemplateData.getNetworkInterfaces()));
            tempalteVersionModel.setNetworkType(launchTemplateData.getNetworkType());
            tempalteVersionModel.setSecurityGroupId(launchTemplateData.getSecurityGroupId());
            tempalteVersionModel.setSystemDiskCategory(launchTemplateData.getSystemDisk().getCategory());
            tempalteVersionModel.setSystemDiskSize(launchTemplateData.getSystemDisk().getSize());
            tempalteVersionModel.setVpcUuid(launchTemplateData.getVpcId());
            tempalteVersionModel.setvSwitchUuid(launchTemplateData.getVSwitchId());
            tempalteVersionModel.setTags(JSON.toJSONString(launchTemplateData.getTags()));
            tempalteVersionModel.setZone(launchTemplateData.getZoneId());
        }
        return tempalteVersionModel;
    }

}
