package com.bocloud.cmp.provider.aliyunconvertor;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

import com.aliyun.ecs20140526.models.DescribeVSwitchesResponseBody.DescribeVSwitchesResponseBodyVSwitchesVSwitch;
import com.bocloud.cmp.entity.enums.TagType;
import com.bocloud.cmp.model.CidrBlockModel;
import com.bocloud.cmp.model.SubnetModel;
import com.bocloud.cmp.model.TagModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;
import com.bocloud.common.utils.ListTool;
import com.google.api.client.util.Lists;

/**
 * 云主机数据转换器
 */
public class SubnetConvertor implements BeanConvertor<SubnetModel, DescribeVSwitchesResponseBodyVSwitchesVSwitch> {

	@Override
	public List<SubnetModel> convertList(List<? extends DescribeVSwitchesResponseBodyVSwitchesVSwitch> objects) {
		List<SubnetModel> models = new ArrayList<>();
		for (DescribeVSwitchesResponseBodyVSwitchesVSwitch object : objects) {
			models.add(convertModel(object));
		}
		return models;
	}

	@Override
	public SubnetModel convertModel(DescribeVSwitchesResponseBodyVSwitchesVSwitch vSwitch) {
		SubnetModel model = new SubnetModel();
		if (null != vSwitch) {
			model.setRemark(vSwitch.getDescription());
			model.setCidr(vSwitch.getCidrBlock());

			List<CidrBlockModel> cidrBlockModels = Lists.newArrayList();
			CidrBlockModel cidrBlockModel = new CidrBlockModel();
			cidrBlockModel.setType("IPV4");
			cidrBlockModel.setTargetId(vSwitch.getVSwitchId());
			cidrBlockModel.setCidrBlock(vSwitch.getCidrBlock());
			cidrBlockModels.add(cidrBlockModel);
			String status = vSwitch.getStatus();
			if (null != status) {
				model.setStatus(status);
			}
			model.setSubnetUuid(vSwitch.getVSwitchId());
			if (StringUtils.isEmpty(vSwitch.getVSwitchName())) {
				model.setName(vSwitch.getVSwitchId());
			} else {
				model.setName(vSwitch.getVSwitchName());
			}
			model.setVpcUuid(vSwitch.getVpcId());
			model.setZone(vSwitch.getZoneId());
			model.setIsDefault(vSwitch.getIsDefault());
			model.setIpVersion("V4");
			model.setResourceGroupUuid(vSwitch.getResourceGroupId());
			String creationTime = vSwitch.getCreationTime();
			if (null != creationTime && !"".equals(creationTime)) {
				model.setGmtCreate(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", creationTime, "Z"));
			}
		}
		return model;
	}

}
