package com.bocloud.cmp.provider.common;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.AliyunProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

/**
 *
 * @author ymh
 *
 */
@Provider("bocloud.cmp.aliyun")
public class AliyunAuthProvider extends AliyunProvider implements AuthProvider {

	private static Logger logger = LoggerFactory.getLogger(AliyunAuthProvider.class);

	private Butler butler;

	public AliyunAuthProvider(Butler butler) {
		super(butler);
		this.butler = butler;
	}

	@Override
	public BocloudResult auth() {
		logger.info("check aliyun...");
		LocationProvider provider = new AliyunLocationProvider(this.butler);
		BocloudResult result = provider.listRegions();
		result = new BocloudResult(result.isSuccess(), "" + result.isSuccess());
		return result;
	}

}
