package com.bocloud.cmp.provider.util;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.bocloud.cmp.model.ResourceGroupModel;

/**
 * 国家电网POC 数据直接读取客户数据库
 * 
 * @author ymh
 * @date 2021/06/10
 */
public class DBUtils {

    private static Logger logger = LoggerFactory.getLogger(DBUtils.class);

    public static List<ResourceGroupModel> Query() {
        Connection connection = null;
        PreparedStatement preparedStatement = null;
        ResultSet resultSet = null;
        List<ResourceGroupModel> resourceGroupModels = new ArrayList<>();
        try {
            String SDdriver = "com.mysql.cj.jdbc.Driver";
            // String SDdriver = "com.mysql.jdbc.Driver";
            String SDurl = "jdbc:mysql://10.4.92.165:13307/zygl?characterEncoding=utf8&useSSL=false";
            String SDuser = "tooluser";
            String SDpassword = "New_4_5_oa";
            Class.forName(SDdriver);
            connection = DriverManager.getConnection(SDurl, SDuser, SDpassword);
            String ss = new String("SELECT * from sync_resource_group;");
            preparedStatement = connection.prepareStatement(ss);
            resultSet = preparedStatement.executeQuery();
            ResourceGroupModel resourceGroupModel = null;
            while (resultSet.next()) {
                resourceGroupModel = new ResourceGroupModel();
                resourceGroupModel.setName(resultSet.getString("name"));
                resourceGroupModel.setResourceGroupUuid(resultSet.getString("id"));
                resourceGroupModel.setDisplayName(resultSet.getString("name"));
                resourceGroupModel.setStatus("OK");
                resourceGroupModels.add(resourceGroupModel);
            }
        } catch (Exception ex) {
            logger.error("查询资源组失败：" + ex.getMessage());
        } finally {
            closeAll(connection, preparedStatement, resultSet);
        }
        return resourceGroupModels;
    }

    public static void closeAll(Connection connection, PreparedStatement preparedStatement, ResultSet resultSet) {
        try {// 按顺序关闭
            if (resultSet != null) {
                resultSet.close();
            }
            if (preparedStatement != null) {
                preparedStatement.close();
            }
            if (connection != null) {
                connection.close();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        Query();
    }

}