package com.bocloud.cmp.awsconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.ElasticIpModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.ListTool;
import software.amazon.awssdk.services.ec2.model.Address;
import software.amazon.awssdk.services.ec2.model.Tag;

import java.util.ArrayList;
import java.util.List;

public class ElasticIpConvertor implements BeanConvertor<ElasticIpModel, Address> {
    @Override
    public List<ElasticIpModel> convertList(List<? extends Address> addresses) {
        List<ElasticIpModel> elasticIpModels = new ArrayList<>();
        for (Address address : addresses) {
            elasticIpModels.add(convertModel(address));
        }
        return elasticIpModels;
    }

    @Override
    public ElasticIpModel convertModel(Address address) {
        ElasticIpModel model = JSONObject.parseObject(JSONObject.toJSONString(address.toBuilder()), ElasticIpModel.class);
        model.setElasticIpUuid(address.allocationId());
        model.setName(address.allocationId());
        if (!ListTool.isEmpty(address.tags())) {
            for (Tag tag :
                    address.tags()) {
                if ("Name".equals(tag.key())) {
                    model.setName(tag.value());
                    break;
                }
            }
        }
        return model;
    }
}
