package com.bocloud.cmp.awsconvertor;

import com.bocloud.cmp.model.KeypairModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import software.amazon.awssdk.services.ec2.model.KeyPairInfo;

import java.util.ArrayList;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: KeypairConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/15 15:56
 */
public class KeypairConvertor implements BeanConvertor<KeypairModel, KeyPairInfo> {
    @Override
    public List<KeypairModel> convertList(List<? extends KeyPairInfo> keyPairInfos) {
        List<KeypairModel> regionModels = new ArrayList<>();
        for (KeyPairInfo keyPairInfo : keyPairInfos) {
            regionModels.add(convertModel(keyPairInfo));
        }
        return regionModels;
    }

    @Override
    public KeypairModel convertModel(KeyPairInfo keyPairInfo) {
        KeypairModel model = new KeypairModel();
        model.setName(keyPairInfo.keyName());
        model.setFingerprint(keyPairInfo.keyFingerprint());
        return model;
    }
}
