package com.bocloud.cmp.awsconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.LbListenerModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import software.amazon.awssdk.services.elasticloadbalancingv2.model.Listener;

import java.util.ArrayList;
import java.util.List;

public class ListenerConvertor implements BeanConvertor<LbListenerModel, Listener> {
    @Override
    public List<LbListenerModel> convertList(List<? extends Listener> listeners) {
        List<LbListenerModel> lbListenerModels = new ArrayList<>();
        for (Listener listener : listeners) {
            lbListenerModels.add(convertModel(listener));
        }
        return lbListenerModels;
    }

    @Override
    public LbListenerModel convertModel(Listener listener) {
        LbListenerModel model = JSONObject.parseObject(JSONObject.toJSONString(listener.toBuilder()), LbListenerModel.class);
        model.setListenerUuid(listener.listenerArn());
        model.setLbUuid(listener.loadBalancerArn());
        model.setPort(listener.port());
        model.setProtocol(listener.protocolAsString());
        return model;
    }
}
