package com.bocloud.cmp.awsconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.LbModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import software.amazon.awssdk.services.elasticloadbalancingv2.model.LoadBalancer;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class LoadBalancerConvertor implements BeanConvertor<LbModel, LoadBalancer> {
    @Override
    public List<LbModel> convertList(List<? extends LoadBalancer> balancers) {
        List<LbModel> lbModels = new ArrayList<>();
        for (LoadBalancer balancer : balancers) {
            lbModels.add(convertModel(balancer));
        }
        return lbModels;
    }

    @Override
    public LbModel convertModel(LoadBalancer balancer) {
        LbModel model = JSONObject.parseObject(JSONObject.toJSONString(balancer.toBuilder()), LbModel.class);
        model.setName(balancer.loadBalancerName());
        model.setLbUuid(balancer.loadBalancerArn());
        model.setVpcUuid(balancer.vpcId());
        model.setLoadBalancerType(balancer.typeAsString());
        model.setCreateTime(Date.from(balancer.createdTime()));
        model.setStatus(balancer.state().codeAsString());
        model.setScheme(balancer.schemeAsString());
        model.setIpAddressType(balancer.ipAddressTypeAsString());
        return model;
    }
}
