package com.bocloud.cmp.awsconvertor;

import com.bocloud.cmp.model.NatGatewayModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.ListTool;
import software.amazon.awssdk.services.ec2.model.NatGateway;
import software.amazon.awssdk.services.ec2.model.Tag;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class NatGatewayConvertor implements BeanConvertor<NatGatewayModel, NatGateway> {

    @Override
    public List<NatGatewayModel> convertList(List<? extends NatGateway> objects) {
        List<NatGatewayModel> regionModels = new ArrayList<NatGatewayModel>();
        for (NatGateway object : objects) {
            NatGatewayModel natGatewayModel = convertModel(object);
            if (natGatewayModel != null) {
                regionModels.add(convertModel(object));
            }
        }
        return regionModels;
    }

    @Override
    public NatGatewayModel convertModel(NatGateway info) {
        if (null == info || "deleted".equals(info.stateAsString())) {
            return null;
        }
        NatGatewayModel natGatewayModel = new NatGatewayModel();
        if (!ListTool.isEmpty(info.tags())) {
            for (Tag tag :
                    info.tags()) {
                if ("Name".equals(tag.key())) {
                    natGatewayModel.setName(tag.value());
                    break;
                }
            }
        }
        natGatewayModel.setUuid(info.natGatewayId());
        natGatewayModel.setStatus(info.stateAsString());
        natGatewayModel.setSubnetUuid(info.subnetId());
        natGatewayModel.setVpcUuid(info.vpcId());
        natGatewayModel.setNetworkInterfaceUuid(info.natGatewayAddresses().get(0).networkInterfaceId());
        natGatewayModel.setGmtCreate(Date.from(info.createTime()));
        return natGatewayModel;
    }
}
