package com.bocloud.cmp.awsconvertor;

import com.bocloud.cmp.model.RegionModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import software.amazon.awssdk.services.ec2.model.Region;

import java.util.ArrayList;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: RegionConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/15 16:11
 */
public class RegionConvertor implements BeanConvertor<RegionModel, Region> {
    @Override
    public List<RegionModel> convertList(List<? extends Region> regions) {
        List<RegionModel> regionModels = new ArrayList<>();
        for (Region region : regions) {
            regionModels.add(convertModel(region));
        }
        return regionModels;
    }

    @Override
    public RegionModel convertModel(Region region) {
        RegionModel model = new RegionModel();
        switch (region.regionName()) {
            case "cn-north-1":
                model.setName("中国(北京)");
                break;
            case "cn-northwest-1":
                model.setName("中国(宁夏)");
                break;
            default:
                model.setName(region.regionName());
                break;
        }
        model.setCode(region.regionName());
        model.setRegionId(region.regionName());
        return model;
    }
}
