package com.bocloud.cmp.awsconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.TagModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import software.amazon.awssdk.services.ec2.model.TagDescription;

import java.util.ArrayList;
import java.util.List;

public class TagConvertor implements BeanConvertor<TagModel, TagDescription> {
    @Override
    public List<TagModel> convertList(List<? extends TagDescription> tags) {
        List<TagModel> tagModels = new ArrayList<>();
        for (TagDescription tag : tags) {
            tagModels.add(convertModel(tag));
        }
        return tagModels;
    }

    @Override
    public TagModel convertModel(TagDescription tag) {
        TagModel model = JSONObject.parseObject(JSONObject.toJSONString(tag.toBuilder()), TagModel.class);
        model.setResourceType(tag.resourceTypeAsString());
        return model;
    }
}
