package com.bocloud.cmp.awsconvertor;

import com.bocloud.cmp.model.LbTargetGroupModel;
import com.bocloud.cmp.model.LbTargetModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import software.amazon.awssdk.services.elasticloadbalancingv2.model.TargetHealthDescription;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class TargetConvertor implements BeanConvertor<LbTargetModel, TargetHealthDescription> {

    public List<LbTargetModel> convertList(List<? extends TargetHealthDescription> descriptions, LbTargetGroupModel groupModel, Map<String, String> serverZoneMap) {
        List<LbTargetModel> groupModels = new ArrayList<>();
        for (TargetHealthDescription description : descriptions) {
            groupModels.add(convertModel(description, groupModel, serverZoneMap));
        }
        return groupModels;
    }

    public LbTargetModel convertModel(TargetHealthDescription description, LbTargetGroupModel groupModel, Map<String, String> serverZoneMap) {
        LbTargetModel model = new LbTargetModel();
        model.setUuid(description.target().id());
        model.setTgUuid(groupModel.getUuid());
        model.setPort(description.target().port());
        if ("instance".equals(groupModel.getType())) {
            model.setAvailabilityZone(serverZoneMap.get(description.target().id()));
        } else {
            model.setAvailabilityZone(description.target().availabilityZone());
        }
        model.setHealthCheckPort(description.healthCheckPort());
        model.setReason(description.targetHealth().reasonAsString());
        model.setState(description.targetHealth().stateAsString());
        model.setDescription(description.targetHealth().description());
        return model;
    }

    @Override
    public List<LbTargetModel> convertList(List<? extends TargetHealthDescription> models) {
        return null;
    }

    @Override
    public LbTargetModel convertModel(TargetHealthDescription model) {
        return null;
    }
}
