package com.bocloud.cmp.awsconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.LbTargetGroupModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import software.amazon.awssdk.services.elasticloadbalancingv2.model.TargetGroup;

import java.util.ArrayList;
import java.util.List;

public class TargetGroupConvertor implements BeanConvertor<LbTargetGroupModel, TargetGroup> {
    @Override
    public List<LbTargetGroupModel> convertList(List<? extends TargetGroup> groups) {
        List<LbTargetGroupModel> groupModels = new ArrayList<>();
        for (TargetGroup group : groups) {
            groupModels.add(convertModel(group));
        }
        return groupModels;
    }

    @Override
    public LbTargetGroupModel convertModel(TargetGroup group) {
        LbTargetGroupModel model = JSONObject.parseObject(JSONObject.toJSONString(group.toBuilder()), LbTargetGroupModel.class);
        model.setName(group.targetGroupName());
        model.setUuid(group.targetGroupArn());
        model.setType(group.targetTypeAsString());
        model.setVpcUuid(group.vpcId());
        model.setLoadBalancerUuids(JSONObject.toJSONString(group.loadBalancerArns()));
        model.setHttpCode(group.matcher() != null ? group.matcher().httpCode() : null);
        model.setGrpcCode(group.matcher() != null ? group.matcher().grpcCode() : null);
        return model;
    }
}
