package com.bocloud.cmp.awsconvertor;

import com.bocloud.cmp.model.ZoneModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import software.amazon.awssdk.services.ec2.model.AvailabilityZone;

import java.util.ArrayList;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: ZoneConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/15 16:15
 */
public class ZoneConvertor implements BeanConvertor<ZoneModel, AvailabilityZone> {

    @Override
    public List<ZoneModel> convertList(List<? extends AvailabilityZone> availabilityZones) {
        List<ZoneModel> zoneModels = new ArrayList<>();
        for (AvailabilityZone availabilityZone : availabilityZones) {
            zoneModels.add(convertModel(availabilityZone));
        }
        return zoneModels;
    }

    @Override
    public ZoneModel convertModel(AvailabilityZone availabilityZone) {
        ZoneModel zoneModel = new ZoneModel();
        zoneModel.setName(availabilityZone.zoneName());//cn-north-1a
        zoneModel.setZoneId(availabilityZone.zoneName());
        zoneModel.setRegionId(availabilityZone.regionName());//cn-north-1
        zoneModel.setZoneNum(availabilityZone.zoneId());//cnn1-az1
        return zoneModel;
    }
}
