package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.common.enums.AwsService;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.AwsProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import software.amazon.awssdk.services.ec2.Ec2Client;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: AwsAuthProvider
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/15 14:56
 */
@Provider("bocloud.cmp.aws")
public class AwsAuthProvider extends AwsProvider implements AuthProvider {

    private static final Logger logger = LoggerFactory.getLogger(AwsProvider.class);

    public AwsAuthProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult auth() {
        try {
            ((Ec2Client) this.getClient(AwsService.EC2)).describeRegions().regions();
            return new BocloudResult(true, "认证通过");
        } catch (Exception e) {
            logger.error("Get error message：{}", e);
            return new BocloudResult(false, "认证失败");
        }
    }
}
