package com.bocloud.cmp.azureconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.ResourceGroupModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.microsoft.azure.management.resources.ResourceGroup;

/**
 * 资源组数据转换器
 *
 * @author wangyu
 * @version 4.1.0-SNAPSHOT
 * @since 2019/8/26
 */
public class ResourceGroupConvertor implements BeanConvertor<ResourceGroupModel, ResourceGroup> {

    @Override
    public ResourceGroupModel convertModel(ResourceGroup resourceGroup) {
        ResourceGroupModel model = new ResourceGroupModel();
        model.setName(resourceGroup.name());
        model.setResourceGroupUuid(resourceGroup.id());
        model.setRegionId(resourceGroup.regionName());
        model.setType(resourceGroup.type());
        model.setProvisioningState(resourceGroup.provisioningState());
        model.setManagedBy(resourceGroup.inner().managedBy());
        model.setTags(null == resourceGroup.tags() ? null : JSONObject.toJSONString(resourceGroup.tags()));
        return model;
    }
}
