package com.bocloud.cmp.azureconvertor.account;

import com.bocloud.cmp.model.azure.account.BatchAccountModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.microsoft.azure.management.batch.BatchAccount;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: BatchConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/7/24 10:50
 */
public class BatchAccountConvertor implements BeanConvertor<BatchAccountModel, BatchAccount> {

    @Override
    public BatchAccountModel convertModel(BatchAccount batchAccount) {
        BatchAccountModel model = new BatchAccountModel();
        model.setUuid(batchAccount.id());
        model.setName(batchAccount.name());
        model.setType(batchAccount.type());
        model.setRegionId(batchAccount.regionName());
        model.setPrimaryKey(batchAccount.getKeys().primary());
        model.setSecondaryKey(batchAccount.getKeys().secondary());
        model.setStatus(batchAccount.inner().provisioningState().name());
        model.setResourceGroupName(batchAccount.resourceGroupName());
        model.setStorageAccountUuid(batchAccount.autoStorage().storageAccountId());
        model.setEndPoint(batchAccount.inner().accountEndpoint());
        model.setLowPriorityCoreQuota(batchAccount.lowPriorityCoreQuota());
        model.setDedicatedCoreQuota(batchAccount.dedicatedCoreQuota());
        model.setPoolQuota(batchAccount.poolQuota());
        model.setJobScheduleQuota(batchAccount.activeJobAndJobScheduleQuota());
        return model;
    }
}