package com.bocloud.cmp.azureconvertor.automation;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.automation.AutomationAccountModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.utils.DateTools;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: AutomationAccountConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/8/11 15:54
 */
public class AutomationAccountConvertor implements BeanJsonConvertor<AutomationAccountModel> {

    @Override
    public AutomationAccountModel convertModel(JSONObject object) {
        AutomationAccountModel model = new AutomationAccountModel();
        model.setUuid(object.getString("id"));
        model.setRegionId(object.getString("location"));
        model.setName(object.getString("name"));
        model.setType(object.getString("type"));
        model.setResourceGroupName(object.getString("id").split("/")[4]);
        model.setGmtCreate(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ss", object.getJSONObject("properties").getString("creationTime"), "Z"));
        model.setGmtModify(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ss", object.getJSONObject("properties").getString("lastModifiedTime"), "Z"));
        return model;
    }
}