package com.bocloud.cmp.azureconvertor.automation;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.automation.LogAnalyticModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: LogAnalyticConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/8/11 17:14
 */
public class LogAnalyticConvertor implements BeanJsonConvertor<LogAnalyticModel> {

    @Override
    public LogAnalyticModel convertModel(JSONObject object) {
        LogAnalyticModel model = new LogAnalyticModel();
        model.setUuid(object.getString("id"));
        model.setRegionId(object.getString("location"));
        model.setName(object.getString("name"));
        model.setType(object.getString("type"));
        model.setResourceGroupName(object.getString("id").split("/")[4]);
        Optional.ofNullable(object.getJSONObject("properties")).ifPresent(properties -> {
            model.setCustomerId(properties.getString("customerId"));
            model.setSource(properties.getString("source"));
            model.setStatus(properties.getString("provisioningState"));
            model.setRetentionInDays(properties.getInteger("retentionInDays"));
            Optional.ofNullable(properties.getJSONObject("sku")).ifPresent(sku -> {
                model.setSku(sku.getString("name"));
                model.setMaxCapacityReservationLevel(sku.getInteger("maxCapacityReservationLevel"));
            });
            Optional.ofNullable(properties.getJSONObject("workspaceCapping")).ifPresent(workspaceCapping -> {
                model.setDailyQuotaGb(workspaceCapping.getInteger("dailyQuotaGb"));
                model.setDataIngestionStatus(workspaceCapping.getString("dataIngestionStatus"));
            });
        });
        return model;
    }
}