package com.bocloud.cmp.azureconvertor.bill;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.bill.BillPeriodModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: BillPeriodConvertor
 * @Description:消费计费周期
 * @author: zhenpingLi/李振平
 * @date: 2021/1/15 10:53
 */
public class BillPeriodConvertor implements BeanJsonConvertor<BillPeriodModel> {

    @Override
    public BillPeriodModel convertModel(JSONObject object) {
        BillPeriodModel model = new BillPeriodModel();
        model.setUuid(object.getString("id"));
        model.setName(object.getString("name"));
        model.setType(object.getString("type"));

        Optional.ofNullable(object.getJSONObject("properties")).ifPresent(properties -> {
                    Optional.ofNullable(properties.getString("billingPeriodStartDate"))
                            .map(this::getData)
                            .ifPresent(model::setStartDate);
                    Optional.ofNullable(properties.getString("billingPeriodEndDate"))
                            .map(this::getData)
                            .ifPresent(model::setEndDate);
                }
        );
        return model;
    }

    private Date getData(String time) {
        try {
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
            Date date = simpleDateFormat.parse(time);
            return date;
        } catch (Exception e) {
            return new Date();
        }

    }


}