package com.bocloud.cmp.azureconvertor.blob;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.blob.ContainerModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: ContainerApiConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/5/11 16:44
 */
public class ContainerApiConvertor implements BeanJsonConvertor<ContainerModel> {

    @Override
    public ContainerModel convertModel(JSONObject object) {
        ContainerModel model = new ContainerModel();
        object.getString("id");
        model.setName(object.getString("name"));
        model.setEtag(object.getString("etag"));
        Optional.ofNullable(object.getJSONObject("properties")).ifPresent(properties -> {
            model.setHasImmutabilityPolicy(properties.getBoolean("hasImmutabilityPolicy"));
            model.setHasLegalHold(properties.getBoolean("hasLegalHold"));
            model.setLastModified(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ss", properties.getString("lastModifiedTime"), "Z"));
            model.setLeaseStatus(properties.getString("leaseStatus").toUpperCase());
            model.setLeaseState(properties.getString("leaseState").toUpperCase());
            model.setLeaseDuration(properties.getString("leaseDuration"));
            //我yue了。api和sdk字段不一致
            String publicAccess = properties.getString("publicAccess");
            if (publicAccess.equalsIgnoreCase("None")) {
                model.setPublicAccess("OFF");
            } else {
                model.setPublicAccess(publicAccess.toUpperCase());
            }
//            model.setPublicAccess(properties.getString("publicAccess").toUpperCase());
            Optional.ofNullable(properties.getJSONObject("metadata")).ifPresent(metadata -> {
                model.setMetadata(metadata.toJSONString());
            });
        });
        return model;
    }

}