package com.bocloud.cmp.azureconvertor.compute;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.AvailabilitySetModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.microsoft.azure.management.compute.AvailabilitySet;

/**
 * @ClassName: AvailabilitySetConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 */
public class AvailabilitySetConvertor implements BeanConvertor<AvailabilitySetModel, AvailabilitySet> {

    @Override
    public AvailabilitySetModel convertModel(AvailabilitySet availabilitySet) {
        AvailabilitySetModel model = new AvailabilitySetModel();
        model.setUuid(availabilitySet.id());
        model.setName(availabilitySet.name());
        model.setResourceGroupName(availabilitySet.resourceGroupName());
        model.setRegionId(availabilitySet.regionName());
        model.setFaultDomainCount(availabilitySet.faultDomainCount());
        model.setUpdateDomainCount(availabilitySet.updateDomainCount());
        model.setStatus("AVAILABLE");
        model.setTags(null == availabilitySet.tags() ? null : JSONObject.toJSONString(availabilitySet.tags()));
        return model;
    }
}