package com.bocloud.cmp.azureconvertor.compute;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.ImageModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.microsoft.azure.management.compute.VirtualMachineCustomImage;

import java.util.Optional;

/**
 * 镜像转换器
 *
 * @author wangyu
 * @version 4.1.0-SNAPSHOT
 * @since 2019/8/26
 */
public class ImageConvertor implements BeanConvertor<ImageModel, VirtualMachineCustomImage> {

    @Override
    public ImageModel convertModel(VirtualMachineCustomImage image) {
        ImageModel model = new ImageModel();
        model.setSize(Optional.ofNullable(image.osDiskImage()).map(osDisk -> osDisk.diskSizeGB().doubleValue()).orElse(0D));
        model.setOsCategory(Optional.ofNullable(image.osDiskImage()).map(osDisk -> osDisk.osType().name()).orElse(null));
        model.setStatus("ACTIVE");
        model.setImageType("PRIVATE");
        model.setImageUuid(image.id());
        model.setName(image.name());
        model.setRegionId(image.regionName());
        model.setResourceGroupName(image.resourceGroupName());
        model.setSourceVirtualMachineId(image.sourceVirtualMachineId());
        model.setTags(null == image.tags() ? null : JSONObject.toJSONString(image.tags()));
        return model;
    }
}
