package com.bocloud.cmp.azureconvertor.compute;

import com.bocloud.cmp.model.ImageModel;
import com.microsoft.azure.PagedList;
import com.microsoft.azure.management.compute.VirtualMachineImage;
import com.microsoft.azure.management.compute.VirtualMachineOffer;
import com.microsoft.azure.management.compute.VirtualMachinePublisher;
import com.microsoft.azure.management.compute.VirtualMachineSku;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: PublisherImageConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/8/17 19:47
 */
public class PublisherImageConvertor {

    public List<ImageModel> convertList(List<? extends VirtualMachinePublisher> models) {
        List<ImageModel> imageModels = new ArrayList<>();
        for (VirtualMachinePublisher publisher : models) {
            if (!publisher.name().equalsIgnoreCase("OpenLogic")) {
                continue;
            }
            //获取offer
            PagedList<VirtualMachineOffer> offers = publisher.offers().list();
            if (!CollectionUtils.isEmpty(offers)) {
                for (VirtualMachineOffer offer : offers) {
                    if (!offer.name().equalsIgnoreCase("CentOS")) {
                        continue;
                    }
                    //获取sku
                    PagedList<VirtualMachineSku> skus = offer.skus().list();
                    if (!CollectionUtils.isEmpty(skus)) {
                        for (VirtualMachineSku sku : skus) {
                            //todo 只要7.6
                            if (!sku.name().equalsIgnoreCase("7.6")) {
                                continue;
                            }
                            //todo 只要7.6
                            //获取镜像
                            PagedList<VirtualMachineImage> images = sku.images().list();
                            if (!CollectionUtils.isEmpty(images)) {
                                for (VirtualMachineImage image : images) {
                                    //todo 这个版本创建成功别的不清楚
                                    if (!image.version().equalsIgnoreCase("7.6.20190708")) {
                                        continue;
                                    }
                                    //todo 这个版本创建成功别的不清楚
                                    ImageModel model = new ImageModel();
                                    model.setPublisher(publisher.name());
                                    model.setOffer(offer.name());
                                    model.setSku(sku.name());
                                    model.setRegionId(publisher.region().name());
                                    model.setImageUuid(image.id().toLowerCase());
                                    model.setOsVersion(image.version());
                                    model.setOsCategory(image.osDiskImage().operatingSystem().name().toUpperCase());
                                    model.setName(offer.name() + " " + sku.name() + " " + image.version());
                                    model.setOsName(offer.name() + " " + sku.name() + " " + image.version());
                                    model.setImageType("PUBLISHER");
                                    model.setStatus("ACTIVE");
                                    imageModels.add(model);
                                }
                            }
                        }
                    }
                }
            }
        }
        return imageModels;
    }

}