package com.bocloud.cmp.azureconvertor.compute;

import com.bocloud.cmp.model.FlavorModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.microsoft.azure.management.compute.VirtualMachineSize;

import java.math.BigDecimal;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: FlavorRegionConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/9/20 15:31
 */
public class VirtualMachineSizeConvertor implements BeanConvertor<FlavorModel, VirtualMachineSize> {

    @Override
    public FlavorModel convertModel(VirtualMachineSize model) {
        FlavorModel flavorModel = new FlavorModel();
        flavorModel.setName(model.name());
        flavorModel.setFlavorUuid(model.name());
        flavorModel.setMemory((BigDecimal.valueOf((double) model.memoryInMB() / 1024).setScale(2, BigDecimal.ROUND_HALF_UP)));
        flavorModel.setDisk(model.resourceDiskSizeInMB() / 1024);
        flavorModel.setCpu(model.numberOfCores());
        return flavorModel;
    }


}
