package com.bocloud.cmp.azureconvertor.db;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.db.AzureDatabaseModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: CloudDatabaseConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/2/2 15:08
 */
public class CloudDatabaseConvertor implements BeanJsonConvertor<AzureDatabaseModel> {

    @Override
    public AzureDatabaseModel convertModelParams(JSONObject object, String... params) {
        String databaseServerUuid = params[0];
        AzureDatabaseModel model = new AzureDatabaseModel();
        model.setUuid(object.getString("id"));
        model.setName(object.getString("name"));
        model.setType(object.getString("type"));
        Optional.ofNullable(object.getJSONObject("properties")).ifPresent(properties -> {
            model.setDbCharset(properties.getString("charset"));
            model.setDbCollation(properties.getString("collation"));
        });
        model.setDatabaseServerUuid(databaseServerUuid);
        return model;
    }

}