package com.bocloud.cmp.azureconvertor.db;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.db.AzureDatabaseServerLogModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: CloudDatabaseServerLogConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/2/4 14:52
 */
public class CloudDatabaseServerLogConvertor implements BeanJsonConvertor<AzureDatabaseServerLogModel> {

    @Override
    public AzureDatabaseServerLogModel convertModelParams(JSONObject object, String... params) {
        String databaseServerUuid = params[0];
        AzureDatabaseServerLogModel model = new AzureDatabaseServerLogModel();
        model.setUuid(object.getString("id"));
        model.setName(object.getString("name"));
        model.setType(object.getString("type"));
        Optional.ofNullable(object.getJSONObject("properties")).ifPresent(properties -> {
            model.setLogCreatedTime(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ss", properties.getString("createdTime"), "Z"));
            model.setLogLastModifiedTime(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ss", properties.getString("lastModifiedTime"), "Z"));
            model.setLogSize(properties.getInteger("sizeInKB"));
            model.setLogType(properties.getString("type"));
            model.setLogUrl(properties.getString("url"));
        });
        model.setDatabaseServerUuid(databaseServerUuid);
        return model;
    }


}