package com.bocloud.cmp.azureconvertor.db;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.db.DbAdministratorModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: DbAdministratorConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/2/2 10:08
 */
public class DbAdministratorConvertor implements BeanJsonConvertor<DbAdministratorModel> {

    @Override
    public DbAdministratorModel convertModelParams(JSONObject object, String... params) {
        String databaseServerUuid = params[0];
        DbAdministratorModel model = new DbAdministratorModel();
        model.setUuid(object.getString("id"));
        model.setName(object.getString("name"));
        model.setType(object.getString("type"));
        Optional.ofNullable(object.getJSONObject("properties")).ifPresent(properties -> {
            model.setAdministratorType(properties.getString("administratorType"));
            model.setLogin(properties.getString("login"));
            model.setSid(properties.getString("sid"));
            model.setTenantId(properties.getString("tenantId"));
        });
        model.setDatabaseServerUuid(databaseServerUuid);
        return model;
    }
}