package com.bocloud.cmp.azureconvertor.db;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.db.DbConfigurationModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: CloudDatabaseServerConfigurationConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/2/4 17:44
 */
public class DbConfigurationConvertor implements BeanJsonConvertor<DbConfigurationModel> {
    @Override
    public DbConfigurationModel convertModelParams(JSONObject object, String... params) {
        String databaseServerUuid = params[0];
        DbConfigurationModel model = new DbConfigurationModel();
        model.setUuid(object.getString("id"));
        model.setName(object.getString("name"));
        model.setType(object.getString("type"));
        Optional.ofNullable(object.getJSONObject("properties")).ifPresent(properties -> {
            model.setAllowedValues(properties.getString("allowedValues"));
            model.setConfigurationValue(properties.getString("value"));
            model.setDataType(properties.getString("dataType"));
            model.setDefaultValue(properties.getString("defaultValue"));
            model.setDescription(properties.getString("description"));
            model.setSource(properties.getString("source"));
        });
        model.setDatabaseServerUuid(databaseServerUuid);
        return model;
    }
}