package com.bocloud.cmp.azureconvertor.db;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.db.DbFirewallRuleModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: DbFirewallRuleConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/2/1 14:05
 */
public class DbFirewallRuleConvertor implements BeanJsonConvertor<DbFirewallRuleModel> {

    @Override
    public DbFirewallRuleModel convertModelParams(JSONObject object, String... params) {
        String databaseServerUuid = params[0];
        DbFirewallRuleModel model = new DbFirewallRuleModel();
        model.setUuid(object.getString("id"));
        model.setName(object.getString("name"));
        model.setType(object.getString("type"));
        Optional.ofNullable(object.getJSONObject("properties")).ifPresent(properties -> {
            model.setStartIpAddress(properties.getString("startIpAddress"));
            model.setEndIpAddress(properties.getString("endIpAddress"));
        });
        model.setDatabaseServerUuid(databaseServerUuid);
        return model;
    }


}