package com.bocloud.cmp.azureconvertor.db;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.db.DbVnetRuleModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: CloudDatabaseServerVirtualNetworkRuleConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/2/4 17:07
 */
public class DbVnetRuleConvertor implements BeanJsonConvertor<DbVnetRuleModel> {

    @Override
    public DbVnetRuleModel convertModelParams(JSONObject object, String... params) {
        String databaseServerUuid = params[0];
        DbVnetRuleModel model = new DbVnetRuleModel();
        model.setUuid(object.getString("id"));
        model.setName(object.getString("name"));
        model.setType(object.getString("type"));
        Optional.ofNullable(object.getJSONObject("properties")).ifPresent(properties -> {
            model.setIgnoreMissingVnetServiceEndpoint(properties.getBoolean("ignoreMissingVnetServiceEndpoint"));
            model.setState(properties.getString("state"));
            model.setSubnetUuid(properties.getString("virtualNetworkSubnetId"));
        });
        model.setDatabaseServerUuid(databaseServerUuid);
        return model;
    }


}