package com.bocloud.cmp.azureconvertor.db;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.db.PerformanceTierModel;
import com.bocloud.cmp.model.azure.db.ServiceLevelObjectiveModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;
import java.util.stream.Collectors;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: AzurePerformanceTierConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/12/22 13:51
 */
public class PerformanceTierConvertor implements BeanJsonConvertor<PerformanceTierModel> {

    @Override
    public PerformanceTierModel convertModelParams(JSONObject object, String... params) {
        String regionId = params[0];
        String Dbtype = params[1];
        PerformanceTierModel model = new PerformanceTierModel();
        model.setUuid(object.getString("id"));
        model.setDbType(Dbtype);
        model.setRegionId(regionId);
        model.setMaxBackupRetentionDays(object.getInteger("maxBackupRetentionDays"));
        model.setMaxLargeStorageMB(object.getInteger("maxLargeStorageMB"));
        model.setMaxStorageMB(object.getInteger("maxStorageMB"));
        model.setMinBackupRetentionDays(object.getInteger("minBackupRetentionDays"));
        model.setMinLargeStorageMB(object.getInteger("minLargeStorageMB"));
        model.setMinStorageMB(object.getInteger("minStorageMB"));
        Optional.ofNullable(object.getJSONArray("serviceLevelObjectives"))
                .map(array -> array.stream()
                        .map(JSONObject::toJSONString)
                        .map(JSONObject::parseObject)
                        .map(slo -> {
                            ServiceLevelObjectiveModel sloModel = new ServiceLevelObjectiveModel();
                            sloModel.setUuid(slo.getString("id"));
                            sloModel.setEdition(slo.getString("edition"));
                            sloModel.setHardwareGeneration(slo.getString("hardwareGeneration"));
                            sloModel.setMaxBackupRetentionDays(slo.getInteger("maxBackupRetentionDays"));
                            sloModel.setMaxStorageMB(slo.getInteger("maxStorageMB"));
                            sloModel.setMinBackupRetentionDays(slo.getInteger("minBackupRetentionDays"));
                            sloModel.setMinStorageMB(slo.getInteger("minStorageMB"));
                            sloModel.setvCore(slo.getInteger("vCore"));
                            sloModel.setRegionId(regionId);
                            sloModel.setDbType(Dbtype);
                            sloModel.setPerformanceTierUuid(model.getUuid());
                            return sloModel;
                        }).collect(Collectors.toList())
                ).ifPresent(model::setLevelObjectiveModels);
        return model;
    }


}