package com.bocloud.cmp.azureconvertor.ddos;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.ddos.DdosCustomPolicieModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;
import java.util.stream.Collectors;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: DdosCustomPolicieConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/3/4 11:11
 */
public class DdosCustomPolicieConvertor implements BeanJsonConvertor<DdosCustomPolicieModel> {

    @Override
    public DdosCustomPolicieModel convertModel(JSONObject object) {
        DdosCustomPolicieModel model = new DdosCustomPolicieModel();
        model.setPolicieUuid(object.getString("id"));
        model.setName(object.getString("name"));
        model.setType(object.getString("type"));
        model.setRegionId(object.getString("location"));
        Optional.ofNullable(object.getJSONObject("properties")).ifPresent(properties -> {
            Optional.ofNullable(properties.getString("provisioningState")).ifPresent(model::setStatus);
            Optional.ofNullable(properties.getString("resourceGuid")).ifPresent(model::setResourceGuid);
            Optional.ofNullable(properties.getJSONArray("publicIPAddresses")).map(publicIPAddresses -> publicIPAddresses.stream().map(JSONObject::toJSONString).map(JSONObject::parseObject).map(publicIPAddress -> publicIPAddress.getString("id")).collect(Collectors.toList())).ifPresent(model::setPublicIpAddressUuids);
        });
        model.setName(object.getString("name"));

        return model;
    }
}