package com.bocloud.cmp.azureconvertor.monitor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.AlarmModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: AlarmConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/12/29 14:39
 */
public class AlarmConvertor implements BeanJsonConvertor<AlarmModel> {

    @Override
    public AlarmModel convertModel(JSONObject object) {
        AlarmModel model = new AlarmModel();
        model.setAlarmId(object.getString("id"));
        model.setName(object.getString("name"));
        model.setType(object.getString("type"));
        Optional.ofNullable(object.getJSONObject("properties")).ifPresent(properties -> {
            Optional.ofNullable(properties.getJSONObject("essentials")).ifPresent(essentials -> {
                model.setLevel(essentials.getString("severity"));//警报 Sev0 的严重性最高，Sev4 为最低。
                model.setSignalType(essentials.getString("signalType"));//信号类型
                model.setStatus(essentials.getString("alertState"));//状态
                model.setTarget(essentials.getString("targetResource"));
                model.setGmtTrigger(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ss", essentials.getString("startDateTime"), "Z"));
                model.setGmtConfirm(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ss", essentials.getString("lastModifiedDateTime"), "Z"));
                model.setRemark(essentials.getString("description"));//描述
                model.setMetricAlertUuid(essentials.getString("alertRule")); //告警规则uuid
                model.setMonitorCondition(essentials.getString("monitorCondition"));//可以是 "激发" 或 "已解决"，表示基础条件是否超出了定义的警报规则阈值。
            });
        });
        return model;
    }
}