package com.bocloud.cmp.azureconvertor.network;

import com.bocloud.cmp.model.SubnetModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.microsoft.azure.management.network.Subnet;

import java.util.Optional;

/**
 * 子网数据转换器
 *
 * @author wangyu
 * @version 4.1.0-SNAPSHOT
 * @since 2019/8/26
 */
public class SubnetConvertor implements BeanConvertor<SubnetModel, Subnet> {

    @Override
    public SubnetModel convertModel(Subnet subnet) {
        SubnetModel model = new SubnetModel();
        model.setGateway(Optional.ofNullable(subnet.addressPrefix()).map(address -> address.substring(0, address.lastIndexOf('.')) + ".1").orElse(null));
        model.setCidr(subnet.addressPrefix());
        model.setSubnetUuid(subnet.inner().id());
        model.setName(subnet.name());
        model.setRouterTableUuid(subnet.routeTableId());
        //插入安全组
        model.setSecurityGroupUuid(Optional.ofNullable(subnet.getNetworkSecurityGroup()).map(securityGroup -> securityGroup.id()).orElse(null));
        return model;
    }
}
