package com.bocloud.cmp.azureconvertor.redis;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.azure.redis.RedisFirewallRuleModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: RedisFirewallRuleConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/3/1 13:41
 */
public class RedisFirewallRuleConvertor implements BeanJsonConvertor<RedisFirewallRuleModel> {

    @Override
    public RedisFirewallRuleModel convertModelParams(JSONObject object, String... params) {
        String redisUuid = params[0];
        RedisFirewallRuleModel model = new RedisFirewallRuleModel();
        model.setUuid(object.getString("id"));
        String name = object.getString("name");
        if (name.contains("/")) {
            String[] nameSplit = name.split("/");
            if (nameSplit.length == 2) {
                model.setName(nameSplit[1]);
            } else {
                model.setName(nameSplit[0]);
            }
        } else {
            model.setName(name);
        }
        model.setType(object.getString("type"));
        Optional.ofNullable(object.getJSONObject("properties")).ifPresent(properties -> {
            model.setStartIp(properties.getString("startIP"));
            model.setEndIp(properties.getString("endIP"));
        });
        model.setRedisUuid(redisUuid);
        return model;
    }
}