package com.bocloud.cmp.azureconvertor.security;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.KeypairModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: KeypairConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/12/30 13:54
 */
public class KeypairConvertor implements BeanJsonConvertor<KeypairModel> {

    @Override
    public KeypairModel convertModel(JSONObject object) {
        KeypairModel model = new KeypairModel();
        model.setName(object.getString("name"));
        model.setFingerprint(object.getString("id"));//密钥uuid
        model.setResourceGroupName(object.getString("id").split("/")[4]);
        model.setRegionId(object.getString("location"));
        Optional.ofNullable(object.getJSONObject("properties")).map(properties -> properties.getString("publicKey")).ifPresent(model::setPublicKey);
        return model;
    }
}