package com.bocloud.cmp.azureconvertor.slb;

import com.bocloud.cmp.model.azure.slb.BackEndModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.microsoft.azure.management.network.LoadBalancerBackend;

import java.util.stream.Collectors;

/**
 * @ClassName: BackEndConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/10/15 14:53
 */
public class BackEndConvertor implements BeanConvertor<BackEndModel, LoadBalancerBackend> {

    @Override
    public BackEndModel convertModel(LoadBalancerBackend backEnd) {
        BackEndModel model = new BackEndModel();
        model.setSlbUuid(backEnd.parent().id());
        model.setUuid(backEnd.inner().id());
        model.setName(backEnd.name());
        model.setVirtualMachineUuids(backEnd.getVirtualMachineIds().stream().collect(Collectors.toList()));
        return model;
    }
}