package com.bocloud.cmp.azureconvertor.slb;

import com.bocloud.cmp.model.azure.slb.InboundNatRuleModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.microsoft.azure.management.network.LoadBalancerInboundNatRule;

/**
 * @ClassName: InboundNatRuleConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/10/15 14:54
 */
public class InboundNatRuleConvertor implements BeanConvertor<InboundNatRuleModel, LoadBalancerInboundNatRule> {

    @Override
    public InboundNatRuleModel convertModel(LoadBalancerInboundNatRule inboundNatRule) {
        InboundNatRuleModel natRuleModel = new InboundNatRuleModel();
        natRuleModel.setSlbUuid(inboundNatRule.parent().id());
        natRuleModel.setUuid(inboundNatRule.inner().id());
        natRuleModel.setName(inboundNatRule.name());
        natRuleModel.setBackEndPort(inboundNatRule.backendPort());
        natRuleModel.setFloatingIPEnabled(inboundNatRule.floatingIPEnabled());
        natRuleModel.setFrontEndPort(inboundNatRule.frontendPort());
        natRuleModel.setFrontEndUuid(inboundNatRule.frontend().inner().id());
        natRuleModel.setIdleTimeoutInMinutes(inboundNatRule.idleTimeoutInMinutes());
        natRuleModel.setProtocol(inboundNatRule.protocol().toString());
        return natRuleModel;
    }
}