package com.bocloud.cmp.azureconvertor.slb;

import com.bocloud.cmp.model.azure.slb.LoadBalanceRuleModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.microsoft.azure.management.network.LoadBalancingRule;

/**
 * @ClassName: LoadBalanceRuleConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/10/15 14:55
 */
public class LoadBalanceRuleConvertor implements BeanConvertor<LoadBalanceRuleModel, LoadBalancingRule> {

    @Override
    public LoadBalanceRuleModel convertModel(LoadBalancingRule lbRule) {
        LoadBalanceRuleModel lbmodel = new LoadBalanceRuleModel();
        lbmodel.setSlbUuid(lbRule.parent().id());
        lbmodel.setUuid(lbRule.inner().id());
        lbmodel.setName(lbRule.name());
        lbmodel.setBackEndPort(lbRule.backendPort());
        lbmodel.setBackEndUuid(lbRule.backend().inner().id());
        lbmodel.setFloatingIpEnabled(lbRule.floatingIPEnabled());
        lbmodel.setFrontEndPort(lbRule.frontendPort());
        lbmodel.setFrontEndUuid(lbRule.frontend().inner().id());
        lbmodel.setIdleTimeoutInMinutes(lbRule.idleTimeoutInMinutes());
        lbmodel.setLoadDistribution(lbRule.loadDistribution().toString());
        lbmodel.setProbeUuid(lbRule.probe().inner().id());
        lbmodel.setProtocol(lbRule.protocol().toString());
        return lbmodel;
    }
}