package com.bocloud.cmp.azureconvertor.slb;

import com.bocloud.cmp.model.azure.slb.FrontEndModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.microsoft.azure.management.network.LoadBalancerPrivateFrontend;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: PrivateFrontEndConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/5/15 10:23
 */
public class PrivateFrontEndConvertor implements BeanConvertor<FrontEndModel, LoadBalancerPrivateFrontend> {

    @Override
    public FrontEndModel convertModel(LoadBalancerPrivateFrontend frontEnd) {
        FrontEndModel frontEndModel = new FrontEndModel();
        frontEndModel.setSlbUuid(frontEnd.parent().id());
        frontEndModel.setUuid(frontEnd.inner().id());
        frontEndModel.setName(frontEnd.name());
        frontEndModel.setFrontEndType("INTERNAL");
        frontEndModel.setPrivateIpAddress(frontEnd.inner().privateIPAddress());
        frontEndModel.setSubnetUuid(frontEnd.inner().subnet().id());
        return frontEndModel;
    }
}