package com.bocloud.cmp.azureconvertor.slb;

import com.bocloud.cmp.model.azure.slb.ProbeModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.microsoft.azure.management.network.LoadBalancerHttpProbe;

/**
 * @ClassName: ProbeHttpConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/10/16 15:13
 */
public class ProbeHttpConvertor implements BeanConvertor<ProbeModel, LoadBalancerHttpProbe> {

    @Override
    public ProbeModel convertModel(LoadBalancerHttpProbe httpProbe) {
        ProbeModel probeModel = new ProbeModel();
        probeModel.setSlbUuid(httpProbe.parent().id());
        probeModel.setUuid(httpProbe.inner().id());
        probeModel.setName(httpProbe.name());
        probeModel.setIntervalInSeconds(httpProbe.intervalInSeconds());
        probeModel.setNumberOfProbes(httpProbe.numberOfProbes());
        probeModel.setProtocol(httpProbe.protocol().toString());
        probeModel.setRequestPath(httpProbe.requestPath());
        probeModel.setPort(httpProbe.port());
        return probeModel;
    }
}