package com.bocloud.cmp.azureconvertor.slb;

import com.bocloud.cmp.model.azure.slb.ProbeModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.microsoft.azure.management.network.LoadBalancerTcpProbe;

/**
 * @ClassName: ProbeConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/10/15 14:55
 */
public class ProbeTcpConvertor implements BeanConvertor<ProbeModel, LoadBalancerTcpProbe> {

    @Override
    public ProbeModel convertModel(LoadBalancerTcpProbe tcpProbe) {
        ProbeModel probeModel = new ProbeModel();
        probeModel.setSlbUuid(tcpProbe.parent().id());
        probeModel.setUuid(tcpProbe.inner().id());
        probeModel.setName(tcpProbe.name());
        probeModel.setIntervalInSeconds(tcpProbe.intervalInSeconds());
        probeModel.setNumberOfProbes(tcpProbe.numberOfProbes());
        probeModel.setProtocol(tcpProbe.protocol().toString());
        probeModel.setPort(tcpProbe.port());
        return probeModel;
    }
}