package com.bocloud.cmp.azureconvertor.slb;

import com.bocloud.cmp.model.azure.slb.FrontEndModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.microsoft.azure.management.network.LoadBalancerPublicFrontend;

/**
 * @ClassName: FrontEndConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/10/15 14:54
 */
public class PublicFrontEndConvertor implements BeanConvertor<FrontEndModel, LoadBalancerPublicFrontend> {

    @Override
    public FrontEndModel convertModel(LoadBalancerPublicFrontend frontEnd) {
        FrontEndModel frontEndModel = new FrontEndModel();
        frontEndModel.setSlbUuid(frontEnd.parent().id());
        frontEndModel.setUuid(frontEnd.inner().id());
        frontEndModel.setName(frontEnd.name());
        frontEndModel.setFrontEndType("EXTERNAL");
        frontEndModel.setPublicIpUuid(frontEnd.publicIPAddressId());
        return frontEndModel;
    }
}