package com.bocloud.cmp.provider;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.azureconvertor.compute.ServerConvertor;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.ServerModel;
import com.bocloud.cmp.model.azure.account.StorageAccountModel;
import com.bocloud.cmp.model.azure.db.AzureDatabaseServerModel;
import com.bocloud.cmp.model.azure.db.ServiceLevelObjectiveModel;
import com.bocloud.cmp.model.azure.redis.RedisModel;
import com.bocloud.cmp.model.azure.slb.OutboundRuleModel;
import com.bocloud.cmp.provider.azure.account.AzureStorageAccountProvider;
import com.bocloud.cmp.provider.azure.db.AzureCloudDatabaseServerProvider;
import com.bocloud.cmp.provider.azure.db.virtualnetwork.AzureDbVnetRuleProvider;
import com.bocloud.cmp.provider.azure.redis.AzureRedisProvider;
import com.bocloud.cmp.provider.azure.slb.AzureOutboundRuleProvider;
import com.bocloud.cmp.provider.blob.AzureContainerProvider;
import com.bocloud.cmp.provider.common.AzureBillProvider;
import com.bocloud.cmp.provider.common.AzureFlavorProvider;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.model.BocloudResult;
import com.microsoft.azure.management.compute.VirtualMachine;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: AzureTestConnection
 * @Description:测试认证类
 * @author: zhenpingLi/李振平
 * @date: 2019/12/17 14:07
 */
public class AzureTestConnection {

    private static BeanConvertor<ServerModel, VirtualMachine> convertor = new ServerConvertor();

    public static void main(String[] args) {
        try {
            Butler butler = new Butler();
            //poc
            butler.setTenant("a35ff72d-5a13-4f94-b56c-a25ead70f0ee");
            butler.setSubscriptionId("bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58");
            butler.setClientId("a179adad-9803-4480-9e94-ea16eaf37580");
            butler.setSecretKey("Fk3ZC.dOun0hHVrkJH0xyX~Um906.-d~0_");
            butler.setVersion("AZURE");
            butler.setRegionId("southeastasia");


//            AzureTestConnection.sdkCon(butler);
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }

    }

    public static String getStartUtcTime(Date date) {
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");
        String time = dateFormat.format(date);//将本地日期格式化为UTC格式的 日期字符串
        time = time.substring(0,11) +"00:00:00"+time.substring(time.length()-1,time.length());
        return time;
    }

    public static String getEndUtcTime(Date date) {
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");
        String time = dateFormat.format(date);//将本地日期格式化为UTC格式的 日期字符串
        time = time.substring(0,11) +"23:59:59"+time.substring(time.length()-1,time.length());
        return time;
    }

    public static void sdkCon(Butler butler) throws Exception {
        AzureBillProvider provider = new AzureBillProvider(butler);
        BocloudResult billPeriods = provider.billPeriods();
        System.out.println("butler = [" + butler + "]");
//        AzureBackEndProvider provider = new AzureBackEndProvider(butler);
//        BackEndModel model  = new BackEndModel();
//        model.setSlbUuid("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/lzpdny/providers/Microsoft.Network/loadBalancers/lzp0513slb");
//        model.setName("lzp0514be");
//         List<String> virtualMachineUuids = new ArrayList<>();
//        virtualMachineUuids.add("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/LZPDNY/providers/Microsoft.Compute/virtualMachines/lzpdny051401");
//        virtualMachineUuids.add("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/lzpdny/providers/Microsoft.Compute/virtualMachines/lzp0960");
//        model.setVirtualMachineUuids(virtualMachineUuids);
//        BocloudResult modify = provider.modify(model);

//        AzureLoadBalanceProvider provider = new AzureLoadBalanceProvider(butler);
//        provider.list();

//        AzurePublicIPAddressProvider provider = new AzurePublicIPAddressProvider(butler);
//        PublicIPAddressModel model = new PublicIPAddressModel();
//        model.setFqdn("lzp898");
//        model.setUuid("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/lzpdny/providers/Microsoft.Network/publicIPAddresses/lzp0515modify-1");
//        model.setIdleTimeoutInMinutes(8);
//        BocloudResult modify = provider.modify(model);
//        AzureOutboundRuleProvider provider = new AzureOutboundRuleProvider(butler);
//        SlbModel model = new SlbModel();
//        model.setName("lzp0513slb");
//        model.setUuid("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/lzpdny/providers/Microsoft.Network/loadBalancers/lzp0513slb");
//        model.setResourceGroupName("lzpdny");
//        provider.list(model);
//        System.out.println("xxxx");
//        AzureLocationProvider provider = new AzureLocationProvider(butler);
//        provider.sync();

//        AzureStorageAccountProvider provider = new AzureStorageAccountProvider(butler);
//        BocloudResult bocloudResult = provider.list();
//        List<StorageAccountModel> storageAccountModels = JSONArray.parseArray(JSONArray.toJSONString(bocloudResult.getData()), StorageAccountModel.class);
//        AzureContainerProvider azureLocationProvider = new AzureContainerProvider(butler);
//        for(StorageAccountModel accountModel : storageAccountModels){
//            BocloudResult result = azureLocationProvider.list(accountModel);
//            String jsonString = JSONObject.toJSONString(result.getData());
//            System.out.println("butler = [" + butler + "]");
//        }


//        StorageAccountModel model = new StorageAccountModel();
//        model.setName("wgroup2storage");
//        model.setResourceGroupName("W-Group");
//        model.setPrimaryEndPoint("https://wgroup2storage.blob.core.windows.net/");
//        model.setFileEndPointPrimary("https://wgroup2storage.file.core.windows.net/");
//        model.setName("lzp04");
//        model.setResourceGroupName("lzpdny");
//        model.setPrimaryKey("5mE8ghqYe6i1BNssw9PviXDCTtS50BdhXrfPKbbOcnRT0PJORsMiILBMY/q0UblUKPx7bOmiWFoytrRR3Z5UNg==");
//        model.setSecondaryKey("MnJRWBKw3h7w2mIMZ4vBSUBEpLVB32BHySxWzAFXHPTmne41uFF4xhWVfkZz3rT+9n+MUcXY4gnxTzQhBG95mg==");
//        model.setPrimaryEndPoint("https://lzp04.blob.core.windows.net/");


//        AzureVolumeProvider provider = new AzureVolumeProvider(butler);
//        provider.getAzure().storageAccounts().getById()
//                .

//        VolumeModel model = new VolumeModel();
//        model.setAzureResourceGroupName("LZPRSG");
//        model.setName("lzp042196");
//        model.setRegionId("japaneast");
//        model.setCategory("StandardSSD_LRS");
//        model.setSize(20);
//        model.setDiskEncryptionUuid("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/LZP55TEST/providers/Microsoft.Compute/diskEncryptionSets/lzptest1");
//
////        model.setAzureResourceGroupName("LZPRSG");
////        model.setName("lzp04211-28");
////        model.setRegionId("japaneast");
////        model.setSourceSnapshotId("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/LZPRSG/providers/Microsoft.Compute/snapshots/lzp04211-1");
//        provider.create(model);
//        System.out.println("butler = [" + butler + "]");


//        AzureInboundNatRuleProvider provider = new AzureInboundNatRuleProvider(butler);
//        InboundNatRuleModel model = new InboundNatRuleModel();
//        model.setName("lzptest");
//         model.setSlbUuid("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/LZPRSG/providers/Microsoft.Network/loadBalancers/lzp01");
//        model.setBackEndPort(8082);
//        model.setFloatingIPEnabled(false);
//        model.setFrontEndUuid("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/LZPRSG/providers/Microsoft.Network/loadBalancers/lzp01/frontendIPConfigurations/frontendf6442914d6");
//        model.setFrontEndPort(8083);
//        model.setIdleTimeoutInMinutes(4);
//        model.setNicIpConfigurationUuid("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/ZXLRGS/providers/Microsoft.Network/networkInterfaces/nic37016986c4b/ipConfigurations/primary");
//        BocloudResult list = provider.create(model);
//        System.out.println("butler = [" + butler + "]");


        //        AzureSecuGroupRuleProvider provider = new AzureSecuGroupRuleProvider(butler);
//        SecurityGroupRuleModel model = new SecurityGroupRuleModel();
//        model.setGroupUuid("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/LZPRSG/providers/Microsoft.Network/networkSecurityGroups/lzpsg");
//        model.setName("hhh");
//        model.setDirection("Inbound");
//        model.setProtocol("Tcp");
//        model.setPriority(100);
//        model.setAction("Allow");
//        model.setSourceAddressPrefix("10.20.30.60,10.30.50.90");
//        model.setDestinationAddressPrefix("Any");
//        model.setSourcePortRange("*");
//        model.setDestinationPortRange("*");
//        BocloudResult result = provider.create(model);

//        AzureFlavorProvider provider = new AzureFlavorProvider(butler);
//        provider.sync();
//        System.out.println("butler = [" + butler + "]");
//        BocloudResult password = provider.changePassword("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/LZPRSG/providers/Microsoft.Compute/virtualMachines/lzp020", "1qaz2WSX5678");
//        BocloudResult list = provider.availableSizes("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/LZPRSG/providers/Microsoft.Compute/virtualMachines/lzp317");
//        AzureProvider provider = new AzureProvider(butler);
//        RedisCache redisCache = provider.getAzure().redisCaches().list().get(0);
//        BocloudResult sync = provider.sync();

    }

    public static void apiCon(Butler butler) throws Exception {
        try {
            String periodUuid ="/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/providers/Microsoft.Billing/billingPeriods/202107";
            String startTime ="2021-07-27T00:00:00Z";
            String endTime ="2021-07-27T23:59:59Z";
//            AzureBill2Provider provider = new AzureBill2Provider(butler);
//            BocloudResult bocloudResult = provider.periodByTimePrices(periodUuid, startTime, endTime);
            System.out.println("butler = [" + butler + "]");

//            AzureCloudDatabaseServerProvider server = new AzureCloudDatabaseServerProvider(butler);
//            AzureDatabaseServerModel model = new AzureDatabaseServerModel();
//            model.setResourceGroupName("lzpdny");
//            model.setName("lzp0617");
//            BocloudResult detail = server.detail(model);

//            AzureDiskEncryptionProvider provider = new AzureDiskEncryptionProvider(butler);
//            BocloudResult result = provider.list();
//            JSONObject jsonValue = JSONObject.parseObject(result.getData().toString());
//            JSONArray jsonArray = jsonValue.getJSONArray("value");
//            List<JSONObject> list = new ArrayList<>();
//            if (null != jsonArray && jsonArray.size() != 0) {
//                for (int i = 0; i < jsonArray.size(); i++) {
//                    JSONObject jsonObject = jsonArray.getJSONObject(i);
//                    if (jsonObject.getString("location").equalsIgnoreCase(butler.getRegionId())) {
//                        list.add(jsonObject);
//                    }
//                }
//            }
//
//            System.out.println("butler = [" + butler + "]");
//
//            AzureBillProvider provider = new AzureBillProvider(butler);
//            BocloudResult result = provider.billDetailList("2021-06");
//            List<PublicCloudBillModel> models = JSONArray.parseArray(JSONObject.toJSONString(result.getData()), PublicCloudBillModel.class);
//            System.out.println(models.size());
//            Map<String, String> map = new HashMap<>();
//            for (PublicCloudBillModel publicCloudBillModel : models) {
//                map.put(publicCloudBillModel.getResourceType(), null);
//            }
//            String bu = "";
//            for (String str : map.keySet()) {
//                bu = bu + str + "、";
//            }
//            System.out.println(bu);
//            System.out.println(map);

//            BocloudResult list = provider.billBySubscriptionId();


//            AzureRestApiProvider provider = new AzureRestApiProvider(butler);
//            String api = "subscriptions/%s/resourceGroups/%s/providers/Microsoft.Compute/virtualMachines/%s?api-version=2020-12-01";
//            String url = String.format(api, provider.getSubscriptionId(), "LZPRSG", "lzp020");
//            String response = provider.request(AzureRestApiProvider.RequestStatus.GET, url, null);
//            System.out.println("butler = [" + butler + "]");

//            String str = "/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourcegroups/lzprsg/providers/microsoft.compute/virtualmachines/lzp008";
//            String[] split = str.split("/");
//            String s = split[6];
//            AzureAlarmProvider provider = new AzureAlarmProvider(butler);
//            BocloudResult sync = provider.sync();
//            AzureResourceCheckNameProvider provider = new AzureResourceCheckNameProvider(butler);
//            BocloudResult result = provider.checkName("mysql", "Microsoft.DBforMySQL");
//            System.out.println("butler = [" + butler + "]");


//            try {
//                AzureRestApiProvider provider = new AzureRestApiProvider(butler);
//                String api = "subscriptions/%s/resourceGroups/%s/providers/Microsoft.Compute/virtualMachines/%s/extensions/%s?api-version=2020-12-01";
//                String url = String.format(api, provider.getSubscriptionId(), "LZPRSG", "lzp020","dda");
//                JSONObject params = new JSONObject();
//                JSONObject properties = new JSONObject();
//                properties.put("publisher", "Microsoft.Compute");
//                properties.put("type", "VMAccessAgent");
//                properties.put("typeHandlerVersion","2.0");
//                properties.put("autoUpgradeMinorVersion", true);
//                JSONObject settings = new JSONObject();
//                settings.put("UserName", "root11");
//                properties.put("settings", settings);
//                JSONObject protectedSettings = new JSONObject();
//                protectedSettings.put("Password", "1qaz2WSX5678");
//                properties.put("protectedSettings", protectedSettings);
//                params.put("location", "japaneast");
//                params.put("properties", properties);
//                String response = provider.request(AzureRestApiProvider.RequestStatus.PUT, url, params.toJSONString());
//                JSONObject jsonObject = JSONObject.parseObject(response);
//                System.out.println(jsonObject);
//            } catch (Exception e) {
//                System.out.println(e.getMessage());
//            }


//            AzureBillProvider provider = new AzureBillProvider(butler);
//            BocloudResult bocloudResult = provider.billDetailList("");
//            System.out.println("butler = [" + butler + "]");
//            BocloudResult result = provider.billBySubscriptionId();
//            System.out.println("butler = [" + butler + "]");

//            AzureRedisProvider provider = new AzureRedisProvider(butler);
//            BocloudResult list = provider.list();
//            RedisModel model = new RedisModel();
//            model.setResourceGroupName("LZPRSG");
//            model.setName("lzp0020");
//            model.setRegionId("japaneast");
//            BocloudResult detail = provider.detail(model);
//            RedisModel model = new RedisModel();
//            model.setResourceGroupName("LZPRSG");
//            model.setName("lzp090");
//            model.setRegionId("japaneast");
//            model.setSkuName("Premium");
//            model.setSkuFamily("P");
//            model.setSkuCapacity("1");
//            model.setEnableNonSslPort(false);
//            model.setMinimumTlsVersion("1.2");
//            model.setPublicNetworkAccess("Enabled");
//            //副本和集群是互斥的
//            model.setReplicasPerMaster(1);
//            model.setShardCount(2);
//            model.setMaxmemoryPolicy("volatile-lru");
//            model.setMaxmemoryReserved(200);
//            model.setMaxfragmentationmemoryReserved(400);
//            BocloudResult result = provider.create(model);

//            BocloudResult modify = provider.modify(model);

//            BocloudResult detail = provider.detail(model);
//            BocloudResult remove = provider.remove(model);
//            BocloudResult result = provider.regenerateKey(model);
//            BocloudResult restart = provider.restart(model);

//            AzureRedisFirewallRuleProvider provider = new AzureRedisFirewallRuleProvider(butler);
//            RedisFirewallRuleModel model = new RedisFirewallRuleModel();
//            model.setResourceGroupName("LZPRSG");
//            model.setRedisName("lzp090");
//            model.setName("lzphhh");
//            model.setStartIp("10.20.30.40");
//            model.setEndIp("10.20.30.40");
//            BocloudResult result = provider.create(model);
//            BocloudResult remove = provider.remove(model);
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }


    public static void mysqlSslEnforcement(Butler butler) {
        AzureCloudDatabaseServerProvider provider = new AzureCloudDatabaseServerProvider(butler);
        AzureDatabaseServerModel model = new AzureDatabaseServerModel();
        model.setResourceGroupName("lzpdny");
        model.setName("lzp0617");
        model.setSslEnforcement("Enabled");
        model.setMinimalTlsVersion("TLS1_2");
        model.setRegionId("southeastasia");
        BocloudResult result = provider.modify(model);
        System.out.println("butler = [" + butler + "]");
    }

    /**
     * mysql调整配置
     *
     * @param butler
     */
    public static void mysqlPricingLayer(Butler butler) {
        AzureCloudDatabaseServerProvider provider = new AzureCloudDatabaseServerProvider(butler);
        AzureDatabaseServerModel model = new AzureDatabaseServerModel();
        model.setResourceGroupName("lzpdny");
        model.setName("lzp0519");
        model.setStorageMb(6144);
        model.setBackupRetentionDays(10);
        model.setGeoRedundantBackup("Enabled");
        model.setStorageAutogrow("Enabled");
        ServiceLevelObjectiveModel sloModel = new ServiceLevelObjectiveModel();
        sloModel.setUuid("GP_Gen5_2");
        sloModel.setEdition("GeneralPurpose");
        sloModel.setvCore(2);
        sloModel.setHardwareGeneration("Gen5");
        model.setSloModel(sloModel);
        model.setRegionId("southeastasia");
        BocloudResult result = provider.pricingLayer(model);
        System.out.println("butler = [" + butler + "]");
    }

    /**
     * redis调整配置
     *
     * @param butler
     */
    public static void redisPricingLayer(Butler butler) {
        AzureRedisProvider provider = new AzureRedisProvider(butler);
        RedisModel model = new RedisModel();
        model.setResourceGroupName("lzpdny");
        model.setName("lzpredis0520");
        model.setSkuName("Standard");
        model.setSkuFamily("C");
        model.setSkuCapacity("2");
        model.setRegionId("southeastasia");
        BocloudResult result = provider.pricingLayer(model);
        System.out.println("butler = [" + butler + "]");
    }

    public static void mysqlDefaultCreate(Butler butler) {
        AzureCloudDatabaseServerProvider provider = new AzureCloudDatabaseServerProvider(butler);
        AzureDatabaseServerModel model = new AzureDatabaseServerModel();
        model.setResourceGroupName("lzpdny");
        model.setName("lzp0617");
        model.setCreateMode("Default");
        model.setAdministratorName("root11");
        model.setAdministratorPassword("1qaz2WSX1234");
        model.setPublicNetworkAccess("Enabled");
        model.setSslEnforcement("Enabled");
        model.setMinimalTlsVersion("TLS1_2");
        model.setVersion("5.7");
        model.setInfrastructureEncryption("Enabled");
        model.setStorageMb(6144);
        model.setBackupRetentionDays(10);
        model.setGeoRedundantBackup("Enabled");
        model.setStorageAutogrow("Enabled");
        ServiceLevelObjectiveModel sloModel = new ServiceLevelObjectiveModel();
        sloModel.setUuid("GP_Gen5_2");
        sloModel.setEdition("GeneralPurpose");
        sloModel.setvCore(2);
        sloModel.setHardwareGeneration("Gen5");
        model.setSloModel(sloModel);
        model.setRegionId("southeastasia");
        BocloudResult result = provider.create(model);
        System.out.println("butler = [" + butler + "]");
    }

    public static void mysqlReplicaCreate(Butler butler) {
        AzureCloudDatabaseServerProvider provider = new AzureCloudDatabaseServerProvider(butler);
        AzureDatabaseServerModel model = new AzureDatabaseServerModel();
        model.setResourceGroupName("lzpdny");
        model.setName("lzp0521fb");
        model.setCreateMode("Replica");
        model.setMasterServerUuid("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/lzpdny/providers/Microsoft.DBforMySQL/servers/lzp0519");
        model.setRegionId("southeastasia");
        BocloudResult result = provider.create(model);
        System.out.println("butler = [" + butler + "]");
    }

    public static void mysqlGeoRestoreCreate(Butler butler) {
        AzureCloudDatabaseServerProvider provider = new AzureCloudDatabaseServerProvider(butler);
        AzureDatabaseServerModel model = new AzureDatabaseServerModel();
        model.setResourceGroupName("lzpdny");
        model.setName("lzp0521fbs");
        model.setCreateMode("GeoRestore");
        model.setMasterServerUuid("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/lzpdny/providers/Microsoft.DBforMySQL/servers/lzp0519");
        model.setRegionId("southeastasia");
        ServiceLevelObjectiveModel sloModel = new ServiceLevelObjectiveModel();
        sloModel.setUuid("GP_Gen5_2");
        sloModel.setEdition("GeneralPurpose");
        sloModel.setvCore(2);
        sloModel.setHardwareGeneration("Gen5");
        model.setSloModel(sloModel);
        BocloudResult result = provider.create(model);
        System.out.println("butler = [" + butler + "]");
    }

    public static void mysqlPointInTimeRestoreCreate(Butler butler) throws Exception {
        AzureCloudDatabaseServerProvider provider = new AzureCloudDatabaseServerProvider(butler);
        AzureDatabaseServerModel model = new AzureDatabaseServerModel();
        model.setResourceGroupName("lzpdny");
        model.setName("lzp0617hy");
        model.setRegionId("southeastasia");
        model.setCreateMode("PointInTimeRestore");
        model.setInfrastructureEncryption("Enabled");
        //要还原的源服务器ID。
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");//注意月份是MM
        Date date = simpleDateFormat.parse("2021-06-17 08:57:16");
        model.setRestorePointInTime(date);
        model.setMasterServerUuid("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/lzpdny/providers/Microsoft.DBforMySQL/servers/lzp0617");
        BocloudResult result = provider.create(model);
        System.out.println("butler = [" + butler + "]");
    }

    public static void mysqlVnetRule(Butler butler) {
        AzureDbVnetRuleProvider provider = new AzureDbVnetRuleProvider(butler);
        AzureDatabaseServerModel model = new AzureDatabaseServerModel();
        model.setResourceGroupName("lzpdny");
        model.setName("lzp0519");
        BocloudResult list = provider.list(model);
        System.out.println("butler = [" + butler + "]");
    }

    public static void slbOutboundRule(Butler butler) {
        AzureOutboundRuleProvider provider = new AzureOutboundRuleProvider(butler);
        OutboundRuleModel model = new OutboundRuleModel();
        model.setResourceGroupName("lzpdny");
        model.setSlbName("lzp0517wb");
        model.setName("lzpcz");
        model.setAllocatedOutboundPorts(64000);
        model.setProtocol("Tcp");
        model.setEnableTcpReset(true);
        model.setIdleTimeoutInMinutes(4);
        model.setBackEndUuid("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/lzpdny/providers/Microsoft.Network/loadBalancers/lzp0517wb/backendAddressPools/lzp0522hdc");
        List<String> list = new ArrayList<>();
        list.add("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/lzpdny/providers/Microsoft.Network/loadBalancers/lzp0517wb/frontendIPConfigurations/xzqdip");
        model.setFrontEndUuids(list);
        provider.create(model);

        System.out.println("butler = [" + butler + "]");
    }

    public static void StorageAccountMinimumTlsVersion(Butler butler) {
        AzureStorageAccountProvider provider = new AzureStorageAccountProvider(butler);
        StorageAccountModel model = new StorageAccountModel();
        model.setResourceGroupName("lzpdny");
        model.setName("lzp04");
        provider.minimumTlsVersion(model);
        System.out.println("butler = [" + butler + "]");
    }

    public static void StorageAccountModifySku(Butler butler) {
        AzureStorageAccountProvider provider = new AzureStorageAccountProvider(butler);
        StorageAccountModel model = new StorageAccountModel();
        model.setUuid("/subscriptions/bd3b5b8a-3115-4436-a7d9-9f9d4afa5e58/resourceGroups/lzp0531rsg1/providers/Microsoft.Storage/storageAccounts/lzp0531996");
        model.setSku("Standard_GRS");
        provider.modify(model);
        System.out.println("butler = [" + butler + "]");
//        AzureNetworkInterfaceProvider provider = new AzureNetworkInterfaceProvider(butler);
//        NetworkInterfaceModel model = new NetworkInterfaceModel();
//        model.setName("nic244349de816");
//        model.setAzureResourceGroupName("lzpdny");
//        provider.effectiveRouterTable(model);

    }

    public static void container(Butler butler) {
        AzureStorageAccountProvider provider = new AzureStorageAccountProvider(butler);
        BocloudResult result = provider.list();
        List<StorageAccountModel> regionModels = JSONArray.parseArray(JSONObject.toJSONString(result.getData()), StorageAccountModel.class);
        StorageAccountModel accountModel = regionModels.stream().filter(model -> model.getName().equalsIgnoreCase("lzp0603sa")).findFirst().get();
        AzureContainerProvider containerProvider = new AzureContainerProvider(butler);
        BocloudResult bocloudResult = containerProvider.list(accountModel);
        String string = JSONObject.toJSONString(bocloudResult.getData());
        System.out.println(string);
    }

    public static void StorageAccount(Butler butler) {
        AzureStorageAccountProvider provider = new AzureStorageAccountProvider(butler);
        StorageAccountModel model = new StorageAccountModel();
        model.setName("lzp0610sa04");
        model.setRegionId("southeastasia");
        model.setResourceGroupName("lzpdny");
        model.setSku("Standard_LRS");
        model.setSkuTier("Standard");
        model.setKind("StorageV2");
        model.setAccessTier("Cool");
        model.setMinimumTlsVersion("TLS1_1");
        provider.create(model);


    }

    public static void flavor(Butler butler) throws Exception {
        try {
            AzureFlavorProvider provider = new AzureFlavorProvider(butler);
            BocloudResult sync = provider.sync();


        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }
}
