package com.bocloud.cmp.provider.azure.storage;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.AzureRestApiProvider;
import com.bocloud.cmp.utils.LogMapUtils;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: AzureDiskEncryptionProvider
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/4/21 15:50
 */
@Provider("bocloud.cmp.azure")
public class AzureDiskEncryptionProvider extends AzureRestApiProvider implements DiskEncryptionProvider {

    public AzureDiskEncryptionProvider(Butler butler) {
        super(butler);
    }

    private static Logger logger = LoggerFactory.getLogger(AzureDiskEncryptionProvider.class);

    @Override
    public BocloudResult list() {
        try {
            //url -> 订阅id、资源组名称、自动化账户名称
            String api = "subscriptions/%s/providers/Microsoft.Compute/diskEncryptionSets?api-version=2020-12-01";
            String url = String.format(api, this.getSubscriptionId());
            String response = this.request(RequestStatus.GET, url, null);
            return new BocloudResult(true, response, LogMapUtils.MAP.get(Thread.currentThread().getStackTrace()[1].getMethodName()));
        } catch (Exception e) {
            logger.error(this.getClass().getName() + " " + Thread.currentThread().getStackTrace()[1].getMethodName() + " error :", e);
            return new BocloudResult(false, e.getMessage());
        }
    }


}