package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.AzureProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: AzureAuthProvider
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/8/7 10:10
 */
@Provider("bocloud.cmp.azure")
public class AzureAuthProvider extends AzureProvider implements AuthProvider {

    private static Logger logger = LoggerFactory.getLogger(AzureAuthProvider.class);

    public AzureAuthProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult auth() {
        try {
            this.getAzure().resourceGroups().list();
            return new BocloudResult(true, "认证通过");
        } catch (Exception e) {
            logger.error("azure auth error：", e);
            return new BocloudResult(false, "认证失败");
        }
    }
}
