package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.azureconvertor.common.FlavorConvertor;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.FlavorModel;
import com.bocloud.cmp.provider.AzureProvider;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import com.microsoft.azure.PagedList;
import com.microsoft.azure.management.compute.ComputeResourceType;
import com.microsoft.azure.management.compute.ComputeSku;
import com.microsoft.azure.management.resources.fluentcore.arm.Region;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: AzureFlavorProvider
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/9/20 11:20
 */
@Provider("bocloud.cmp.azure")
public class AzureFlavorProvider extends AzureProvider implements FlavorProvider {

    private static Logger logger = LoggerFactory.getLogger(AzureFlavorProvider.class);

    private BeanConvertor<FlavorModel, ComputeSku> convertor = new FlavorConvertor();

    public AzureFlavorProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult sync() {
        try {
            PagedList<ComputeSku> computeSkus = this.getAzure().computeSkus().listbyRegionAndResourceType(Region.fromName(this.getRegionId()), ComputeResourceType.VIRTUALMACHINES);
            List<FlavorModel> flavorModels = convertor.convertList(computeSkus);
//            Map<String, String> map = new HashMap<>();
//            for (FlavorModel flavorModel : flavorModels) {
//                map.put(flavorModel.getFamily(), null);
//            }
            return new BocloudResult(true, flavorModels, "list flavor success!");
        } catch (Exception e) {
            logger.error("list flavor error :", e);
            return new BocloudResult(false, e.getMessage());
        }
    }

    @Override
    public BocloudResult create(FlavorModel flavor) {
        return null;
    }

    @Override
    public BocloudResult remove(String flavorId) {
        return null;
    }

    @Override
    public BocloudResult update(FlavorModel flavorModel) {
        return null;
    }
}
