package com.bocloud.cmp.provider.common;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.azureconvertor.common.RegionConvertor;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.RegionModel;
import com.bocloud.cmp.provider.AzureRestApiProvider;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: AzureRegionProvider
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/12/23 11:40
 */
@Provider("bocloud.cmp.azure")
public class AzureRegionProvider extends AzureRestApiProvider implements RegionProvider {

    public AzureRegionProvider(Butler butler) {
        super(butler);
    }

    private BeanJsonConvertor<RegionModel> convertor = new RegionConvertor();

    @Override
    public BocloudResult list() {
        //url -> 订阅id、资源组名称、自动化账户名称
        String api = "subscriptions/%s/locations?api-version=2019-11-01";
        String url = String.format(api, this.getSubscriptionId());
        String response = this.request(RequestStatus.GET, url, null);
        JSONObject jsonObject = JSONObject.parseObject(response);
        List<RegionModel> models = convertor.convertList(jsonObject.getJSONArray("value"));
        return new BocloudResult(true, models, "查询成功!");
    }

}