package com.bocloud.cmp.provider;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.common.EasyStackLocationProvider;
import com.bocloud.cmp.provider.common.EasyStackQuotaProvider;
import com.bocloud.cmp.provider.monitor.EasyStackAlarmProvider;
import com.bocloud.common.model.BocloudResult;
import org.openstack4j.model.compute.QuotaSetUpdate;
import org.openstack4j.model.compute.builder.QuotaSetUpdateBuilder;
import org.openstack4j.model.network.NetQuota;
import org.openstack4j.model.storage.block.BlockQuotaSet;
import org.openstack4j.model.storage.block.builder.BlockQuotaSetBuilder;
import org.openstack4j.openstack.compute.domain.NovaQuotaSet;
import org.openstack4j.openstack.compute.domain.NovaQuotaSetUpdate;
import org.openstack4j.openstack.networking.domain.NeutronNetQuota;
import org.openstack4j.openstack.storage.block.domain.CinderBlockQuotaSet;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: EasyStackConnectTest
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/12/20 14:11
 */
public class EasyStackConnectTest {

    public static void main(String[] args) {
        try {
//            System.setProperty("javax.net.ssl.trustStore","D:\\job\\install\\JDK\\jre\\lib\\cacerts");

//            System.setProperty("javax.net.ssl.trustStore","D:\\security");
            Butler butler = new Butler();
            butler.setUrl("http://10.20.4.1:5000");
            butler.setUsername("cmp");
            butler.setPassword("Beyondcent@123");
            butler.setProjectName("cmp");
            butler.setDomainName("default");
            butler.setVersion("V3");
            butler.setUuid("123321");
            EasyStackQuotaProvider provider = new EasyStackQuotaProvider(butler);
            BocloudResult bocloudResult = provider.quota("0055266dfbc0493ebf0f0c76a3645cf6");
            QuotaSetUpdate quotaupdate = NovaQuotaSetUpdate.builder().metadataItems(128).injectedFileContentBytes(10240)
                    .injectedFiles(5).cores(4000).floatingIps(10).instances(1001).injectedFilePathBytes(255)
                    .keyPairs(100).build();
            BlockQuotaSet blockQuotaSet = CinderBlockQuotaSet.builder().volumes(3001).snapshots(10).gigabytes(200000).build();
            NetQuota netQuota = NeutronNetQuota.builder().subnet(10).router(10).port(10).network(10)
                    .floatingIP(10).securityGroup(10).securityGroupRule(20).build();

//            BocloudResult bocloudResult = provider.quotaupdate("0055266dfbc0493ebf0f0c76a3645cf6", quotaupdate,blockQuotaSet,netQuota);
            System.out.println(bocloudResult.getData());
        } catch (Exception e) {
            System.out.println(e);

        }

    }
}