package com.bocloud.cmp.provider.convertor;

import com.bocloud.cmp.model.FirewallPolicyModel;
import com.bocloud.cmp.model.FirewallRuleModel;
import org.openstack4j.model.network.ext.FirewallPolicy;
import org.openstack4j.model.network.ext.FirewallRule;

import java.util.ArrayList;
import java.util.List;

/**
 * easystack防火墙策略数据转换器
 */
public class FirewallPolicyConvertor implements BeanConvertor<FirewallPolicyModel, FirewallPolicy> {

    @Override
    public List<FirewallPolicyModel> convertList(List<? extends FirewallPolicy> firewallPolicys) {
        List<FirewallPolicyModel> models = new ArrayList<>();
        for (FirewallPolicy firewallPolicy : firewallPolicys) {
            models.add(convertModel(firewallPolicy));
        }
        return models;
    }

    @Override
    public FirewallPolicyModel convertModel(FirewallPolicy firewallPolicy) {
        FirewallPolicyModel model = new FirewallPolicyModel();
        model.setPolicyUuid(firewallPolicy.getId());
        model.setName(firewallPolicy.getName());
        model.setTenantUuid(firewallPolicy.getTenantId());
        model.setRemark(firewallPolicy.getDescription());
        model.setShared(firewallPolicy.isShared());
        model.setAudited(firewallPolicy.isAudited());
        model.setRuleUuids(firewallPolicy.getFirewallRuleIds());
        model.setFirewallUuids(firewallPolicy.getFirewallList());
        List<? extends FirewallRule> firewallRules = firewallPolicy.getNeutronFirewallRules();
        List<FirewallRuleModel> rules = new ArrayList<>();
        BeanConvertor<FirewallRuleModel, FirewallRule> convertRule = new FirewallRuleConvertor();
        if (!firewallRules.isEmpty()) {
            for (FirewallRule firewallRule : firewallRules) {
                rules.add(convertRule.convertModel(firewallRule));
            }
        }
        model.setRules(rules);
        return model;
    }
}
