package com.bocloud.cmp.provider.convertor;

import com.bocloud.cmp.model.FloatingIpModel;
import com.bocloud.cmp.provider.utils.StatusConverter;
import org.openstack4j.model.network.NetFloatingIP;

import java.util.ArrayList;
import java.util.List;

/**
 * easystack浮动IP数据转换器
 */
public class FloatingIpConvertor implements BeanConvertor<FloatingIpModel, NetFloatingIP> {

    @Override
    public List<FloatingIpModel> convertList(List<? extends NetFloatingIP> netFloatingIPs) {
        List<FloatingIpModel> models = new ArrayList<>();
        for (NetFloatingIP netFloatingIP : netFloatingIPs) {
            models.add(convertModel(netFloatingIP));
        }
        return models;
    }

    @Override
    public FloatingIpModel convertModel(NetFloatingIP netFloatingIP) {
        FloatingIpModel model = new FloatingIpModel();
        model.setFloatingIpUuid(netFloatingIP.getId());
        model.setRouterUuid(netFloatingIP.getRouterId());
        model.setTenantUuid(netFloatingIP.getTenantId());
        model.setFloatingNetworkUuid(netFloatingIP.getFloatingNetworkId());
        model.setFloatingIpAddress(netFloatingIP.getFloatingIpAddress());
        model.setFixedIpAddress(netFloatingIP.getFixedIpAddress());
        model.setPortUuid(netFloatingIP.getPortId());
        model.setStatus(StatusConverter.Network.converter(netFloatingIP.getStatus()));
        return model;
    }

}
