package com.bocloud.cmp.provider.convertor;

import com.bocloud.cmp.model.HeatStackModel;
import com.bocloud.common.utils.DateTools;
import org.openstack4j.model.heat.Stack;

import java.util.ArrayList;
import java.util.List;

/**
 * easystack heat service stack
 */
public class HeatStackConvertor implements BeanConvertor<HeatStackModel, Stack> {

    @Override
    public List<HeatStackModel> convertList(List<? extends Stack> stacks) {
        List<HeatStackModel> heatStackModels = new ArrayList<>();
        for (Stack stack : stacks) {
            heatStackModels.add(convertModel(stack));
        }
        return heatStackModels;
    }

    @Override
    public HeatStackModel convertModel(Stack stack) {
        HeatStackModel model = new HeatStackModel();
        if (null != stack) {
            model.setName(stack.getName());
            model.setStackUuid(stack.getId());
            model.setOutputs(model.getOutputs());
            model.setDescription(stack.getDescription());
            model.setParameters(stack.getParameters());
            model.setStatus(stack.getStatus());
            model.setStackStatusReason(stack.getStackStatusReason());
            model.setTemplateDescription(stack.getTemplateDescription());
            String createdAt = stack.getCreationTime();
            if (null != createdAt && !"".equals(createdAt)) {
                model.setCreationTime(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdAt, "Z"));
            }
        }
        return model;
    }
}
