package com.bocloud.cmp.provider.convertor;

import com.bocloud.cmp.model.LbMemberModel;
import org.openstack4j.model.network.ext.MemberV2;

import java.util.ArrayList;
import java.util.List;

/**
 * easystack负载均衡数据member转换器
 */
public class LbMemberConvertor implements BeanConvertor<LbMemberModel, MemberV2> {

    @Override
    public List<LbMemberModel> convertList(List<? extends MemberV2> members) {
        List<LbMemberModel> models = new ArrayList<>();
        for (MemberV2 member : members) {
            models.add(convertModel(member));
        }
        return models;
    }

    @Override
    public LbMemberModel convertModel(MemberV2 member) {
        LbMemberModel model = new LbMemberModel();
        model.setAddress(member.getAddress());
        model.setMemberUuid(member.getId());
        model.setPort(member.getProtocolPort());
        model.setSubnetUuid(member.getSubnetId());
        model.setTenantUuid(member.getTenantId());
        model.setAdminStateUp(member.isAdminStateUp());
        model.setWeight(member.getWeight());
        return model;
    }
}
