package com.bocloud.cmp.provider.convertor;

import com.bocloud.cmp.model.RouterModel;
import com.bocloud.cmp.provider.utils.StatusConverter;
import org.openstack4j.model.network.Router;
import org.openstack4j.model.network.State;

import java.util.ArrayList;
import java.util.List;

/**
 * easystack路由器数据转换器
 */
public class RouterConvertor implements BeanConvertor<RouterModel, Router> {

    @Override
    public List<RouterModel> convertList(List<? extends Router> models) {
        List<RouterModel> routeModels = new ArrayList<>();
        for (Router router : models) {
            State state = router.getStatus();
            if (State.ACTIVE == state || State.DOWN == state || State.ERROR == state) {
                routeModels.add(convertModel(router));
            }
        }
        return routeModels;
    }

    @Override
    public RouterModel convertModel(Router router) {
        RouterModel model = new RouterModel();
        model.setAdminStateup(router.isAdminStateUp());
        model.setStatus(router.getStatus().name());
        if (null != router.getExternalGatewayInfo()) {
            model.setNetworkUuid(router.getExternalGatewayInfo().getNetworkId());
            model.setEnableSnat(router.getExternalGatewayInfo().isEnableSnat());
        }
        model.setStatus(StatusConverter.Network.converter(router.getStatus().name()));
        model.setName(router.getName());
        model.setRouterUuid(router.getId());
        model.setTenantUuid(router.getTenantId());
        return model;
    }

}
