package com.bocloud.cmp.provider.convertor;

import com.bocloud.cmp.model.VipModel;
import org.openstack4j.model.network.ext.SessionPersistence;
import org.openstack4j.model.network.ext.Vip;

import java.util.ArrayList;
import java.util.List;

/**
 * easystack Vip数据转换器
 */
public class VipConvertor implements BeanConvertor<VipModel, Vip> {

    @Override
    public List<VipModel> convertList(List<? extends Vip> vips) {
        List<VipModel> vipModels = new ArrayList<>();
        for (Vip vip : vips) {
            vipModels.add(convertModel(vip));
        }
        return vipModels;
    }

    @Override
    public VipModel convertModel(Vip vip) {
        VipModel model = new VipModel();
        model.setVipUuid(vip.getId());
        model.setName(vip.getName());
        model.setAddress(vip.getAddress());
        model.setAdminStateUp(vip.isAdminStateUp());
        model.setConnLimit(vip.getConnectionLimit());
        model.setRemark(vip.getDescription());
        model.setPoolUuid(vip.getPoolId());
        model.setProtocol(vip.getProtocol().name());
        model.setPort(vip.getProtocolPort());
        SessionPersistence sessPersis = vip.getSessionPersistence();
        if (null != sessPersis) {
            model.setCookieName(sessPersis.getCookieName());
            model.setSessPersisType(sessPersis.getType().name());
        }
        model.setStatus(vip.getStatus());
        model.setSubnetUuid(vip.getSubnetId());
        model.setTenantUuid(vip.getTenantId());
        return model;
    }

}
