package com.bocloud.cmp.provider.convertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.VpnPolicyModel;

import java.util.ArrayList;
import java.util.List;

/**
 * vpn策略转换器
 */
public class VpnPolicyConvertor implements BeanConvertor<VpnPolicyModel, JSONObject> {

    @Override
    public List<VpnPolicyModel> convertList(List<? extends JSONObject> objects) {
        List<VpnPolicyModel> vpnPolicyModels = new ArrayList<>();
        for (JSONObject object : objects) {
            vpnPolicyModels.add(convertModel(object));
        }
        return vpnPolicyModels;
    }

    @Override
    public VpnPolicyModel convertModel(JSONObject object) {
        if (null == object) {
            return null;
        }
        VpnPolicyModel model = new VpnPolicyModel();
        model.setName(object.getString("name"));
        model.setAuthorizationAlgorithm(object.getString("auth_algorithm"));
        model.setEncryptionAlgorithm(object.getString("encryption_algorithm"));
        model.setGroupSecret(object.getString("pfs"));
        model.setPfs(object.getString("pfs"));
        String mode = object.getString("phase1_negotiation_mode");
        if (null == mode) {
            mode = object.getString("encapsulation_mode");
        }
        model.setMode(mode);
        model.setVersion(object.getString("ike_version"));
        model.setRemark(object.getString("description"));
        model.setPolicyUuid(object.getString("id"));
        JSONObject lifetime = object.getJSONObject("lifetime");
        if (null != lifetime) {
            model.setKeyUnit(lifetime.getString("units"));
            model.setKeyValue(lifetime.getString("value"));
        }
        model.setProtocol(object.getString("transform_protocol"));

        model.setTenantUuid(object.getString("tenant_id"));
        return model;
    }
}
