package com.bocloud.cmp.provider.listener;

import org.apache.commons.lang3.StringUtils;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.EasyStackClientFactory;

/**
 * easystack云供应商监听器，用来实时监听缓存的butler信息
 */
public class EasyStackButlerListener implements ButlerEventListener {

    private String code;

    public EasyStackButlerListener(String code) {
        this.code = code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Override
    public String getCode() {
        return code;
    }

    @Override
    public void onRemoved(Butler butler) {
        String projectName = butler.getProjectName();
        if (StringUtils.isEmpty(projectName)) {
            projectName = butler.getTenant();
        }
        EasyStackClientFactory.getInstance().removeToken(butler.getUuid(), projectName);
    }

    @Override
    public void onChanged(Butler butler) {
        EasyStackClientFactory.getInstance().updateToken(butler);
    }
}
