package com.bocloud.cmp.provider.monitor;

import com.bocloud.cmp.model.AlarmModel;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.EasyStackProvider;
import com.bocloud.cmp.provider.convertor.AlarmConvertor;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import org.openstack4j.model.telemetry.Alarm;

import java.util.ArrayList;
import java.util.List;

/**
 * easystack告警操作类
 */
@Provider("bocloud.cmp.easystack")
public class EasyStackAlarmProvider extends EasyStackProvider implements AlarmProvider {

    public EasyStackAlarmProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult sync() {
        List<? extends Alarm> alarms = new ArrayList<>();
        alarms = this.getClient().telemetry().alarms().list();
        List<AlarmModel> models = new ArrayList<>();
        if (null != alarms) {
            BeanConvertor<AlarmModel, Alarm> convertAlarm = new AlarmConvertor();
            models = convertAlarm.convertList(alarms);
            return new BocloudResult(true, models, "success");
        }
        return new BocloudResult(false, "failed");
    }

    @Override
    public BocloudResult create(AlarmModel alarmModel) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public BocloudResult update(AlarmModel alarmModel) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public BocloudResult confirm(AlarmModel alarmModel) {
        // TODO Auto-generated method stub
        return null;
    }

}
