package com.bocloud.cmp.provider.f5;

import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.F5Provider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.http.HttpClient;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.Result;

/**
 * Created by liuyuanyuan on 2019/5/7 16:52
 */
@Provider("bocloud.cmp.f5")
public class F5DeviceProvider extends F5Provider implements DeviceProvider {

    private static final Logger logger = LoggerFactory.getLogger(F5DeviceProvider.class);
    private Butler butler;

    public F5DeviceProvider(Butler butler) {
        super(butler);
        this.butler = butler;
    }

    @Override
    public BocloudResult list() {
        // 处理请求路径
        String url = "/mgmt/tm/cm/device/";
        url = butler.getUrl() + url;
        HttpClient httpClient = new HttpClient(30000);
        Map<String, Object> header = buildHeader();
        Result result = httpClient.get(header, null, url);
        if (result.isFailed()) {
            logger.error(result.getMessage());
            return new BocloudResult(false, "获取Device列表数据失败:" + result.getMessage());
        }
        return new BocloudResult(true, result.getMessage());
    }
}
