package com.bocloud.cmp.provider.f5;

import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.F5Provider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.http.HttpClient;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.Result;

/**
 * f5 vlan操作服务接口实现类
 *
 * @author liuyuanyuan
 */

@Provider("bocloud.cmp.f5")
public class F5VlansProvider extends F5Provider implements VlansProvider {

    private static final Logger logger = LoggerFactory.getLogger(F5VlansProvider.class);
    private Butler butler;

    public F5VlansProvider(Butler butler) {
        super(butler);
        this.butler = butler;
    }

    @Override
    public BocloudResult list() {
        // 获取vlan列表。。。
        // 处理请求路径
        String url = "/mgmt/tm/net/vlan/";
        url = butler.getUrl() + url;
        HttpClient httpClient = new HttpClient(30000);
        Map<String, Object> header = buildHeader();
        Result result = httpClient.get(header, null, url);
        if (result.isFailed()) {
            logger.error(result.getMessage());
            return new BocloudResult(false, "获取Vlan数据失败:" + result.getMessage());
        }
        return new BocloudResult(true, result.getMessage());
    }

}
