package com.bocloud.cmp.common.model;

/**
 * 《ManageOne 6.5.1 OTenantSecurity服务API参考》4.9.2 获取用户token
 *
 * 示例1（“name”为企业帐户名称，此处以“examplename”为例）：
 * "scope": {
 *   "domain": {
 *     "name": "examplename"
 *   }
 * }
 * 该示例表示本token仅能访问examplename企业帐户下的资源。
 *
 * 示例2：
 * "scope": {
 *   "project": {
 *    	"id": "0215ef11e49d4743be23dd97a1561e91"
 *   }
 * }
 * 该示例表示本token仅能访问所属企业帐户下的id为0215ef11e49d4743be23dd97a1561e91的project下的资源。
 *
 * 示例3：
 * "scope": {
 *   "project": {
 *      "domain": {
 *        "name": "examplename"
 *       },
 *      "name": "project_example"
 *    }
 * }
 * 该示例表示本token仅能访问examplename企业帐户下名称为project_example的project下的资源。
 *
 */
public class FusionCloudScope {

	private FusionCloudProject project;
	private FusionCloudDomain domain;

	/**
	 * 
	 */
	public FusionCloudScope() {
		super();
	}

	/**
	 * @param project
	 */
	public FusionCloudScope(FusionCloudProject project) {
		super();
		this.project = project;
	}

	public FusionCloudScope(FusionCloudDomain domain) {
		this.domain = domain;
	}

	/**
	 * @return the project
	 */
	public FusionCloudProject getProject() {
		return project;
	}

	/**
	 * @param project
	 *            the project to set
	 */
	public void setProject(FusionCloudProject project) {
		this.project = project;
	}

	public FusionCloudDomain getDomain() {
		return domain;
	}

	public void setDomain(FusionCloudDomain domain) {
		this.domain = domain;
	}
}
