package com.bocloud.cmp.fusioncloudconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.FlavorModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @Date: Created in 2018/9/19
 * @Author: guopeng
 * @Description:
 */
public class FlavorConvertor implements BeanConvertor<FlavorModel, JSONObject> {

	@Override
	public List<FlavorModel> convertList(List<? extends JSONObject> models) {
		List<FlavorModel> flavorModels = new ArrayList<FlavorModel>();
		for (JSONObject model : models) {
			String uuid = model.getString("id");
			if ((null != uuid) && (uuid.length() > 3)) {
				flavorModels.add(convertModel(model));
			}
		}
		return flavorModels;
	}

	@Override
	public FlavorModel convertModel(JSONObject model) {
		FlavorModel flavorModel = new FlavorModel();
		flavorModel.setName(model.getString("name"));
		flavorModel.setCpu(model.getInteger("vcpus"));
		flavorModel.setDisk(model.getInteger("disk"));
		flavorModel.setFlavorUuid(model.getString("id"));
		flavorModel.setMemory(BigDecimal.valueOf(model.getInteger("ram")).divide(BigDecimal.valueOf(1024), 2,
				BigDecimal.ROUND_HALF_UP));
		flavorModel.setUuid(model.getString("id"));
		return flavorModel;
	}
}
