package com.bocloud.cmp.fusioncloudconvertor;

import java.util.ArrayList;
import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.FloatingIpModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

/**
 * @Date: Created in 2018/9/20
 * @Author: guopeng
 * @Description:
 */
public class FloatingIpConvertor implements BeanConvertor<FloatingIpModel, JSONObject> {
	@Override
	public List<FloatingIpModel> convertList(List<? extends JSONObject> models) {
		List<FloatingIpModel> floatingIpModels = new ArrayList<FloatingIpModel>();
		for (JSONObject model : models) {
			floatingIpModels.add(convertModel(model));
		}
		return floatingIpModels;
	}

	@Override
	public FloatingIpModel convertModel(JSONObject model) {
		FloatingIpModel floatingIpModel = new FloatingIpModel();
		floatingIpModel.setRouterUuid(model.getString("router_id"));
		floatingIpModel.setStatus(model.getString("status"));
		floatingIpModel.setTenantUuid(model.getString("tenant_id"));
		floatingIpModel.setFloatingNetworkUuid(model.getString("floating_network_id"));
		floatingIpModel.setFixedIpAddress(model.getString("fixed_ip_address"));
		floatingIpModel.setFloatingIpAddress(model.getString("floating_ip_address"));
		floatingIpModel.setPortUuid(model.getString("port_id"));
		floatingIpModel.setFloatingIpUuid(model.getString("id"));
		return floatingIpModel;
	}
}
