package com.bocloud.cmp.fusioncloudconvertor;

import java.util.ArrayList;
import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.KeypairModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

/**
 * 华为私有云密钥数据转换器
 *
 * @author wangyu
 * @version 3.0.0-SNAPSHOT
 * @since 2018/9/21
 */
public class KeypairConvertor implements BeanConvertor<KeypairModel, JSONObject> {

	@Override
	public List<KeypairModel> convertList(List<? extends JSONObject> objects) {
		List<KeypairModel> keypairModels = new ArrayList<KeypairModel>();
		for (JSONObject object : objects) {
			keypairModels.add(convertModel(object));
		}
		return keypairModels;
	}

	@Override
	public KeypairModel convertModel(JSONObject object) {
		KeypairModel model = new KeypairModel();
		model.setFingerprint(object.getString("fingerprint"));
		model.setName(object.getString("name"));
		model.setPublicKey(object.getString("public_key"));
		model.setPrivateKey(object.getString("private_key"));
		return model;
	}
}
