package com.bocloud.cmp.fusioncloudconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.LbModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: LbConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/2/27 11:30
 */
public class LbConvertor implements BeanConvertor<LbModel, JSONObject> {
    @Override
    public List<LbModel> convertList(List<? extends JSONObject> models) {
        List<LbModel> lbModels = new ArrayList<>();
        for (JSONObject model : models) {
            lbModels.add(convertModel(model));
        }
        return lbModels;
    }

    @Override
    public LbModel convertModel(JSONObject object) {
        LbModel model = new LbModel();
        model.setLbUuid(object.getString("id"));//负载均衡id
        model.setName(object.getString("name"));
        model.setRemark(object.getString("description"));
        model.setTenantUuid(object.getString("tenant_id"));
        model.setSubnetUuid(object.getString("vip_subnet_id"));
        model.setVipAddress(object.getString("vip_address"));
        model.setVipPortUuid(object.getString("vip_port_id"));
        model.setAdminStateUp(object.getBoolean("admin_state_up"));
        model.setListeners(JSONArray.parseArray(object.getString("listeners"), String.class));
        model.setProvisioningStatus(object.getString("provisioning_status"));
        model.setOperatingStatus(object.getString("operating_status"));
        model.setProvider(object.getString("provider"));
        return model;
    }
}
