package com.bocloud.cmp.fusioncloudconvertor;

import java.util.ArrayList;
import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.RegionModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

/**
 * 华为私有云域数据转换器
 *
 * @author wangyu
 * @version 3.0.0-SNAPSHOT
 * @since 2018/9/21
 */
public class RegionConvertor implements BeanConvertor<RegionModel, JSONObject> {

	@Override
	public List<RegionModel> convertList(List<? extends JSONObject> objects) {
		List<RegionModel> regionModels = new ArrayList<RegionModel>();
		for (JSONObject object : objects) {
			regionModels.add(convertModel(object));
		}
		return regionModels;
	}

	@Override
	public RegionModel convertModel(JSONObject object) {
		RegionModel model = new RegionModel();
		model.setName(object.getString("zoneName"));
		model.setCode(object.getString("zoneName"));
		model.setRegionId(object.getString("zoneName"));
		return model;
	}
}
