package com.bocloud.cmp.fusioncloudconvertor;

import java.util.ArrayList;
import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.RouterModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

/**
 * @Date: Created in 2018/9/19
 * @Author: guopeng
 * @Description:
 */
public class RouterConvertor implements BeanConvertor<RouterModel, JSONObject> {

	@Override
	public List<RouterModel> convertList(List<? extends JSONObject> models) {
		List<RouterModel> routerModels = new ArrayList<RouterModel>();
		for (JSONObject model : models) {
			routerModels.add(convertModel(model));
		}
		return routerModels;
	}

	@Override
	public RouterModel convertModel(JSONObject model) {
		RouterModel routerModel = new RouterModel();
		routerModel.setStatus(model.getString("status"));
		routerModel.setName(model.getString("name"));
		routerModel.setAdminStateup(model.getBoolean("admin_state_up"));
		routerModel.setTenantUuid(model.getString("tenant_id"));
		routerModel.setProjectUuid(model.getString("project_id"));
		routerModel.setRouterUuid(model.getString("id"));
		if (model.containsKey("external_gateway_info")) {
			JSONObject object = model.getJSONObject("external_gateway_info");
			routerModel.setNetworkUuid(object.getString("network_id"));
			routerModel.setEnableSnat(object.getBoolean("enable_snat"));
		}
		if (model.containsKey("ha")) {
			routerModel.setHa(model.getBoolean("ha"));
		}
		if (model.containsKey("subnet_id")) {
			routerModel.setSubnetUuid(model.getString("subnet_id"));
		}
		if (model.containsKey("port_id")) {
			routerModel.setPortUuid(model.getString("port_id"));
		}
		return routerModel;
	}
}
