package com.bocloud.cmp.provider.compute;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.fusioncloudconvertor.HostConvertor;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.HostModel;
import com.bocloud.cmp.model.HostOperateModel;
import com.bocloud.cmp.provider.FusionCloudProvider;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.Result;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import java.util.List;

/**
 * 宿主机
 * 
 * @author Administrator
 *
 */
@Provider("bocloud.cmp.fusioncloud")
public class FusionCloudHostProvider extends FusionCloudProvider implements HostProvider {

	private static final Logger logger = LoggerFactory.getLogger(FusionCloudHostProvider.class);

	private BeanConvertor<HostModel, JSONObject> hostConvertor = new HostConvertor();

	public FusionCloudHostProvider(Butler butler) {
		super(butler);
	}

	@Override
	public BocloudResult create(HostOperateModel arg0) {
		return null;
	}

	@Override
	public BocloudResult detail(HostOperateModel arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BocloudResult detail(Long arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BocloudResult disconn(HostOperateModel arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BocloudResult enterMode(HostOperateModel arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BocloudResult exitMode(HostOperateModel arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BocloudResult list() {
		try {
			String url = this.getUrl() + "/rest/cmdb/v1/instances/SYS_PhysicalHost";
			JSONObject params = new JSONObject();
			Result result = this.getClient().get(buildMonitorHeader(), params, url);
			JSONObject parseObject = JSON.parseObject(result.getMessage(), JSONObject.class);
			String objList = parseObject.getString("objList");
			List<JSONObject> parseArray = JSON.parseArray(objList, JSONObject.class);
			Integer totalPageNo = parseObject.getInteger("totalPageNo");
			if (null != totalPageNo && totalPageNo > 1) {
				for (int i = 2; i <= totalPageNo; i++) {
					result = this.getClient().get(buildMonitorHeader(), params, url + "?pageNo=" + i);
					JSONObject obj = JSON.parseObject(result.getMessage(), JSONObject.class);
					String hosts = obj.getString("objList");
					List<JSONObject> array = JSON.parseArray(hosts, JSONObject.class);
					if (null != array && array.size() > 0) {
						parseArray.addAll(array);
					}
				}
			}
			return new BocloudResult(true, hostConvertor.convertList(parseArray), "查询成功");
		} catch (Exception e) {
			logger.error("查询宿主机Error : " + e.getMessage());
			return new BocloudResult(false, e.getMessage());
		}
	}

	@Override
	public BocloudResult list(String arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BocloudResult listPerf() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BocloudResult monitor() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BocloudResult moveTo(HostOperateModel arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BocloudResult reboot(HostOperateModel arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BocloudResult reconn(HostOperateModel arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BocloudResult remove(HostOperateModel arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BocloudResult shutdown(HostOperateModel arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BocloudResult summary(Long arg0) {
		// TODO Auto-generated method stub
		return null;
	}

}
