package com.bocloud.cmp.convertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.ClusterModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: ClusterContervor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/10/14 14:11
 */
public class ClusterConvertor implements BeanJsonConvertor<ClusterModel> {

    @Override
    public ClusterModel convertModelParams(JSONObject object, String... params) {
        ClusterModel model = new ClusterModel();
        Optional.ofNullable(object.getString("urn")).ifPresent(model::setClusterVal);
        Optional.ofNullable(object.getString("uri")).ifPresent(model::setUri);
        Optional.ofNullable(object.getString("name")).ifPresent(model::setName);
//        Optional.ofNullable(object.getString("arch")).ifPresent(model::setArch);
        Optional.ofNullable(object.getString("parentObjUrn")).ifPresent(model::setParentObjUrn);
        Optional.ofNullable(object.getString("description")).ifPresent(model::setRemark);
//        Optional.ofNullable(object.getBoolean("isMemOvercommit")).ifPresent(model::setIsMemOvercommit);
//        Optional.ofNullable(object.getBoolean("isEnableHa")).ifPresent(model::setIsEnableHa);
//        Optional.ofNullable(object.getBoolean("isEnableDrs")).ifPresent(model::setIsEnableDrs);
//        Optional.ofNullable(object.getBoolean("isEnableImc")).ifPresent(model::setIsEnableImc);
//        Optional.ofNullable(object.getBoolean("enableGuestNuma")).ifPresent(model::setEnableGuestNuma);
//        Optional.ofNullable(object.getBoolean("enableIOTailor")).ifPresent(model::setEnableIoTailor);
//        Optional.ofNullable(object.getString("resStrategy")).ifPresent(model::setResStrategy);
//        Optional.ofNullable(object.getBoolean("isAutoAdjustNuma")).ifPresent(model::setIsAutoAdjustNuma);
        Optional.ofNullable(object.getJSONObject("cpuResource")).ifPresent(cpuResource -> {
            Optional.ofNullable(cpuResource.getLong("totalSizeMHz")).ifPresent(model::setCpuTotal);
            Optional.ofNullable(cpuResource.getLong("allocatedSizeMHz")).ifPresent(model::setCpuUsed);
        });
        Optional.ofNullable(object.getJSONObject("memResource")).ifPresent(cpuResource -> {
            Optional.ofNullable(cpuResource.getDouble("totalSizeMB")).ifPresent(model::setMemTotal);
            Optional.ofNullable(cpuResource.getDouble("allocatedSizeMB")).ifPresent(model::setMemUsed);
        });
//        //非重要参数
//        Optional.ofNullable(object.getString("parentObjName")).ifPresent(model::setParentObjName);
//        Optional.ofNullable(object.getBoolean("EnableHostNumaDRS")).ifPresent(model::setEnableHostNumaDRS);
//        Optional.ofNullable(object.getString("imcSetting")).ifPresent(model::setImcSetting);
//        Optional.ofNullable(object.getBoolean("enableGuestNuma")).ifPresent(model::setEnableGuestNuma);
//        Optional.ofNullable(object.getBoolean("highPerformance")).ifPresent(model::setHighPerformance);
        if (null!=params && 0 != params.length) {
            String vdcUri = params[0];
            model.setVdcUri(vdcUri);
        }
        return model;
    }

    @Override
    public ClusterModel convertModel(JSONObject object) {
        ClusterModel model = new ClusterModel();
        Optional.ofNullable(object.getString("urn")).ifPresent(model::setClusterVal);
        Optional.ofNullable(object.getString("uri")).ifPresent(model::setUri);
        Optional.ofNullable(object.getString("name")).ifPresent(model::setName);
        Optional.ofNullable(object.getString("arch")).ifPresent(model::setArch);
        Optional.ofNullable(object.getString("parentObjUrn")).ifPresent(model::setParentObjUrn);
        Optional.ofNullable(object.getString("description")).ifPresent(model::setRemark);
        Optional.ofNullable(object.getBoolean("isMemOvercommit")).ifPresent(model::setIsMemOvercommit);
        Optional.ofNullable(object.getBoolean("isEnableHa")).ifPresent(model::setIsEnableHa);
        Optional.ofNullable(object.getBoolean("isEnableDrs")).ifPresent(model::setIsEnableDrs);
        Optional.ofNullable(object.getBoolean("isEnableImc")).ifPresent(model::setIsEnableImc);
        Optional.ofNullable(object.getBoolean("enableGuestNuma")).ifPresent(model::setEnableGuestNuma);
        Optional.ofNullable(object.getBoolean("enableIOTailor")).ifPresent(model::setEnableIoTailor);
        Optional.ofNullable(object.getString("resStrategy")).ifPresent(model::setResStrategy);
        Optional.ofNullable(object.getBoolean("isAutoAdjustNuma")).ifPresent(model::setIsAutoAdjustNuma);
        Optional.ofNullable(object.getJSONObject("cpuResource")).ifPresent(cpuResource -> {
            Optional.ofNullable(cpuResource.getLong("totalSizeMHz")).ifPresent(model::setCpuTotal);
            Optional.ofNullable(cpuResource.getLong("allocatedSizeMHz")).ifPresent(model::setCpuUsed);
        });
        Optional.ofNullable(object.getJSONObject("memResource")).ifPresent(cpuResource -> {
            Optional.ofNullable(cpuResource.getDouble("totalSizeMB")).ifPresent(model::setMemTotal);
            Optional.ofNullable(cpuResource.getDouble("allocatedSizeMB")).ifPresent(model::setMemUsed);
        });
        //非重要参数
        Optional.ofNullable(object.getString("parentObjName")).ifPresent(model::setParentObjName);
        Optional.ofNullable(object.getBoolean("EnableHostNumaDRS")).ifPresent(model::setEnableHostNumaDRS);
        Optional.ofNullable(object.getString("imcSetting")).ifPresent(model::setImcSetting);
        Optional.ofNullable(object.getBoolean("enableGuestNuma")).ifPresent(model::setEnableGuestNuma);
        Optional.ofNullable(object.getBoolean("highPerformance")).ifPresent(model::setHighPerformance);
        return model;
    }

}