package com.bocloud.cmp.convertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.DataStoreModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: DataStoreConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/10/20 17:02
 */
public class DataStoreConvertor implements BeanJsonConvertor<DataStoreModel> {
    @Override
    public DataStoreModel convertModelParams(JSONObject object,String... params) {
        DataStoreModel model = new DataStoreModel();
        Optional.ofNullable(object.getString("urn")).ifPresent(model::setStoreVal);
        Optional.ofNullable(object.getString("uri")).ifPresent(model::setUri);
        Optional.ofNullable(object.getString("suUrn")).ifPresent(model::setStoreDeviceUuid);
        Optional.ofNullable(object.getString("storageType")).ifPresent(model::setType);
        Optional.ofNullable(object.getString("name")).ifPresent(model::setName);
        Optional.ofNullable(object.getString("status")).ifPresent(model::setStatus);
        Optional.ofNullable(object.getString("description")).ifPresent(model::setRemark);
        Optional.ofNullable(object.getDouble("actualCapacityGB")).ifPresent(model::setCapacity);
        Optional.ofNullable(object.getDouble("actualFreeSizeGB")).ifPresent(model::setFreeSpace);
        Optional.ofNullable(JSONArray.parseArray(JSONObject.toJSONString(object.get("hosts")),String.class)).ifPresent(model::setHostUuids);
        if (null!=params && 0 != params.length) {
            String vdcUri = params[0];
            model.setVdcUri(vdcUri);
        }
        return model;
    }

}
