package com.bocloud.cmp.convertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.HostModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: HostConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/10/14 17:25
 */
public class HostConvertor implements BeanJsonConvertor<HostModel> {

    @Override
    public HostModel convertModelParams(JSONObject object,String... params) {
        HostModel model = new HostModel();
        Optional.ofNullable(object.getString("urn")).ifPresent(model::setUuid);
        Optional.ofNullable(object.getString("uri")).ifPresent(model::setUri);
        Optional.ofNullable(object.getString("name")).ifPresent(model::setName);
        Optional.ofNullable(object.getString("description")).ifPresent(model::setRemark);
        Optional.ofNullable(object.getString("ip")).ifPresent(model::setHostIp);
        Optional.ofNullable(object.getString("clusterUrn")).ifPresent(model::setClusterUuid);
        Optional.ofNullable(object.getString("status")).ifPresent(model::setStatus);
        Optional.ofNullable(object.getBoolean("isMaintaining")).ifPresent(model::setMaintained);
//        Optional.ofNullable(object.getDouble("memQuantityMB")).ifPresent(model::setMemTotal);
        Optional.ofNullable(object.getInteger("cpuQuantity")).ifPresent(model::setCpuNum);
        Optional.ofNullable(object.getLong("nicQuantity")).ifPresent(model::setNicTotal);
//        Optional.ofNullable(object.getLong("cpuMHz")).ifPresent(model::setCpuHz);
        Optional.ofNullable(object.getJSONObject("cpuResource")).ifPresent(cpuResource -> {
//            Optional.ofNullable(cpuResource.getLong("totalSizeMHz")).ifPresent(model::setCpuTotal);
            Optional.ofNullable(cpuResource.getLong("totalSizeMHz"))
                    .map(totalSizeMHz -> totalSizeMHz/1024).ifPresent(model::setCpuHz);
            Optional.ofNullable(cpuResource.getLong("allocatedSizeMHz"))
                    .map(allocatedSizeMHz -> allocatedSizeMHz/1024).ifPresent(model::setCpuUsed);
        });
        Optional.ofNullable(object.getJSONObject("memResource")).ifPresent(cpuResource -> {
            Optional.ofNullable(cpuResource.getDouble("totalSizeMB"))
                    .map(totalSizeMB -> totalSizeMB/1024).ifPresent(model::setMemTotal);
            Optional.ofNullable(cpuResource.getDouble("allocatedSizeMB"))
                    .map(allocatedSizeMB -> allocatedSizeMB/1024).ifPresent(model::setMemUsed);
        });
        if (null!=params && 0 != params.length) {
            String vdcUri = params[0];
            model.setVdcUri(vdcUri);
        }
        return model;
    }
}