package com.bocloud.cmp.convertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.fusionsphere.FusionSphereOsVersionModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: OsVersionConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/11/3 11:33
 */
public class OsVersionConvertor implements BeanJsonConvertor<FusionSphereOsVersionModel> {

    @Override
    public FusionSphereOsVersionModel convertModelParams(JSONObject object, String... params) {
        FusionSphereOsVersionModel model = new FusionSphereOsVersionModel();
        Optional.ofNullable(object.getString("id")).ifPresent(model::setOsVersionUuid);
        Optional.ofNullable(object.getString("versionDes")).ifPresent(model::setVersionDes);
        Optional.ofNullable(object.getString("osType")).ifPresent(model::setOsType);
        Optional.ofNullable(object.getInteger("osBit")).ifPresent(model::setOsBit);
        Optional.ofNullable(object.getInteger("cpuQuantityLimit")).ifPresent(model::setCpuQuantityLimit);
        Optional.ofNullable(object.getInteger("cpuSocketLimit")).ifPresent(model::setCpuSocketLimit);
        Optional.ofNullable(object.getInteger("memQuantityLimit")).ifPresent(model::setMemQuantityLimit);
        Optional.ofNullable(object.getBoolean("supportCpuHotPlug")).ifPresent(model::setSupportCpuHotPlug);
        Optional.ofNullable(object.getBoolean("supportMemHotPlug")).ifPresent(model::setSupportMemHotPlug);
        Optional.ofNullable(object.getBoolean("supportHibernateAndWakeup")).ifPresent(model::setSupportHibernateAndWakeup);
        Optional.ofNullable(object.getBoolean("supportUEFIFirmware")).ifPresent(model::setSupportUefiFirmware);
        Optional.ofNullable(object.getBoolean("supportDiskHotPlug")).ifPresent(model::setSupportDiskHotPlug);
        Optional.ofNullable(object.getBoolean("supportDiskHotUnPlug")).ifPresent(model::setSupportDiskHotUnPlug);
        Optional.ofNullable(object.getBoolean("supportNicHotPlug")).ifPresent(model::setSupportNicHotPlug);
        Optional.ofNullable(object.getBoolean("supportNicHotUnplug")).ifPresent(model::setSupportNicHotUnplug);
        Optional.ofNullable(object.getBoolean("supportMigrate")).ifPresent(model::setSupportMigrate);
        Optional.ofNullable(object.getBoolean("supportHostAndStorageMigrate")).ifPresent(model::setSupportHostAndStorageMigrate);
        Optional.ofNullable(object.getBoolean("supportFreeClock")).ifPresent(model::setSupportFreeClock);
        Optional.ofNullable(object.getBoolean("supportMemorySnapshot")).ifPresent(model::setSupportMemorySnapshot);
        Optional.ofNullable(object.getBoolean("supportStorageSnapshot")).ifPresent(model::setSupportStorageSnapshot);
        Optional.ofNullable(object.getBoolean("supportVSS")).ifPresent(model::setSupportVss);
        Optional.ofNullable(object.getBoolean("supportUsbPassThrough")).ifPresent(model::setSupportUsbPassThrough);
        Optional.ofNullable(object.getBoolean("supportSriov")).ifPresent(model::setSupportSriov);
        Optional.ofNullable(object.getBoolean("supportDiskExpand")).ifPresent(model::setSupportDiskExpand);
        Optional.ofNullable(object.getBoolean("supportDiskShrink")).ifPresent(model::setSupportDiskShrink);
        Optional.ofNullable(object.getBoolean("supportUpgrade")).ifPresent(model::setSupportUpgrade);
        Optional.ofNullable(object.getBoolean("supportSSD")).ifPresent(model::setSupportSsd);
        Optional.ofNullable(object.getBoolean("gpuPassThroughSupported")).ifPresent(model::setGpuPassThroughSupported);
        Optional.ofNullable(object.getBoolean("gpuVirtualizationSupported")).ifPresent(model::setGpuVirtualizationSupported);
        Optional.ofNullable(object.getBoolean("supportIB")).ifPresent(model::setSupportIb);
        Optional.ofNullable(object.getBoolean("supportGuestNuma")).ifPresent(model::setSupportGuestNuma);
        Optional.ofNullable(object.getBoolean("supportVirtioBlk")).ifPresent(model::setSupportVirtioBlk);
        Optional.ofNullable(object.getBoolean("supportVirtioScsi")).ifPresent(model::setSupportVirtioScsi);
        Optional.ofNullable(object.getString("floppyFile")).ifPresent(model::setFloppyFile);
        Optional.ofNullable(object.getInteger("defaultMemoryQuantity")).ifPresent(model::setDefaultMemoryQuantity);
        Optional.ofNullable(object.getInteger("defaultCPUQuantity")).ifPresent(model::setDefaultCpuQuantity);
        Optional.ofNullable(object.getInteger("defaultSysVolQuantity")).ifPresent(model::setDefaultSysVolQuantity);
        String vdcUri = params[0];
        model.setVdcUri(vdcUri);
        return model;
    }


}