package com.bocloud.cmp.convertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.PortGroupModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: PortGroupConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/10/26 14:11
 */
public class PortGroupConvertor implements BeanJsonConvertor<PortGroupModel> {

    @Override
    public PortGroupModel convertModel(JSONObject object) {
        PortGroupModel model = new PortGroupModel();
        Optional.ofNullable(object.getString("urn")).ifPresent(model::setGroupVal);
        Optional.ofNullable(object.getString("uri")).ifPresent(model::setUri);
        Optional.ofNullable(object.getString("name")).ifPresent(model::setName);
        Optional.ofNullable(object.getString("description")).ifPresent(model::setRemark);
        Optional.ofNullable(object.getString("portType")).ifPresent(model::setType);
        Optional.ofNullable(object.getInteger("vlanId")).ifPresent(model::setVlanId);
        Optional.ofNullable(object.getString("vlanRange")).ifPresent(model::setVlanRange);
        Optional.ofNullable(object.getLong("txLimit")).ifPresent(model::setOutAverageBandWidth);
        Optional.ofNullable(object.getLong("txPeakLimit")).ifPresent(model::setOutPeakBandWidth);
        Optional.ofNullable(object.getLong("txBurstSize")).ifPresent(model::setOutBurstSize);
//        Optional.ofNullable(object.getLong("txWeight")).ifPresent(model::);
//        Optional.ofNullable(object.getLong("txReserve")).ifPresent(model::);

        Optional.ofNullable(object.getLong("rxLimit")).ifPresent(model::setInAverageBandWidth);
        Optional.ofNullable(object.getLong("rxPeakLimit")).ifPresent(model::setInPeakBandWidth);
        Optional.ofNullable(object.getLong("rxBurstSize")).ifPresent(model::setInBurstSize);
        Optional.ofNullable(object.getBoolean("isIpMacBind")).ifPresent(model::setIsIpMacBind);
        Optional.ofNullable(object.getInteger("ipBcstSuppress")).ifPresent(model::setIpBcstSuppress);
        Optional.ofNullable(object.getBoolean("isCalcTCPCheckSum")).ifPresent(model::setIsCalcTcpCheckSum);
        Optional.ofNullable(object.getBoolean("isDhcpIsolation")).ifPresent(model::setIsDhcpIsolation);
        return model;
    }

}