package com.bocloud.cmp.convertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.SecurityGroupModel;
import com.bocloud.cmp.model.ServerModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;
import java.util.stream.Collectors;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: SecurityGroupConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/10/21 14:00
 */
public class SecurityGroupConvertor implements BeanJsonConvertor<SecurityGroupModel> {

    @Override
    public SecurityGroupModel convertModelParams(JSONObject object,String... params) {
        SecurityGroupModel model = new SecurityGroupModel();
        model.setGroupUuid(object.getString("sgId"));
        model.setName(object.getString("sgName"));
        model.setRemark(object.getString("sgDesc"));
        Optional.ofNullable(object.getJSONArray("vmList"))
                .map(vmList -> vmList
                        .stream()
                        .map(JSONObject::toJSONString)
                        .map(JSONObject::parseObject)
                        .map(vm -> {
                            ServerModel serverModel = new ServerModel();
                            serverModel.setInstanceId(vm.getString("vmUrn"));
                            serverModel.setName(vm.getString("vmName"));
                            return serverModel;
                        }).collect(Collectors.toList())
                ).ifPresent(model::setServerModels);
        if (null!=params && 0 != params.length) {
            String vdcUri = params[0];
            model.setVdcUri(vdcUri);
        }
        return model;
    }
}