package com.bocloud.cmp.convertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.SecurityGroupRuleModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: SecurityGroupRuleConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/10/22 10:10
 */
public class SecurityGroupRuleConvertor implements BeanJsonConvertor<SecurityGroupRuleModel> {

    @Override
    public SecurityGroupRuleModel convertModel(JSONObject object) {
        SecurityGroupRuleModel model = new SecurityGroupRuleModel();
        model.setGroupUuid(object.getString("securityGroupId"));
        model.setRuleUuid(object.getString("rulesId"));
        model.setProtocol(object.getString("ipProtocol"));
        model.setIpRanges(object.getString("ipRanges"));
        model.setPortMin(object.getInteger("fromPort"));
        model.setPortMax(object.getInteger("toPort"));
        model.setDirection(object.getString("direction"));
        model.setIpVersion(object.getString("ipVersion"));
        return model;
    }

}