package com.bocloud.cmp.convertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.HostModel;
import com.bocloud.cmp.model.fusionsphere.StorageDeviceModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;
import java.util.stream.Collectors;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: StorageDeviceConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/10/20 15:43
 */
public class StorageDeviceConvertor implements BeanJsonConvertor<StorageDeviceModel> {

    @Override
    public StorageDeviceModel convertModelParams(JSONObject object,String... params) {
        StorageDeviceModel model = new StorageDeviceModel();
        Optional.ofNullable(object.getString("urn")).ifPresent(model::setUrn);
        Optional.ofNullable(object.getString("uri")).ifPresent(model::setUri);
        Optional.ofNullable(object.getString("sdUrn")).ifPresent(model::setSdUrn);
        Optional.ofNullable(object.getString("sdId")).ifPresent(model::setSdId);
        Optional.ofNullable(object.getString("sdName")).ifPresent(model::setSdName);
        Optional.ofNullable(object.getString("name")).ifPresent(model::setName);
        Optional.ofNullable(object.getString("type")).ifPresent(model::setType);
        Optional.ofNullable(object.getInteger("capacityGB")).ifPresent(model::setCapacityGb);
        Optional.ofNullable(object.getString("status")).ifPresent(model::setStatus);
        Optional.ofNullable(object.getString("refreshTime")).ifPresent(model::setRefreshTime);
        Optional.ofNullable(object.getBoolean("isThin")).ifPresent(model::setIsThin);
        Optional.ofNullable(object.getString("wwn")).ifPresent(model::setWwn);
        Optional.ofNullable(object.getInteger("suHostID")).ifPresent(model::setSuHostId);
        Optional.ofNullable(object.getString("sanSN")).ifPresent(model::setSanSn);
        Optional.ofNullable(object.getString("suLunID")).ifPresent(model::setSuLunId);
        Optional.ofNullable(object.getInteger("supportADL")).ifPresent(model::setSupportAdl);
        Optional.ofNullable(object.getInteger("hostNum")).ifPresent(model::setHostNum);
        Optional.ofNullable(object.getJSONArray("hostList"))
                .map(hostList -> hostList
                        .stream()
                        .map(JSONObject::toJSONString)
                        .map(JSONObject::parseObject)
                        .map(host -> {
                            HostModel hostModel = new HostModel();
                            hostModel.setUuid(host.getString("urn"));
                            hostModel.setName(host.getString("hostName"));
                            hostModel.setClusterUuid(host.getString("clusterUrn"));
                            hostModel.setHostIp(host.getString("hostIp"));
                            hostModel.setStatus(host.getString("status"));
                            return hostModel;
                        }).collect(Collectors.toList())
                ).ifPresent(model::setHostModels);
        String vdcUri = params[0];
        model.setVdcUri(vdcUri);
        return model;
    }

}