package com.bocloud.cmp.convertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.fusionsphere.FusionSphereUpLinkPortModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: PortGroup
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/10/25 15:30
 */
public class UpLinkPortConvertor implements BeanJsonConvertor<FusionSphereUpLinkPortModel> {

    @Override
    public FusionSphereUpLinkPortModel convertModelParams(JSONObject object, String... params) {
        FusionSphereUpLinkPortModel model = new FusionSphereUpLinkPortModel();
        Optional.ofNullable(object.getString("hostUrn")).ifPresent(model::setHostUuid);
        Optional.ofNullable(object.getString("portUrn")).ifPresent(model::setPortAggrUuid);
        Optional.ofNullable(object.getString("hostName")).ifPresent(model::setHostName);
        Optional.ofNullable(object.getString("portName")).ifPresent(model::setPortName);
        Optional.ofNullable(object.getString("status")).ifPresent(model::setStatus);
        if (null != params && 0 != params.length) {
            String vdcUri = params[0];
            model.setVdcUri(vdcUri);
        }
        return model;
    }

}