package com.bocloud.cmp.convertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.fusionsphere.HostPortModel;
import com.bocloud.cmp.model.fusionsphere.UplinkPortAggrModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Optional;
import java.util.stream.Collectors;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: UplinkPortAggrConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/11/3 20:44
 */
public class UplinkPortAggrConvertor implements BeanJsonConvertor<UplinkPortAggrModel> {

    @Override
    public UplinkPortAggrModel convertModel(JSONObject object) {
        UplinkPortAggrModel model = new UplinkPortAggrModel();
        Optional.ofNullable(object.getString("urn")).ifPresent(model::setAggrUuid);
        Optional.ofNullable(object.getString("uri")).ifPresent(model::setUri);
        Optional.ofNullable(object.getString("name")).ifPresent(model::setName);
        Optional.ofNullable(object.getString("dvSwitchUrn")).ifPresent(model::setSwitcherUuid);
        Optional.ofNullable(object.getString("description")).ifPresent(model::setDescription);
        Optional.ofNullable(object.getInteger("strategy")).ifPresent(model::setStrategy);
        Optional.ofNullable(object.getString("mac")).ifPresent(model::setMac);
        Optional.ofNullable(object.getInteger("speed")).ifPresent(model::setSpeed);
        Optional.ofNullable(object.getInteger("duplex")).ifPresent(model::setDuplex);
        Optional.ofNullable(object.getInteger("mtu")).ifPresent(model::setMtu);
        Optional.ofNullable(object.getInteger("status")).ifPresent(model::setStatus);
        Optional.ofNullable(object.getJSONArray("uplinkPorts"))
                .map(uplinkPorts -> uplinkPorts
                        .stream()
                        .map(JSONObject::toJSONString)
                        .map(JSONObject::parseObject)
                        .map(uplinkPort -> {
                            HostPortModel portModel = new HostPortModel();
                            portModel.setPortUuid(uplinkPort.getString("urn"));
                            portModel.setUri(uplinkPort.getString("uri"));
                            portModel.setName(uplinkPort.getString("name"));
                            portModel.setSpeed(uplinkPort.getInteger("speed"));
                            return portModel;
                        }).collect(Collectors.toList())
                ).ifPresent(model::setHostPortModels);
        return model;
    }


}