package com.bocloud.cmp.convertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.VolumeModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: VolumeConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/10/21 13:59
 */
public class VolumeConvertor implements BeanJsonConvertor<VolumeModel> {

    @Override
    public VolumeModel convertModelParams(JSONObject object,String... params){
        VolumeModel model = new VolumeModel();
        model.setVolumeUuid(object.getString("urn"));
        model.setUri(object.getString("uri"));
        model.setName(object.getString("name"));
        model.setAllocatedSize(object.getDoubleValue("volProvisionSize"));
        model.setSize(object.getInteger("quantityGB"));
        model.setStatus(status(object.getString("status")));
        model.setVolumeType(object.getString("volType"));//磁盘配置模式 0：普通卷 1：延迟置零卷
        model.setType(object.getString("type"));//卷类型，取值为normal（普通卷）、share（共享卷）；
        model.setThinlyProvisioned(object.getBoolean("isThin"));
        model.setIndepDisk(object.getBoolean("indepDisk"));
        model.setPersistentDisk(object.getBoolean("persistentDisk"));
        model.setDataStoreUuid(object.getString("datastoreUrn"));
        if (null!=params && 0 != params.length) {
            String vdcUri = params[0];
            model.setVdcUri(vdcUri);
        }
        return model;
    }

    private String status(String status) {
        String newStatus = "EXCEPTION";
        switch (status) {
            case "CREATING"://创建中
                newStatus = status;
                break;
            case "DELETING"://删除中
                newStatus = status;
                break;
            case "USE"://可用的
                newStatus = "AVAILABLE";
                break;
            case "RESTORING"://恢复中
                newStatus = status;
                break;
            case "RESTORED"://已恢复；
                newStatus = status;
                break;
            case "SNAPSHOTING"://正在做快照
                newStatus = status;
                break;
            case "FORMATING"://正在格式化
                newStatus = status;
                break;
            case "FORMATFAILED"://格式化失败
                newStatus = status;
                break;
            case "COPYING"://拷贝中；
                newStatus = status;
                break;
            case "COPYFAILED"://拷贝失败；
                newStatus = status;
                break;
            case "MAGRATING"://迁移中
                newStatus = status;
                break;
            case "RESIZING"://扩容中；；
                newStatus = status;
                break;
            case "SHRINKING"://磁盘容量回收中；
                newStatus = status;
                break;
            default:
                newStatus = status;
                break;
        }
        return newStatus;

    }

}