package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.FusionSphereRestApiProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import lombok.extern.slf4j.Slf4j;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: FusionSphereAuthProvider
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/10/25 14:09
 */
@Slf4j
@Provider("bocloud.cmp.fusionsphere")
public class FusionSphereAuthProvider extends FusionSphereRestApiProvider implements AuthProvider {

    public FusionSphereAuthProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult auth() {
        Token authToken = super.getFusionSphereAuthToken();
        if (null != authToken) {
            if(null!=authToken.getAuthToken()){
                return new BocloudResult(true, "认证成功");
            }
        }
        return new BocloudResult(false, "认证失败");
    }
}