package com.bocloud.cmp.provider.storage;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.convertor.UplinkPortAggrConvertor;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.fusionsphere.UplinkPortAggrModel;
import com.bocloud.cmp.provider.FusionSphereRestApiProvider;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.cmp.utils.LogMapUtils;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import lombok.extern.slf4j.Slf4j;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: FusionSphereUplinkPortAggrProvider
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/11/3 20:33
 */
@Slf4j
@Provider("bocloud.cmp.fusionsphere")
public class FusionSphereUplinkPortAggrProvider extends FusionSphereRestApiProvider implements UplinkPortAggrProvider {

    private BeanJsonConvertor<UplinkPortAggrModel> convertor = new UplinkPortAggrConvertor();

    public FusionSphereUplinkPortAggrProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult detail(String aggrUuid) {
        String response = this.request(RequestStatus.GET, aggrUuid, null);
        JSONObject jsonObject = JSONObject.parseObject(response);
        UplinkPortAggrModel model = convertor.convertModel(jsonObject);
        return new BocloudResult(true, model, LogMapUtils.MAP.get(Thread.currentThread().getStackTrace()[1].getMethodName()));
    }


}