package com.bocloud.cmp.utils;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.fusionsphere.TaskModel;
import com.bocloud.cmp.provider.FusionSphereRestApiProvider;
import lombok.extern.slf4j.Slf4j;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: TaskProvider
 * @Description:任务管理
 * @author: zhenpingLi/李振平
 * @date: 2021/10/18 15:03
 */
@Slf4j
public class TaskProvider {

    public static TaskModel get2Task(String taskUri, Butler butler) {
        TaskModel taskModel = new TaskModel(false,"默认失败");
        try {
            Long startTime = System.currentTimeMillis();
            Long endTime = System.currentTimeMillis();
            while (endTime - startTime < 3 * 60 * 60 * 1000) {
                log.info("执行任务查询：{}", taskUri);
                Thread.sleep(5 * 1000);
                taskModel = TaskProvider.taskCon(taskUri, butler);
                log.info("获取任务状态状态：{}", taskModel.getStatus());
                if (taskModel.getStatus().equalsIgnoreCase("success")) {
                    taskModel.setBusinessStatus(true);
                    break;
                } else if (taskModel.getStatus().equalsIgnoreCase("failed")) {
                    taskModel.setBusinessStatus(false);
                    break;
                }
                endTime = System.currentTimeMillis();
            }
        } catch (Exception e) {
            log.error("task error :", e);
        }
        return taskModel;
    }

    public static boolean getTask(String taskUri, Butler butler) {
        boolean taskStatu = false;
        try {
            Long startTime = System.currentTimeMillis();
            Long endTime = System.currentTimeMillis();
            while (endTime - startTime < 3 * 60 * 60 * 1000) {
                log.info("执行任务查询：{}", taskUri);
                Thread.sleep(5 * 1000);
                TaskModel taskModel = TaskProvider.taskCon(taskUri, butler);
                log.info("获取任务状态状态：{}", taskModel.getStatus());
                if (taskModel.getStatus().equalsIgnoreCase("success")) {
                    taskStatu = true;
                    break;
                } else if (taskModel.getStatus().equalsIgnoreCase("failed")) {
                    break;
                }
                endTime = System.currentTimeMillis();
            }
        } catch (Exception e) {
            log.error("task error :", e);
        }
        return taskStatu;
    }

    public static TaskModel taskCon(String taskUri, Butler butler) {
        FusionSphereRestApiProvider provider = new FusionSphereRestApiProvider(butler);
        String request = provider.request(FusionSphereRestApiProvider.RequestStatus.GET, taskUri, null);
        return JSONObject.parseObject(request, TaskModel.class);
    }


}