ALTER TABLE `vdc`
    ADD COLUMN `uri` VARCHAR(128) DEFAULT NULL COMMENT '站点uri';
ALTER TABLE `vdc`
    ADD COLUMN `ip` VARCHAR(32) DEFAULT NULL COMMENT '站点IP';
ALTER TABLE `vdc`
    ADD COLUMN `is_dc` TINYINT(1) DEFAULT NULL COMMENT '是否是域控制器（KVM未支持）';
ALTER TABLE `vdc`
    ADD COLUMN `is_self` TINYINT(1) DEFAULT NULL COMMENT '是否是当前站点';
ALTER TABLE `vdc`
    ADD COLUMN `mgnt_network_type` VARCHAR(16) DEFAULT NULL COMMENT '管理面ip版本，取值ipv4,ipv6';
ALTER TABLE `clusters`
    ADD COLUMN `res_strategy` VARCHAR(32) DEFAULT NULL COMMENT '分配策略 loadBalance: 负载均衡、random: 随机';
ALTER TABLE `clusters`
    ADD COLUMN `arch` VARCHAR(32) DEFAULT NULL COMMENT '集群架构，x86场景为x86,arm场景下为arm';
ALTER TABLE `clusters`
    ADD COLUMN `uri` VARCHAR(128) DEFAULT NULL COMMENT '访问该cluster对应的uri地址';
ALTER TABLE `clusters`
    ADD COLUMN `is_mem_overcommit` TINYINT(1) DEFAULT NULL COMMENT '内存复用开关';
ALTER TABLE `clusters`
    ADD COLUMN `is_enable_ha` TINYINT(1) DEFAULT NULL COMMENT 'HA功能开关';
ALTER TABLE `clusters`
    ADD COLUMN `is_enable_drs` TINYINT(1) DEFAULT NULL COMMENT 'DRS开关';
ALTER TABLE `clusters`
    ADD COLUMN `is_enable_imc` TINYINT(1) DEFAULT NULL COMMENT '异构迁移集群';
ALTER TABLE `clusters`
    ADD COLUMN `enable_guest_numa` TINYINT(1) DEFAULT NULL COMMENT '集群非统一内存访问开关';
ALTER TABLE `clusters`
    ADD COLUMN `enable_io_tailor` TINYINT(1) DEFAULT NULL COMMENT '集群本地内存盘开关';
ALTER TABLE `clusters`
    ADD COLUMN `is_auto_adjust_numa` TINYINT(1) DEFAULT NULL COMMENT '是否开启NUMA结构自动调整';
ALTER TABLE `server`
    ADD COLUMN `uri` VARCHAR(128) DEFAULT NULL COMMENT '访问主机的uri';
ALTER TABLE `data_store`
    ADD COLUMN `storage_device_id` BIGINT(20) DEFAULT NULL COMMENT '存储设备Id';
ALTER TABLE `data_store`
    ADD COLUMN `use_type` INT(8) DEFAULT NULL COMMENT '使用方式';
ALTER TABLE `data_store`
    ADD COLUMN `uri` VARCHAR(128) DEFAULT NULL COMMENT '访问该data_store对应的uri地址';
ALTER TABLE `volume`
    ADD COLUMN `uri` VARCHAR(128) DEFAULT NULL COMMENT '访问该volume对应的uri地址';
ALTER TABLE `volume`
    ADD COLUMN `vdc_id` BIGINT(20) DEFAULT NULL COMMENT '数据中心id';
ALTER TABLE `volume`
    ADD COLUMN `persistent_disk` TINYINT(1) DEFAULT NULL COMMENT '是否持久化磁盘';
ALTER TABLE `volume`
    ADD COLUMN `indep_disk` TINYINT(1) DEFAULT NULL COMMENT '是否为独立磁盘';
ALTER TABLE `volume`
    ADD COLUMN `pci_type` VARCHAR(128) DEFAULT NULL COMMENT '磁盘挂载的总线类型';
ALTER TABLE `volume`
    ADD COLUMN `sequence_num` INT(8) DEFAULT NULL COMMENT '磁盘对应的总线槽位编号';
ALTER TABLE `volume`
    ADD COLUMN `io_mode` VARCHAR(128) DEFAULT NULL COMMENT '磁盘IO模式';
ALTER TABLE `volume`
    ADD COLUMN `access_mode` INT(8) DEFAULT NULL COMMENT '磁盘访问权限';
CREATE TABLE `fusion_sphere_storage_device`
(
    `id`                  BIGINT(20) NOT NULL AUTO_INCREMENT,
    `name`                VARCHAR(128) DEFAULT NULL,
    `status`              VARCHAR(16)  DEFAULT NULL,
    `is_deleted`          TINYINT(1) DEFAULT NULL,
    `creator_id`          BIGINT(20) DEFAULT NULL,
    `mender_id`           BIGINT(20) DEFAULT NULL,
    `owner_id`            BIGINT(20) DEFAULT NULL,
    `gmt_create`          DATETIME     DEFAULT NULL,
    `gmt_modify`          DATETIME     DEFAULT NULL,
    `remark`              VARCHAR(128) DEFAULT NULL,
    `props`               TEXT,
    `vendor_id`           BIGINT(20) DEFAULT NULL,
    `project_id`          BIGINT(20) DEFAULT NULL,
    `tenant_id`           BIGINT(20) DEFAULT NULL,
    `urn`                 VARCHAR(128) DEFAULT NULL,
    `uri`                 VARCHAR(128) DEFAULT NULL,
    `sd_urn`              VARCHAR(128) DEFAULT NULL,
    `storage_resource_id` BIGINT(20) DEFAULT NULL,
    `type`                VARCHAR(64)  DEFAULT NULL,
    `capacity_gb`         INT(8) DEFAULT NULL,
    `refresh_time`        VARCHAR(64)  DEFAULT NULL,
    `is_thin`             TINYINT(1) DEFAULT NULL,
    `wwn`                 VARCHAR(64)  DEFAULT NULL,
    `su_host_id`          INT(8) DEFAULT NULL,
    `san_sn`              VARCHAR(64)  DEFAULT NULL,
    `su_lun_id`           VARCHAR(64)  DEFAULT NULL,
    `support_adl`         INT(8) DEFAULT NULL,
    `host_num`            INT(8) DEFAULT NULL,
    `vdc_id`              BIGINT(20) DEFAULT NULL,
    PRIMARY KEY (`id`)
) ENGINE=INNODB DEFAULT CHARSET=utf8;
CREATE TABLE `fusion_sphere_device_host`
(
    `id`        BIGINT(20) NOT NULL AUTO_INCREMENT,
    `device_id` BIGINT(20) DEFAULT NULL,
    `host_id`   BIGINT(20) DEFAULT NULL,
    PRIMARY KEY (`id`)
)ENGINE=INNODB DEFAULT CHARSET=utf8;
ALTER TABLE `switcher`
    ADD COLUMN `uri` VARCHAR(128) DEFAULT NULL COMMENT '访问该switcher对应的uri地址';
ALTER TABLE `switcher`
    ADD COLUMN `is_igmp_snooping` TINYINT(1) DEFAULT NULL COMMENT '组播';
ALTER TABLE `port`
    ADD COLUMN `vdc_id` BIGINT(20) DEFAULT NULL COMMENT '数据中心id';
ALTER TABLE `port`
    ADD COLUMN `device_id` BIGINT(20) DEFAULT NULL COMMENT '设备ID';
CREATE TABLE `fusion_sphere_vlan_pool`
(
    `id`            BIGINT(20) NOT NULL AUTO_INCREMENT,
    `switcher_id`   BIGINT(20) DEFAULT NULL,
    `start_vlan_id` int(8) DEFAULT NULL,
    `end_vlan_id`   int(8) DEFAULT NULL,
    PRIMARY KEY (`id`)
) ENGINE=INNODB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
ALTER TABLE `port_group`
    ADD COLUMN `uri` VARCHAR(128) DEFAULT NULL COMMENT '访问该vm对应的uri地址';
ALTER TABLE `port_group`
    ADD COLUMN `is_ip_mac_bind` TINYINT(1) DEFAULT NULL COMMENT '/是否设置该端口组内的云主机的IP地址与MAC地址绑定';
ALTER TABLE `port_group`
    ADD COLUMN `ip_bcst_suppress` INT(8) DEFAULT NULL COMMENT '广播抑制：0表示未开启';
ALTER TABLE `port_group`
    ADD COLUMN `is_calc_tcp_check_sum` TINYINT(1) DEFAULT NULL COMMENT '填充tcp校检和：false表示关闭';
ALTER TABLE `port_group`
    ADD COLUMN `is_dhcp_isolation` TINYINT(1) DEFAULT NULL COMMENT 'dhcp隔离：false表示关闭';
ALTER TABLE `network_card`
    ADD COLUMN `enable_security_group` TINYINT(1) DEFAULT NULL COMMENT '云主机网卡是否开启安全组';
ALTER TABLE `network_card`
    ADD COLUMN `security_group_id` BIGINT(20) DEFAULT NULL COMMENT '安全组Id';
ALTER TABLE `network_card`
    ADD COLUMN `port_group_id` BIGINT(20) DEFAULT NULL COMMENT '端口组ID';
ALTER TABLE `network_card`
    ADD COLUMN `type` VARCHAR(32) DEFAULT NULL COMMENT '类型';
ALTER TABLE `network_card`
    ADD COLUMN `vringbuf` int(8) DEFAULT NULL COMMENT 'IO环大小';
ALTER TABLE `network_card`
    ADD COLUMN `queues` int(8) DEFAULT NULL COMMENT '队列数';
ALTER TABLE `network_card`
    ADD COLUMN `uri` VARCHAR(128) DEFAULT NULL COMMENT 'uri';
ALTER TABLE `network_card`
    ADD COLUMN `server_id` BIGINT(20)DEFAULT NULL COMMENT 'server_id';
ALTER TABLE `server_sgroup`
    ADD COLUMN `nic_id` BIGINT(20) DEFAULT NULL COMMENT '网卡ID（networkCard）';
ALTER TABLE security_group_rule
    ADD COLUMN ip_ranges VARCHAR(64) DEFAULT NULL;
ALTER TABLE security_group_rule
    ADD COLUMN ip_version VARCHAR(64) DEFAULT NULL;
ALTER TABLE security_group_rule
    ADD COLUMN type VARCHAR(64) DEFAULT NULL;
ALTER TABLE `snapshot`
    ADD COLUMN `uri` VARCHAR(128) DEFAULT NULL COMMENT 'uri';
ALTER TABLE `cloud_server`
    ADD COLUMN `is_binding_host` TINYINT(1) DEFAULT NULL COMMENT '是否与主机绑定';
ALTER TABLE `cloud_server`
    ADD COLUMN `uri` VARCHAR(128) DEFAULT NULL COMMENT '访问该vm对应的uri地址';
ALTER TABLE `security_group`
    ADD COLUMN `vdc_id` BIGINT(20) DEFAULT NULL COMMENT '数据中心id';
CREATE TABLE `fusion_sphere_host_port`
(
    `id`              BIGINT(20) NOT NULL AUTO_INCREMENT,
    `name`            VARCHAR(128) DEFAULT NULL,
    `status`          VARCHAR(16)  DEFAULT NULL,
    `is_deleted`      TINYINT(1) DEFAULT NULL,
    `creator_id`      BIGINT(20) DEFAULT NULL,
    `mender_id`       BIGINT(20) DEFAULT NULL,
    `owner_id`        BIGINT(20) DEFAULT NULL,
    `gmt_create`      DATETIME     DEFAULT NULL,
    `gmt_modify`      DATETIME     DEFAULT NULL,
    `remark`          VARCHAR(128) DEFAULT NULL,
    `props`           TEXT,
    `host_id`         BIGINT(20) DEFAULT NULL,
    `port_uuid`       VARCHAR(128) DEFAULT NULL,
    `uri`             VARCHAR(128) DEFAULT NULL,
    `flag`            int(8) DEFAULT NULL,
    `is_used`         VARCHAR(16)  DEFAULT NULL,
    `bind_status`     VARCHAR(64)  DEFAULT NULL,
    `speed`           INT(8) DEFAULT NULL,
    `strategy`        VARCHAR(64)  DEFAULT NULL,
    `nic_id`          BIGINT(20) DEFAULT NULL,
    `nic_mode`        VARCHAR(64)  DEFAULT NULL,
    `system_intf_num` INT(8) DEFAULT NULL,
    `dvs_id`          BIGINT(20) DEFAULT NULL,
    `nic_speed`       INT(8) DEFAULT NULL,
    `driver_mode`     VARCHAR(64)  DEFAULT NULL,
    `numa_node`       INT(8) DEFAULT NULL,
    `vendor_id`       BIGINT(20) DEFAULT NULL,
    PRIMARY KEY (`id`)
) ENGINE=INNODB DEFAULT CHARSET=utf8;
CREATE TABLE `fusion_sphere_up_link`
(
    `id`          BIGINT(20) NOT NULL AUTO_INCREMENT,
    `host_id`     BIGINT(20) DEFAULT NULL,
    `port_id`     BIGINT(20) DEFAULT NULL,
    `switcher_id` BIGINT(20) DEFAULT NULL,
    `vendor_id`   BIGINT(20) DEFAULT NULL,
    `status`      VARCHAR(32) DEFAULT NULL,
    PRIMARY KEY (`id`)
) ENGINE=INNODB DEFAULT CHARSET=utf8;
CREATE TABLE `fusion_sphere_up_link_port`
(
    `id`             BIGINT(20) NOT NULL AUTO_INCREMENT,
    `host_id`        BIGINT(20) DEFAULT NULL,
    `port_id`        BIGINT(20) DEFAULT NULL,
    `switcher_id`    BIGINT(20) DEFAULT NULL,
    `vendor_id`      BIGINT(20) DEFAULT NULL,
    `status`         VARCHAR(32)  DEFAULT NULL,
    `port_aggr_uuid` VARCHAR(128) DEFAULT NULL,
    PRIMARY KEY (`id`)
) ENGINE=INNODB DEFAULT CHARSET=utf8;
CREATE TABLE `fusion_sphere_os_version`
(
    `id`              BIGINT(20) NOT NULL AUTO_INCREMENT,
    `os_version_uuid` VARCHAR(64)  DEFAULT NULL,
    `version_des`     VARCHAR(256) DEFAULT NULL,
    `os_type`         VARCHAR(64)  DEFAULT NULL,
    `vdc_id`          BIGINT(20) DEFAULT NULL,
    `vendor_id`       BIGINT(20) DEFAULT NULL,
    PRIMARY KEY (`id`)
) ENGINE=INNODB DEFAULT CHARSET=utf8;
ALTER TABLE `server`
    ADD COLUMN `arch` VARCHAR(32) DEFAULT NULL;
ALTER TABLE `fusion_sphere_host_port`
    ADD COLUMN `parent_id` BIGINT(20) DEFAULT NULL;
ALTER TABLE `port_group`
    ADD COLUMN `vlan_range` VARCHAR(256) DEFAULT NULL;
ALTER TABLE `cloud_server`
    ADD COLUMN `arch` VARCHAR(32) DEFAULT NULL;
ALTER TABLE `cloud_server`
    ADD COLUMN `cd_rom_status` VARCHAR(32) DEFAULT NULL;
ALTER TABLE `permission` MODIFY COLUMN service_codes VARCHAR (1024);
ALTER TABLE `snapshot`
    ADD COLUMN `need_memory_shot` TINYINT(1) DEFAULT NULL;
ALTER TABLE `snapshot`
    ADD COLUMN `is_consistent` TINYINT(1) DEFAULT NULL;
ALTER TABLE `volume`
    ADD COLUMN `category_id` BIGINT(20) DEFAULT NULL COMMENT '服务类型id';

-- 字典配置
insert into `dictionary` (`id`, `name`, `value`, `pid`, `weight`)
values ('993', 'FusionSphere', 'FUSIONSPHERE', '558', '1');
insert into `dictionary` (`id`, `name`, `value`, `pid`, `weight`)
values ('994', 'FC', 'FUSIONSPHERE', '895', '1');
insert into `dictionary` (`id`, `name`, `value`, `pid`, `weight`)
values ('995', 'FC', 'FUSIONSPHERE', '896', '1');

-- 添加菜单
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11622', 'FusionSphere', NULL, '53', '2021-10-28 15:07:18', '2021-11-09 17:44:54', '37', '37', 'NORMAL', '0',
        NULL, NULL, 'fusionSphere', NULL, 'view', '1', '0', 'FUSIONSPHERE', 'vendorHeader', 'fusionSphere/vdc',
        '[{\"key\":\"vendorType\",\"value\":\"FUSIONSPHERE\"}]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11623', '站点', NULL, '11622', '2021-10-28 15:08:55', '2021-10-28 15:08:55', '37', NULL, 'NORMAL', '0', NULL,
        NULL, 'vdc', NULL, 'menu', '1', '0', NULL, 'FCVdc', NULL, '[]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11624', '集群', NULL, '11622', '2021-10-28 15:09:37', '2021-10-28 15:09:37', '37', NULL, 'NORMAL', '0', NULL,
        NULL, 'cluster', NULL, 'menu', '2', '0', NULL, 'FCCluster', NULL, '[]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11625', '主机', NULL, '11622', '2021-10-28 15:10:07', '2021-11-05 15:20:45', '37', '38', 'NORMAL', '0', NULL,
        NULL, 'host', NULL, 'menu', '1', '0', 'FCHost', 'FCHost', NULL, '[]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11626', '云主机', NULL, '11622', '2021-10-28 15:10:34', '2021-11-05 15:21:08', '37', '38', 'NORMAL', '0', NULL,
        NULL, 'vm', NULL, 'menu', '4', '0', 'FCVm', 'FCVm', NULL, '[]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11627', '快照', NULL, '11622', '2021-10-28 15:11:20', '2021-10-28 15:11:20', '37', NULL, 'NORMAL', '0', NULL,
        NULL, 'snapshot', NULL, 'menu', '5', '0', NULL, 'FCSnapshot', NULL, '[]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11628', '存储设备', NULL, '11622', '2021-10-28 15:11:55', '2021-10-28 15:11:55', '37', NULL, 'NORMAL', '0', NULL,
        NULL, 'store_device', NULL, 'menu', '6', '0', NULL, 'FCStoreDevice', NULL, '[]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11629', '数据存储', NULL, '11622', '2021-10-28 15:12:26', '2021-10-28 15:12:26', '37', NULL, 'NORMAL', '0', NULL,
        NULL, 'data_store', NULL, 'menu', '7', '0', NULL, 'FCDataStore', NULL, '[]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11630', '安全组', NULL, '11622', '2021-10-28 15:13:04', '2021-10-28 15:13:04', '37', NULL, 'NORMAL', '0', NULL,
        NULL, 'sgroup', NULL, 'menu', '8', '0', NULL, 'FCSgroup', NULL, '[]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11631', '交换机', NULL, '11622', '2021-10-28 15:13:59', '2021-10-28 15:14:32', '37', '37', 'NORMAL', '0', NULL,
        NULL, 'switch', NULL, 'menu', '9', '0', NULL, 'FCSwitch', NULL, '[]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11632', '上行链路组', NULL, '11622', '2021-10-29 15:50:17', '2021-11-02 09:15:43', '38', '38', 'NORMAL', '1', NULL,
        NULL, 'uplinkPort', NULL, 'menu', '9', '0', 'UplinkPort', 'FCUplinkPort', NULL, '[]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11633', '创建FC云主机', NULL, '53', '2021-11-03 10:51:31', '2021-11-03 10:53:10', '37', '37', 'NORMAL', '1', NULL,
        NULL, 'fc_vm_add/:id', NULL, 'menu', '20', '0', 'FcVmAdd', 'FcVmAdd', NULL, '[]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11634', '新增FusionSphere云主机', NULL, '53', '2021-11-03 11:22:43', '2021-11-11 17:56:28', '37', '37', 'NORMAL',
        '0', NULL, NULL, 'fusionComputer_vm_add/:id', NULL, 'view', '42', '0', 'FusionComputerVmAdd',
        'FusionComputerVmAdd', NULL, '[]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11635', '新增FC云主机', NULL, '53', '2021-11-03 13:52:25', '2021-11-03 14:47:38', '38', '38', 'NORMAL', '1', NULL,
        NULL, 'fc_server/:id', NULL, 'view', '99', '0', 'fcServer', 'FCServerAdd', NULL,
        '[{\"key\":\"noTag\",\"value\":\"true\"}]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11636', '云主机模板', NULL, '11622', '2021-11-11 17:42:54', '2021-11-11 17:42:54', '37', NULL, 'NORMAL', '0', NULL,
        NULL, 'vm_template', NULL, 'menu', '10', '0', 'FusionSphereVmTpl', 'FusionSphereVmTpl', NULL, '[]', '[]', NULL);
insert into `permission` (`id`, `name`, `remark`, `parent_id`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`,
                          `status`, `is_deleted`, `owner_id`, `props`, `path`, `icon`, `category`, `priority`,
                          `is_tenant`, `router`, `component`, `redirect`, `meta`, `params`, `service_codes`)
values ('11637', '新增FusionSphere云主机', NULL, '53', '2021-11-11 17:58:24', '2021-11-11 18:07:11', '37', '37', 'NORMAL',
        '0', NULL, NULL, 'templat-server/:id/:templateId', NULL, 'view', '43', '0', 'FusionSphereVmAddByTpl',
        'FusionSphereVmAddByTpl', NULL, '[]', '[]', NULL);

-- 插入失败 手动给管理员授权菜单
insert into `role_permission` (`id`, `role_id`, `permission_id`)
values ('283016', '1', '11622');
insert into `role_permission` (`id`, `role_id`, `permission_id`)
values ('283017', '1', '11623');
insert into `role_permission` (`id`, `role_id`, `permission_id`)
values ('283018', '1', '11625');
insert into `role_permission` (`id`, `role_id`, `permission_id`)
values ('283019', '1', '11624');
insert into `role_permission` (`id`, `role_id`, `permission_id`)
values ('283020', '1', '11626');
insert into `role_permission` (`id`, `role_id`, `permission_id`)
values ('283021', '1', '11627');
insert into `role_permission` (`id`, `role_id`, `permission_id`)
values ('283022', '1', '11628');
insert into `role_permission` (`id`, `role_id`, `permission_id`)
values ('283023', '1', '11629');
insert into `role_permission` (`id`, `role_id`, `permission_id`)
values ('283024', '1', '11630');
insert into `role_permission` (`id`, `role_id`, `permission_id`)
values ('283025', '1', '11631');
insert into `role_permission` (`id`, `role_id`, `permission_id`)
values ('283026', '1', '11636');
insert into `role_permission` (`id`, `role_id`, `permission_id`)
values ('283232', '1', '11637');
-- 服务目录

INSERT INTO cloud_service(name, code, catalog_id, sn, billable, bill_policy, basic_price, discount, vendor_type, status,
                          gmt_create, gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, icon_id,
                          template_name, unit, template_id, is_reserved, is_public)
SELECT 'FusionSphere云主机',
       'fusionsphere.standard.server',
       1,
       max(id),
       1,
       'agility',
       '[{\"name\":\"CPU\",\"spec\":\"核\",\"number\":1,\"hourPrice\":1,\"monthPrice\":1,\"yearPrice\":1,\"specName\":\"cpu\"},{\"name\":\"内存\",\"spec\":\"GB\",\"number\":1,\"hourPrice\":1,\"monthPrice\":1,\"yearPrice\":1,\"specName\":\"memory\"}]',
       1.000,
       'FUSIONSPHERE',
       'PUBLISHED',
       '2021-11-08 11:10:29',
       '2021-11-25 14:35:40',
       2,
       9,
       NULL,
       0,
       '云主机是由CPU、内存、磁盘等虚拟化资源组成的随时可获取、弹性可扩展、按需使用的虚拟的计算服务器。同时它结合虚拟私有云、备份服务等，为用户打造一个高效、可靠、安全的计算环境，确保服务持久稳定运行。',
       NULL,
       198,
       NULL,
       '台',
       NULL,
       NULL,
       0
FROM cloud_service;

INSERT INTO cloud_service(name, code, catalog_id, sn, billable, bill_policy, basic_price, discount, vendor_type, status,
                          gmt_create, gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, icon_id,
                          template_name, unit, template_id, is_reserved, is_public)
SELECT 'FusionSphere云硬盘',
       'fusionsphere.standard.volume',
       2,
       max(id),
       1,
       'agility',
       '[{\"name\":\"磁盘\",\"spec\":\"GB\",\"number\":1,\"hourPrice\":1,\"monthPrice\":1,\"yearPrice\":1,\"specName\":\"disk\"}]',
       1.000,
       'FUSIONSPHERE',
       'PUBLISHED',
       '2021-11-08 11:29:55',
       '2021-11-30 14:33:13',
       2,
       9,
       NULL,
       0,
       'FusionSphere平台下，云主机硬盘服务',
       NULL,
       199,
       NULL,
       '个',
       NULL,
       NULL,
       0
FROM cloud_service;

--  service_category 注意code必须完全相同，因为前端需要针对code做出操作
--  注意：service_id需要与cloud_service对应的id一致

INSERT INTO service_category(service_id, name, code, status, gmt_create, gmt_modify, creator_id, mender_id, owner_id,
                             is_deleted, remark, props, is_reserved, sn)
SELECT id,
       '标准型',
       'fusionsphere.standard.amount',
       NULL,
       '2021-11-08 11:23:54',
       '2021-11-23 14:35:14',
       2,
       2,
       NULL,
       0,
       NULL,
       NULL,
       0,
       (SELECT max(id) FROM service_category)
FROM cloud_service
WHERE name = 'FusionSphere云主机';

INSERT INTO service_category(service_id, name, code, status, gmt_create, gmt_modify, creator_id, mender_id, owner_id,
                             is_deleted, remark, props, is_reserved, sn)
SELECT id,
       '从属',
       'PERSISTENT',
       NULL,
       '2021-11-09 11:33:36',
       '2021-11-09 11:33:36',
       2,
       1,
       NULL,
       0,
       '从属：indepDisk：false /persistentDisk : true',
       NULL,
       0,
       (SELECT max(id) FROM service_category)
FROM cloud_service
WHERE name = 'FusionSphere云硬盘';

INSERT INTO service_category(service_id, name, code, status, gmt_create, gmt_modify, creator_id, mender_id, owner_id,
                             is_deleted, remark, props, is_reserved, sn)
SELECT id,
       '独立-持久',
       'INDEPPERSISTENT',
       NULL,
       '2021-11-09 11:33:36',
       '2021-11-09 11:33:36',
       2,
       1,
       NULL,
       0,
       '独立-持久：indepDisk：true/persistentDisk : true',
       NULL,
       0,
       (SELECT max(id) FROM service_category)
FROM cloud_service
WHERE name = 'FusionSphere云硬盘';

INSERT INTO service_category(service_id, name, code, status, gmt_create, gmt_modify, creator_id, mender_id, owner_id,
                             is_deleted, remark, props, is_reserved, sn)
SELECT id,
       '独立-非持久',
       'INDEP',
       NULL,
       '2021-11-09 11:33:36',
       '2021-11-09 11:33:36',
       2,
       1,
       NULL,
       0,
       '独立-非持久：indepDisk：true/persistentDisk : false',
       NULL,
       0,
       (SELECT max(id) FROM service_category)
FROM cloud_service
WHERE name = 'FusionSphere云硬盘';

-- servicesku 内置数据可以视情况添加

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'fusionsphere.standard.1',
       b.id,
       '[{\"unit\":\"核\",\"specName\":\"cpu\",\"displayName\":\"CPU\",\"specValue\":\"2\"},{\"unit\":\"GB\",\"specName\":\"memory\",\"displayName\":\"内存\",\"specValue\":\"2\"}]',
       NULL,
       'enable',
       '2021-11-08 11:24:46',
       '2021-11-09 14:40:53',
       2,
       NULL,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'fusionsphere-1001',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云主机'
  AND b.name = '标准型';

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'fusionsphere.standard.2',
       b.id,
       '[{\"unit\":\"核\",\"specName\":\"cpu\",\"displayName\":\"CPU\",\"specValue\":\"2\"},{\"unit\":\"GB\",\"specName\":\"memory\",\"displayName\":\"内存\",\"specValue\":\"4\"}]',
       NULL,
       'enable',
       '2021-11-08 11:24:46',
       '2021-11-09 14:40:53',
       2,
       NULL,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'fusionsphere-1002',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云主机'
  AND b.name = '标准型';

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'FUSIONSPHERE-PERSISTENT-10',
       b.id,
       '[{\"unit\":\"GB\",\"specName\":\"disk\",\"displayName\":\"磁盘\",\"specValue\":\"10\"}]',
       NULL,
       'enable',
       '2021-11-09 11:35:23',
       '2021-11-09 14:43:13',
       1,
       1,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'FUSIONSPHERE-PERSISTENT-10',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云硬盘'
  AND b.name = '从属';

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'FUSIONSPHERE-PERSISTENT-20',
       b.id,
       '[{\"unit\":\"GB\",\"specName\":\"disk\",\"displayName\":\"磁盘\",\"specValue\":\"20\"}]',
       NULL,
       'enable',
       '2021-11-09 11:35:23',
       '2021-11-09 14:43:13',
       1,
       1,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'FUSIONSPHERE-PERSISTENT-20',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云硬盘'
  AND b.name = '从属';

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'FUSIONSPHERE-PERSISTENT-50',
       b.id,
       '[{\"unit\":\"GB\",\"specName\":\"disk\",\"displayName\":\"磁盘\",\"specValue\":\"50\"}]',
       NULL,
       'enable',
       '2021-11-09 11:35:23',
       '2021-11-09 14:43:13',
       1,
       1,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'FUSIONSPHERE-PERSISTENT-50',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云硬盘'
  AND b.name = '从属';

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'FUSIONSPHERE-PERSISTENT-80',
       b.id,
       '[{\"unit\":\"GB\",\"specName\":\"disk\",\"displayName\":\"磁盘\",\"specValue\":\"80\"}]',
       NULL,
       'enable',
       '2021-11-09 11:35:23',
       '2021-11-09 14:43:13',
       1,
       1,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'FUSIONSPHERE-PERSISTENT-80',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云硬盘'
  AND b.name = '从属';

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'FUSIONSPHERE-INDEPPERSISTENT-10',
       b.id,
       '[{\"unit\":\"GB\",\"specName\":\"disk\",\"displayName\":\"磁盘\",\"specValue\":\"10\"}]',
       NULL,
       'enable',
       '2021-11-09 11:35:23',
       '2021-11-09 14:43:13',
       1,
       1,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'FUSIONSPHERE-INDEPPERSISTENT-10',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云硬盘'
  AND b.name = '独立-持久';

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'FUSIONSPHERE-INDEPPERSISTENT-20',
       b.id,
       '[{\"unit\":\"GB\",\"specName\":\"disk\",\"displayName\":\"磁盘\",\"specValue\":\"20\"}]',
       NULL,
       'enable',
       '2021-11-09 11:35:23',
       '2021-11-09 14:43:13',
       1,
       1,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'FUSIONSPHERE-INDEPPERSISTENT-20',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云硬盘'
  AND b.name = '独立-持久';

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'FUSIONSPHERE-INDEPPERSISTENT-50',
       b.id,
       '[{\"unit\":\"GB\",\"specName\":\"disk\",\"displayName\":\"磁盘\",\"specValue\":\"50\"}]',
       NULL,
       'enable',
       '2021-11-09 11:35:23',
       '2021-11-09 14:43:13',
       1,
       1,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'FUSIONSPHERE-INDEPPERSISTENT-50',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云硬盘'
  AND b.name = '独立-持久';

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'FUSIONSPHERE-INDEPPERSISTENT-80',
       b.id,
       '[{\"unit\":\"GB\",\"specName\":\"disk\",\"displayName\":\"磁盘\",\"specValue\":\"80\"}]',
       NULL,
       'enable',
       '2021-11-09 11:35:23',
       '2021-11-09 14:43:13',
       1,
       1,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'FUSIONSPHERE-INDEPPERSISTENT-80',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云硬盘'
  AND b.name = '独立-持久';

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'FUSIONSPHERE-INDEP-10',
       b.id,
       '[{\"unit\":\"GB\",\"specName\":\"disk\",\"displayName\":\"磁盘\",\"specValue\":\"10\"}]',
       NULL,
       'enable',
       '2021-11-09 11:35:23',
       '2021-11-09 14:43:13',
       1,
       1,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'FUSIONSPHERE-INDEP-10',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云硬盘'
  AND b.name = '独立-非持久';

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'FUSIONSPHERE-INDEP-20',
       b.id,
       '[{\"unit\":\"GB\",\"specName\":\"disk\",\"displayName\":\"磁盘\",\"specValue\":\"20\"}]',
       NULL,
       'enable',
       '2021-11-09 11:35:23',
       '2021-11-09 14:43:13',
       1,
       1,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'FUSIONSPHERE-INDEP-20',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云硬盘'
  AND b.name = '独立-非持久';

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'FUSIONSPHERE-INDEP-50',
       b.id,
       '[{\"unit\":\"GB\",\"specName\":\"disk\",\"displayName\":\"磁盘\",\"specValue\":\"50\"}]',
       NULL,
       'enable',
       '2021-11-09 11:35:23',
       '2021-11-09 14:43:13',
       1,
       1,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'FUSIONSPHERE-INDEP-50',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云硬盘'
  AND b.name = '独立-非持久';

INSERT INTO service_sku(sn, catalog_id, service_id, service_code, code, category_id, spec, name, status, gmt_create,
                        gmt_modify, creator_id, mender_id, owner_id, is_deleted, remark, props, is_reserved,
                        tariff_code, hour_price, month_price, year_price)
SELECT (SELECT max(id) FROM service_sku),
       a.catalog_id,
       a.id,
       a.code,
       'FUSIONSPHERE-INDEP-80',
       b.id,
       '[{\"unit\":\"GB\",\"specName\":\"disk\",\"displayName\":\"磁盘\",\"specValue\":\"80\"}]',
       NULL,
       'enable',
       '2021-11-09 11:35:23',
       '2021-11-09 14:43:13',
       1,
       1,
       NULL,
       0,
       NULL,
       NULL,
       NULL,
       'FUSIONSPHERE-INDEP-80',
       NULL,
       NULL,
       NULL
FROM cloud_service a
         JOIN service_category b ON a.id = b.service_id
WHERE a.name = 'FusionSphere云硬盘'
  AND b.name = '独立-非持久';

-- order_sn
INSERT INTO order_sn(catalog_id, service_id, category_id, sku_id, catalog_sn, service_sn, category_sn, sku_sn,
                     current_num)
SELECT a.catalog_id,
       a.service_id,
       a.category_id,
       a.id,
       b.sn,
       c.sn,
       d.sn,
       a.sn,
       0
FROM service_sku a
         JOIN service_catalog b ON a.catalog_id = b.id
         JOIN cloud_service c ON a.service_id = c.id
         JOIN service_category d ON a.category_id = d.id
WHERE c.name IN ('FusionSphere云主机', 'FusionSphere云硬盘');
-- 测试数据
-- insert into `ip_pool` (`id`, `name`, `gmt_create`, `gmt_modify`, `creator_id`, `mender_id`, `owner_id`, `props`, `remark`, `is_deleted`, `status`, `pools`, `cidr`, `gateway`, `dns_names`, `vendor_id`, `network_id`, `subnet_id`, `vlan_id`, `version`, `router_port_id`, `port_group_id`, `segment_id`) values('377','lzpPool','2021-11-15 18:29:02','2021-11-15 18:29:02','1','1',NULL,NULL,NULL,'0',NULL,'[\"10.40.20.229-10.40.20.234\"]','10.40.20.0/24','10.40.20.254','[\"114.114.114.114\"]',NULL,NULL,NULL,NULL,'V4',NULL,NULL,NULL);
-- insert into `ip` (`id`, `ip`, `mask`, `gateway`, `dns`, `vendor_id`, `resource_id`, `target`, `catalog`, `subnet_id`, `network_id`, `pool_id`, `gmt_create`, `status`, `remark`) values('3800','10.40.20.229','255.255.255.0','10.40.20.254','114.114.114.114','58',NULL,NULL,'VM',NULL,NULL,'377','2021-11-15 19:07:14','free',NULL);
-- insert into `ip` (`id`, `ip`, `mask`, `gateway`, `dns`, `vendor_id`, `resource_id`, `target`, `catalog`, `subnet_id`, `network_id`, `pool_id`, `gmt_create`, `status`, `remark`) values('3801','10.40.20.230','255.255.255.0','10.40.20.254','114.114.114.114','58',NULL,NULL,'VM',NULL,NULL,'377','2021-11-15 19:07:14','free',NULL);
-- insert into `ip` (`id`, `ip`, `mask`, `gateway`, `dns`, `vendor_id`, `resource_id`, `target`, `catalog`, `subnet_id`, `network_id`, `pool_id`, `gmt_create`, `status`, `remark`) values('3802','10.40.20.231','255.255.255.0','10.40.20.254','114.114.114.114','58',NULL,NULL,'VM',NULL,NULL,'377','2021-11-15 19:07:14','free',NULL);
-- insert into `ip` (`id`, `ip`, `mask`, `gateway`, `dns`, `vendor_id`, `resource_id`, `target`, `catalog`, `subnet_id`, `network_id`, `pool_id`, `gmt_create`, `status`, `remark`) values('3803','10.40.20.232','255.255.255.0','10.40.20.254','114.114.114.114','58',NULL,NULL,'VM',NULL,NULL,'377','2021-11-15 19:07:14','free',NULL);
-- insert into `ip` (`id`, `ip`, `mask`, `gateway`, `dns`, `vendor_id`, `resource_id`, `target`, `catalog`, `subnet_id`, `network_id`, `pool_id`, `gmt_create`, `status`, `remark`) values('3804','10.40.20.233','255.255.255.0','10.40.20.254','114.114.114.114','58',NULL,NULL,'VM',NULL,NULL,'377','2021-11-15 19:07:14','free',NULL);
-- insert into `ip` (`id`, `ip`, `mask`, `gateway`, `dns`, `vendor_id`, `resource_id`, `target`, `catalog`, `subnet_id`, `network_id`, `pool_id`, `gmt_create`, `status`, `remark`) values('3805','10.40.20.234','255.255.255.0','10.40.20.254','114.114.114.114','58',NULL,NULL,'VM',NULL,NULL,'377','2021-11-15 19:07:14','free',NULL);
