package com.bocloud.cmp.provider.builder;

import org.w3c.dom.Element;

import com.bocloud.cmp.model.NetworkModel;
import com.bocloud.cmp.model.h3c.H3cNetWorkModel;
import com.bocloud.cmp.model.h3c.utils.ElementUtils;

public class H3cNetworkModelBuilder extends H3cBasicBuilder {

    private H3cNetWorkModel h3cNetworkModel = null;

    @Override
    public H3cBasicBuilder initByModel(Object model) {
        if (model == null) {
            return null;
        } else if (model instanceof H3cNetWorkModel) {
            h3cNetworkModel = (H3cNetWorkModel) model;
            return this;
        } else if (model instanceof NetworkModel) {
            // 将公共模型转h3c模型
//            NetworkModel networkModel = (NetworkModel) model;
//            this.h3cNetworkModel = new H3cNetWorkModel();
//            // FIXME
//            h3cNetworkModel.setDeviceModel(networkModel.getType());
//            //FIXME
//            h3cNetworkModel.setVsId(Long.parseLong(networkModel.getNetworkUuid()));
//            //FIXME
//            h3cNetworkModel.setVsName(networkModel.getName());
//            h3cNetworkModel.setProfileId(Long.parseLong(networkModel.getSegmentationId()));
//            h3cNetworkModel.setIsKernelAccelerated(0);
//            h3cNetworkModel.setIpAddr(networkModel.getNetworkVal());
            return this;
        }
        return null;
    }

    @Override
    protected Object getModel() {
        return this.h3cNetworkModel;
    }


    public void addElementToCreateVmXml(Element domain) {
        Element network = ElementUtils.addChild(domain, "network", null);
        // 网卡设备型号，枚举值：rtl8139：普通网卡;virtio：Virtio网卡;e1000：Intel
        // e1000网卡。
        addElement(network, "deviceModel");
        // 虚拟交换机id。
        addElement(network, "vsId");
        // 虚拟交换机名称。
        addElement(network, "vsName");
        // 网络策略模板id。
        addElement(network, "profileId");
        // 是否设置内核加速，枚举值：1：代表设置内核加速，0：代表不设置。
        addElement(network, "isKernelAccelerated");
        // 网卡绑定IP地址。
        addElement(network, "ipAddr");
        domain.appendChild(network);
    }
}
