package com.bocloud.cmp.provider.builder;

import org.w3c.dom.Element;

import com.bocloud.cmp.model.h3c.H3cStorageModel;
import com.bocloud.cmp.model.h3c.utils.ElementUtils;

public class H3cStorageModelBuilder extends H3cBasicBuilder {

    private H3cStorageModel h3CStorageModel = null;

    @Override
    public H3cBasicBuilder initByModel(Object model) {
        if (model == null) {
            return null;
        } else if (model instanceof H3cStorageModel) {
            this.h3CStorageModel = (H3cStorageModel) model;
            return this;
        }
        return null;
    }

    @Override
    protected Object getModel() {
        return this.h3CStorageModel;
    }


    public void addElementToCreateVmXml(Element domain) {
        Element storage = ElementUtils.addChild(domain, "storage", null);
        // 存储类型，枚举值：disk：硬盘， cdrom：光驱， floppy：软驱。
        addElement(storage, "device");
        // 存储设备类型，枚举值：ide：IDE硬盘， scsi：SCSI硬盘， usb：USB硬盘;，virtio：Virtio
        addElement(storage, "targetBus");

        // 存储文件路径,当增加软驱时，若值为autoVirtio，则根据操作系统类型自动加载一个软驱设备。
        addElement(storage, "storeFile");
        // 磁盘缓存方，枚举值：directsync，writethrough，writeback，none
        addElement(storage, "cacheType");
        // 分配类型:0指定 1动态分配。
        addElement(storage, "assignType");
        // 类型。枚举值：file 文件， block 块设备。
        addElement(storage, "type");
        // 存储卷类型，必须和使用的存储卷的类型保持一致，枚举值：qcow2，raw
        addElement(storage, "driveType");

        addElement(storage, "capacity");
        domain.appendChild(storage);
    }
}
