package com.bocloud.cmp.provider.builder;

import org.w3c.dom.Element;

import com.bocloud.cmp.model.VolumeModel;
import com.bocloud.cmp.model.h3c.H3cVolumeModel;
import com.bocloud.cmp.model.h3c.utils.ElementUtils;

public class H3cVolumeModelBuilder extends H3cBasicBuilder {

    private H3cVolumeModel h3cVolumeModel = null;

    @Override
    public H3cBasicBuilder initByModel(Object model) {
        if (model == null) {
            return null;
        } else if (model instanceof VolumeModel) {
            // 将公共模型转h3c模型
            VolumeModel volumeModel = (VolumeModel) model;
            H3cVolumeModel h3cVolumeModel = new H3cVolumeModel();
            //FIXME
            h3cVolumeModel.setHostId(Long.valueOf(volumeModel.getInstanceId()));
            //FIXME
            h3cVolumeModel.setSpName(volumeModel.getRemark());
            h3cVolumeModel.setVolName(volumeModel.getName());
            h3cVolumeModel.setCapacity(Long.valueOf(volumeModel.getSize()));
            h3cVolumeModel.setFormat(volumeModel.getCategory());
            h3cVolumeModel.setBaseFile("/vms/" + volumeModel.getName());
            //FIXME
//            h3cVolumeModel.setBaseFile(volumeModel.getBaseFile);
            this.h3cVolumeModel = h3cVolumeModel;
            return this;
        }
        return null;
    }

    @Override
    protected Object getModel() {
        return this.h3cVolumeModel;
    }


    public String buildCreateXml() {
        if (this.h3cVolumeModel == null) {
            return "";
        }
        try {
            Element domain = ElementUtils.creatRoot("volAddParameter");
            // 指定存储池所在的主机 ID。
            addElement(domain, "hostId");
            // 存储池名称。
            addElement(domain, "spName");
            // 存储卷名称。
            addElement(domain, "volName");
            // 存储卷的最大容量。
            addElement(domain, "capacity");
            //存储卷的格式：支持raw和qcow2格式。
            addElement(domain, "format");

            return ElementUtils.toFormatedXML(domain);
        } catch (Exception e) {
            logger.error("", e);
        }
        return null;
    }


}
