package com.bocloud.cmp.provider.common;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.h3c.entity.RsCommList;
import com.bocloud.cmp.model.h3c.entity.RsHost;
import com.bocloud.cmp.model.h3c.utils.RestUtil;
import com.bocloud.cmp.provider.H3cProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

/**
 * 华三认证
 * 
 * @author ymh
 *
 */
@Provider("bocloud.cmp.h3c")
public class H3cAuthProvider extends H3cProvider implements AuthProvider {

	private static Logger logger = LoggerFactory.getLogger(H3cAuthProvider.class);

	public H3cAuthProvider(Butler butler) {
		super(butler);
	}

	@Override
	public BocloudResult<?> auth() {
		try {
			List<RsHost> result = null;
			String casuri = "/cas/casrs/host";
			@SuppressWarnings("unchecked")
			RsCommList<RsHost> comlist = RestUtil.httpGet(defaultHttpClient, casuri, RsCommList.class);
			if (comlist != null) {
				result = comlist.getData();
				logger.info(JSON.toJSONString(result));
			}
			return new BocloudResult (true, "认证失败！");
		} catch (Exception e) {
			return new BocloudResult (false, "认证失败！");
		} finally {
			logout();
		}
	}

}
