package com.bocloud.cmp.provider.common;

import java.util.List;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.VDCModel;
import com.bocloud.cmp.provider.H3cProvider;
import com.bocloud.cmp.provider.compute.H3cHostPoolProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

/**
 * 华三认证
 * 
 * @author ymh
 *
 */
@Provider("bocloud.cmp.h3c")
public class H3cVdcProvider extends H3cProvider implements VdcProvider {

	private Butler butler;

	public H3cVdcProvider(Butler butler) {
		super(butler);
		this.butler = butler;
	}

	@Override
	public BocloudResult list() {
		H3cHostPoolProvider hostPoolProvider = new H3cHostPoolProvider(butler);
		BocloudResult<List<VDCModel>> vdcModelResult = hostPoolProvider.list();
		if (vdcModelResult.isFailed()) {
			return new BocloudResult (false, "查询VDC数据异常：" + vdcModelResult.getMessage());
		}
		return vdcModelResult;
	}

}
