package com.bocloud.cmp.provider.factory;

import com.bocloud.cmp.provider.common.H3cEventHandler;
import com.bocloud.cmp.provider.utils.XmlUtils;
import com.bocloud.common.utils.ListTool;
import org.dom4j.Element;

import java.util.List;

public class H3cEventHandlerFactory {
    /**
     * 增加云主机
     */
    public static final String EVENT_TYPE_ADD_VM = "20";
    /**
     * 删除云主机
     */
    public static final String EVENT_TYPE_DEL_VM = "21";
    /**
     * 修改云主机
     */
    public static final String EVENT_TYPE_MOD_VM = "22";

    /**
     * 启动云主机
     */
    public static final String EVENT_TYPE_START_VM = "30";

    /**
     * 关闭云主机电源
     */
    public static final String EVENT_TYPE_STOP_VM = "31";
    /**
     * 正常关闭云主机
     */
    public static final String EVENT_TYPE_STOP_VM_NORMALLY = "32";
    /**
     * 迁移云主机
     */
    public static final String EVENT_TYPE_MIGRATE_VM = "38";


    public static H3cEventHandler getHandler(String xml) {
        //可能也包含心跳的数据,这里replace一下
        xml = xml.replaceAll("#HEART_BEAT", "");
        List<Element> nodesByXpath = XmlUtils.getNodesByXpath(xml, "event/eventType");
        if (!ListTool.isEmpty(nodesByXpath)) {
            Element element = nodesByXpath.get(0);
            if (element != null) {
                String eventType = element.getText();
                switch (eventType) {
                    //TODO  此处将提供实现 不同实现的处理逻辑
                    case EVENT_TYPE_ADD_VM:
                        break;

                }
                return new EmptyHandler(element.asXML());
            }
        }
        return new EmptyHandler();

    }

    public static class EmptyHandler implements H3cEventHandler {

        private String xml;

        @Override
        public void handle() {
            System.out.println("执行了" + xml);
        }

        public EmptyHandler(String xml) {
            this.xml = xml;
        }

        public EmptyHandler() {

        }
    }
}
