package com.bocloud.cmp.provider.utils;

import org.apache.commons.codec.binary.Base64;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;
import java.nio.charset.Charset;

import static javax.crypto.Cipher.DECRYPT_MODE;
import static javax.crypto.Cipher.ENCRYPT_MODE;

public class H3cToolsUtils {
    private static final byte[] SECRET_KEY = "li_01010".getBytes();
    private static Cipher decryptDesCipher = null;
    private static Cipher encryptDesCipher = null;

    public H3cToolsUtils() {
    }

    public static String decryptText(String cryptoText) {
        return decryptText(cryptoText, Charset.defaultCharset().name());
    }

    public static String decryptText(String cryptoText, String charsetName) {
        try {
            byte[] bytes = Base64.decodeBase64(cryptoText.getBytes(charsetName));
            if (bytes != null) {
                bytes = decrypt(bytes);
                if (bytes != null) {
                    return new String(bytes, charsetName);
                }
            }
        } catch (Exception var3) {
            ;
        }

        return null;
    }

    public static byte[] decrypt(byte[] cryptoData) {
        if (decryptDesCipher == null) {
            try {
                DESKeySpec desKeySpec = new DESKeySpec(SECRET_KEY);
                SecretKeyFactory factory = SecretKeyFactory.getInstance("DES");
                SecretKey desSecretKey = factory.generateSecret(desKeySpec);
                decryptDesCipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
                decryptDesCipher.init(DECRYPT_MODE, desSecretKey);
            } catch (Exception var5) {
                return null;
            }
        }

        try {
            return decryptDesCipher.doFinal(cryptoData);
        } catch (Exception var4) {
            return null;
        }
    }

    public static byte[] encryptString(String string) {
        if (encryptDesCipher == null) {
            try {
                DESKeySpec desKeySpec = new DESKeySpec(SECRET_KEY);
                SecretKeyFactory factory = SecretKeyFactory.getInstance("DES");
                SecretKey desSecretKey = factory.generateSecret(desKeySpec);
                encryptDesCipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
                encryptDesCipher.init(ENCRYPT_MODE, desSecretKey);
            } catch (Exception var5) {
                return null;
            }
        }

        try {
            return encryptDesCipher.doFinal(string.getBytes(Charset.defaultCharset().name()));
        } catch (Exception var4) {
            return null;
        }
    }

    public static String encryptStringToText(String string) {
        return Base64.encodeBase64String(H3cToolsUtils.encryptString(string));
    }

    public static int getCidr(String mask) {
        StringBuffer sbf;
        String str;
        int inetmask=0,count=0;       //子网掩码缩写代码
        String[] ipList=mask.split("\\.");
        for(int n=0;n<ipList.length;n++)
        {
            sbf = toBin(Integer.parseInt(ipList[n]));
            str=sbf.reverse().toString();


            //统计2进制字符串中1的个数
            count=0;
            for(int i=0;i<str.length();i++){
                i=str.indexOf('1',i);  //查找 字符'1'出现的位置
                if(i==-1){break;}
                count++;  //统计字符出现次数
            }
            inetmask+=count;

        }
        return inetmask ;

    }

    public static StringBuffer toBin(int x) {
        StringBuffer result = new StringBuffer();
        result.append(x % 2);
        x /= 2;
        while (x > 0) {
            result.append(x % 2);
            x /= 2;
        }
        return result;
    }


    public static void main(String[] args) {
        System.out.println(H3cToolsUtils.decryptText("L48dyUHQrDQ="));
        System.out.println(Base64.encodeBase64String(H3cToolsUtils.encryptString("admin")));
        System.out.println(H3cToolsUtils.decryptText("wECTLMtI7D8="));

        System.out.println(getCidr("255.255.255.0"));
    }
}
