package com.bocloud.cmp.provider;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.hmc.sdk.api.v7.V7LogonService;
import com.bocloud.cmp.provider.hmc.sdk.api.v8.V8LogonService;
import com.bocloud.cmp.provider.hmc.sdk.enums.HmcVersion;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcAuthAdapter;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcAuthInfo;

public class HmcAccessableProvider extends GenericProvider implements SuperProvider {

    private final Butler butler;

    public HmcAccessableProvider(Butler butler) {
        super(butler);
        this.butler = butler;
    }

    @Override
    public boolean accessable() {
        if (HmcVersion.V8.name().equalsIgnoreCase(butler.getVersion())) {
            return V8LogonService.getSession(new HmcAuthAdapter(butler)) != null;
        } else if (HmcVersion.V7.name().equalsIgnoreCase(butler.getVersion())) {
            return V7LogonService.getSession(new HmcAuthAdapter(butler)) != null;
        } else {
            return false;
        }
    }

    protected HmcAuthInfo getAuth() {
        return new HmcAuthAdapter(butler);
    }
}
