package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.HostModel;
import com.bocloud.cmp.provider.HmcDispatcherProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

@Provider("bocloud.cmp.hmc")
public class HmcLocationProvider extends HmcDispatcherProvider implements LocationProvider {

    public HmcLocationProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult listRegions() {
        return super.getHmcProviderImpl(LocationProvider.class, this.getClass()).listRegions();
    }

    @Override
    public BocloudResult sync() {
        return super.getHmcProviderImpl(LocationProvider.class, this.getClass()).sync();
    }

    @Override
    public BocloudResult listZones(String region) {
        return super.getHmcProviderImpl(LocationProvider.class, this.getClass()).listZones(region);
    }

    @Override
    public BocloudResult syncPortByNetworkUuid(String networkUuid) {
        return super.getHmcProviderImpl(LocationProvider.class, this.getClass()).syncPortByNetworkUuid(networkUuid);
    }

    @Override
    public BocloudResult getHostModel(HostModel host) {
        return super.getHmcProviderImpl(LocationProvider.class, this.getClass()).getHostModel(host);
    }
}
