package com.bocloud.cmp.provider.common.v8;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.HmcAccessableProvider;
import com.bocloud.cmp.provider.common.AuthProvider;
import com.bocloud.cmp.provider.hmc.sdk.api.v8.V8LogonService;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcAuthAdapter;
import com.bocloud.common.model.BocloudResult;
import org.apache.commons.lang3.StringUtils;

/**
 * hmc认证操作类
 *
 * 
 * @author lkx007
 *
 */
public class HmcAuthProvider extends HmcAccessableProvider implements AuthProvider {

    private final Butler butler;

    public HmcAuthProvider(Butler butler) {
        super(butler);
        this.butler = butler;
    }

    @Override
    public BocloudResult auth() {
        String session = V8LogonService.getSession(new HmcAuthAdapter(butler));
        return new BocloudResult(StringUtils.isNotEmpty(session), session, session);
    }

    @Override
    public BocloudResult removeAuthFromMemory(String endpoint, String username) {
        V8LogonService.clearSession(new HmcAuthAdapter(butler));
        return new BocloudResult(true, "执行成功");
    }
}
