package com.bocloud.cmp.provider.hmc;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.HmcDispatcherProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

/**
 * HMC通用Provider
 * 
 * @author sxp
 * @since Nov 20, 2018
 */
@Provider("bocloud.cmp.hmc")
public class HmcCommonProvider extends HmcDispatcherProvider implements CommonProvider {

    public HmcCommonProvider(Butler butler) {
        super(butler);
    }
    
    /**
     * 获取任务执行状态
     * 
     * @author sxp
     * @since Nov 20, 2018
     */
    @Override
    public BocloudResult getJobStatus(String jobId) {
        return getHmcProviderImpl(CommonProvider.class, this.getClass()).getJobStatus(jobId);
    }
    
    /**
     * 获取任务执行状态-带超时时间
     * 
     * @author sxp
     * @since Nov 20, 2018
     */
    @Override
    public BocloudResult getJobStatus(String jobId, long timeout){
        return getHmcProviderImpl(CommonProvider.class, this.getClass()).getJobStatus(jobId, timeout);
    }

}
