package com.bocloud.cmp.provider.hmc;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.hmc.HmcPartitionModel;
import com.bocloud.cmp.provider.HmcDispatcherProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

@Provider("bocloud.cmp.hmc")
public class HmcPartitionProvider extends HmcDispatcherProvider implements PartitionProvider {

    public HmcPartitionProvider(Butler bulter) {
        super(bulter);
    }

    @Override
    public BocloudResult createLogicalPartition(String managedSystemUuid, HmcPartitionModel par) {
        return getHmcProviderImpl(PartitionProvider.class, this.getClass()).createLogicalPartition(managedSystemUuid, par);
    }

    @Override
    public BocloudResult createVirtualIOServer(String managedSystemUuid, HmcPartitionModel par) {
        return getHmcProviderImpl(PartitionProvider.class, this.getClass()).createVirtualIOServer(managedSystemUuid, par);
    }

    @Override
    public BocloudResult delete(String managedSystemUuid, String partitionUuid, Boolean isVios) {
        return getHmcProviderImpl(PartitionProvider.class, this.getClass()).delete(managedSystemUuid, partitionUuid, isVios);
    }

    @Override
    public BocloudResult updateLogicalPartition(HmcPartitionModel partition, String managedSystemUuid, String partitionUuid) {
        return getHmcProviderImpl(PartitionProvider.class, this.getClass()).updateLogicalPartition(partition, managedSystemUuid, partitionUuid);
    }

    @Override
    public BocloudResult updateVirtualIOServer(HmcPartitionModel partition, String managedSystemUuid, String partitionUuid) {
        return getHmcProviderImpl(PartitionProvider.class, this.getClass()).updateVirtualIOServer(partition, managedSystemUuid, partitionUuid);
    }

    @Override
    public BocloudResult getPartitionAttribute(String partitionUuid, Boolean isVios) {
        return getHmcProviderImpl(PartitionProvider.class, this.getClass()).getPartitionAttribute(partitionUuid, isVios);
    }

    @Override
    public BocloudResult powerOffPartition(String uuid, Boolean isVios) {
        return getHmcProviderImpl(PartitionProvider.class, this.getClass()).powerOffPartition(uuid, isVios);
    }

    @Override
    public BocloudResult restartPartition(String uuid, Boolean isVios) {
        return getHmcProviderImpl(PartitionProvider.class, this.getClass()).restartPartition(uuid, isVios);
    }

    @Override
    public BocloudResult powerOnPartition(String uuid, String profileUuid, Boolean isVios) {
        return getHmcProviderImpl(PartitionProvider.class, this.getClass()).powerOnPartition(uuid, profileUuid, isVios);
    }

    @Override
    public BocloudResult queryPartitionState(String uuid, Boolean isVios) {
        return getHmcProviderImpl(PartitionProvider.class, this.getClass()).queryPartitionState(uuid, isVios);
    }

    @Override
    public BocloudResult queryPartitionRMCState(String uuid, Boolean isVios) {
        return getHmcProviderImpl(PartitionProvider.class, this.getClass()).queryPartitionRMCState(uuid, isVios);
    }

    @Override
    public BocloudResult getVirtualScsiAdapters(String href) {
        return getHmcProviderImpl(PartitionProvider.class, this.getClass()).getVirtualScsiAdapters(href);
    }
}
