package com.bocloud.cmp.provider.hmc;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.hmc.HmcPartitionModel;
import com.bocloud.cmp.model.hmc.HmcProfileModel;
import com.bocloud.cmp.provider.HmcDispatcherProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

@Provider("bocloud.cmp.hmc")
public class HmcProfileProvider extends HmcDispatcherProvider implements ProfileProvider {

    public HmcProfileProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult create(HmcPartitionModel partition, HmcProfileModel profile) {
        return getHmcProviderImpl(ProfileProvider.class, this.getClass()).create(partition, profile);
    }

    @Override
    public BocloudResult update(HmcProfileModel profile, boolean isVIOS, String partitionUuid, String profileUuid) {
        return getHmcProviderImpl(ProfileProvider.class, this.getClass()).update(profile, isVIOS, partitionUuid, profileUuid);
    }

    @Override
    public BocloudResult delete(boolean isVios, String partitionUuid, String profileUuid) {
        return getHmcProviderImpl(ProfileProvider.class, this.getClass()).delete(isVios, partitionUuid, profileUuid);
    }

    @Override
    public BocloudResult getProfile(boolean isVios, String partitionUuid, String profileUuid) {
        return getHmcProviderImpl(ProfileProvider.class, this.getClass()).getProfile(isVios, partitionUuid, profileUuid);
    }

    @Override
    public BocloudResult getProfile(boolean isVios, String partitionUuid) {
        return getHmcProviderImpl(ProfileProvider.class, this.getClass()).getProfile(isVios, partitionUuid);
    }
}
