package com.bocloud.cmp.provider.hmc;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.hmc.sdk.module.ManagedSystem;
import com.bocloud.cmp.provider.HmcDispatcherProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

@Provider("bocloud.cmp.hmc")
public class HmcServerProvider extends HmcDispatcherProvider implements ServerProvider {

    public HmcServerProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult get() {
        return getHmcProviderImpl(ServerProvider.class, this.getClass()).get();
    }

    @Override
    public BocloudResult update(String managedSystemUuid, ManagedSystem managedSystem) {
        return getHmcProviderImpl(ServerProvider.class, this.getClass()).update(managedSystemUuid, managedSystem);
    }

    @Override
    public BocloudResult powerOnManagedSystem(String managedSystemUuid) {
        return getHmcProviderImpl(ServerProvider.class, this.getClass()).powerOnManagedSystem(managedSystemUuid);
    }

    @Override
    public BocloudResult powerOffManagedSystem(String managedSystemUuid) {
        return getHmcProviderImpl(ServerProvider.class, this.getClass()).powerOffManagedSystem(managedSystemUuid);
    }

    @Override
    public BocloudResult resetConnection(String managedSystemUuid) {
        return getHmcProviderImpl(ServerProvider.class, this.getClass()).resetConnection(managedSystemUuid);
    }

    @Override
    public BocloudResult removeConnection(String managedSystemUuid) {
        return getHmcProviderImpl(ServerProvider.class, this.getClass()).removeConnection(managedSystemUuid);
    }

    @Override
    public BocloudResult powerOn(String managedSystemUuid) {
        return getHmcProviderImpl(ServerProvider.class, this.getClass()).powerOn(managedSystemUuid);
    }

    @Override
    public BocloudResult powerOff(String managedSystemUuid) {
        return getHmcProviderImpl(ServerProvider.class, this.getClass()).powerOff(managedSystemUuid);
    }

    @Override
    public BocloudResult queryManagedSystemState(String managedSystemUuid) {
        return getHmcProviderImpl(ServerProvider.class, this.getClass()).queryManagedSystemState(managedSystemUuid);
    }

    @Override
    public BocloudResult queryManagedSystemAttribute(String managedSystemUuid) {
        return getHmcProviderImpl(ServerProvider.class, this.getClass()).queryManagedSystemAttribute(managedSystemUuid);
    }

    @Override
    public BocloudResult queryManagementConsoleUuid() {
        return getHmcProviderImpl(ServerProvider.class, this.getClass()).queryManagementConsoleUuid();
    }

    @Override
    public BocloudResult addManagedSystem(String consoleUuid, String hostIp, String password) {
        return getHmcProviderImpl(ServerProvider.class, this.getClass()).addManagedSystem(consoleUuid, hostIp, password);
    }

    @Override
    public BocloudResult removeManagedSystemConnection(String consoleUuid, String managedSystemUuid) {
        return getHmcProviderImpl(ServerProvider.class, this.getClass()).removeManagedSystemConnection(consoleUuid, managedSystemUuid);
    }
}
