package com.bocloud.cmp.provider.hmc;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.hmc.HmcVirtualFibreChannelMappingModel;
import com.bocloud.cmp.provider.HmcDispatcherProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

/**
 * @author luyanchao
 * @since 2018/12/18 16:53
 */
@Provider("bocloud.cmp.hmc")
public class HmcVirtualFibreChannelMappingProvider extends HmcDispatcherProvider implements VirtualFibreChannelMappingProvider {

    public HmcVirtualFibreChannelMappingProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult addVfcToVios(String managedSystemUuid, String viosUuid, HmcVirtualFibreChannelMappingModel mapping) {
        return getHmcProviderImpl(VirtualFibreChannelMappingProvider.class, this.getClass()).addVfcToVios(managedSystemUuid, viosUuid, mapping);
    }

    @Override
    public BocloudResult removeVfcFromVios(String managedSystemUuid, String viosUuid, HmcVirtualFibreChannelMappingModel mapping) {
        return getHmcProviderImpl(VirtualFibreChannelMappingProvider.class, this.getClass()).removeVfcFromVios(managedSystemUuid, viosUuid, mapping);
    }

    @Override
    public BocloudResult getVfcFromPartition(String partitionUuid) {
        return getHmcProviderImpl(VirtualFibreChannelMappingProvider.class, this.getClass()).getVfcFromPartition(partitionUuid);
    }
}
