package com.bocloud.cmp.provider.hmc;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.hmc.HmcVirtualSwitchModel;
import com.bocloud.cmp.provider.HmcDispatcherProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

@Provider("bocloud.cmp.hmc")
public class HmcVirtualNetworkProvider extends HmcDispatcherProvider implements VirtualNetworkProvider {

    public HmcVirtualNetworkProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult createVirtualSwitch(HmcVirtualSwitchModel virtualSwitch, String serverUuid) {
        return getHmcProviderImpl(VirtualNetworkProvider.class, this.getClass()).createVirtualSwitch(virtualSwitch, serverUuid);
    }

    @Override
    public BocloudResult deleteVirtualSwitch(String serverUuid, String vswitchUuid) {
        return getHmcProviderImpl(VirtualNetworkProvider.class, this.getClass()).deleteVirtualSwitch(serverUuid, vswitchUuid);
    }

    @Override
    public BocloudResult updateVirtualSwitch(HmcVirtualSwitchModel virtualSwitch, String serverUuid, String vswitchUuid) {
        return getHmcProviderImpl(VirtualNetworkProvider.class, this.getClass()).updateVirtualSwitch(virtualSwitch, serverUuid, vswitchUuid);
    }

    @Override
    public BocloudResult getClientNetworkAdapter(String laprUuid) {
        return getHmcProviderImpl(VirtualNetworkProvider.class, this.getClass()).getClientNetworkAdapter(laprUuid);
    }
}
