package com.bocloud.cmp.provider.hmc;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.hmc.sdk.module.VolumeGroup;
import com.bocloud.cmp.provider.HmcDispatcherProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

/**
 * hmc volume group driver
 *
 * @author lkx007
 */
@Provider("bocloud.cmp.hmc")
public class HmcVolumeGroupProvider extends HmcDispatcherProvider implements VolumeGroupProvider {

    public HmcVolumeGroupProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult getVolumeGroup(String viosUuid) {
        return getHmcProviderImpl(VolumeGroupProvider.class, this.getClass()).getVolumeGroup(viosUuid);
    }

    @Override
    public BocloudResult getVolumeGroup(String viosUuid, String volumeGroupUuid) {
        return getHmcProviderImpl(VolumeGroupProvider.class, this.getClass()).getVolumeGroup(viosUuid, volumeGroupUuid);
    }

    @Override
    public BocloudResult createVirtualDisk(String viosUuid, String volumeGroupUuid, Double diskCapacity, String diskName) {
        return getHmcProviderImpl(VolumeGroupProvider.class, this.getClass()).createVirtualDisk(viosUuid, volumeGroupUuid, diskCapacity, diskName);
    }

    @Override
    public BocloudResult deleteVirtualDisk(String viosUuid, String volumeGroupUuid, String diskName) {
        return getHmcProviderImpl(VolumeGroupProvider.class, this.getClass()).deleteVirtualDisk(viosUuid, volumeGroupUuid, diskName);
    }

    @Override
    public BocloudResult assign(String managedSystemUuid, String viosUuid, String lparUuid, String diskName, String diskCapacity, Integer viosId, Integer lparId, Integer lparSlot, boolean isPhysical) {
        return getHmcProviderImpl(VolumeGroupProvider.class, this.getClass()).assign(managedSystemUuid, viosUuid, lparUuid, diskName, diskCapacity, viosId, lparId, lparSlot, isPhysical);
    }

    @Override
    public BocloudResult unAssign(String managedSystemUuid, String viosUuid, String diskName, boolean isPhysical) {
        return getHmcProviderImpl(VolumeGroupProvider.class, this.getClass()).unAssign(managedSystemUuid, viosUuid, diskName, isPhysical);
    }

    @Override
    public BocloudResult updateVirtualDisk(String viosUuid, String volumeGroupUuid, Double diskCapacity, String diskName) {
        return getHmcProviderImpl(VolumeGroupProvider.class, this.getClass()).updateVirtualDisk(viosUuid, volumeGroupUuid, diskCapacity, diskName);
    }

    @Override
    public BocloudResult createVolumeGroup(String viosUuid, VolumeGroup volumeGroup) {
        return getHmcProviderImpl(VolumeGroupProvider.class, this.getClass()).createVolumeGroup(viosUuid, volumeGroup);
    }

    @Override
    public BocloudResult deleteVolumeGroup(String viosUuid, String volumeGroupUuid) {
        return getHmcProviderImpl(VolumeGroupProvider.class, this.getClass()).deleteVolumeGroup(viosUuid, volumeGroupUuid);
    }
}
