package com.bocloud.cmp.provider.hmc.sdk.api.v8;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcAuthInfo;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module.V8VirtualNetworkBridgeResponse;
import com.bocloud.cmp.provider.hmc.sdk.util.XmlUtils;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.Result;

import java.util.Optional;


public class V8VirtualNetworkBridgeService extends V8BaseService {
    private static final String TYPE = "NetworkBridge";
    private static final String CONTENT_TYPE = "application/vnd.ibm.powervm.uom+xml; type=" + TYPE;
    private static final String API = "/rest/api/uom/ManagedSystem/%s/" + TYPE;
    private static final String SPECIFIED_API = API + "/%s";

    /**
     * 查询主机所有虚拟网桥
     *
     */
    public static BocloudResult get(HmcAuthInfo auth, String ManagedSystemUuid) {
        String api = String.format(API, ManagedSystemUuid);
        Result result = httpGet(auth, auth.getEndpoint() + api, CONTENT_TYPE);
        if (result.isFailed()) {
            return new BocloudResult(false, result.getMessage());
        }
        V8VirtualNetworkBridgeResponse response = Optional.ofNullable(result.getMessage())
                .map(msg -> msg.replace(TYPE + ":" + TYPE, TYPE))
                .map(msg -> XmlUtils.parseObject(V8VirtualNetworkBridgeResponse.class, msg))
                .orElse(null);
        return new BocloudResult(true, response, "执行成功");
    }


}
