package com.bocloud.cmp.provider.hmc.sdk.model;

import java.util.Objects;

/**
 * HMC认证信息
 * 
 * @author sxp
 * @since May 3, 2018
 */
public class HmcAuthInfo {

    /**
     * HMC服务器地址
     */
    private String endpoint;

    /** 用户名 */
    private String username;

    /** 密码 */
    private String password;


    public HmcAuthInfo(String endpoint, String username, String password) {
        this.endpoint = endpoint;
        this.username = username;
        this.password = password;
    }

    public String getEndpoint() {
        return endpoint;
    }

    public String getUsername() {
        return username;
    }

    public String getPassword() {
        return password;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        HmcAuthInfo that = (HmcAuthInfo) o;
        return Objects.equals(endpoint, that.endpoint) && Objects.equals(username, that.username);
    }

    @Override
    public int hashCode() {
        return Objects.hash(endpoint, username);
    }
}
