package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module.V7XAPISession;

import javax.xml.bind.annotation.*;

/**
 * 登陆的返回结果(XML对应的Java类)
 *
 * @author sxp
 * @since May 3, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "LogonResponse")
public class V7LogonResponse {
    @XmlAttribute
    private String xmlns;

    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "X-API-Session")
    private V7XAPISession session;

    public V7LogonResponse() {
    }

    public String getXmlns() {
        return xmlns;
    }

    public void setXmlns(String xmlns) {
        this.xmlns = xmlns;
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public V7XAPISession getSession() {
        return session;
    }

    public void setSession(V7XAPISession session) {
        this.session = session;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }

}
