package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.job;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

/**
 * InnerJobResponse
 *
 * @author 007
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "JobResponse")
public class V7InnerJobResponse {
    @XmlAttribute(name = "schemaVersion")
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "TargetUuid")
    private String targetUuid;

    @XmlElement(name = "JobID")
    private String jobId;

    /**
     * timeStarted 1528437222875
     */
    @XmlElement(name = "TimeStarted")
    private String timeStarted;

    /**
     * timeCompleted
     * <p>
     * 1528437223282
     */
    @XmlElement(name = "TimeCompleted")
    private String timeCompleted;

    /**
     * status
     *
     * <pre>
     * 作业执行完成的状态: COMPLETED_OK COMPLETED_WITH_WARNINGS 作业执行失败的状态:
     * COMPLETED_WITH_ERROR FAILED_BEFORE_COMPLETION
     *
     * <pre>
     */
    @XmlElement(name = "Status")
    private String status;

    /**
     * results
     */
    @XmlElement(name = "Results")
    private V7JobResults results;

    /**
     * @return the schemaVersion
     */
    public String getSchemaVersion() {
        return schemaVersion;
    }

    /**
     * @param schemaVersion the schemaVersion to set
     */
    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    /**
     * @return the metadata
     */
    public V7Metadata getMetadata() {
        return metadata;
    }

    /**
     * @param metadata the metadata to set
     */
    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    /**
     * @return the targetUuid
     */
    public String getTargetUuid() {
        return targetUuid;
    }

    /**
     * @param targetUuid the targetUuid to set
     */
    public void setTargetUuid(String targetUuid) {
        this.targetUuid = targetUuid;
    }

    public String getJobId() {
        return jobId;
    }

    public void setJobId(String jobId) {
        this.jobId = jobId;
    }

    /**
     * @return the timeStarted
     */
    public String getTimeStarted() {
        return timeStarted;
    }

    /**
     * @param timeStarted the timeStarted to set
     */
    public void setTimeStarted(String timeStarted) {
        this.timeStarted = timeStarted;
    }

    /**
     * @return the timeCompleted
     */
    public String getTimeCompleted() {
        return timeCompleted;
    }

    /**
     * @param timeCompleted the timeCompleted to set
     */
    public void setTimeCompleted(String timeCompleted) {
        this.timeCompleted = timeCompleted;
    }

    /**
     * @return the status
     */
    public String getStatus() {
        return status;
    }

    /**
     * @param status the status to set
     */
    public void setStatus(String status) {
        this.status = status;
    }

    /**
     * @return the results
     */
    public V7JobResults getResults() {
        return results;
    }

    /**
     * @param results the results to set
     */
    public void setResults(V7JobResults results) {
        this.results = results;
    }

    public V7InnerJobResponse() {
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }
}
