package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.job;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

/**
 * JobParameter
 *
 * @author 007
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "JobParameter")
public class V7JobParameter {
    /**
     * V1_2_0
     */
    @XmlAttribute(name = "schemaVersion")
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    /**
     *
     */
    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    /**
     * returnCode/result/ErrorData
     */
    @XmlElement(name = "ParameterName")
    private String parameterName;

    /**
     * value
     * <p>
     * ParameterName为result或ErrorData时，对应的ParameterValue为任务执行提示信息
     * </p>
     */
    @XmlElement(name = "ParameterValue")
    private String parameterValue;

    public V7JobParameter() {
    }

    /**
     * @return the schemaVersion
     */
    public String getSchemaVersion() {
        return schemaVersion;
    }

    /**
     * @param schemaVersion the schemaVersion to set
     */
    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    /**
     * @return the metadata
     */
    public V7Metadata getMetadata() {
        return metadata;
    }

    /**
     * @param metadata the metadata to set
     */
    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    /**
     * @return the parameterName
     */
    public String getParameterName() {
        return parameterName;
    }

    /**
     * @param parameterName the parameterName to set
     */
    public void setParameterName(String parameterName) {
        this.parameterName = parameterName;
    }

    /**
     * @return the parameterValue
     */
    public String getParameterValue() {
        return parameterValue;
    }

    /**
     * @param parameterValue the parameterValue to set
     */
    public void setParameterValue(String parameterValue) {
        this.parameterValue = parameterValue;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }
}
