package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

/**
 * 客户端网络适配器
 *
 * @author sxp
 * @since Jun 27, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "ClientNetworkAdapter")
public class V7ClientNetworkAdapter {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "DynamicReconfigurationConnectorName")
    private String dynamicReconfigurationConnectorName;

    @XmlElement(name = "LocationCode")
    private String locationCode;

    @XmlElement(name = "RequiredAdapter")
    private String requiredAdapter;

    @XmlElement(name = "VariedOn")
    private String variedOn;

    @XmlElement(name = "VirtualSlotNumber")
    private String virtualSlotNumber;

    @XmlElement(name = "MACAddress")
    private String macAddress;

    /**
     * 端口虚拟以太网（VLAN 标识）
     */
    @XmlElement(name = "PortVLANID")
    private String portVlanId;

    @XmlElement(name = "QualityOfServicePriorityEnabled")
    private String qualityOfServicePriorityEnabled;

    @XmlElement(name = "TaggedVLANSupported")
    private String taggedVlanSupported;

    @XmlElement(name = "AssociatedVirtualSwitch")
    private V7AssociatedVirtualSwitch associatedVirtualSwitch;

    @XmlElement(name = "VirtualSwitchID")
    private String virtualSwitchID;

    @XmlElement(name = "VirtualNetworks")
    private V7VirtualNetworks virtualNetworks;

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public String getDynamicReconfigurationConnectorName() {
        return dynamicReconfigurationConnectorName;
    }

    public void setDynamicReconfigurationConnectorName(String dynamicReconfigurationConnectorName) {
        this.dynamicReconfigurationConnectorName = dynamicReconfigurationConnectorName;
    }

    public String getLocationCode() {
        return locationCode;
    }

    public void setLocationCode(String locationCode) {
        this.locationCode = locationCode;
    }

    public String getRequiredAdapter() {
        return requiredAdapter;
    }

    public void setRequiredAdapter(String requiredAdapter) {
        this.requiredAdapter = requiredAdapter;
    }

    public String getVariedOn() {
        return variedOn;
    }

    public void setVariedOn(String variedOn) {
        this.variedOn = variedOn;
    }

    public String getVirtualSlotNumber() {
        return virtualSlotNumber;
    }

    public void setVirtualSlotNumber(String virtualSlotNumber) {
        this.virtualSlotNumber = virtualSlotNumber;
    }

    public String getMacAddress() {
        return macAddress;
    }

    public void setMacAddress(String macAddress) {
        this.macAddress = macAddress;
    }

    public String getPortVlanId() {
        return portVlanId;
    }

    public void setPortVlanId(String portVlanId) {
        this.portVlanId = portVlanId;
    }

    public String getQualityOfServicePriorityEnabled() {
        return qualityOfServicePriorityEnabled;
    }

    public void setQualityOfServicePriorityEnabled(String qualityOfServicePriorityEnabled) {
        this.qualityOfServicePriorityEnabled = qualityOfServicePriorityEnabled;
    }

    public String getTaggedVlanSupported() {
        return taggedVlanSupported;
    }

    public void setTaggedVlanSupported(String taggedVlanSupported) {
        this.taggedVlanSupported = taggedVlanSupported;
    }

    public V7AssociatedVirtualSwitch getAssociatedVirtualSwitch() {
        return associatedVirtualSwitch;
    }

    public void setAssociatedVirtualSwitch(V7AssociatedVirtualSwitch associatedVirtualSwitch) {
        this.associatedVirtualSwitch = associatedVirtualSwitch;
    }

    public String getVirtualSwitchID() {
        return virtualSwitchID;
    }

    public void setVirtualSwitchID(String virtualSwitchID) {
        this.virtualSwitchID = virtualSwitchID;
    }

    public V7VirtualNetworks getVirtualNetworks() {
        return virtualNetworks;
    }

    public void setVirtualNetworks(V7VirtualNetworks virtualNetworks) {
        this.virtualNetworks = virtualNetworks;
    }

}
