package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "CurrentSharedProcessorConfiguration")
public class V7CurrentSharedProcessorConfiguration {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "AllocatedVirtualProcessors")
    private String allocatedVirtualProcessors;

    @XmlElement(name = "CurrentMaximumProcessingUnits")
    private String currentMaximumProcessingUnits;

    @XmlElement(name = "CurrentMinimumProcessingUnits")
    private String currentMinimumProcessingUnits;

    @XmlElement(name = "CurrentProcessingUnits")
    private String currentProcessingUnits;

    @XmlElement(name = "CurrentSharedProcessorPoolID")
    private String currentSharedProcessorPoolID;

    @XmlElement(name = "CurrentMinimumVirtualProcessors")
    private String currentMinimumVirtualProcessors;

    @XmlElement(name = "CurrentMaximumVirtualProcessors")
    private String currentMaximumVirtualProcessors;

    @XmlElement(name = "RuntimeProcessingUnits")
    private String runtimeProcessingUnits;

    public V7CurrentSharedProcessorConfiguration() {
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public String getAllocatedVirtualProcessors() {
        return allocatedVirtualProcessors;
    }

    public void setAllocatedVirtualProcessors(String allocatedVirtualProcessors) {
        this.allocatedVirtualProcessors = allocatedVirtualProcessors;
    }

    public String getCurrentMaximumProcessingUnits() {
        return currentMaximumProcessingUnits;
    }

    public void setCurrentMaximumProcessingUnits(String currentMaximumProcessingUnits) {
        this.currentMaximumProcessingUnits = currentMaximumProcessingUnits;
    }

    public String getCurrentMinimumProcessingUnits() {
        return currentMinimumProcessingUnits;
    }

    public void setCurrentMinimumProcessingUnits(String currentMinimumProcessingUnits) {
        this.currentMinimumProcessingUnits = currentMinimumProcessingUnits;
    }

    public String getCurrentProcessingUnits() {
        return currentProcessingUnits;
    }

    public void setCurrentProcessingUnits(String currentProcessingUnits) {
        this.currentProcessingUnits = currentProcessingUnits;
    }

    public String getCurrentSharedProcessorPoolID() {
        return currentSharedProcessorPoolID;
    }

    public void setCurrentSharedProcessorPoolID(String currentSharedProcessorPoolID) {
        this.currentSharedProcessorPoolID = currentSharedProcessorPoolID;
    }

    public String getCurrentMinimumVirtualProcessors() {
        return currentMinimumVirtualProcessors;
    }

    public void setCurrentMinimumVirtualProcessors(String currentMinimumVirtualProcessors) {
        this.currentMinimumVirtualProcessors = currentMinimumVirtualProcessors;
    }

    public String getCurrentMaximumVirtualProcessors() {
        return currentMaximumVirtualProcessors;
    }

    public void setCurrentMaximumVirtualProcessors(String currentMaximumVirtualProcessors) {
        this.currentMaximumVirtualProcessors = currentMaximumVirtualProcessors;
    }

    public String getRuntimeProcessingUnits() {
        return runtimeProcessingUnits;
    }

    public void setRuntimeProcessingUnits(String runtimeProcessingUnits) {
        this.runtimeProcessingUnits = runtimeProcessingUnits;
    }

    @Override
    public String toString() {
        return "CurrentSharedProcessorConfiguration [metadata=" + metadata + ", allocatedVirtualProcessors="
                + allocatedVirtualProcessors + ", currentMaximumProcessingUnits=" + currentMaximumProcessingUnits
                + ", currentMinimumProcessingUnits=" + currentMinimumProcessingUnits + ", currentProcessingUnits="
                + currentProcessingUnits + ", currentSharedProcessorPoolID=" + currentSharedProcessorPoolID
                + ", currentMinimumVirtualProcessors=" + currentMinimumVirtualProcessors
                + ", currentMaximumVirtualProcessors=" + currentMaximumVirtualProcessors + ", runtimeProcessingUnits="
                + runtimeProcessingUnits + "]";
    }

}
