package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "LogicalPartition")
public class V7LogicalPartition {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "AllowPerformanceDataCollection")
    private String allowPerformanceDataCollection;

    @XmlElement(name = "AssociatedPartitionProfile")
    private V7AssociatedPartitionProfile associatedPartitionProfile;

    @XmlElement(name = "AvailabilityPriority")
    private String availabilityPriority;

    @XmlElement(name = "CurrentAllocatedBarrierSynchronizationRegisterArrays")
    private String currentAllocatedBarrierSynchronizationRegisterArrays;

    @XmlElement(name = "CurrentProcessorCompatibilityMode")
    private String currentProcessorCompatibilityMode;

    @XmlElement(name = "CurrentProfileSync")
    private String currentProfileSync;

    @XmlElement(name = "IsConnectionMonitoringEnabled")
    private String isConnectionMonitoringEnabled;

    @XmlElement(name = "IsOperationInProgress")
    private String isOperationInProgress;

    @XmlElement(name = "IsRedundantErrorPathReportingEnabled")
    private String isRedundantErrorPathReportingEnabled;

    @XmlElement(name = "IsVirtualServiceAttentionLEDOn")
    private String isVirtualServiceAttentionLEDOn;

    @XmlElement(name = "KeylockPosition")
    private String keylockPosition;

    @XmlElement(name = "LogicalSerialNumber")
    private String logicalSerialNumber;

    @XmlElement(name = "OperatingSystemVersion")
    private String operatingSystemVersion;

    @XmlElement(name = "PartitionCapabilities")
    private V7PartitionCapabilities partitionCapabilities;

    @XmlElement(name = "PartitionID")
    private String partitionID;

    @XmlElement(name = "PartitionIOConfiguration")
    private V7PartitionIOConfiguration partitionIOConfiguration;

    @XmlElement(name = "PartitionMemoryConfiguration")
    private V7PartitionMemoryConfiguration partitionMemoryConfiguration;

    @XmlElement(name = "PartitionName")
    private String partitionName;

    @XmlElement(name = "PartitionProcessorConfiguration")
    private V7PartitionProcessorConfiguration partitionProcessorConfiguration;

    @XmlElement(name = "PartitionProfiles")
    private V7PartitionProfiles partitionProfiles;

    @XmlElement(name = "PartitionState")
    private String partitionState;

    @XmlElement(name = "PartitionType")
    private String partitionType;

    @XmlElement(name = "PartitionUUID")
    private String partitionUUID;

    @XmlElement(name = "PendingProcessorCompatibilityMode")
    private String pendingProcessorCompatibilityMode;

    @XmlElement(name = "ProcessorPool")
    private V7ProcessorPool processorPool;

    @XmlElement(name = "ProgressState")
    private String progressState;

    @XmlElement(name = "ResourceMonitoringControlState")
    private String resourceMonitoringControlState;

    @XmlElement(name = "ResourceMonitoringIPAddress")
    private String resourceMonitoringIPAddress;

    @XmlElement(name = "AssociatedManagedSystem")
    private V7AssociatedManagedSystem associatedManagedSystem;

    @XmlElement(name = "ClientNetworkAdapters")
    private V7ClientNetworkAdapters clientNetworkAdapters;

    @XmlElement(name = "HostEthernetAdapterLogicalPorts")
    private V7HostEthernetAdapterLogicalPorts hostEthernetAdapterLogicalPorts;

    @XmlElement(name = "IsServicePartition")
    private String isServicePartition;

    @XmlElement(name = "ReferenceCode")
    private String referenceCode;

    //HMC790不支持这个参数
    //@XmlElement(name = "AssignAllResources")
    //private V7AssignAllResources assignAllResources;

    @XmlElement(name = "PowerOnWithHypervisor")
    private V7PowerOnWithHypervisor powerOnWithHypervisor;

    @XmlElement(name = "RemoteRestartCapable")
    private String remoteRestartCapable;

    @XmlElement(name = "SimplifiedRemoteRestartCapable")
    private V7SimplifiedRemoteRestartCapable simplifiedRemoteRestartCapable;

    @XmlElement(name = "HasDedicatedProcessorsForMigration")
    private String hasDedicatedProcessorsForMigration;

    @XmlElement(name = "SuspendCapable")
    private String suspendCapable;

    @XmlElement(name = "RemoteRestartState")
    private String remoteRestartState;

    @XmlElement(name = "VirtualSCSIClientAdapters")
    private V7VirtualSCSIClientAdapters VirtualSCSIClientAdapters;


    public V7LogicalPartition() {
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public V7AssociatedPartitionProfile getAssociatedPartitionProfile() {
        return associatedPartitionProfile;
    }

    public void setAssociatedPartitionProfile(V7AssociatedPartitionProfile associatedPartitionProfile) {
        this.associatedPartitionProfile = associatedPartitionProfile;
    }

    public String getAllowPerformanceDataCollection() {
        return allowPerformanceDataCollection;
    }

    public void setAllowPerformanceDataCollection(String allowPerformanceDataCollection) {
        this.allowPerformanceDataCollection = allowPerformanceDataCollection;
    }

    public String getAvailabilityPriority() {
        return availabilityPriority;
    }

    public void setAvailabilityPriority(String availabilityPriority) {
        this.availabilityPriority = availabilityPriority;
    }

    public String getCurrentAllocatedBarrierSynchronizationRegisterArrays() {
        return currentAllocatedBarrierSynchronizationRegisterArrays;
    }

    public void setCurrentAllocatedBarrierSynchronizationRegisterArrays(
            String currentAllocatedBarrierSynchronizationRegisterArrays) {
        this.currentAllocatedBarrierSynchronizationRegisterArrays = currentAllocatedBarrierSynchronizationRegisterArrays;
    }

    public String getCurrentProcessorCompatibilityMode() {
        return currentProcessorCompatibilityMode;
    }

    public void setCurrentProcessorCompatibilityMode(String currentProcessorCompatibilityMode) {
        this.currentProcessorCompatibilityMode = currentProcessorCompatibilityMode;
    }

    public String getCurrentProfileSync() {
        return currentProfileSync;
    }

    public void setCurrentProfileSync(String currentProfileSync) {
        this.currentProfileSync = currentProfileSync;
    }

    public String getIsConnectionMonitoringEnabled() {
        return isConnectionMonitoringEnabled;
    }

    public void setIsConnectionMonitoringEnabled(String isConnectionMonitoringEnabled) {
        this.isConnectionMonitoringEnabled = isConnectionMonitoringEnabled;
    }

    public String getIsOperationInProgress() {
        return isOperationInProgress;
    }

    public void setIsOperationInProgress(String isOperationInProgress) {
        this.isOperationInProgress = isOperationInProgress;
    }

    public String getIsRedundantErrorPathReportingEnabled() {
        return isRedundantErrorPathReportingEnabled;
    }

    public void setIsRedundantErrorPathReportingEnabled(String isRedundantErrorPathReportingEnabled) {
        this.isRedundantErrorPathReportingEnabled = isRedundantErrorPathReportingEnabled;
    }

    public String getIsVirtualServiceAttentionLEDOn() {
        return isVirtualServiceAttentionLEDOn;
    }

    public void setIsVirtualServiceAttentionLEDOn(String isVirtualServiceAttentionLEDOn) {
        this.isVirtualServiceAttentionLEDOn = isVirtualServiceAttentionLEDOn;
    }

    public String getKeylockPosition() {
        return keylockPosition;
    }

    public void setKeylockPosition(String keylockPosition) {
        this.keylockPosition = keylockPosition;
    }

    public String getLogicalSerialNumber() {
        return logicalSerialNumber;
    }

    public void setLogicalSerialNumber(String logicalSerialNumber) {
        this.logicalSerialNumber = logicalSerialNumber;
    }

    public String getOperatingSystemVersion() {
        return operatingSystemVersion;
    }

    public void setOperatingSystemVersion(String operatingSystemVersion) {
        this.operatingSystemVersion = operatingSystemVersion;
    }

    public V7PartitionCapabilities getPartitionCapabilities() {
        return partitionCapabilities;
    }

    public void setPartitionCapabilities(V7PartitionCapabilities partitionCapabilities) {
        this.partitionCapabilities = partitionCapabilities;
    }

    public String getPartitionID() {
        return partitionID;
    }

    public void setPartitionID(String partitionID) {
        this.partitionID = partitionID;
    }

    public V7PartitionIOConfiguration getPartitionIOConfiguration() {
        return partitionIOConfiguration;
    }

    public void setPartitionIOConfiguration(V7PartitionIOConfiguration partitionIOConfiguration) {
        this.partitionIOConfiguration = partitionIOConfiguration;
    }

    public V7PartitionMemoryConfiguration getPartitionMemoryConfiguration() {
        return partitionMemoryConfiguration;
    }

    public void setPartitionMemoryConfiguration(V7PartitionMemoryConfiguration partitionMemoryConfiguration) {
        this.partitionMemoryConfiguration = partitionMemoryConfiguration;
    }

    public String getPartitionName() {
        return partitionName;
    }

    public void setPartitionName(String partitionName) {
        this.partitionName = partitionName;
    }

    public V7PartitionProcessorConfiguration getPartitionProcessorConfiguration() {
        return partitionProcessorConfiguration;
    }

    public void setPartitionProcessorConfiguration(V7PartitionProcessorConfiguration partitionProcessorConfiguration) {
        this.partitionProcessorConfiguration = partitionProcessorConfiguration;
    }

    public V7PartitionProfiles getPartitionProfiles() {
        return partitionProfiles;
    }

    public void setPartitionProfiles(V7PartitionProfiles partitionProfiles) {
        this.partitionProfiles = partitionProfiles;
    }

    public String getPartitionState() {
        return partitionState;
    }

    public void setPartitionState(String partitionState) {
        this.partitionState = partitionState;
    }

    public String getPartitionType() {
        return partitionType;
    }

    public void setPartitionType(String partitionType) {
        this.partitionType = partitionType;
    }

    public String getPartitionUUID() {
        return partitionUUID;
    }

    public void setPartitionUUID(String partitionUUID) {
        this.partitionUUID = partitionUUID;
    }

    public String getPendingProcessorCompatibilityMode() {
        return pendingProcessorCompatibilityMode;
    }

    public void setPendingProcessorCompatibilityMode(String pendingProcessorCompatibilityMode) {
        this.pendingProcessorCompatibilityMode = pendingProcessorCompatibilityMode;
    }

    public V7ProcessorPool getProcessorPool() {
        return processorPool;
    }

    public void setProcessorPool(V7ProcessorPool processorPool) {
        this.processorPool = processorPool;
    }

    public String getProgressState() {
        return progressState;
    }

    public void setProgressState(String progressState) {
        this.progressState = progressState;
    }

    public String getResourceMonitoringControlState() {
        return resourceMonitoringControlState;
    }

    public void setResourceMonitoringControlState(String resourceMonitoringControlState) {
        this.resourceMonitoringControlState = resourceMonitoringControlState;
    }

    public String getResourceMonitoringIPAddress() {
        return resourceMonitoringIPAddress;
    }

    public void setResourceMonitoringIPAddress(String resourceMonitoringIPAddress) {
        this.resourceMonitoringIPAddress = resourceMonitoringIPAddress;
    }

    public V7AssociatedManagedSystem getAssociatedManagedSystem() {
        return associatedManagedSystem;
    }

    public void setAssociatedManagedSystem(V7AssociatedManagedSystem associatedManagedSystem) {
        this.associatedManagedSystem = associatedManagedSystem;
    }

    public V7HostEthernetAdapterLogicalPorts getHostEthernetAdapterLogicalPorts() {
        return hostEthernetAdapterLogicalPorts;
    }

    public void setHostEthernetAdapterLogicalPorts(V7HostEthernetAdapterLogicalPorts hostEthernetAdapterLogicalPorts) {
        this.hostEthernetAdapterLogicalPorts = hostEthernetAdapterLogicalPorts;
    }

    public String getIsServicePartition() {
        return isServicePartition;
    }

    public void setIsServicePartition(String isServicePartition) {
        this.isServicePartition = isServicePartition;
    }

    public String getReferenceCode() {
        return referenceCode;
    }

    public void setReferenceCode(String referenceCode) {
        this.referenceCode = referenceCode;
    }

    public V7PowerOnWithHypervisor getPowerOnWithHypervisor() {
        return powerOnWithHypervisor;
    }

    public void setPowerOnWithHypervisor(V7PowerOnWithHypervisor powerOnWithHypervisor) {
        this.powerOnWithHypervisor = powerOnWithHypervisor;
    }

    public String getRemoteRestartCapable() {
        return remoteRestartCapable;
    }

    public void setRemoteRestartCapable(String remoteRestartCapable) {
        this.remoteRestartCapable = remoteRestartCapable;
    }

    public V7SimplifiedRemoteRestartCapable getSimplifiedRemoteRestartCapable() {
        return simplifiedRemoteRestartCapable;
    }

    public void setSimplifiedRemoteRestartCapable(V7SimplifiedRemoteRestartCapable simplifiedRemoteRestartCapable) {
        this.simplifiedRemoteRestartCapable = simplifiedRemoteRestartCapable;
    }

    public String getHasDedicatedProcessorsForMigration() {
        return hasDedicatedProcessorsForMigration;
    }

    public void setHasDedicatedProcessorsForMigration(String hasDedicatedProcessorsForMigration) {
        this.hasDedicatedProcessorsForMigration = hasDedicatedProcessorsForMigration;
    }

    public String getSuspendCapable() {
        return suspendCapable;
    }

    public void setSuspendCapable(String suspendCapable) {
        this.suspendCapable = suspendCapable;
    }

    public String getRemoteRestartState() {
        return remoteRestartState;
    }

    public void setRemoteRestartState(String remoteRestartState) {
        this.remoteRestartState = remoteRestartState;
    }

    public V7ClientNetworkAdapters getClientNetworkAdapters() {
        return clientNetworkAdapters;
    }

    public void setClientNetworkAdapters(V7ClientNetworkAdapters clientNetworkAdapters) {
        this.clientNetworkAdapters = clientNetworkAdapters;
    }

    public V7VirtualSCSIClientAdapters getVirtualSCSIClientAdapters() {
        return VirtualSCSIClientAdapters;
    }

    public void setVirtualSCSIClientAdapters(V7VirtualSCSIClientAdapters virtualSCSIClientAdapters) {
        VirtualSCSIClientAdapters = virtualSCSIClientAdapters;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this, true);
    }

}
