package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Atom;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "LogicalVolumeVirtualTargetDevice")
public class V7LogicalVolumeVirtualTargetDevice {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "LogicalUnitAddress")
    private String logicalUnitAddress;

    @XmlElement(name = "TargetName")
    private String targetName;

    @XmlElement(name = "UniqueDeviceID")
    private String uniqueDeviceID;

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public String getLogicalUnitAddress() {
        return logicalUnitAddress;
    }

    public void setLogicalUnitAddress(String logicalUnitAddress) {
        this.logicalUnitAddress = logicalUnitAddress;
    }

    public String getTargetName() {
        return targetName;
    }

    public void setTargetName(String targetName) {
        this.targetName = targetName;
    }

    public String getUniqueDeviceID() {
        return uniqueDeviceID;
    }

    public void setUniqueDeviceID(String uniqueDeviceID) {
        this.uniqueDeviceID = uniqueDeviceID;
    }

    public V7LogicalVolumeVirtualTargetDevice() {
    }

    public V7LogicalVolumeVirtualTargetDevice(String logicalUnitAddress, String targetName, String uniqueDeviceID) {
        super();
        this.metadata = new V7Metadata(new V7Atom());
        this.logicalUnitAddress = logicalUnitAddress;
        this.targetName = targetName;
        this.uniqueDeviceID = uniqueDeviceID;
    }

    public V7LogicalVolumeVirtualTargetDevice(String logicalUnitAddress, String targetName) {
        super();
        this.metadata = new V7Metadata(new V7Atom());
        this.logicalUnitAddress = logicalUnitAddress;
        this.targetName = targetName;
    }

    public V7LogicalVolumeVirtualTargetDevice(String targetName) {
        super();
        this.metadata = new V7Metadata(new V7Atom());
        this.targetName = targetName;
    }

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }

}
