package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

/**
 * 控制台信息的ManagementConsole部分
 * <p>
 * ManagementConsole
 * </p>
 *
 * @author sxp
 * @since May 4, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "ManagementConsole")
public class V7MC {
    @XmlAttribute
    private String xmlns;

    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "MachineTypeModelAndSerialNumber")
    private V7MachineTypeModelAndSerialNumber machineTypeModelAndSerialNumber;

    @XmlElement(name = "ManagedSystems")
    private V7ManagedSystems managedSystems;

    @XmlElement(name = "ManagementConsoleName")
    private V7ManagementConsoleName mManagementConsoleName;

    @XmlElement(name = "NetworkInterfaces")
    private V7NetworkInterfaces networkInterfaces;

    @XmlElement(name = "TemplateObjectModelVersion")
    private V7TemplateObjectModelVersion templateObjectModelVersion;

    @XmlElement(name = "UserObjectModelVersion")
    private V7UserObjectModelVersion userObjectModelVersion;

    @XmlElement(name = "VersionInfo")
    private V7VersionInfo versionInfo;

    @XmlElement(name = "WebObjectModelVersion")
    private V7WebObjectModelVersion webObjectModelVersion;

    @XmlElement(name = "BIOS")
    private V7BIOS bIOS;

    @XmlElement(name = "BaseVersion")
    private V7BaseVersion baseVersion;

    @XmlElement(name = "Driver")
    private V7Driver driver;

    @XmlElement(name = "LicenseID")
    private V7LicenseID licenseID;

    @XmlElement(name = "LicenseFirstYear")
    private V7LicenseFirstYear licenseFirstYear;

    public V7MC() {
    }

    public String getXmlns() {
        return xmlns;
    }

    public void setXmlns(String xmlns) {
        this.xmlns = xmlns;
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public V7MachineTypeModelAndSerialNumber getMachineTypeModelAndSerialNumber() {
        return machineTypeModelAndSerialNumber;
    }

    public void setMachineTypeModelAndSerialNumber(V7MachineTypeModelAndSerialNumber machineTypeModelAndSerialNumber) {
        this.machineTypeModelAndSerialNumber = machineTypeModelAndSerialNumber;
    }

    public V7ManagedSystems getManagedSystems() {
        return managedSystems;
    }

    public void setManagedSystems(V7ManagedSystems managedSystems) {
        this.managedSystems = managedSystems;
    }

    public V7ManagementConsoleName getmManagementConsoleName() {
        return mManagementConsoleName;
    }

    public void setmManagementConsoleName(V7ManagementConsoleName mManagementConsoleName) {
        this.mManagementConsoleName = mManagementConsoleName;
    }

    public V7NetworkInterfaces getNetworkInterfaces() {
        return networkInterfaces;
    }

    public void setNetworkInterfaces(V7NetworkInterfaces networkInterfaces) {
        this.networkInterfaces = networkInterfaces;
    }

    public V7TemplateObjectModelVersion getTemplateObjectModelVersion() {
        return templateObjectModelVersion;
    }

    public void setTemplateObjectModelVersion(V7TemplateObjectModelVersion templateObjectModelVersion) {
        this.templateObjectModelVersion = templateObjectModelVersion;
    }

    public V7UserObjectModelVersion getUserObjectModelVersion() {
        return userObjectModelVersion;
    }

    public void setUserObjectModelVersion(V7UserObjectModelVersion userObjectModelVersion) {
        this.userObjectModelVersion = userObjectModelVersion;
    }

    public V7VersionInfo getVersionInfo() {
        return versionInfo;
    }

    public void setVersionInfo(V7VersionInfo versionInfo) {
        this.versionInfo = versionInfo;
    }

    public V7WebObjectModelVersion getWebObjectModelVersion() {
        return webObjectModelVersion;
    }

    public void setWebObjectModelVersion(V7WebObjectModelVersion webObjectModelVersion) {
        this.webObjectModelVersion = webObjectModelVersion;
    }

    public V7BIOS getbIOS() {
        return bIOS;
    }

    public void setbIOS(V7BIOS bIOS) {
        this.bIOS = bIOS;
    }

    public V7BaseVersion getBaseVersion() {
        return baseVersion;
    }

    public void setBaseVersion(V7BaseVersion baseVersion) {
        this.baseVersion = baseVersion;
    }

    public V7Driver getDriver() {
        return driver;
    }

    public void setDriver(V7Driver driver) {
        this.driver = driver;
    }

    public V7LicenseID getLicenseID() {
        return licenseID;
    }

    public void setLicenseID(V7LicenseID licenseID) {
        this.licenseID = licenseID;
    }

    public V7LicenseFirstYear getLicenseFirstYear() {
        return licenseFirstYear;
    }

    public void setLicenseFirstYear(V7LicenseFirstYear licenseFirstYear) {
        this.licenseFirstYear = licenseFirstYear;
    }

    @Override
    public String toString() {
        return "MC [xmlns=" + xmlns + ", schemaVersion=" + schemaVersion + ", metadata=" + metadata
                + ", machineTypeModelAndSerialNumber=" + machineTypeModelAndSerialNumber + ", managedSystems="
                + managedSystems + ", mManagementConsoleName=" + mManagementConsoleName + ", networkInterfaces="
                + networkInterfaces + ", templateObjectModelVersion=" + templateObjectModelVersion
                + ", userObjectModelVersion=" + userObjectModelVersion + ", versionInfo=" + versionInfo
                + ", webObjectModelVersion=" + webObjectModelVersion + ", bIOS=" + bIOS + ", baseVersion=" + baseVersion
                + ", driver=" + driver + ", licenseID=" + licenseID + ", licenseFirstYear=" + licenseFirstYear + "]";
    }

}
