package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "ManagedSystem")
public class V7ManagedSystem {

    @XmlAttribute(name = "schemaVersion")
    private String schemaVersion;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "ActivatedLevel")
    private String activatedLevel;

    @XmlElement(name = "AssociatedIPLConfiguration")
    private V7AssociatedIPLConfiguration associatedIPLConfiguration;

    @XmlElement(name = "AssociatedLogicalPartitions")
    private V7AssociatedLogicalPartitions associatedLogicalPartitions;

    @XmlElement(name = "AssociatedSystemCapabilities")
    private V7AssociatedSystemCapabilities associatedSystemCapabilities;

    @XmlElement(name = "AssociatedSystemIOConfiguration")
    private V7AssociatedSystemIOConfiguration associatedSystemIOConfiguration;

    @XmlElement(name = "AssociatedSystemMemoryConfiguration")
    private V7AssociatedSystemMemoryConfiguration associatedSystemMemoryConfiguration;

    @XmlElement(name = "AssociatedSystemProcessorConfiguration")
    private V7AssociatedSystemProcessorConfiguration associatedSystemProcessorConfiguration;

    @XmlElement(name = "AssociatedVirtualIOServers")
    private V7AssociatedVirtualIOServers associatedVirtualIOServers;

    @XmlElement(name = "MachineTypeModelAndSerialNumber")
    private V7MachineTypeModelAndSerialNumber machineTypeModelAndSerialNumber;

    @XmlElement(name = "ManufacturingDefaultConfigurationEnabled")
    private String manufacturingDefaultConfigurationEnabled;

    @XmlElement(name = "MaximumPartitions")
    private String maximumPartitions;

    @XmlElement(name = "MaximumPowerControlPartitions")
    private String maximumPowerControlPartitions;

    @XmlElement(name = "MaximumRemoteRestartPartitions")
    private String maximumRemoteRestartPartitions;

    @XmlElement(name = "MaximumSharedProcessorCapablePartitionID")
    private String maximumSharedProcessorCapablePartitionID;

    @XmlElement(name = "MaximumSuspendablePartitions")
    private String maximumSuspendablePartitions;

    @XmlElement(name = "PhysicalSystemAttentionLEDState")
    private String physicalSystemAttentionLEDState;

    @XmlElement(name = "PrimaryIPAddress")
    private String primaryIPAddress;

    @XmlElement(name = "Hostname")
    private V7Hostname hostname;

    @XmlElement(name = "ServiceProcessorFailoverEnabled")
    private V7ServiceProcessorFailoverEnabled serviceProcessorFailoverEnabled;

    @XmlElement(name = "ServiceProcessorFailoverReason")
    private V7ServiceProcessorFailoverReason serviceProcessorFailoverReason;

    @XmlElement(name = "ServiceProcessorFailoverState")
    private V7ServiceProcessorFailoverState serviceProcessorFailoverState;

    @XmlElement(name = "ServiceProcessorVersion")
    private String serviceProcessorVersion;

    @XmlElement(name = "State")
    private String state;

    @XmlElement(name = "SystemName")
    private String systemName;

    @XmlElement(name = "SystemTime")
    private String systemTime;

    @XmlElement(name = "VirtualSystemAttentionLEDState")
    private String virtualSystemAttentionLEDState;

    @XmlElement(name = "SystemMigrationInformation")
    private V7SystemMigrationInformation systemMigrationInformation;

    @XmlElement(name = "ServicePartition")
    private V7ServicePartition servicePartition;

    @XmlElement(name = "ReferenceCode")
    private String referenceCode;

    @XmlElement(name = "MergedReferenceCode")
    private V7MergedReferenceCode mergedReferenceCode;

    @XmlElement(name = "SystemFirmware")
    private V7SystemFirmware systemFirmware;

    @XmlElement(name = "CapacityOnDemandProperties")
    private V7CapacityOnDemandProperties capacityOnDemandProperties;

    @XmlElement(name = "EnergyManagementConfiguration")
    private V7EnergyManagementConfiguration energyManagementConfiguration;

    @XmlElement(name = "IsPowerVMManagementMaster")
    private V7IsPowerVMManagementMaster isPowerVMManagementMaster;

    @XmlElement(name = "IsClassicHMCManagement")
    private V7IsClassicHMCManagement isClassicHMCManagement;

    @XmlElement(name = "IsPowerVMManagementWithoutMaster")
    private V7IsPowerVMManagementWithoutMaster isPowerVMManagementWithoutMaster;

    @XmlElement(name = "IsManagementPartitionPowerVMManagementMaster")
    private V7IsManagementPartitionPowerVMManagementMaster isManagementPartitionPowerVMManagementMaster;

    @XmlElement(name = "IsHMCPowerVMManagementMaster")
    private V7IsHMCPowerVMManagementMaster isHMCPowerVMManagementMaster;

    @XmlElement(name = "IsNotPowerVMManagementMaster")
    private V7isNotPowerVMManagementMaster isNotPowerVMManagementMaster;

    @XmlElement(name = "IsPowerVMManagementNormalMaster")
    private V7IsPowerVMManagementNormalMaster isPowerVMManagementNormalMaster;

    @XmlElement(name = "IsPowerVMManagementPersistentMaster")
    private V7IsPowerVMManagementPersistentMaster isPowerVMManagementPersistentMaster;

    @XmlElement(name = "IsPowerVMManagementTemporaryMaster")
    private V7IsPowerVMManagementTemporaryMaster isPowerVMManagementTemporaryMaster;

    @XmlElement(name = "IsPowerVMManagementPartitionEnabled")
    private V7IsPowerVMManagementPartitionEnabled isPowerVMManagementPartitionEnabled;

    @XmlElement(name = "Description")
    private V7Description description;

    @XmlElement(name = "SystemLocation")
    private V7SystemLocation systemLocation;


    public V7ManagedSystem() {
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public String getActivatedLevel() {
        return activatedLevel;
    }

    public void setActivatedLevel(String activatedLevel) {
        this.activatedLevel = activatedLevel;
    }

    public V7AssociatedIPLConfiguration getAssociatedIPLConfiguration() {
        return associatedIPLConfiguration;
    }

    public void setAssociatedIPLConfiguration(V7AssociatedIPLConfiguration associatedIPLConfiguration) {
        this.associatedIPLConfiguration = associatedIPLConfiguration;
    }

    public V7AssociatedLogicalPartitions getAssociatedLogicalPartitions() {
        return associatedLogicalPartitions;
    }

    public void setAssociatedLogicalPartitions(V7AssociatedLogicalPartitions associatedLogicalPartitions) {
        this.associatedLogicalPartitions = associatedLogicalPartitions;
    }

    public V7AssociatedSystemCapabilities getAssociatedSystemCapabilities() {
        return associatedSystemCapabilities;
    }

    public void setAssociatedSystemCapabilities(V7AssociatedSystemCapabilities associatedSystemCapabilities) {
        this.associatedSystemCapabilities = associatedSystemCapabilities;
    }

    public V7AssociatedSystemIOConfiguration getAssociatedSystemIOConfiguration() {
        return associatedSystemIOConfiguration;
    }

    public void setAssociatedSystemIOConfiguration(V7AssociatedSystemIOConfiguration associatedSystemIOConfiguration) {
        this.associatedSystemIOConfiguration = associatedSystemIOConfiguration;
    }

    public V7AssociatedSystemMemoryConfiguration getAssociatedSystemMemoryConfiguration() {
        return associatedSystemMemoryConfiguration;
    }

    public void setAssociatedSystemMemoryConfiguration(
            V7AssociatedSystemMemoryConfiguration associatedSystemMemoryConfiguration) {
        this.associatedSystemMemoryConfiguration = associatedSystemMemoryConfiguration;
    }

    public V7AssociatedSystemProcessorConfiguration getAssociatedSystemProcessorConfiguration() {
        return associatedSystemProcessorConfiguration;
    }

    public void setAssociatedSystemProcessorConfiguration(
            V7AssociatedSystemProcessorConfiguration associatedSystemProcessorConfiguration) {
        this.associatedSystemProcessorConfiguration = associatedSystemProcessorConfiguration;
    }

    public V7AssociatedVirtualIOServers getAssociatedVirtualIOServers() {
        return associatedVirtualIOServers;
    }

    public void setAssociatedVirtualIOServers(V7AssociatedVirtualIOServers associatedVirtualIOServers) {
        this.associatedVirtualIOServers = associatedVirtualIOServers;
    }

    public V7MachineTypeModelAndSerialNumber getMachineTypeModelAndSerialNumber() {
        return machineTypeModelAndSerialNumber;
    }

    public void setMachineTypeModelAndSerialNumber(V7MachineTypeModelAndSerialNumber machineTypeModelAndSerialNumber) {
        this.machineTypeModelAndSerialNumber = machineTypeModelAndSerialNumber;
    }

    public String getManufacturingDefaultConfigurationEnabled() {
        return manufacturingDefaultConfigurationEnabled;
    }

    public void setManufacturingDefaultConfigurationEnabled(String manufacturingDefaultConfigurationEnabled) {
        this.manufacturingDefaultConfigurationEnabled = manufacturingDefaultConfigurationEnabled;
    }

    public String getMaximumPartitions() {
        return maximumPartitions;
    }

    public void setMaximumPartitions(String maximumPartitions) {
        this.maximumPartitions = maximumPartitions;
    }

    public String getMaximumPowerControlPartitions() {
        return maximumPowerControlPartitions;
    }

    public void setMaximumPowerControlPartitions(String maximumPowerControlPartitions) {
        this.maximumPowerControlPartitions = maximumPowerControlPartitions;
    }

    public String getMaximumRemoteRestartPartitions() {
        return maximumRemoteRestartPartitions;
    }

    public void setMaximumRemoteRestartPartitions(String maximumRemoteRestartPartitions) {
        this.maximumRemoteRestartPartitions = maximumRemoteRestartPartitions;
    }

    public String getMaximumSharedProcessorCapablePartitionID() {
        return maximumSharedProcessorCapablePartitionID;
    }

    public void setMaximumSharedProcessorCapablePartitionID(String maximumSharedProcessorCapablePartitionID) {
        this.maximumSharedProcessorCapablePartitionID = maximumSharedProcessorCapablePartitionID;
    }

    public String getMaximumSuspendablePartitions() {
        return maximumSuspendablePartitions;
    }

    public void setMaximumSuspendablePartitions(String maximumSuspendablePartitions) {
        this.maximumSuspendablePartitions = maximumSuspendablePartitions;
    }

    public String getPhysicalSystemAttentionLEDState() {
        return physicalSystemAttentionLEDState;
    }

    public void setPhysicalSystemAttentionLEDState(String physicalSystemAttentionLEDState) {
        this.physicalSystemAttentionLEDState = physicalSystemAttentionLEDState;
    }

    public String getPrimaryIPAddress() {
        return primaryIPAddress;
    }

    public void setPrimaryIPAddress(String primaryIPAddress) {
        this.primaryIPAddress = primaryIPAddress;
    }

    public V7Hostname getHostname() {
        return hostname;
    }

    public void setHostname(V7Hostname hostname) {
        this.hostname = hostname;
    }

    public V7ServiceProcessorFailoverEnabled getServiceProcessorFailoverEnabled() {
        return serviceProcessorFailoverEnabled;
    }

    public void setServiceProcessorFailoverEnabled(V7ServiceProcessorFailoverEnabled serviceProcessorFailoverEnabled) {
        this.serviceProcessorFailoverEnabled = serviceProcessorFailoverEnabled;
    }

    public V7ServiceProcessorFailoverReason getServiceProcessorFailoverReason() {
        return serviceProcessorFailoverReason;
    }

    public void setServiceProcessorFailoverReason(V7ServiceProcessorFailoverReason serviceProcessorFailoverReason) {
        this.serviceProcessorFailoverReason = serviceProcessorFailoverReason;
    }

    public V7ServiceProcessorFailoverState getServiceProcessorFailoverState() {
        return serviceProcessorFailoverState;
    }

    public void setServiceProcessorFailoverState(V7ServiceProcessorFailoverState serviceProcessorFailoverState) {
        this.serviceProcessorFailoverState = serviceProcessorFailoverState;
    }

    public String getServiceProcessorVersion() {
        return serviceProcessorVersion;
    }

    public void setServiceProcessorVersion(String serviceProcessorVersion) {
        this.serviceProcessorVersion = serviceProcessorVersion;
    }

    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    public String getSystemName() {
        return systemName;
    }

    public void setSystemName(String systemName) {
        this.systemName = systemName;
    }

    public String getSystemTime() {
        return systemTime;
    }

    public void setSystemTime(String systemTime) {
        this.systemTime = systemTime;
    }

    public String getVirtualSystemAttentionLEDState() {
        return virtualSystemAttentionLEDState;
    }

    public void setVirtualSystemAttentionLEDState(String virtualSystemAttentionLEDState) {
        this.virtualSystemAttentionLEDState = virtualSystemAttentionLEDState;
    }

    public V7SystemMigrationInformation getSystemMigrationInformation() {
        return systemMigrationInformation;
    }

    public void setSystemMigrationInformation(V7SystemMigrationInformation systemMigrationInformation) {
        this.systemMigrationInformation = systemMigrationInformation;
    }

    public String getReferenceCode() {
        return referenceCode;
    }

    public void setReferenceCode(String referenceCode) {
        this.referenceCode = referenceCode;
    }

    public V7MergedReferenceCode getMergedReferenceCode() {
        return mergedReferenceCode;
    }

    public void setMergedReferenceCode(V7MergedReferenceCode mergedReferenceCode) {
        this.mergedReferenceCode = mergedReferenceCode;
    }

    public V7SystemFirmware getSystemFirmware() {
        return systemFirmware;
    }

    public void setSystemFirmware(V7SystemFirmware systemFirmware) {
        this.systemFirmware = systemFirmware;
    }

    public V7CapacityOnDemandProperties getCapacityOnDemandProperties() {
        return capacityOnDemandProperties;
    }

    public void setCapacityOnDemandProperties(V7CapacityOnDemandProperties capacityOnDemandProperties) {
        this.capacityOnDemandProperties = capacityOnDemandProperties;
    }

    public V7EnergyManagementConfiguration getEnergyManagementConfiguration() {
        return energyManagementConfiguration;
    }

    public void setEnergyManagementConfiguration(V7EnergyManagementConfiguration energyManagementConfiguration) {
        this.energyManagementConfiguration = energyManagementConfiguration;
    }

    public V7IsPowerVMManagementMaster getIsPowerVMManagementMaster() {
        return isPowerVMManagementMaster;
    }

    public void setIsPowerVMManagementMaster(V7IsPowerVMManagementMaster isPowerVMManagementMaster) {
        this.isPowerVMManagementMaster = isPowerVMManagementMaster;
    }

    public V7IsClassicHMCManagement getIsClassicHMCManagement() {
        return isClassicHMCManagement;
    }

    public void setIsClassicHMCManagement(V7IsClassicHMCManagement isClassicHMCManagement) {
        this.isClassicHMCManagement = isClassicHMCManagement;
    }

    public V7IsPowerVMManagementWithoutMaster getIsPowerVMManagementWithoutMaster() {
        return isPowerVMManagementWithoutMaster;
    }

    public void setIsPowerVMManagementWithoutMaster(V7IsPowerVMManagementWithoutMaster isPowerVMManagementWithoutMaster) {
        this.isPowerVMManagementWithoutMaster = isPowerVMManagementWithoutMaster;
    }

    public V7IsManagementPartitionPowerVMManagementMaster getIsManagementPartitionPowerVMManagementMaster() {
        return isManagementPartitionPowerVMManagementMaster;
    }

    public void setIsManagementPartitionPowerVMManagementMaster(V7IsManagementPartitionPowerVMManagementMaster isManagementPartitionPowerVMManagementMaster) {
        this.isManagementPartitionPowerVMManagementMaster = isManagementPartitionPowerVMManagementMaster;
    }

    public V7IsHMCPowerVMManagementMaster getIsHMCPowerVMManagementMaster() {
        return isHMCPowerVMManagementMaster;
    }

    public void setIsHMCPowerVMManagementMaster(V7IsHMCPowerVMManagementMaster isHMCPowerVMManagementMaster) {
        this.isHMCPowerVMManagementMaster = isHMCPowerVMManagementMaster;
    }

    public V7isNotPowerVMManagementMaster getIsNotPowerVMManagementMaster() {
        return isNotPowerVMManagementMaster;
    }

    public void setIsNotPowerVMManagementMaster(V7isNotPowerVMManagementMaster isNotPowerVMManagementMaster) {
        this.isNotPowerVMManagementMaster = isNotPowerVMManagementMaster;
    }

    public V7IsPowerVMManagementNormalMaster getIsPowerVMManagementNormalMaster() {
        return isPowerVMManagementNormalMaster;
    }

    public void setIsPowerVMManagementNormalMaster(V7IsPowerVMManagementNormalMaster isPowerVMManagementNormalMaster) {
        this.isPowerVMManagementNormalMaster = isPowerVMManagementNormalMaster;
    }

    public V7IsPowerVMManagementPersistentMaster getIsPowerVMManagementPersistentMaster() {
        return isPowerVMManagementPersistentMaster;
    }

    public void setIsPowerVMManagementPersistentMaster(V7IsPowerVMManagementPersistentMaster isPowerVMManagementPersistentMaster) {
        this.isPowerVMManagementPersistentMaster = isPowerVMManagementPersistentMaster;
    }

    public V7IsPowerVMManagementTemporaryMaster getIsPowerVMManagementTemporaryMaster() {
        return isPowerVMManagementTemporaryMaster;
    }

    public void setIsPowerVMManagementTemporaryMaster(V7IsPowerVMManagementTemporaryMaster isPowerVMManagementTemporaryMaster) {
        this.isPowerVMManagementTemporaryMaster = isPowerVMManagementTemporaryMaster;
    }

    public V7IsPowerVMManagementPartitionEnabled getIsPowerVMManagementPartitionEnabled() {
        return isPowerVMManagementPartitionEnabled;
    }

    public void setIsPowerVMManagementPartitionEnabled(V7IsPowerVMManagementPartitionEnabled isPowerVMManagementPartitionEnabled) {
        this.isPowerVMManagementPartitionEnabled = isPowerVMManagementPartitionEnabled;
    }

    public V7Description getDescription() {
        return description;
    }

    public void setDescription(V7Description description) {
        this.description = description;
    }

    public V7SystemLocation getSystemLocation() {
        return systemLocation;
    }

    public void setSystemLocation(V7SystemLocation systemLocation) {
        this.systemLocation = systemLocation;
    }

    public V7ServicePartition getServicePartition() {
        return servicePartition;
    }

    public void setServicePartition(V7ServicePartition servicePartition) {
        this.servicePartition = servicePartition;
    }

    @Override
    public String toString() {
        return "ManagedSystem [metadata=" + metadata + ", activatedLevel=" + activatedLevel
                + ", associatedIPLConfiguration=" + associatedIPLConfiguration + ", associatedLogicalPartitions="
                + associatedLogicalPartitions + ", associatedSystemCapabilities=" + associatedSystemCapabilities
                + ", associatedSystemIOConfiguration=" + associatedSystemIOConfiguration
                + ", associatedSystemMemoryConfiguration=" + associatedSystemMemoryConfiguration
                + ", associatedSystemProcessorConfiguration=" + associatedSystemProcessorConfiguration
                + ", associatedVirtualIOServers=" + associatedVirtualIOServers + ", machineTypeModelAndSerialNumber="
                + machineTypeModelAndSerialNumber + ", manufacturingDefaultConfigurationEnabled="
                + manufacturingDefaultConfigurationEnabled + ", maximumPartitions=" + maximumPartitions
                + ", maximumPowerControlPartitions=" + maximumPowerControlPartitions
                + ", maximumRemoteRestartPartitions=" + maximumRemoteRestartPartitions
                + ", maximumSharedProcessorCapablePartitionID=" + maximumSharedProcessorCapablePartitionID
                + ", maximumSuspendablePartitions=" + maximumSuspendablePartitions
                + ", physicalSystemAttentionLEDState=" + physicalSystemAttentionLEDState + ", primaryIPAddress="
                + primaryIPAddress + ", hostname=" + hostname + ", serviceProcessorFailoverEnabled="
                + serviceProcessorFailoverEnabled + ", serviceProcessorFailoverReason=" + serviceProcessorFailoverReason
                + ", serviceProcessorFailoverState=" + serviceProcessorFailoverState + ", serviceProcessorVersion="
                + serviceProcessorVersion + ", state=" + state + ", systemName=" + systemName + ", systemTime="
                + systemTime + ", virtualSystemAttentionLEDState=" + virtualSystemAttentionLEDState
                + ", systemMigrationInformation=" + systemMigrationInformation + ", referenceCode=" + referenceCode
                + ", mergedReferenceCode=" + mergedReferenceCode + ", systemFirmware=" + systemFirmware
                + ", capacityOnDemandProperties=" + capacityOnDemandProperties + "]";
    }

}
