package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7ResponseBase;

import javax.xml.bind.annotation.*;
import java.util.List;

/**
 * HMC控制台管理的所有系统信息(V7)
 *
 * @author sxp
 * @since May 7, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "feed")
public class V7ManagedSystemResponse extends V7ResponseBase {
    @XmlAttribute
    private String xmlns;

    @XmlElement(name = "entry")
    private List<V7ManagedSystemEntry> entries;

    public V7ManagedSystemResponse() {
    }

    public String getXmlns() {
        return xmlns;
    }

    public void setXmlns(String xmlns) {
        this.xmlns = xmlns;
    }

    @Override
    public String getId() {
        return id;
    }

    @Override
    public void setId(String id) {
        this.id = id;
    }

    @Override
    public String getUpdated() {
        return updated;
    }

    @Override
    public void setUpdated(String updated) {
        this.updated = updated;
    }

    @Override
    public List<V7Link> getLink() {
        return link;
    }

    @Override
    public void setLink(List<V7Link> link) {
        this.link = link;
    }

    @Override
    public String getGenerator() {
        return generator;
    }

    @Override
    public void setGenerator(String generator) {
        this.generator = generator;
    }

    public List<V7ManagedSystemEntry> getEntries() {
        return entries;
    }

    public void setEntries(List<V7ManagedSystemEntry> entries) {
        this.entries = entries;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }

}
