package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "ProcessorAttributes")
public class V7ProcessorAttributes {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "DedicatedProcessorConfiguration")
    private V7DedicatedProcessorConfiguration dedicatedProcessorConfiguration;

    @XmlElement(name = "HasDedicatedProcessors")
    private String hasDedicatedProcessors;

    @XmlElement(name = "SharedProcessorConfiguration")
    private V7SharedProcessorConfiguration sharedProcessorConfiguration;

    @XmlElement(name = "SharingMode")
    private String sharingMode;

    public V7ProcessorAttributes() {
    }

    /**
     * @return the schemaVersion
     */
    public String getSchemaVersion() {
        return schemaVersion;
    }

    /**
     * @param schemaVersion the schemaVersion to set
     */
    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public String getHasDedicatedProcessors() {
        return hasDedicatedProcessors;
    }

    public void setHasDedicatedProcessors(String hasDedicatedProcessors) {
        this.hasDedicatedProcessors = hasDedicatedProcessors;
    }

    public V7SharedProcessorConfiguration getSharedProcessorConfiguration() {
        return sharedProcessorConfiguration;
    }

    public void setSharedProcessorConfiguration(V7SharedProcessorConfiguration sharedProcessorConfiguration) {
        this.sharedProcessorConfiguration = sharedProcessorConfiguration;
    }

    public String getSharingMode() {
        return sharingMode;
    }

    public void setSharingMode(String sharingMode) {
        this.sharingMode = sharingMode;
    }

    /**
     * @return the dedicatedProcessorConfiguration
     */
    public V7DedicatedProcessorConfiguration getDedicatedProcessorConfiguration() {
        return dedicatedProcessorConfiguration;
    }

    /**
     * @param dedicatedProcessorConfiguration the dedicatedProcessorConfiguration to set
     */
    public void setDedicatedProcessorConfiguration(V7DedicatedProcessorConfiguration dedicatedProcessorConfiguration) {
        this.dedicatedProcessorConfiguration = dedicatedProcessorConfiguration;
    }

    @Override
    public String toString() {
        return "ProcessorAttributes [metadata=" + metadata + ", hasDedicatedProcessors=" + hasDedicatedProcessors
                + ", sharedProcessorConfiguration=" + sharedProcessorConfiguration
                + ", dedicatedProcessorConfiguration=" + dedicatedProcessorConfiguration + ", sharingMode="
                + sharingMode + "]";
    }

}
