package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

/**
 * 虚拟以太网适配器
 *
 * @author sxp
 * @since Jun 29, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "ProfileClientNetworkAdapter")
public class V7ProfileClientNetworkAdapter {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    /**
     * 以太网适配器ID
     */
    @XmlElement(name = "VirtualSlotNumber")
    private String virtualSlotNumber;

    /**
     * 要激活虚拟服务器，此适配器是否为必需的
     */
    @XmlElement(name = "IsRequired")
    private String isRequired;

    /**
     * 允许适配器的其他虚拟 LAN 标识
     */
    @XmlElement(name = "IsTaggedVLANSupported")
    private String isTaggedVlanSupported;

    /**
     * 端口虚拟以太网VLAN标识
     */
    @XmlElement(name = "PortVLANID")
    private String portVlanID;

    /**
     * isTaggedVlanSupported为true时，这个字段有值
     * <p>
     * 每个VLANID之间以一个空格分隔
     * </p>
     */
    @XmlElement(name = "TaggedVLANIDs")
    private String taggedVlanIds;

    @XmlElement(name = "IsQualityOfServicePriorityEnabled")
    private String isQualityOfServicePriorityEnabled;

    @XmlElement(name = "VirtualSwitchID")
    private String virtualSwitchID;

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public String getVirtualSlotNumber() {
        return virtualSlotNumber;
    }

    public void setVirtualSlotNumber(String virtualSlotNumber) {
        this.virtualSlotNumber = virtualSlotNumber;
    }

    public String getIsRequired() {
        return isRequired;
    }

    public void setIsRequired(String isRequired) {
        this.isRequired = isRequired;
    }

    public String getIsTaggedVlanSupported() {
        return isTaggedVlanSupported;
    }

    public void setIsTaggedVlanSupported(String isTaggedVlanSupported) {
        this.isTaggedVlanSupported = isTaggedVlanSupported;
    }

    public String getPortVlanID() {
        return portVlanID;
    }

    public void setPortVlanID(String portVlanID) {
        this.portVlanID = portVlanID;
    }

    public String getIsQualityOfServicePriorityEnabled() {
        return isQualityOfServicePriorityEnabled;
    }

    public void setIsQualityOfServicePriorityEnabled(String isQualityOfServicePriorityEnabled) {
        this.isQualityOfServicePriorityEnabled = isQualityOfServicePriorityEnabled;
    }

    public String getVirtualSwitchID() {
        return virtualSwitchID;
    }

    public void setVirtualSwitchID(String virtualSwitchID) {
        this.virtualSwitchID = virtualSwitchID;
    }

    public String getTaggedVlanIds() {
        return taggedVlanIds;
    }

    public void setTaggedVlanIds(String taggedVlanIds) {
        this.taggedVlanIds = taggedVlanIds;
    }

}
