package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "SharedProcessorConfiguration")
public class V7SharedProcessorConfiguration {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "DesiredProcessingUnits")
    private String desiredProcessingUnits;

    @XmlElement(name = "DesiredVirtualProcessors")
    private String desiredVirtualProcessors;

    @XmlElement(name = "MaximumProcessingUnits")
    private String maximumProcessingUnits;

    @XmlElement(name = "MaximumVirtualProcessors")
    private String maximumVirtualProcessors;

    @XmlElement(name = "MinimumProcessingUnits")
    private String minimumProcessingUnits;

    @XmlElement(name = "MinimumVirtualProcessors")
    private String minimumVirtualProcessors;

    @XmlElement(name = "SharedProcessorPoolID")
    private String sharedProcessorPoolID;

    @XmlElement(name = "UncappedWeight")
    private String uncappedWeight;

    public V7SharedProcessorConfiguration() {
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public String getDesiredProcessingUnits() {
        return desiredProcessingUnits;
    }

    public void setDesiredProcessingUnits(String desiredProcessingUnits) {
        this.desiredProcessingUnits = desiredProcessingUnits;
    }

    public String getDesiredVirtualProcessors() {
        return desiredVirtualProcessors;
    }

    public void setDesiredVirtualProcessors(String desiredVirtualProcessors) {
        this.desiredVirtualProcessors = desiredVirtualProcessors;
    }

    public String getMaximumProcessingUnits() {
        return maximumProcessingUnits;
    }

    public void setMaximumProcessingUnits(String maximumProcessingUnits) {
        this.maximumProcessingUnits = maximumProcessingUnits;
    }

    public String getMaximumVirtualProcessors() {
        return maximumVirtualProcessors;
    }

    public void setMaximumVirtualProcessors(String maximumVirtualProcessors) {
        this.maximumVirtualProcessors = maximumVirtualProcessors;
    }

    public String getMinimumProcessingUnits() {
        return minimumProcessingUnits;
    }

    public void setMinimumProcessingUnits(String minimumProcessingUnits) {
        this.minimumProcessingUnits = minimumProcessingUnits;
    }

    public String getMinimumVirtualProcessors() {
        return minimumVirtualProcessors;
    }

    public void setMinimumVirtualProcessors(String minimumVirtualProcessors) {
        this.minimumVirtualProcessors = minimumVirtualProcessors;
    }

    public String getSharedProcessorPoolID() {
        return sharedProcessorPoolID;
    }

    public void setSharedProcessorPoolID(String sharedProcessorPoolID) {
        this.sharedProcessorPoolID = sharedProcessorPoolID;
    }

    public String getUncappedWeight() {
        return uncappedWeight;
    }

    public void setUncappedWeight(String uncappedWeight) {
        this.uncappedWeight = uncappedWeight;
    }

    @Override
    public String toString() {
        return "SharedProcessorConfiguration [metadata=" + metadata + ", desiredProcessingUnits="
                + desiredProcessingUnits + ", desiredVirtualProcessors=" + desiredVirtualProcessors
                + ", maximumProcessingUnits=" + maximumProcessingUnits + ", maximumVirtualProcessors="
                + maximumVirtualProcessors + ", minimumProcessingUnits=" + minimumProcessingUnits
                + ", minimumVirtualProcessors=" + minimumVirtualProcessors + ", sharedProcessorPoolID="
                + sharedProcessorPoolID + ", uncappedWeight=" + uncappedWeight + "]";
    }

}
