package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

/**
 * 版本信息
 *
 * @author sxp
 * @since May 4, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "VersionInfo")
public class V7VersionInfo {
    @XmlAttribute
    private String kb;

    @XmlAttribute
    private String kxe;

    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "BuildLevel")
    private V7BuildLevel buildLevel;

    @XmlElement(name = "Maintenance")
    private V7Maintenance maintenance;

    @XmlElement(name = "Minor")
    private V7Minor minor;

    @XmlElement(name = "Release")
    private V7Release release;

    @XmlElement(name = "ServicePackName")
    private V7ServicePackName servicePackName;

    @XmlElement(name = "Version")
    private V7Version version;

    public V7VersionInfo() {
    }

    public String getKb() {
        return kb;
    }

    public void setKb(String kb) {
        this.kb = kb;
    }

    public String getKxe() {
        return kxe;
    }

    public void setKxe(String kxe) {
        this.kxe = kxe;
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public V7BuildLevel getBuildLevel() {
        return buildLevel;
    }

    public void setBuildLevel(V7BuildLevel buildLevel) {
        this.buildLevel = buildLevel;
    }

    public V7Maintenance getMaintenance() {
        return maintenance;
    }

    public void setMaintenance(V7Maintenance maintenance) {
        this.maintenance = maintenance;
    }

    public V7Minor getMinor() {
        return minor;
    }

    public void setMinor(V7Minor minor) {
        this.minor = minor;
    }

    public V7Release getRelease() {
        return release;
    }

    public void setRelease(V7Release release) {
        this.release = release;
    }

    public V7ServicePackName getServicePackName() {
        return servicePackName;
    }

    public void setServicePackName(V7ServicePackName servicePackName) {
        this.servicePackName = servicePackName;
    }

    public V7Version getVersion() {
        return version;
    }

    public void setVersion(V7Version version) {
        this.version = version;
    }

    @Override
    public String toString() {
        return "VersionInfo [kb=" + kb + ", kxe=" + kxe + ", schemaVersion=" + schemaVersion + ", metadata=" + metadata
                + ", buildLevel=" + buildLevel + ", maintenance=" + maintenance + ", minor=" + minor + ", release="
                + release + ", servicePackName=" + servicePackName + ", version=" + version + "]";
    }

}
