package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Atom;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "VirtualDisk")
public class V7VirtualDisk {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "DiskCapacity")
    private String diskCapacity;

    @XmlElement(name = "DiskLabel")
    private String diskLabel;

    @XmlElement(name = "DiskName")
    private String diskName;

    @XmlElement(name = "UniqueDeviceID")
    private String uniqueDeviceID;

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public String getDiskCapacity() {
        return diskCapacity;
    }

    public void setDiskCapacity(String diskCapacity) {
        this.diskCapacity = diskCapacity;
    }

    public String getDiskLabel() {
        return diskLabel;
    }

    public void setDiskLabel(String diskLabel) {
        this.diskLabel = diskLabel;
    }

    public String getDiskName() {
        return diskName;
    }

    public void setDiskName(String diskName) {
        this.diskName = diskName;
    }

    public String getUniqueDeviceID() {
        return uniqueDeviceID;
    }

    public void setUniqueDeviceID(String uniqueDeviceID) {
        this.uniqueDeviceID = uniqueDeviceID;
    }

    public V7VirtualDisk() {
    }

    public V7VirtualDisk(String diskCapacity, String diskLabel, String diskName, String uniqueDeviceID) {
        super();
        this.metadata = new V7Metadata(new V7Atom());
        this.diskCapacity = diskCapacity;
        this.diskLabel = diskLabel;
        this.diskName = diskName;
        this.uniqueDeviceID = uniqueDeviceID;
    }

    public V7VirtualDisk(String diskCapacity, String diskLabel, String diskName) {
        super();
        this.metadata = new V7Metadata(new V7Atom());
        this.diskCapacity = diskCapacity;
        this.diskLabel = diskLabel;
        this.diskName = diskName;
    }

    public V7VirtualDisk(String diskCapacity, String diskName) {
        super();
        this.metadata = new V7Metadata(new V7Atom());
        this.diskCapacity = diskCapacity;
        this.diskName = diskName;
    }

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }

}
