package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Atom;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "VirtualSCSIMapping")
public class V7VirtualSCSIMapping {
    @XmlAttribute(name = "schemaVersion")
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "AssociatedLogicalPartition")
    private V7Link associatedLogicalPartition;

    @XmlElement(name = "ClientAdapter")
    private V7ClientAdapter clientAdapter;

    @XmlElement(name = "ServerAdapter")
    private V7ServerAdapter serverAdapter;

    @XmlElement(name = "Storage")
    private V7Storage storage;

    @XmlElement(name = "TargetDevice")
    private V7TargetDevice targetDevice;

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public V7Link getAssociatedLogicalPartition() {
        return associatedLogicalPartition;
    }

    public void setAssociatedLogicalPartition(V7Link associatedLogicalPartition) {
        this.associatedLogicalPartition = associatedLogicalPartition;
    }

    public V7ClientAdapter getClientAdapter() {
        return clientAdapter;
    }

    public void setClientAdapter(V7ClientAdapter clientAdapter) {
        this.clientAdapter = clientAdapter;
    }

    public V7ServerAdapter getServerAdapter() {
        return serverAdapter;
    }

    public void setServerAdapter(V7ServerAdapter serverAdapter) {
        this.serverAdapter = serverAdapter;
    }

    public V7Storage getStorage() {
        return storage;
    }

    public void setStorage(V7Storage storage) {
        this.storage = storage;
    }

    public V7TargetDevice getTargetDevice() {
        return targetDevice;
    }

    public void setTargetDevice(V7TargetDevice targetDevice) {
        this.targetDevice = targetDevice;
    }

    public V7VirtualSCSIMapping() {
    }

    public V7VirtualSCSIMapping(V7ServerAdapter serverAdapter, V7Storage storage, V7TargetDevice targetDevice) {
        super();
        this.metadata = new V7Metadata(new V7Atom());
        this.serverAdapter = serverAdapter;
        this.storage = storage;
        this.targetDevice = targetDevice;
    }

    public V7VirtualSCSIMapping(V7ServerAdapter serverAdapter, V7Storage storage) {
        super();
        this.metadata = new V7Metadata(new V7Atom());
        this.serverAdapter = serverAdapter;
        this.storage = storage;
    }

    public V7VirtualSCSIMapping(V7ClientAdapter clientAdapter, V7ServerAdapter serverAdapter, V7Storage storage,
                                V7TargetDevice targetDevice) {
        super();
        this.metadata = new V7Metadata(new V7Atom());
        this.clientAdapter = clientAdapter;
        this.serverAdapter = serverAdapter;
        this.storage = storage;
        this.targetDevice = targetDevice;
    }

    public V7VirtualSCSIMapping(V7ClientAdapter clientAdapter, V7ServerAdapter serverAdapter, V7Storage storage) {
        super();
        this.metadata = new V7Metadata(new V7Atom());
        this.clientAdapter = clientAdapter;
        this.serverAdapter = serverAdapter;
        this.storage = storage;
    }

    public V7VirtualSCSIMapping(V7Storage storage, V7TargetDevice targetDevice) {
        super();
        this.metadata = new V7Metadata(new V7Atom());
        this.storage = storage;
        this.targetDevice = targetDevice;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }

}
