package com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.common.V7Metadata;

import javax.xml.bind.annotation.*;

/**
 * 卷组Content实体类
 *
 * @author sxp
 * @since Jul 4, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "VolumeGroup")
public class V7VolumeGroup {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V10;

    @XmlElement(name = "Metadata")
    private V7Metadata metadata;

    @XmlElement(name = "AvailableSize")
    private String availableSize;

    @XmlElement(name = "FreeSpace")
    private String freeSpace;

    @XmlElement(name = "GroupCapacity")
    private String groupCapacity;

    @XmlElement(name = "GroupName")
    private String groupName;

    @XmlElement(name = "GroupSerialID")
    private String groupSerialID;

    @XmlElement(name = "MaximumLogicalVolumes")
    private String maximumLogicalVolumes;

    @XmlElement(name = "PhysicalVolumes")
    private V7PhysicalVolumes physicalVolumes;

    @XmlElement(name = "MediaRepositories")
    private V7MediaRepositories mediaRepositories;

    @XmlElement(name = "UniqueDeviceID")
    private String uniqueDeviceID;

    @XmlElement(name = "VirtualDisks")
    private V7VirtualDisks virtualDisks;

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V7Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V7Metadata metadata) {
        this.metadata = metadata;
    }

    public String getAvailableSize() {
        return availableSize;
    }

    public void setAvailableSize(String availableSize) {
        this.availableSize = availableSize;
    }

    public String getFreeSpace() {
        return freeSpace;
    }

    public void setFreeSpace(String freeSpace) {
        this.freeSpace = freeSpace;
    }

    public String getGroupCapacity() {
        return groupCapacity;
    }

    public void setGroupCapacity(String groupCapacity) {
        this.groupCapacity = groupCapacity;
    }

    public String getGroupName() {
        return groupName;
    }

    public void setGroupName(String groupName) {
        this.groupName = groupName;
    }

    public String getGroupSerialID() {
        return groupSerialID;
    }

    public void setGroupSerialID(String groupSerialID) {
        this.groupSerialID = groupSerialID;
    }

    public String getMaximumLogicalVolumes() {
        return maximumLogicalVolumes;
    }

    public void setMaximumLogicalVolumes(String maximumLogicalVolumes) {
        this.maximumLogicalVolumes = maximumLogicalVolumes;
    }

    public V7PhysicalVolumes getPhysicalVolumes() {
        return physicalVolumes;
    }

    public void setPhysicalVolumes(V7PhysicalVolumes physicalVolumes) {
        this.physicalVolumes = physicalVolumes;
    }

    public String getUniqueDeviceID() {
        return uniqueDeviceID;
    }

    public void setUniqueDeviceID(String uniqueDeviceID) {
        this.uniqueDeviceID = uniqueDeviceID;
    }

    public V7VirtualDisks getVirtualDisks() {
        return virtualDisks;
    }

    public void setVirtualDisks(V7VirtualDisks virtualDisks) {
        this.virtualDisks = virtualDisks;
    }

    public V7MediaRepositories getMediaRepositories() {
        return mediaRepositories;
    }

    public void setMediaRepositories(V7MediaRepositories mediaRepositories) {
        this.mediaRepositories = mediaRepositories;
    }

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }

}
