package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common;

import com.alibaba.fastjson.JSONObject;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * HttpErrorResponse
 *
 * @author lkx007
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "HttpErrorResponse")
public class V8HttpErrorResponse {

    /**
     * 500
     */
    @XmlElement(name = "HTTPStatus")
    private String httpStatus;

    /**
     * /rest/api/uom/ManagedSystem/25cc2a4e-b946-3b98-acaa-cdf90628809a/LogicalPartition
     */
    @XmlElement(name = "RequestURI")
    private String uri;
    /**
     * Unknown internal error.
     */
    @XmlElement(name = "ReasonCode")
    private String reasonCode;
    /**
     * detail error message
     */
    @XmlElement(name = "Message")
    private String message;

    /**
     * stackTrace
     */
    @XmlElement(name = "StackTrace")
    private String stackTrace;

    /**
     * @return the httpStatus
     */
    public String getHttpStatus() {
        return httpStatus;
    }

    /**
     * @param httpStatus the httpStatus to set
     */
    public void setHttpStatus(String httpStatus) {
        this.httpStatus = httpStatus;
    }

    /**
     * @return the uri
     */
    public String getUri() {
        return uri;
    }

    /**
     * @param uri the uri to set
     */
    public void setUri(String uri) {
        this.uri = uri;
    }

    /**
     * @return the reasonCode
     */
    public String getReasonCode() {
        return reasonCode;
    }

    /**
     * @param reasonCode the reasonCode to set
     */
    public void setReasonCode(String reasonCode) {
        this.reasonCode = reasonCode;
    }

    /**
     * @return the message
     */
    public String getMessage() {
        return message;
    }

    /**
     * @param message the message to set
     */
    public void setMessage(String message) {
        this.message = message;
    }

    public String getStackTrace() {
        return stackTrace;
    }

    public void setStackTrace(String stackTrace) {
        this.stackTrace = stackTrace;
    }

    public V8HttpErrorResponse() {
    }

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }

}

