package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module.V8Password;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module.V8UserID;

import javax.xml.bind.annotation.*;

/**
 * 登陆请求(XML对应的Java类)
 *
 * @author sxp
 * @since May 3, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "LogonRequest")
@XmlType(propOrder = {"xmlns", "schemaVersion", "metadata", "userId", "password"})
public class V8LogonRequest {
    @XmlAttribute
    private String xmlns;

    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "UserID")
    private V8UserID userId;

    @XmlElement(name = "Password")
    private V8Password password;

    public V8LogonRequest() {
        init();
    }

    private void init() {
        xmlns = "http://www.ibm.com/xmlns/systems/power/firmware/web/mc/2012_10/";
        schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V110;
    }

    public String getXmlns() {
        return xmlns;
    }

    public void setXmlns(String xmlns) {
        this.xmlns = xmlns;
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public V8UserID getUserId() {
        return userId;
    }

    public void setUserId(V8UserID userId) {
        this.userId = userId;
    }

    public V8Password getPassword() {
        return password;
    }

    public void setPassword(V8Password password) {
        this.password = password;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }

}
