package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module.V8XAPISession;

import javax.xml.bind.annotation.*;

/**
 * 登陆的返回结果(XML对应的Java类)
 *
 * @author sxp
 * @since May 3, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "LogonResponse")
public class V8LogonResponse {
    @XmlAttribute
    private String xmlns;

    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "X-API-Session")
    private V8XAPISession session;

    public V8LogonResponse() {
    }

    public String getXmlns() {
        return xmlns;
    }

    public void setXmlns(String xmlns) {
        this.xmlns = xmlns;
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public V8XAPISession getSession() {
        return session;
    }

    public void setSession(V8XAPISession session) {
        this.session = session;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }

}
