package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.job;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module.V8Author;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module.V8Link;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import java.util.List;

/**
 * JobResultEntry
 * <p>
 * 提交作业任务返回的结果，查询Job返回的结果
 * </p>
 *
 * @author 007
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "entry")
public class V8JobResultEntry {
    /**
     * id
     */
    @XmlElement(name = "id")
    private String id;

    /**
     * title
     */
    @XmlElement(name = "title")
    private String title;

    /**
     * published
     */
    @XmlElement(name = "published")
    private String published;

    /**
     * links
     */
    @XmlElement(name = "link")
    private List<V8Link> links;

    /**
     * author
     */
    @XmlElement(name = "author")
    private V8Author author;

    /**
     * content
     */
    @XmlElement(name = "content")
    private V8JobResultContent content;

    /**
     * @return the id
     */
    public String getId() {
        return id;
    }

    /**
     * @param id the id to set
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * @return the title
     */
    public String getTitle() {
        return title;
    }

    /**
     * @param title the title to set
     */
    public void setTitle(String title) {
        this.title = title;
    }

    /**
     * @return the published
     */
    public String getPublished() {
        return published;
    }

    /**
     * @param published the published to set
     */
    public void setPublished(String published) {
        this.published = published;
    }

    /**
     * @return the links
     */
    public List<V8Link> getLinks() {
        return links;
    }

    /**
     * @param links the links to set
     */
    public void setLinks(List<V8Link> links) {
        this.links = links;
    }

    /**
     * @return the author
     */
    public V8Author getAuthor() {
        return author;
    }

    /**
     * @param author the author to set
     */
    public void setAuthor(V8Author author) {
        this.author = author;
    }

    /**
     * @return the content
     */
    public V8JobResultContent getContent() {
        return content;
    }

    /**
     * @param content the content to set
     */
    public void setContent(V8JobResultContent content) {
        this.content = content;
    }

    public V8JobResultEntry() {
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }

}
