package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.job;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;
import java.util.List;

/**
 * JobResults
 *
 * @author 007
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "Results")
public class V8JobResults {
    /**
     * V1_2_0
     */
    @XmlAttribute(name = "schemaVersion")
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;
    /**
     * metadata
     */
    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    /**
     * jobParameters
     */
    @XmlElement(name = "JobParameter")
    private List<V8JobParameter> jobParameters;

    /**
     * @return the schemaVersion
     */
    public String getSchemaVersion() {
        return schemaVersion;
    }

    /**
     * @param schemaVersion the schemaVersion to set
     */
    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    /**
     * @return the metadata
     */
    public V8Metadata getMetadata() {
        return metadata;
    }

    /**
     * @param metadata the metadata to set
     */
    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    /**
     * @return the jobParameters
     */
    public List<V8JobParameter> getJobParameters() {
        return jobParameters;
    }

    /**
     * @param jobParameters the jobParameters to set
     */
    public void setJobParameters(List<V8JobParameter> jobParameters) {
        this.jobParameters = jobParameters;
    }

    public V8JobResults() {
    }

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }

}
