package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

/**
 * 电源和灯光设置
 *
 * @author sxp
 * @since May 17, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "AssociatedIPLConfiguration")
public class V8AssociatedIPLConfiguration {

    @XmlAttribute(name = "group")
    private String group;

    @XmlAttribute(name = "schemaVersion")
    private String schemaVersion;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "CurrentManufacturingDefaulConfigurationtBootMode")
    private String currentManufacturingDefaultConfigurationBootMode;

    @XmlElement(name = "CurrentPowerOnSide")
    private String currentPowerOnSide;

    @XmlElement(name = "CurrentSystemKeylock")
    private String currentSystemKeylock;

    @XmlElement(name = "MajorBootType")
    private String majorBootType;

    @XmlElement(name = "MinorBootType")
    private String minorBootType;

    @XmlElement(name = "PendingManufacturingDefaulConfigurationtBootMode")
    private String pendingManufacturingDefaultConfigurationBootMode;

    @XmlElement(name = "PendingPowerOnSide")
    private String pendingPowerOnSide; // 供电端: Temporary临时  Permanent永久

    @XmlElement(name = "PendingSystemKeylock")
    private String pendingSystemKeylock; // 键锁位置: normal正常  manual手动

    @XmlElement(name = "PowerOnLogicalPartitionStartPolicy")
    private String powerOnLogicalPartitionStartPolicy;

    @XmlElement(name = "PowerOnOption")
    private String powerOnOption;

    @XmlElement(name = "PowerOnSpeed")
    private String powerOnSpeed;

    @XmlElement(name = "PowerOnSpeedOverride")
    private String powerOnSpeedOverride;

    @XmlElement(name = "PowerOffWhenLastLogicalPartitionIsShutdown")
    private String powerOffWhenLastLogicalPartitionIsShutdown;

    @XmlElement(name = "CurrentManufacturingDefaultConfigurationSource")
    private V8CurrentManufacturingDefaultConfigurationSource currentManufacturingDefaultConfigurationSource;

    @XmlElement(name = "PendingManufacturingDefaultConfigurationSource")
    private V8PendingManufacturingDefaultConfigurationSource pendingManufacturingDefaultConfigurationSource;

    @XmlElement(name = "PendingPowerOnLogicalPartitionStartPolicy")
    private V8PendingPowerOnLogicalPartitionStartPolicy pendingPowerOnLogicalPartitionStartPolicy; // 分区启动策略: autostart 始终自动启动  userinit 由用户启动   autorecovery 自动启动以执行自动回复

    @XmlElement(name = "PowerOnSource")
    private V8PowerOnSource powerOnSource;

    public V8AssociatedIPLConfiguration() {
    }

    public String getGroup() {
        return group;
    }

    public void setGroup(String group) {
        this.group = group;
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getCurrentManufacturingDefaultConfigurationBootMode() {
        return currentManufacturingDefaultConfigurationBootMode;
    }

    public void setCurrentManufacturingDefaultConfigurationBootMode(
            String currentManufacturingDefaultConfigurationBootMode) {
        this.currentManufacturingDefaultConfigurationBootMode = currentManufacturingDefaultConfigurationBootMode;
    }

    public String getCurrentPowerOnSide() {
        return currentPowerOnSide;
    }

    public void setCurrentPowerOnSide(String currentPowerOnSide) {
        this.currentPowerOnSide = currentPowerOnSide;
    }

    public String getCurrentSystemKeylock() {
        return currentSystemKeylock;
    }

    public void setCurrentSystemKeylock(String currentSystemKeylock) {
        this.currentSystemKeylock = currentSystemKeylock;
    }

    public String getMajorBootType() {
        return majorBootType;
    }

    public void setMajorBootType(String majorBootType) {
        this.majorBootType = majorBootType;
    }

    public String getMinorBootType() {
        return minorBootType;
    }

    public void setMinorBootType(String minorBootType) {
        this.minorBootType = minorBootType;
    }

    public String getPendingManufacturingDefaultConfigurationBootMode() {
        return pendingManufacturingDefaultConfigurationBootMode;
    }

    public void setPendingManufacturingDefaultConfigurationBootMode(
            String pendingManufacturingDefaultConfigurationBootMode) {
        this.pendingManufacturingDefaultConfigurationBootMode = pendingManufacturingDefaultConfigurationBootMode;
    }

    public String getPendingPowerOnSide() {
        return pendingPowerOnSide;
    }

    public void setPendingPowerOnSide(String pendingPowerOnSide) {
        this.pendingPowerOnSide = pendingPowerOnSide;
    }

    public String getPendingSystemKeylock() {
        return pendingSystemKeylock;
    }

    public void setPendingSystemKeylock(String pendingSystemKeylock) {
        this.pendingSystemKeylock = pendingSystemKeylock;
    }

    public String getPowerOnLogicalPartitionStartPolicy() {
        return powerOnLogicalPartitionStartPolicy;
    }

    public void setPowerOnLogicalPartitionStartPolicy(String powerOnLogicalPartitionStartPolicy) {
        this.powerOnLogicalPartitionStartPolicy = powerOnLogicalPartitionStartPolicy;
    }

    public String getPowerOnOption() {
        return powerOnOption;
    }

    public void setPowerOnOption(String powerOnOption) {
        this.powerOnOption = powerOnOption;
    }

    public String getPowerOnSpeed() {
        return powerOnSpeed;
    }

    public void setPowerOnSpeed(String powerOnSpeed) {
        this.powerOnSpeed = powerOnSpeed;
    }

    public String getPowerOnSpeedOverride() {
        return powerOnSpeedOverride;
    }

    public void setPowerOnSpeedOverride(String powerOnSpeedOverride) {
        this.powerOnSpeedOverride = powerOnSpeedOverride;
    }

    public String getPowerOffWhenLastLogicalPartitionIsShutdown() {
        return powerOffWhenLastLogicalPartitionIsShutdown;
    }

    public V8CurrentManufacturingDefaultConfigurationSource getCurrentManufacturingDefaultConfigurationSource() {
        return currentManufacturingDefaultConfigurationSource;
    }

    public void setCurrentManufacturingDefaultConfigurationSource(V8CurrentManufacturingDefaultConfigurationSource currentManufacturingDefaultConfigurationSource) {
        this.currentManufacturingDefaultConfigurationSource = currentManufacturingDefaultConfigurationSource;
    }

    public V8PendingManufacturingDefaultConfigurationSource getPendingManufacturingDefaultConfigurationSource() {
        return pendingManufacturingDefaultConfigurationSource;
    }

    public void setPendingManufacturingDefaultConfigurationSource(V8PendingManufacturingDefaultConfigurationSource pendingManufacturingDefaultConfigurationSource) {
        this.pendingManufacturingDefaultConfigurationSource = pendingManufacturingDefaultConfigurationSource;
    }

    public V8PendingPowerOnLogicalPartitionStartPolicy getPendingPowerOnLogicalPartitionStartPolicy() {
        return pendingPowerOnLogicalPartitionStartPolicy;
    }

    public void setPendingPowerOnLogicalPartitionStartPolicy(V8PendingPowerOnLogicalPartitionStartPolicy pendingPowerOnLogicalPartitionStartPolicy) {
        this.pendingPowerOnLogicalPartitionStartPolicy = pendingPowerOnLogicalPartitionStartPolicy;
    }

    public V8PowerOnSource getPowerOnSource() {
        return powerOnSource;
    }

    public void setPowerOnSource(V8PowerOnSource powerOnSource) {
        this.powerOnSource = powerOnSource;
    }

    public void setPowerOffWhenLastLogicalPartitionIsShutdown(String powerOffWhenLastLogicalPartitionIsShutdown) {
        this.powerOffWhenLastLogicalPartitionIsShutdown = powerOffWhenLastLogicalPartitionIsShutdown;
    }

    @Override
    public String toString() {
        return "AssociatedIPLConfiguration [metadata=" + metadata
                + ", currentManufacturingDefaultConfigurationBootMode="
                + currentManufacturingDefaultConfigurationBootMode + ", currentPowerOnSide=" + currentPowerOnSide
                + ", currentSystemKeylock=" + currentSystemKeylock + ", majorBootType=" + majorBootType
                + ", minorBootType=" + minorBootType + ", pendingManufacturingDefaultConfigurationBootMode="
                + pendingManufacturingDefaultConfigurationBootMode + ", pendingPowerOnSide=" + pendingPowerOnSide
                + ", pendingSystemKeylock=" + pendingSystemKeylock + ", powerOnLogicalPartitionStartPolicy="
                + powerOnLogicalPartitionStartPolicy + ", powerOnOption=" + powerOnOption + ", powerOnSpeed="
                + powerOnSpeed + ", powerOnSpeedOverride=" + powerOnSpeedOverride
                + ", powerOffWhenLastLogicalPartitionIsShutdown=" + powerOffWhenLastLogicalPartitionIsShutdown
                + ", currentManufacturingDefaultConfigurationSource=" + currentManufacturingDefaultConfigurationSource
                + ", pendingManufacturingDefaultConfigurationSource=" + pendingManufacturingDefaultConfigurationSource
                + ", pendingPowerOnLogicalPartitionStartPolicy=" + pendingPowerOnLogicalPartitionStartPolicy
                + ", powerOnSource=" + powerOnSource + "]";
    }

}
