package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;
import java.util.List;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "AssociatedSystemMemoryConfiguration")
public class V8AssociatedSystemMemoryConfiguration {

    @XmlAttribute(name = "schemaVersion")
    private String schemaVersion;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "AllowedHardwarePageTableRations")
    private List<String> allowedHardwarePageTableRations;

    @XmlElement(name = "AllowedMemoryRegionSize")
    private String allowedMemoryRegionSize;

    @XmlElement(name = "AvailableBarrierSynchronizationRegisterArrays")
    private String availableBarrierSynchronizationRegisterArrays;

    @XmlElement(name = "BarrierSynchronizationRegisterArraySize")
    private String barrierSynchronizationRegisterArraySize;

    @XmlElement(name = "ConfigurableHugePages")
    private String configurableHugePages;

    @XmlElement(name = "ConfigurableSystemMemory")
    private String configurableSystemMemory;

    @XmlElement(name = "CurrentAvailableHugePages")
    private String currentAvailableHugePages;

    @XmlElement(name = "CurrentAvailableSystemMemory")
    private String currentAvailableSystemMemory;

    @XmlElement(name = "CurrentLogicalMemoryBlockSize")
    private String currentLogicalMemoryBlockSize;

    @XmlElement(name = "DeconfiguredSystemMemory")
    private V8DeconfiguredSystemMemory deconfiguredSystemMemory;

    @XmlElement(name = "DefaultHardwarePageTableRatio")
    private String defaultHardwarePageTableRatio;

    @XmlElement(name = "DefaultHardwarePagingTableRatioForDedicatedMemoryPartition")
    private String defaultHardwarePagingTableRatioForDedicatedMemoryPartition;

    @XmlElement(name = "HugePageCount")
    private String hugePageCount;

    @XmlElement(name = "HugePageSize")
    private String hugePageSize;

    @XmlElement(name = "InstalledSystemMemory")
    private String installedSystemMemory;

    @XmlElement(name = "MaximumHugePages")
    private String maximumHugePages;

    @XmlElement(name = "MaximumMemoryPoolCount")
    private String maximumMemoryPoolCount;

    @XmlElement(name = "MaximumPagingVirtualIOServersPerSharedMemoryPool")
    private String maximumPagingVirtualIOServersPerSharedMemoryPool;

    @XmlElement(name = "MemoryMirroringState")
    private String memoryMirroringState;

    @XmlElement(name = "MemoryRegionSize")
    private String memoryRegionSize;

    @XmlElement(name = "MemoryUsedByHypervisor")
    private String memoryUsedByHypervisor;

    @XmlElement(name = "PendingAvailableHugePages")
    private String pendingAvailableHugePages;

    @XmlElement(name = "PendingAvailableSystemMemory")
    private String pendingAvailableSystemMemory;

    @XmlElement(name = "PendingLogicalMemoryBlockSize")
    private String pendingLogicalMemoryBlockSize;

    @XmlElement(name = "PendingMemoryRegionSize")
    private String pendingMemoryRegionSize;

    @XmlElement(name = "RequestedHugePages")
    private String requestedHugePages;

    @XmlElement(name = "TemporaryMemoryForLogicalPartitionMobilityInUse")
    private V8TemporaryMemoryForLogicalPartitionMobilityInUse temporaryMemoryForLogicalPartitionMobilityInUse;

    @XmlElement(name = "TotalBarrierSynchronizationRegisterArrays")
    private String totalBarrierSynchronizationRegisterArrays;

    public V8AssociatedSystemMemoryConfiguration() {
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public List<String> getAllowedHardwarePageTableRations() {
        return allowedHardwarePageTableRations;
    }

    public void setAllowedHardwarePageTableRations(List<String> allowedHardwarePageTableRations) {
        this.allowedHardwarePageTableRations = allowedHardwarePageTableRations;
    }

    public String getAllowedMemoryRegionSize() {
        return allowedMemoryRegionSize;
    }

    public void setAllowedMemoryRegionSize(String allowedMemoryRegionSize) {
        this.allowedMemoryRegionSize = allowedMemoryRegionSize;
    }

    public String getAvailableBarrierSynchronizationRegisterArrays() {
        return availableBarrierSynchronizationRegisterArrays;
    }

    public void setAvailableBarrierSynchronizationRegisterArrays(String availableBarrierSynchronizationRegisterArrays) {
        this.availableBarrierSynchronizationRegisterArrays = availableBarrierSynchronizationRegisterArrays;
    }

    public String getBarrierSynchronizationRegisterArraySize() {
        return barrierSynchronizationRegisterArraySize;
    }

    public void setBarrierSynchronizationRegisterArraySize(String barrierSynchronizationRegisterArraySize) {
        this.barrierSynchronizationRegisterArraySize = barrierSynchronizationRegisterArraySize;
    }

    public String getConfigurableHugePages() {
        return configurableHugePages;
    }

    public void setConfigurableHugePages(String configurableHugePages) {
        this.configurableHugePages = configurableHugePages;
    }

    public String getConfigurableSystemMemory() {
        return configurableSystemMemory;
    }

    public void setConfigurableSystemMemory(String configurableSystemMemory) {
        this.configurableSystemMemory = configurableSystemMemory;
    }

    public String getCurrentAvailableHugePages() {
        return currentAvailableHugePages;
    }

    public void setCurrentAvailableHugePages(String currentAvailableHugePages) {
        this.currentAvailableHugePages = currentAvailableHugePages;
    }

    public String getCurrentAvailableSystemMemory() {
        return currentAvailableSystemMemory;
    }

    public void setCurrentAvailableSystemMemory(String currentAvailableSystemMemory) {
        this.currentAvailableSystemMemory = currentAvailableSystemMemory;
    }

    public String getCurrentLogicalMemoryBlockSize() {
        return currentLogicalMemoryBlockSize;
    }

    public void setCurrentLogicalMemoryBlockSize(String currentLogicalMemoryBlockSize) {
        this.currentLogicalMemoryBlockSize = currentLogicalMemoryBlockSize;
    }

    public V8DeconfiguredSystemMemory getDeconfiguredSystemMemory() {
        return deconfiguredSystemMemory;
    }

    public void setDeconfiguredSystemMemory(V8DeconfiguredSystemMemory deconfiguredSystemMemory) {
        this.deconfiguredSystemMemory = deconfiguredSystemMemory;
    }

    public String getDefaultHardwarePageTableRatio() {
        return defaultHardwarePageTableRatio;
    }

    public void setDefaultHardwarePageTableRatio(String defaultHardwarePageTableRatio) {
        this.defaultHardwarePageTableRatio = defaultHardwarePageTableRatio;
    }

    public String getDefaultHardwarePagingTableRatioForDedicatedMemoryPartition() {
        return defaultHardwarePagingTableRatioForDedicatedMemoryPartition;
    }

    public void setDefaultHardwarePagingTableRatioForDedicatedMemoryPartition(
            String defaultHardwarePagingTableRatioForDedicatedMemoryPartition) {
        this.defaultHardwarePagingTableRatioForDedicatedMemoryPartition = defaultHardwarePagingTableRatioForDedicatedMemoryPartition;
    }

    public String getHugePageCount() {
        return hugePageCount;
    }

    public void setHugePageCount(String hugePageCount) {
        this.hugePageCount = hugePageCount;
    }

    public String getHugePageSize() {
        return hugePageSize;
    }

    public void setHugePageSize(String hugePageSize) {
        this.hugePageSize = hugePageSize;
    }

    public String getInstalledSystemMemory() {
        return installedSystemMemory;
    }

    public void setInstalledSystemMemory(String installedSystemMemory) {
        this.installedSystemMemory = installedSystemMemory;
    }

    public String getMaximumHugePages() {
        return maximumHugePages;
    }

    public void setMaximumHugePages(String maximumHugePages) {
        this.maximumHugePages = maximumHugePages;
    }

    public String getMaximumMemoryPoolCount() {
        return maximumMemoryPoolCount;
    }

    public void setMaximumMemoryPoolCount(String maximumMemoryPoolCount) {
        this.maximumMemoryPoolCount = maximumMemoryPoolCount;
    }

    public String getMaximumPagingVirtualIOServersPerSharedMemoryPool() {
        return maximumPagingVirtualIOServersPerSharedMemoryPool;
    }

    public void setMaximumPagingVirtualIOServersPerSharedMemoryPool(
            String maximumPagingVirtualIOServersPerSharedMemoryPool) {
        this.maximumPagingVirtualIOServersPerSharedMemoryPool = maximumPagingVirtualIOServersPerSharedMemoryPool;
    }

    public String getMemoryMirroringState() {
        return memoryMirroringState;
    }

    public void setMemoryMirroringState(String memoryMirroringState) {
        this.memoryMirroringState = memoryMirroringState;
    }

    public String getMemoryRegionSize() {
        return memoryRegionSize;
    }

    public void setMemoryRegionSize(String memoryRegionSize) {
        this.memoryRegionSize = memoryRegionSize;
    }

    public String getMemoryUsedByHypervisor() {
        return memoryUsedByHypervisor;
    }

    public void setMemoryUsedByHypervisor(String memoryUsedByHypervisor) {
        this.memoryUsedByHypervisor = memoryUsedByHypervisor;
    }

    public String getPendingAvailableHugePages() {
        return pendingAvailableHugePages;
    }

    public void setPendingAvailableHugePages(String pendingAvailableHugePages) {
        this.pendingAvailableHugePages = pendingAvailableHugePages;
    }

    public String getPendingAvailableSystemMemory() {
        return pendingAvailableSystemMemory;
    }

    public void setPendingAvailableSystemMemory(String pendingAvailableSystemMemory) {
        this.pendingAvailableSystemMemory = pendingAvailableSystemMemory;
    }

    public String getPendingLogicalMemoryBlockSize() {
        return pendingLogicalMemoryBlockSize;
    }

    public void setPendingLogicalMemoryBlockSize(String pendingLogicalMemoryBlockSize) {
        this.pendingLogicalMemoryBlockSize = pendingLogicalMemoryBlockSize;
    }

    public String getPendingMemoryRegionSize() {
        return pendingMemoryRegionSize;
    }

    public void setPendingMemoryRegionSize(String pendingMemoryRegionSize) {
        this.pendingMemoryRegionSize = pendingMemoryRegionSize;
    }

    public String getRequestedHugePages() {
        return requestedHugePages;
    }

    public void setRequestedHugePages(String requestedHugePages) {
        this.requestedHugePages = requestedHugePages;
    }

    public V8TemporaryMemoryForLogicalPartitionMobilityInUse getTemporaryMemoryForLogicalPartitionMobilityInUse() {
        return temporaryMemoryForLogicalPartitionMobilityInUse;
    }

    public void setTemporaryMemoryForLogicalPartitionMobilityInUse(
            V8TemporaryMemoryForLogicalPartitionMobilityInUse temporaryMemoryForLogicalPartitionMobilityInUse) {
        this.temporaryMemoryForLogicalPartitionMobilityInUse = temporaryMemoryForLogicalPartitionMobilityInUse;
    }

    public String getTotalBarrierSynchronizationRegisterArrays() {
        return totalBarrierSynchronizationRegisterArrays;
    }

    public void setTotalBarrierSynchronizationRegisterArrays(String totalBarrierSynchronizationRegisterArrays) {
        this.totalBarrierSynchronizationRegisterArrays = totalBarrierSynchronizationRegisterArrays;
    }

    @Override
    public String toString() {
        return "AssociatedSystemMemoryConfiguration [allowedMemoryRegionSize=" + allowedMemoryRegionSize
                + ", availableBarrierSynchronizationRegisterArrays=" + availableBarrierSynchronizationRegisterArrays
                + ", barrierSynchronizationRegisterArraySize=" + barrierSynchronizationRegisterArraySize
                + ", configurableHugePages=" + configurableHugePages + ", configurableSystemMemory="
                + configurableSystemMemory + ", currentAvailableHugePages=" + currentAvailableHugePages
                + ", currentAvailableSystemMemory=" + currentAvailableSystemMemory + ", currentLogicalMemoryBlockSize="
                + currentLogicalMemoryBlockSize + ", deconfiguredSystemMemory=" + deconfiguredSystemMemory
                + ", defaultHardwarePageTableRatio=" + defaultHardwarePageTableRatio
                + ", defaultHardwarePagingTableRatioForDedicatedMemoryPartition="
                + defaultHardwarePagingTableRatioForDedicatedMemoryPartition + ", hugePageCount=" + hugePageCount
                + ", hugePageSize=" + hugePageSize + ", installedSystemMemory=" + installedSystemMemory
                + ", maximumHugePages=" + maximumHugePages + ", maximumMemoryPoolCount=" + maximumMemoryPoolCount
                + ", maximumPagingVirtualIOServersPerSharedMemoryPool="
                + maximumPagingVirtualIOServersPerSharedMemoryPool + ", memoryMirroringState=" + memoryMirroringState
                + ", memoryRegionSize=" + memoryRegionSize + ", memoryUsedByHypervisor=" + memoryUsedByHypervisor
                + ", pendingAvailableHugePages=" + pendingAvailableHugePages + ", pendingAvailableSystemMemory="
                + pendingAvailableSystemMemory + ", pendingLogicalMemoryBlockSize=" + pendingLogicalMemoryBlockSize
                + ", pendingMemoryRegionSize=" + pendingMemoryRegionSize + ", requestedHugePages=" + requestedHugePages
                + ", temporaryMemoryForLogicalPartitionMobilityInUse=" + temporaryMemoryForLogicalPartitionMobilityInUse
                + ", totalBarrierSynchronizationRegisterArrays=" + totalBarrierSynchronizationRegisterArrays + "]";
    }

}
