package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;
import java.util.List;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "AssociatedSystemProcessorConfiguration")
public class V8AssociatedSystemProcessorConfiguration {

    @XmlAttribute(name = "schemaVersion")
    private String schemaVersion;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "ConfigurableSystemProcessorUnits")
    private String configurableSystemProcessorUnits;

    @XmlElement(name = "CurrentAvailableSystemProcessorUnits")
    private String currentAvailableSystemProcessorUnits;

    @XmlElement(name = "CurrentMaximumProcessorsPerAIXOrLinuxPartition")
    private String currentMaximumProcessorsPerAIXOrLinuxPartition;

    @XmlElement(name = "CurrentMaximumProcessorsPerIBMiPartition")
    private String currentMaximumProcessorsPerIBMiPartition;

    @XmlElement(name = "CurrentMaximumAllowedProcessorsPerPartition")
    private String currentMaximumAllowedProcessorsPerPartition;

    @XmlElement(name = "CurrentMaximumProcessorsPerVirtualIOServerPartition")
    private String currentMaximumProcessorsPerVirtualIOServerPartition;

    @XmlElement(name = "CurrentMaximumVirtualProcessorsPerAIXOrLinuxPartition")
    private String currentMaximumVirtualProcessorsPerAIXOrLinuxPartition;

    @XmlElement(name = "CurrentMaximumVirtualProcessorsPerIBMiPartition")
    private String currentMaximumVirtualProcessorsPerIBMiPartition;

    @XmlElement(name = "CurrentMaximumVirtualProcessorsPerVirtualIOServerPartition")
    private String currentMaximumVirtualProcessorsPerVirtualIOServerPartition;

    @XmlElement(name = "DeconfiguredSystemProcessorUnits")
    private V8DeconfiguredSystemProcessorUnits deconfiguredSystemProcessorUnits;

    @XmlElement(name = "InstalledSystemProcessorUnits")
    private String installedSystemProcessorUnits;

    @XmlElement(name = "MaximumProcessorUnitsPerIBMiPartition")
    private String maximumProcessorUnitsPerIBMiPartition;

    @XmlElement(name = "MaximumAllowedVirtualProcessorsPerPartition")
    private String maximumAllowedVirtualProcessorsPerPartition;

    @XmlElement(name = "MinimumProcessorUnitsPerVirtualProcessor")
    private String minimumProcessorUnitsPerVirtualProcessor;

    @XmlElement(name = "PendingAvailableSystemProcessorUnits")
    private String pendingAvailableSystemProcessorUnits;

    @XmlElement(name = "SharedProcessorPoolCount")
    private String sharedProcessorPoolCount;

    @XmlElement(name = "SupportedPartitionProcessorCompatibilityModes")
    private List<String> supportedPartitionProcessorCompatibilityModes;

    @XmlElement(name = "TemporaryProcessorUnitsForLogicalPartitionMobilityInUse")
    private V8TemporaryProcessorUnitsForLogicalPartitionMobilityInUse temporaryProcessorUnitsForLogicalPartitionMobilityInUse;

    @XmlElement(name = "SharedProcessorPool")
    private String sharedProcessorPool;

    public V8AssociatedSystemProcessorConfiguration() {
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getConfigurableSystemProcessorUnits() {
        return configurableSystemProcessorUnits;
    }

    public void setConfigurableSystemProcessorUnits(String configurableSystemProcessorUnits) {
        this.configurableSystemProcessorUnits = configurableSystemProcessorUnits;
    }

    public String getCurrentAvailableSystemProcessorUnits() {
        return currentAvailableSystemProcessorUnits;
    }

    public void setCurrentAvailableSystemProcessorUnits(String currentAvailableSystemProcessorUnits) {
        this.currentAvailableSystemProcessorUnits = currentAvailableSystemProcessorUnits;
    }

    public String getCurrentMaximumProcessorsPerAIXOrLinuxPartition() {
        return currentMaximumProcessorsPerAIXOrLinuxPartition;
    }

    public void setCurrentMaximumProcessorsPerAIXOrLinuxPartition(
            String currentMaximumProcessorsPerAIXOrLinuxPartition) {
        this.currentMaximumProcessorsPerAIXOrLinuxPartition = currentMaximumProcessorsPerAIXOrLinuxPartition;
    }

    public String getCurrentMaximumProcessorsPerIBMiPartition() {
        return currentMaximumProcessorsPerIBMiPartition;
    }

    public void setCurrentMaximumProcessorsPerIBMiPartition(String currentMaximumProcessorsPerIBMiPartition) {
        this.currentMaximumProcessorsPerIBMiPartition = currentMaximumProcessorsPerIBMiPartition;
    }

    public String getCurrentMaximumAllowedProcessorsPerPartition() {
        return currentMaximumAllowedProcessorsPerPartition;
    }

    public void setCurrentMaximumAllowedProcessorsPerPartition(String currentMaximumAllowedProcessorsPerPartition) {
        this.currentMaximumAllowedProcessorsPerPartition = currentMaximumAllowedProcessorsPerPartition;
    }

    public String getCurrentMaximumProcessorsPerVirtualIOServerPartition() {
        return currentMaximumProcessorsPerVirtualIOServerPartition;
    }

    public void setCurrentMaximumProcessorsPerVirtualIOServerPartition(
            String currentMaximumProcessorsPerVirtualIOServerPartition) {
        this.currentMaximumProcessorsPerVirtualIOServerPartition = currentMaximumProcessorsPerVirtualIOServerPartition;
    }

    public String getCurrentMaximumVirtualProcessorsPerAIXOrLinuxPartition() {
        return currentMaximumVirtualProcessorsPerAIXOrLinuxPartition;
    }

    public void setCurrentMaximumVirtualProcessorsPerAIXOrLinuxPartition(
            String currentMaximumVirtualProcessorsPerAIXOrLinuxPartition) {
        this.currentMaximumVirtualProcessorsPerAIXOrLinuxPartition = currentMaximumVirtualProcessorsPerAIXOrLinuxPartition;
    }

    public String getCurrentMaximumVirtualProcessorsPerIBMiPartition() {
        return currentMaximumVirtualProcessorsPerIBMiPartition;
    }

    public void setCurrentMaximumVirtualProcessorsPerIBMiPartition(
            String currentMaximumVirtualProcessorsPerIBMiPartition) {
        this.currentMaximumVirtualProcessorsPerIBMiPartition = currentMaximumVirtualProcessorsPerIBMiPartition;
    }

    public String getCurrentMaximumVirtualProcessorsPerVirtualIOServerPartition() {
        return currentMaximumVirtualProcessorsPerVirtualIOServerPartition;
    }

    public void setCurrentMaximumVirtualProcessorsPerVirtualIOServerPartition(
            String currentMaximumVirtualProcessorsPerVirtualIOServerPartition) {
        this.currentMaximumVirtualProcessorsPerVirtualIOServerPartition = currentMaximumVirtualProcessorsPerVirtualIOServerPartition;
    }

    public V8DeconfiguredSystemProcessorUnits getDeconfiguredSystemProcessorUnits() {
        return deconfiguredSystemProcessorUnits;
    }

    public void setDeconfiguredSystemProcessorUnits(V8DeconfiguredSystemProcessorUnits deconfiguredSystemProcessorUnits) {
        this.deconfiguredSystemProcessorUnits = deconfiguredSystemProcessorUnits;
    }

    public String getInstalledSystemProcessorUnits() {
        return installedSystemProcessorUnits;
    }

    public void setInstalledSystemProcessorUnits(String installedSystemProcessorUnits) {
        this.installedSystemProcessorUnits = installedSystemProcessorUnits;
    }

    public String getMaximumProcessorUnitsPerIBMiPartition() {
        return maximumProcessorUnitsPerIBMiPartition;
    }

    public void setMaximumProcessorUnitsPerIBMiPartition(String maximumProcessorUnitsPerIBMiPartition) {
        this.maximumProcessorUnitsPerIBMiPartition = maximumProcessorUnitsPerIBMiPartition;
    }

    public String getMaximumAllowedVirtualProcessorsPerPartition() {
        return maximumAllowedVirtualProcessorsPerPartition;
    }

    public void setMaximumAllowedVirtualProcessorsPerPartition(String maximumAllowedVirtualProcessorsPerPartition) {
        this.maximumAllowedVirtualProcessorsPerPartition = maximumAllowedVirtualProcessorsPerPartition;
    }

    public String getMinimumProcessorUnitsPerVirtualProcessor() {
        return minimumProcessorUnitsPerVirtualProcessor;
    }

    public void setMinimumProcessorUnitsPerVirtualProcessor(String minimumProcessorUnitsPerVirtualProcessor) {
        this.minimumProcessorUnitsPerVirtualProcessor = minimumProcessorUnitsPerVirtualProcessor;
    }

    public String getPendingAvailableSystemProcessorUnits() {
        return pendingAvailableSystemProcessorUnits;
    }

    public void setPendingAvailableSystemProcessorUnits(String pendingAvailableSystemProcessorUnits) {
        this.pendingAvailableSystemProcessorUnits = pendingAvailableSystemProcessorUnits;
    }

    public String getSharedProcessorPoolCount() {
        return sharedProcessorPoolCount;
    }

    public void setSharedProcessorPoolCount(String sharedProcessorPoolCount) {
        this.sharedProcessorPoolCount = sharedProcessorPoolCount;
    }

    public List<String> getSupportedPartitionProcessorCompatibilityModes() {
        return supportedPartitionProcessorCompatibilityModes;
    }

    public void setSupportedPartitionProcessorCompatibilityModes(
            List<String> supportedPartitionProcessorCompatibilityModes) {
        this.supportedPartitionProcessorCompatibilityModes = supportedPartitionProcessorCompatibilityModes;
    }

    public V8TemporaryProcessorUnitsForLogicalPartitionMobilityInUse getTemporaryProcessorUnitsForLogicalPartitionMobilityInUse() {
        return temporaryProcessorUnitsForLogicalPartitionMobilityInUse;
    }

    public void setTemporaryProcessorUnitsForLogicalPartitionMobilityInUse(
            V8TemporaryProcessorUnitsForLogicalPartitionMobilityInUse temporaryProcessorUnitsForLogicalPartitionMobilityInUse) {
        this.temporaryProcessorUnitsForLogicalPartitionMobilityInUse = temporaryProcessorUnitsForLogicalPartitionMobilityInUse;
    }

    public String getSharedProcessorPool() {
        return sharedProcessorPool;
    }

    public void setSharedProcessorPool(String sharedProcessorPool) {
        this.sharedProcessorPool = sharedProcessorPool;
    }

    @Override
    public String toString() {
        return "AssociatedSystemProcessorConfiguration [metadata=" + metadata + ", configurableSystemProcessorUnits="
                + configurableSystemProcessorUnits + ", currentAvailableSystemProcessorUnits="
                + currentAvailableSystemProcessorUnits + ", currentMaximumProcessorsPerAIXOrLinuxPartition="
                + currentMaximumProcessorsPerAIXOrLinuxPartition + ", currentMaximumProcessorsPerIBMiPartition="
                + currentMaximumProcessorsPerIBMiPartition + ", currentMaximumAllowedProcessorsPerPartition="
                + currentMaximumAllowedProcessorsPerPartition + ", currentMaximumProcessorsPerVirtualIOServerPartition="
                + currentMaximumProcessorsPerVirtualIOServerPartition
                + ", currentMaximumVirtualProcessorsPerAIXOrLinuxPartition="
                + currentMaximumVirtualProcessorsPerAIXOrLinuxPartition
                + ", currentMaximumVirtualProcessorsPerIBMiPartition=" + currentMaximumVirtualProcessorsPerIBMiPartition
                + ", currentMaximumVirtualProcessorsPerVirtualIOServerPartition="
                + currentMaximumVirtualProcessorsPerVirtualIOServerPartition + ", deconfiguredSystemProcessorUnits="
                + deconfiguredSystemProcessorUnits + ", installedSystemProcessorUnits=" + installedSystemProcessorUnits
                + ", maximumProcessorUnitsPerIBMiPartition=" + maximumProcessorUnitsPerIBMiPartition
                + ", maximumAllowedVirtualProcessorsPerPartition=" + maximumAllowedVirtualProcessorsPerPartition
                + ", minimumProcessorUnitsPerVirtualProcessor=" + minimumProcessorUnitsPerVirtualProcessor
                + ", pendingAvailableSystemProcessorUnits=" + pendingAvailableSystemProcessorUnits
                + ", sharedProcessorPoolCount=" + sharedProcessorPoolCount
                + ", supportedPartitionProcessorCompatibilityModes=" + supportedPartitionProcessorCompatibilityModes
                + ", temporaryProcessorUnitsForLogicalPartitionMobilityInUse="
                + temporaryProcessorUnitsForLogicalPartitionMobilityInUse + ", sharedProcessorPool="
                + sharedProcessorPool + "]";
    }

}
