package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Atom;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "ClientAdapter")
public class V8ClientAdapter {
    @XmlAttribute(name = "schemaVersion")
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "AdapterType")
    private String adapterType;

    @XmlElement(name = "DynamicReconfigurationConnectorName")
    private String dynamicReconfigurationConnectorName;

    @XmlElement(name = "LocationCode")
    private String locationCode;

    @XmlElement(name = "LocalPartitionID")
    private String localPartitionId;

    @XmlElement(name = "RequiredAdapter")
    private String requiredAdapter;

    @XmlElement(name = "VariedOn")
    private String variedOn;

    @XmlElement(name = "VirtualSlotNumber")
    private String virtualSlotNumber;

    @XmlElement(name = "AdapterName")
    private String adapterName;

    @XmlElement(name = "ConnectingPartitionID")
    private String connectingPartitionID;

    @XmlElement(name = "ConnectingVirtualSlotNumber")
    private String connectingVirtualSlotNumber;

    @XmlElement(name = "BackingDeviceName")
    private String backingDeviceName;

    @XmlElement(name = "RemoteLogicalPartitionID")
    private String remoteLogicalPartitionId;

    @XmlElement(name = "RemoteSlotNumber")
    private String remoteSlotNumber;

    @XmlElement(name = "ServerLocationCode")
    private String serverLocationCode;

    @XmlElement(name = "WWPNs")
    private String wwpns;

    public V8ClientAdapter() {
    }

    public V8ClientAdapter(String localPartitionId, String remoteLogicalPartitionId, String remoteSlotNumber,
                           String requiredAdapter) {
        this.metadata = new V8Metadata(new V8Atom());
        this.adapterType = "Client";
        this.localPartitionId = localPartitionId;
        this.remoteLogicalPartitionId = remoteLogicalPartitionId;
        this.remoteSlotNumber = remoteSlotNumber;
        this.requiredAdapter = requiredAdapter;
    }

    public V8ClientAdapter(String localPartitionId, String remoteLogicalPartitionId, String requiredAdapter) {
        this.metadata = new V8Metadata(new V8Atom());
        this.adapterType = "Client";
        this.localPartitionId = localPartitionId;
        this.remoteLogicalPartitionId = remoteLogicalPartitionId;
        this.requiredAdapter = requiredAdapter;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getAdapterType() {
        return adapterType;
    }

    public void setAdapterType(String adapterType) {
        this.adapterType = adapterType;
    }

    public String getDynamicReconfigurationConnectorName() {
        return dynamicReconfigurationConnectorName;
    }

    public void setDynamicReconfigurationConnectorName(String dynamicReconfigurationConnectorName) {
        this.dynamicReconfigurationConnectorName = dynamicReconfigurationConnectorName;
    }

    public String getLocationCode() {
        return locationCode;
    }

    public void setLocationCode(String locationCode) {
        this.locationCode = locationCode;
    }

    public String getLocalPartitionId() {
        return localPartitionId;
    }

    public void setLocalPartitionId(String localPartitionId) {
        this.localPartitionId = localPartitionId;
    }

    public String getRequiredAdapter() {
        return requiredAdapter;
    }

    public void setRequiredAdapter(String requiredAdapter) {
        this.requiredAdapter = requiredAdapter;
    }

    public String getVariedOn() {
        return variedOn;
    }

    public void setVariedOn(String variedOn) {
        this.variedOn = variedOn;
    }

    public String getVirtualSlotNumber() {
        return virtualSlotNumber;
    }

    public void setVirtualSlotNumber(String virtualSlotNumber) {
        this.virtualSlotNumber = virtualSlotNumber;
    }

    public String getRemoteLogicalPartitionId() {
        return remoteLogicalPartitionId;
    }

    public void setRemoteLogicalPartitionId(String remoteLogicalPartitionId) {
        this.remoteLogicalPartitionId = remoteLogicalPartitionId;
    }

    public String getRemoteSlotNumber() {
        return remoteSlotNumber;
    }

    public void setRemoteSlotNumber(String remoteSlotNumber) {
        this.remoteSlotNumber = remoteSlotNumber;
    }

    public String getServerLocationCode() {
        return serverLocationCode;
    }

    public void setServerLocationCode(String serverLocationCode) {
        this.serverLocationCode = serverLocationCode;
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public String getWwpns() {
        return wwpns;
    }

    public void setWwpns(String wwpns) {
        this.wwpns = wwpns;
    }

    public String getAdapterName() {
        return adapterName;
    }

    public void setAdapterName(String adapterName) {
        this.adapterName = adapterName;
    }

    public String getConnectingPartitionID() {
        return connectingPartitionID;
    }

    public void setConnectingPartitionID(String connectingPartitionID) {
        this.connectingPartitionID = connectingPartitionID;
    }

    public String getConnectingVirtualSlotNumber() {
        return connectingVirtualSlotNumber;
    }

    public void setConnectingVirtualSlotNumber(String connectingVirtualSlotNumber) {
        this.connectingVirtualSlotNumber = connectingVirtualSlotNumber;
    }

    public String getBackingDeviceName() {
        return backingDeviceName;
    }

    public void setBackingDeviceName(String backingDeviceName) {
        this.backingDeviceName = backingDeviceName;
    }

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }

}
