package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "IOAdapter")
public class V8IOAdapter {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "AdapterID")
    private String adapterID;

    @XmlElement(name = "Description")
    private String description;

    @XmlElement(name = "DeviceName")
    private String deviceName;

    @XmlElement(name = "DeviceType")
    private String deviceType;

    @XmlElement(name = "DynamicReconfigurationConnectorName")
    private String dynamicReconfigurationConnectorName;

    @XmlElement(name = "PhysicalLocation")
    private String physicalLocation;

    @XmlElement(name = "UniqueDeviceID")
    private String uniqueDeviceID;

    @XmlElement(name = "LogicalPartitionAssignmentCapable")
    private V8LogicalPartitionAssignmentCapable logicalPartitionAssignmentCapable;

    public V8IOAdapter() {
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getAdapterID() {
        return adapterID;
    }

    public void setAdapterID(String adapterID) {
        this.adapterID = adapterID;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDeviceName() {
        return deviceName;
    }

    public void setDeviceName(String deviceName) {
        this.deviceName = deviceName;
    }

    /**
     * @return the deviceType
     */
    public String getDeviceType() {
        return deviceType;
    }

    /**
     * @param deviceType the deviceType to set
     */
    public void setDeviceType(String deviceType) {
        this.deviceType = deviceType;
    }

    public String getDynamicReconfigurationConnectorName() {
        return dynamicReconfigurationConnectorName;
    }

    public void setDynamicReconfigurationConnectorName(String dynamicReconfigurationConnectorName) {
        this.dynamicReconfigurationConnectorName = dynamicReconfigurationConnectorName;
    }

    public String getPhysicalLocation() {
        return physicalLocation;
    }

    public void setPhysicalLocation(String physicalLocation) {
        this.physicalLocation = physicalLocation;
    }

    public String getUniqueDeviceID() {
        return uniqueDeviceID;
    }

    public void setUniqueDeviceID(String uniqueDeviceID) {
        this.uniqueDeviceID = uniqueDeviceID;
    }

    public V8LogicalPartitionAssignmentCapable getLogicalPartitionAssignmentCapable() {
        return logicalPartitionAssignmentCapable;
    }

    public void setLogicalPartitionAssignmentCapable(V8LogicalPartitionAssignmentCapable logicalPartitionAssignmentCapable) {
        this.logicalPartitionAssignmentCapable = logicalPartitionAssignmentCapable;
    }

    @Override
    public String toString() {
        return "IOAdapter [metadata=" + metadata + ", adapterID=" + adapterID + ", description=" + description
                + ", deviceName=" + deviceName + ", dynamicReconfigurationConnectorName="
                + dynamicReconfigurationConnectorName + ", physicalLocation=" + physicalLocation + ", uniqueDeviceID="
                + uniqueDeviceID + ", logicalPartitionAssignmentCapable=" + logicalPartitionAssignmentCapable + "]";
    }

}
