package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "LogicalPartitionProfile")
public class V8LogicalPartitionProfile {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "AffinityGroupID")
    private String affinityGroupID;

    @XmlElement(name = "AssignAllResources")
    private String assignAllResources;

    @XmlElement(name = "AssociatedPartition")
    private V8AssociatedPartition associatedPartition;

    @XmlElement(name = "AutoStart")
    private String autoStart;

    @XmlElement(name = "BootMode")
    private String bootMode;

    @XmlElement(name = "ConnectionMonitoringEnabled")
    private String connectionMonitoringEnabled;

    @XmlElement(name = "DesiredProcessorCompatibilityMode")
    private String desiredProcessorCompatibilityMode;

    @XmlElement(name = "HostEthernetAdapterLogicalPorts")
    private V8HostEthernetAdapterLogicalPorts hostEthernetAdapterLogicalPorts;

    @XmlElement(name = "IOConfigurationInstance")
    private V8IOConfigurationInstance ioConfigurationInstance;

    @XmlElement(name = "ProcessorAttributes")
    private V8ProcessorAttributes processorAttributes;

    @XmlElement(name = "ProfileMemory")
    private V8ProfileMemory profileMemory;

    @XmlElement(name = "ProfileName")
    private String profileName;

    @XmlElement(name = "ProfileType")
    private String profileType = HmcSdkConstant.PROFILE_TYPE;

    @XmlElement(name = "RedundantErrorPathReportingEnabled")
    private String redundantErrorPathReportingEnabled;

    @XmlElement(name = "SettingID")
    private String settingID;

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getAffinityGroupID() {
        return affinityGroupID;
    }

    public void setAffinityGroupID(String affinityGroupID) {
        this.affinityGroupID = affinityGroupID;
    }

    public String getAssignAllResources() {
        return assignAllResources;
    }

    public void setAssignAllResources(String assignAllResources) {
        this.assignAllResources = assignAllResources;
    }

    public V8AssociatedPartition getAssociatedPartition() {
        return associatedPartition;
    }

    public void setAssociatedPartition(V8AssociatedPartition associatedPartition) {
        this.associatedPartition = associatedPartition;
    }

    public String getAutoStart() {
        return autoStart;
    }

    public void setAutoStart(String autoStart) {
        this.autoStart = autoStart;
    }

    public String getBootMode() {
        return bootMode;
    }

    public void setBootMode(String bootMode) {
        this.bootMode = bootMode;
    }

    public String getConnectionMonitoringEnabled() {
        return connectionMonitoringEnabled;
    }

    public void setConnectionMonitoringEnabled(String connectionMonitoringEnabled) {
        this.connectionMonitoringEnabled = connectionMonitoringEnabled;
    }

    public String getDesiredProcessorCompatibilityMode() {
        return desiredProcessorCompatibilityMode;
    }

    public void setDesiredProcessorCompatibilityMode(String desiredProcessorCompatibilityMode) {
        this.desiredProcessorCompatibilityMode = desiredProcessorCompatibilityMode;
    }

    public V8HostEthernetAdapterLogicalPorts getHostEthernetAdapterLogicalPorts() {
        return hostEthernetAdapterLogicalPorts;
    }

    public void setHostEthernetAdapterLogicalPorts(V8HostEthernetAdapterLogicalPorts hostEthernetAdapterLogicalPorts) {
        this.hostEthernetAdapterLogicalPorts = hostEthernetAdapterLogicalPorts;
    }

    public V8IOConfigurationInstance getIoConfigurationInstance() {
        return ioConfigurationInstance;
    }

    public void setIoConfigurationInstance(V8IOConfigurationInstance ioConfigurationInstance) {
        this.ioConfigurationInstance = ioConfigurationInstance;
    }

    public V8ProcessorAttributes getProcessorAttributes() {
        return processorAttributes;
    }

    public void setProcessorAttributes(V8ProcessorAttributes processorAttributes) {
        this.processorAttributes = processorAttributes;
    }

    public V8ProfileMemory getProfileMemory() {
        return profileMemory;
    }

    public void setProfileMemory(V8ProfileMemory profileMemory) {
        this.profileMemory = profileMemory;
    }

    public String getProfileName() {
        return profileName;
    }

    public void setProfileName(String profileName) {
        this.profileName = profileName;
    }

    public String getProfileType() {
        return profileType;
    }

    public void setProfileType(String profileType) {
        this.profileType = profileType;
    }

    public String getRedundantErrorPathReportingEnabled() {
        return redundantErrorPathReportingEnabled;
    }

    public void setRedundantErrorPathReportingEnabled(String redundantErrorPathReportingEnabled) {
        this.redundantErrorPathReportingEnabled = redundantErrorPathReportingEnabled;
    }

    public String getSettingID() {
        return settingID;
    }

    public void setSettingID(String settingID) {
        this.settingID = settingID;
    }

}
