package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

/**
 * 控制台信息的ManagementConsole部分
 * <p>
 * ManagementConsole
 * </p>
 *
 * @author sxp
 * @since May 4, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "ManagementConsole")
public class V8MC {
    @XmlAttribute
    private String xmlns;

    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "MachineTypeModelAndSerialNumber")
    private V8MachineTypeModelAndSerialNumber machineTypeModelAndSerialNumber;

    @XmlElement(name = "ManagedSystems")
    private V8ManagedSystems managedSystems;

    @XmlElement(name = "ManagementConsoleName")
    private V8ManagementConsoleName mManagementConsoleName;

    @XmlElement(name = "NetworkInterfaces")
    private V8NetworkInterfaces networkInterfaces;

    @XmlElement(name = "TemplateObjectModelVersion")
    private V8TemplateObjectModelVersion templateObjectModelVersion;

    @XmlElement(name = "UserObjectModelVersion")
    private V8UserObjectModelVersion userObjectModelVersion;

    @XmlElement(name = "VersionInfo")
    private V8VersionInfo versionInfo;

    @XmlElement(name = "WebObjectModelVersion")
    private V8WebObjectModelVersion webObjectModelVersion;

    @XmlElement(name = "BIOS")
    private V8BIOS bIOS;

    @XmlElement(name = "BaseVersion")
    private V8BaseVersion baseVersion;

    @XmlElement(name = "Driver")
    private V8Driver driver;

    @XmlElement(name = "LicenseID")
    private V8LicenseID licenseID;

    @XmlElement(name = "LicenseFirstYear")
    private V8LicenseFirstYear licenseFirstYear;

    public V8MC() {
    }

    public String getXmlns() {
        return xmlns;
    }

    public void setXmlns(String xmlns) {
        this.xmlns = xmlns;
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public V8MachineTypeModelAndSerialNumber getMachineTypeModelAndSerialNumber() {
        return machineTypeModelAndSerialNumber;
    }

    public void setMachineTypeModelAndSerialNumber(V8MachineTypeModelAndSerialNumber machineTypeModelAndSerialNumber) {
        this.machineTypeModelAndSerialNumber = machineTypeModelAndSerialNumber;
    }

    public V8ManagedSystems getManagedSystems() {
        return managedSystems;
    }

    public void setManagedSystems(V8ManagedSystems managedSystems) {
        this.managedSystems = managedSystems;
    }

    public V8ManagementConsoleName getmManagementConsoleName() {
        return mManagementConsoleName;
    }

    public void setmManagementConsoleName(V8ManagementConsoleName mManagementConsoleName) {
        this.mManagementConsoleName = mManagementConsoleName;
    }

    public V8NetworkInterfaces getNetworkInterfaces() {
        return networkInterfaces;
    }

    public void setNetworkInterfaces(V8NetworkInterfaces networkInterfaces) {
        this.networkInterfaces = networkInterfaces;
    }

    public V8TemplateObjectModelVersion getTemplateObjectModelVersion() {
        return templateObjectModelVersion;
    }

    public void setTemplateObjectModelVersion(V8TemplateObjectModelVersion templateObjectModelVersion) {
        this.templateObjectModelVersion = templateObjectModelVersion;
    }

    public V8UserObjectModelVersion getUserObjectModelVersion() {
        return userObjectModelVersion;
    }

    public void setUserObjectModelVersion(V8UserObjectModelVersion userObjectModelVersion) {
        this.userObjectModelVersion = userObjectModelVersion;
    }

    public V8VersionInfo getVersionInfo() {
        return versionInfo;
    }

    public void setVersionInfo(V8VersionInfo versionInfo) {
        this.versionInfo = versionInfo;
    }

    public V8WebObjectModelVersion getWebObjectModelVersion() {
        return webObjectModelVersion;
    }

    public void setWebObjectModelVersion(V8WebObjectModelVersion webObjectModelVersion) {
        this.webObjectModelVersion = webObjectModelVersion;
    }

    public V8BIOS getbIOS() {
        return bIOS;
    }

    public void setbIOS(V8BIOS bIOS) {
        this.bIOS = bIOS;
    }

    public V8BaseVersion getBaseVersion() {
        return baseVersion;
    }

    public void setBaseVersion(V8BaseVersion baseVersion) {
        this.baseVersion = baseVersion;
    }

    public V8Driver getDriver() {
        return driver;
    }

    public void setDriver(V8Driver driver) {
        this.driver = driver;
    }

    public V8LicenseID getLicenseID() {
        return licenseID;
    }

    public void setLicenseID(V8LicenseID licenseID) {
        this.licenseID = licenseID;
    }

    public V8LicenseFirstYear getLicenseFirstYear() {
        return licenseFirstYear;
    }

    public void setLicenseFirstYear(V8LicenseFirstYear licenseFirstYear) {
        this.licenseFirstYear = licenseFirstYear;
    }

    @Override
    public String toString() {
        return "MC [xmlns=" + xmlns + ", schemaVersion=" + schemaVersion + ", metadata=" + metadata
                + ", machineTypeModelAndSerialNumber=" + machineTypeModelAndSerialNumber + ", managedSystems="
                + managedSystems + ", mManagementConsoleName=" + mManagementConsoleName + ", networkInterfaces="
                + networkInterfaces + ", templateObjectModelVersion=" + templateObjectModelVersion
                + ", userObjectModelVersion=" + userObjectModelVersion + ", versionInfo=" + versionInfo
                + ", webObjectModelVersion=" + webObjectModelVersion + ", bIOS=" + bIOS + ", baseVersion=" + baseVersion
                + ", driver=" + driver + ", licenseID=" + licenseID + ", licenseFirstYear=" + licenseFirstYear + "]";
    }

}
