package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "ManagedSystem")
public class V8ManagedSystem {

    @XmlAttribute(name = "schemaVersion")
    private String schemaVersion;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "ActivatedLevel")
    private String activatedLevel;

    @XmlElement(name = "AssociatedIPLConfiguration")
    private V8AssociatedIPLConfiguration associatedIPLConfiguration;

    @XmlElement(name = "AssociatedLogicalPartitions")
    private V8AssociatedLogicalPartitions associatedLogicalPartitions;

    @XmlElement(name = "AssociatedSystemCapabilities")
    private V8AssociatedSystemCapabilities associatedSystemCapabilities;

    @XmlElement(name = "AssociatedSystemIOConfiguration")
    private V8AssociatedSystemIOConfiguration associatedSystemIOConfiguration;

    @XmlElement(name = "AssociatedSystemMemoryConfiguration")
    private V8AssociatedSystemMemoryConfiguration associatedSystemMemoryConfiguration;

    @XmlElement(name = "AssociatedSystemProcessorConfiguration")
    private V8AssociatedSystemProcessorConfiguration associatedSystemProcessorConfiguration;

    @XmlElement(name = "AssociatedVirtualIOServers")
    private V8AssociatedVirtualIOServers associatedVirtualIOServers;

    @XmlElement(name = "MachineTypeModelAndSerialNumber")
    private V8MachineTypeModelAndSerialNumber machineTypeModelAndSerialNumber;

    @XmlElement(name = "ManufacturingDefaultConfigurationEnabled")
    private String manufacturingDefaultConfigurationEnabled;

    @XmlElement(name = "MaximumPartitions")
    private String maximumPartitions;

    @XmlElement(name = "MaximumPowerControlPartitions")
    private String maximumPowerControlPartitions;

    @XmlElement(name = "MaximumRemoteRestartPartitions")
    private String maximumRemoteRestartPartitions;

    @XmlElement(name = "MaximumSharedProcessorCapablePartitionID")
    private String maximumSharedProcessorCapablePartitionID;

    @XmlElement(name = "MaximumSuspendablePartitions")
    private String maximumSuspendablePartitions;

    @XmlElement(name = "PhysicalSystemAttentionLEDState")
    private String physicalSystemAttentionLEDState;

    @XmlElement(name = "PrimaryIPAddress")
    private String primaryIPAddress;

    @XmlElement(name = "Hostname")
    private V8Hostname hostname;

    @XmlElement(name = "ServiceProcessorFailoverEnabled")
    private V8ServiceProcessorFailoverEnabled serviceProcessorFailoverEnabled;

    @XmlElement(name = "ServiceProcessorFailoverReason")
    private V8ServiceProcessorFailoverReason serviceProcessorFailoverReason;

    @XmlElement(name = "ServiceProcessorFailoverState")
    private V8ServiceProcessorFailoverState serviceProcessorFailoverState;

    @XmlElement(name = "ServiceProcessorVersion")
    private String serviceProcessorVersion;

    @XmlElement(name = "State")
    private String state;

    @XmlElement(name = "SystemName")
    private String systemName;

    @XmlElement(name = "SystemTime")
    private String systemTime;

    @XmlElement(name = "VirtualSystemAttentionLEDState")
    private String virtualSystemAttentionLEDState;

    @XmlElement(name = "SystemMigrationInformation")
    private V8SystemMigrationInformation systemMigrationInformation;

    @XmlElement(name = "ServicePartition")
    private V8ServicePartition servicePartition;

    @XmlElement(name = "ReferenceCode")
    private String referenceCode;

    @XmlElement(name = "MergedReferenceCode")
    private V8MergedReferenceCode mergedReferenceCode;

    @XmlElement(name = "SystemFirmware")
    private V8SystemFirmware systemFirmware;

    @XmlElement(name = "CapacityOnDemandProperties")
    private V8CapacityOnDemandProperties capacityOnDemandProperties;

    @XmlElement(name = "EnergyManagementConfiguration")
    private V8EnergyManagementConfiguration energyManagementConfiguration;

    @XmlElement(name = "IsPowerVMManagementMaster")
    private V8IsPowerVMManagementMaster isPowerVMManagementMaster;

    @XmlElement(name = "IsClassicHMCManagement")
    private V8IsClassicHMCManagement isClassicHMCManagement;

    @XmlElement(name = "IsPowerVMManagementWithoutMaster")
    private V8IsPowerVMManagementWithoutMaster isPowerVMManagementWithoutMaster;

    @XmlElement(name = "IsManagementPartitionPowerVMManagementMaster")
    private V8IsManagementPartitionPowerVMManagementMaster isManagementPartitionPowerVMManagementMaster;

    @XmlElement(name = "IsHMCPowerVMManagementMaster")
    private V8IsHMCPowerVMManagementMaster isHMCPowerVMManagementMaster;

    @XmlElement(name = "IsNotPowerVMManagementMaster")
    private V8isNotPowerVMManagementMaster isNotPowerVMManagementMaster;

    @XmlElement(name = "IsPowerVMManagementNormalMaster")
    private V8IsPowerVMManagementNormalMaster isPowerVMManagementNormalMaster;

    @XmlElement(name = "IsPowerVMManagementPersistentMaster")
    private V8IsPowerVMManagementPersistentMaster isPowerVMManagementPersistentMaster;

    @XmlElement(name = "IsPowerVMManagementTemporaryMaster")
    private V8IsPowerVMManagementTemporaryMaster isPowerVMManagementTemporaryMaster;

    @XmlElement(name = "IsPowerVMManagementPartitionEnabled")
    private V8IsPowerVMManagementPartitionEnabled isPowerVMManagementPartitionEnabled;

    @XmlElement(name = "Description")
    private V8Description description;

    @XmlElement(name = "SystemLocation")
    private V8SystemLocation systemLocation;


    public V8ManagedSystem() {
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getActivatedLevel() {
        return activatedLevel;
    }

    public void setActivatedLevel(String activatedLevel) {
        this.activatedLevel = activatedLevel;
    }

    public V8AssociatedIPLConfiguration getAssociatedIPLConfiguration() {
        return associatedIPLConfiguration;
    }

    public void setAssociatedIPLConfiguration(V8AssociatedIPLConfiguration associatedIPLConfiguration) {
        this.associatedIPLConfiguration = associatedIPLConfiguration;
    }

    public V8AssociatedLogicalPartitions getAssociatedLogicalPartitions() {
        return associatedLogicalPartitions;
    }

    public void setAssociatedLogicalPartitions(V8AssociatedLogicalPartitions associatedLogicalPartitions) {
        this.associatedLogicalPartitions = associatedLogicalPartitions;
    }

    public V8AssociatedSystemCapabilities getAssociatedSystemCapabilities() {
        return associatedSystemCapabilities;
    }

    public void setAssociatedSystemCapabilities(V8AssociatedSystemCapabilities associatedSystemCapabilities) {
        this.associatedSystemCapabilities = associatedSystemCapabilities;
    }

    public V8AssociatedSystemIOConfiguration getAssociatedSystemIOConfiguration() {
        return associatedSystemIOConfiguration;
    }

    public void setAssociatedSystemIOConfiguration(V8AssociatedSystemIOConfiguration associatedSystemIOConfiguration) {
        this.associatedSystemIOConfiguration = associatedSystemIOConfiguration;
    }

    public V8AssociatedSystemMemoryConfiguration getAssociatedSystemMemoryConfiguration() {
        return associatedSystemMemoryConfiguration;
    }

    public void setAssociatedSystemMemoryConfiguration(
            V8AssociatedSystemMemoryConfiguration associatedSystemMemoryConfiguration) {
        this.associatedSystemMemoryConfiguration = associatedSystemMemoryConfiguration;
    }

    public V8AssociatedSystemProcessorConfiguration getAssociatedSystemProcessorConfiguration() {
        return associatedSystemProcessorConfiguration;
    }

    public void setAssociatedSystemProcessorConfiguration(
            V8AssociatedSystemProcessorConfiguration associatedSystemProcessorConfiguration) {
        this.associatedSystemProcessorConfiguration = associatedSystemProcessorConfiguration;
    }

    public V8AssociatedVirtualIOServers getAssociatedVirtualIOServers() {
        return associatedVirtualIOServers;
    }

    public void setAssociatedVirtualIOServers(V8AssociatedVirtualIOServers associatedVirtualIOServers) {
        this.associatedVirtualIOServers = associatedVirtualIOServers;
    }

    public V8MachineTypeModelAndSerialNumber getMachineTypeModelAndSerialNumber() {
        return machineTypeModelAndSerialNumber;
    }

    public void setMachineTypeModelAndSerialNumber(V8MachineTypeModelAndSerialNumber machineTypeModelAndSerialNumber) {
        this.machineTypeModelAndSerialNumber = machineTypeModelAndSerialNumber;
    }

    public String getManufacturingDefaultConfigurationEnabled() {
        return manufacturingDefaultConfigurationEnabled;
    }

    public void setManufacturingDefaultConfigurationEnabled(String manufacturingDefaultConfigurationEnabled) {
        this.manufacturingDefaultConfigurationEnabled = manufacturingDefaultConfigurationEnabled;
    }

    public String getMaximumPartitions() {
        return maximumPartitions;
    }

    public void setMaximumPartitions(String maximumPartitions) {
        this.maximumPartitions = maximumPartitions;
    }

    public String getMaximumPowerControlPartitions() {
        return maximumPowerControlPartitions;
    }

    public void setMaximumPowerControlPartitions(String maximumPowerControlPartitions) {
        this.maximumPowerControlPartitions = maximumPowerControlPartitions;
    }

    public String getMaximumRemoteRestartPartitions() {
        return maximumRemoteRestartPartitions;
    }

    public void setMaximumRemoteRestartPartitions(String maximumRemoteRestartPartitions) {
        this.maximumRemoteRestartPartitions = maximumRemoteRestartPartitions;
    }

    public String getMaximumSharedProcessorCapablePartitionID() {
        return maximumSharedProcessorCapablePartitionID;
    }

    public void setMaximumSharedProcessorCapablePartitionID(String maximumSharedProcessorCapablePartitionID) {
        this.maximumSharedProcessorCapablePartitionID = maximumSharedProcessorCapablePartitionID;
    }

    public String getMaximumSuspendablePartitions() {
        return maximumSuspendablePartitions;
    }

    public void setMaximumSuspendablePartitions(String maximumSuspendablePartitions) {
        this.maximumSuspendablePartitions = maximumSuspendablePartitions;
    }

    public String getPhysicalSystemAttentionLEDState() {
        return physicalSystemAttentionLEDState;
    }

    public void setPhysicalSystemAttentionLEDState(String physicalSystemAttentionLEDState) {
        this.physicalSystemAttentionLEDState = physicalSystemAttentionLEDState;
    }

    public String getPrimaryIPAddress() {
        return primaryIPAddress;
    }

    public void setPrimaryIPAddress(String primaryIPAddress) {
        this.primaryIPAddress = primaryIPAddress;
    }

    public V8Hostname getHostname() {
        return hostname;
    }

    public void setHostname(V8Hostname hostname) {
        this.hostname = hostname;
    }

    public V8ServiceProcessorFailoverEnabled getServiceProcessorFailoverEnabled() {
        return serviceProcessorFailoverEnabled;
    }

    public void setServiceProcessorFailoverEnabled(V8ServiceProcessorFailoverEnabled serviceProcessorFailoverEnabled) {
        this.serviceProcessorFailoverEnabled = serviceProcessorFailoverEnabled;
    }

    public V8ServiceProcessorFailoverReason getServiceProcessorFailoverReason() {
        return serviceProcessorFailoverReason;
    }

    public void setServiceProcessorFailoverReason(V8ServiceProcessorFailoverReason serviceProcessorFailoverReason) {
        this.serviceProcessorFailoverReason = serviceProcessorFailoverReason;
    }

    public V8ServiceProcessorFailoverState getServiceProcessorFailoverState() {
        return serviceProcessorFailoverState;
    }

    public void setServiceProcessorFailoverState(V8ServiceProcessorFailoverState serviceProcessorFailoverState) {
        this.serviceProcessorFailoverState = serviceProcessorFailoverState;
    }

    public String getServiceProcessorVersion() {
        return serviceProcessorVersion;
    }

    public void setServiceProcessorVersion(String serviceProcessorVersion) {
        this.serviceProcessorVersion = serviceProcessorVersion;
    }

    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    public String getSystemName() {
        return systemName;
    }

    public void setSystemName(String systemName) {
        this.systemName = systemName;
    }

    public String getSystemTime() {
        return systemTime;
    }

    public void setSystemTime(String systemTime) {
        this.systemTime = systemTime;
    }

    public String getVirtualSystemAttentionLEDState() {
        return virtualSystemAttentionLEDState;
    }

    public void setVirtualSystemAttentionLEDState(String virtualSystemAttentionLEDState) {
        this.virtualSystemAttentionLEDState = virtualSystemAttentionLEDState;
    }

    public V8SystemMigrationInformation getSystemMigrationInformation() {
        return systemMigrationInformation;
    }

    public void setSystemMigrationInformation(V8SystemMigrationInformation systemMigrationInformation) {
        this.systemMigrationInformation = systemMigrationInformation;
    }

    public String getReferenceCode() {
        return referenceCode;
    }

    public void setReferenceCode(String referenceCode) {
        this.referenceCode = referenceCode;
    }

    public V8MergedReferenceCode getMergedReferenceCode() {
        return mergedReferenceCode;
    }

    public void setMergedReferenceCode(V8MergedReferenceCode mergedReferenceCode) {
        this.mergedReferenceCode = mergedReferenceCode;
    }

    public V8SystemFirmware getSystemFirmware() {
        return systemFirmware;
    }

    public void setSystemFirmware(V8SystemFirmware systemFirmware) {
        this.systemFirmware = systemFirmware;
    }

    public V8CapacityOnDemandProperties getCapacityOnDemandProperties() {
        return capacityOnDemandProperties;
    }

    public void setCapacityOnDemandProperties(V8CapacityOnDemandProperties capacityOnDemandProperties) {
        this.capacityOnDemandProperties = capacityOnDemandProperties;
    }

    public V8EnergyManagementConfiguration getEnergyManagementConfiguration() {
        return energyManagementConfiguration;
    }

    public void setEnergyManagementConfiguration(V8EnergyManagementConfiguration energyManagementConfiguration) {
        this.energyManagementConfiguration = energyManagementConfiguration;
    }

    public V8IsPowerVMManagementMaster getIsPowerVMManagementMaster() {
        return isPowerVMManagementMaster;
    }

    public void setIsPowerVMManagementMaster(V8IsPowerVMManagementMaster isPowerVMManagementMaster) {
        this.isPowerVMManagementMaster = isPowerVMManagementMaster;
    }

    public V8IsClassicHMCManagement getIsClassicHMCManagement() {
        return isClassicHMCManagement;
    }

    public void setIsClassicHMCManagement(V8IsClassicHMCManagement isClassicHMCManagement) {
        this.isClassicHMCManagement = isClassicHMCManagement;
    }

    public V8IsPowerVMManagementWithoutMaster getIsPowerVMManagementWithoutMaster() {
        return isPowerVMManagementWithoutMaster;
    }

    public void setIsPowerVMManagementWithoutMaster(V8IsPowerVMManagementWithoutMaster isPowerVMManagementWithoutMaster) {
        this.isPowerVMManagementWithoutMaster = isPowerVMManagementWithoutMaster;
    }

    public V8IsManagementPartitionPowerVMManagementMaster getIsManagementPartitionPowerVMManagementMaster() {
        return isManagementPartitionPowerVMManagementMaster;
    }

    public void setIsManagementPartitionPowerVMManagementMaster(V8IsManagementPartitionPowerVMManagementMaster isManagementPartitionPowerVMManagementMaster) {
        this.isManagementPartitionPowerVMManagementMaster = isManagementPartitionPowerVMManagementMaster;
    }

    public V8IsHMCPowerVMManagementMaster getIsHMCPowerVMManagementMaster() {
        return isHMCPowerVMManagementMaster;
    }

    public void setIsHMCPowerVMManagementMaster(V8IsHMCPowerVMManagementMaster isHMCPowerVMManagementMaster) {
        this.isHMCPowerVMManagementMaster = isHMCPowerVMManagementMaster;
    }

    public V8isNotPowerVMManagementMaster getIsNotPowerVMManagementMaster() {
        return isNotPowerVMManagementMaster;
    }

    public void setIsNotPowerVMManagementMaster(V8isNotPowerVMManagementMaster isNotPowerVMManagementMaster) {
        this.isNotPowerVMManagementMaster = isNotPowerVMManagementMaster;
    }

    public V8IsPowerVMManagementNormalMaster getIsPowerVMManagementNormalMaster() {
        return isPowerVMManagementNormalMaster;
    }

    public void setIsPowerVMManagementNormalMaster(V8IsPowerVMManagementNormalMaster isPowerVMManagementNormalMaster) {
        this.isPowerVMManagementNormalMaster = isPowerVMManagementNormalMaster;
    }

    public V8IsPowerVMManagementPersistentMaster getIsPowerVMManagementPersistentMaster() {
        return isPowerVMManagementPersistentMaster;
    }

    public void setIsPowerVMManagementPersistentMaster(V8IsPowerVMManagementPersistentMaster isPowerVMManagementPersistentMaster) {
        this.isPowerVMManagementPersistentMaster = isPowerVMManagementPersistentMaster;
    }

    public V8IsPowerVMManagementTemporaryMaster getIsPowerVMManagementTemporaryMaster() {
        return isPowerVMManagementTemporaryMaster;
    }

    public void setIsPowerVMManagementTemporaryMaster(V8IsPowerVMManagementTemporaryMaster isPowerVMManagementTemporaryMaster) {
        this.isPowerVMManagementTemporaryMaster = isPowerVMManagementTemporaryMaster;
    }

    public V8IsPowerVMManagementPartitionEnabled getIsPowerVMManagementPartitionEnabled() {
        return isPowerVMManagementPartitionEnabled;
    }

    public void setIsPowerVMManagementPartitionEnabled(V8IsPowerVMManagementPartitionEnabled isPowerVMManagementPartitionEnabled) {
        this.isPowerVMManagementPartitionEnabled = isPowerVMManagementPartitionEnabled;
    }

    public V8Description getDescription() {
        return description;
    }

    public void setDescription(V8Description description) {
        this.description = description;
    }

    public V8SystemLocation getSystemLocation() {
        return systemLocation;
    }

    public void setSystemLocation(V8SystemLocation systemLocation) {
        this.systemLocation = systemLocation;
    }

    public V8ServicePartition getServicePartition() {
        return servicePartition;
    }

    public void setServicePartition(V8ServicePartition servicePartition) {
        this.servicePartition = servicePartition;
    }

    @Override
    public String toString() {
        return "ManagedSystem [metadata=" + metadata + ", activatedLevel=" + activatedLevel
                + ", associatedIPLConfiguration=" + associatedIPLConfiguration + ", associatedLogicalPartitions="
                + associatedLogicalPartitions + ", associatedSystemCapabilities=" + associatedSystemCapabilities
                + ", associatedSystemIOConfiguration=" + associatedSystemIOConfiguration
                + ", associatedSystemMemoryConfiguration=" + associatedSystemMemoryConfiguration
                + ", associatedSystemProcessorConfiguration=" + associatedSystemProcessorConfiguration
                + ", associatedVirtualIOServers=" + associatedVirtualIOServers + ", machineTypeModelAndSerialNumber="
                + machineTypeModelAndSerialNumber + ", manufacturingDefaultConfigurationEnabled="
                + manufacturingDefaultConfigurationEnabled + ", maximumPartitions=" + maximumPartitions
                + ", maximumPowerControlPartitions=" + maximumPowerControlPartitions
                + ", maximumRemoteRestartPartitions=" + maximumRemoteRestartPartitions
                + ", maximumSharedProcessorCapablePartitionID=" + maximumSharedProcessorCapablePartitionID
                + ", maximumSuspendablePartitions=" + maximumSuspendablePartitions
                + ", physicalSystemAttentionLEDState=" + physicalSystemAttentionLEDState + ", primaryIPAddress="
                + primaryIPAddress + ", hostname=" + hostname + ", serviceProcessorFailoverEnabled="
                + serviceProcessorFailoverEnabled + ", serviceProcessorFailoverReason=" + serviceProcessorFailoverReason
                + ", serviceProcessorFailoverState=" + serviceProcessorFailoverState + ", serviceProcessorVersion="
                + serviceProcessorVersion + ", state=" + state + ", systemName=" + systemName + ", systemTime="
                + systemTime + ", virtualSystemAttentionLEDState=" + virtualSystemAttentionLEDState
                + ", systemMigrationInformation=" + systemMigrationInformation + ", referenceCode=" + referenceCode
                + ", mergedReferenceCode=" + mergedReferenceCode + ", systemFirmware=" + systemFirmware
                + ", capacityOnDemandProperties=" + capacityOnDemandProperties + "]";
    }

}
