package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "MediaRepositories")
public class V8MediaRepositories {
    @XmlAttribute
    private String group;

    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    /*
     * 暂时来看，virtualMediaRepository只有一个
     *
     */
    @XmlElement(name = "VirtualMediaRepository")
    private V8VirtualMediaRepository virtualMediaRepository;

    /**
     * @return the group
     */
    public String getGroup() {
        return group;
    }

    /**
     * @param group the group to set
     */
    public void setGroup(String group) {
        this.group = group;
    }

    /**
     * @return the schemaVersion
     */
    public String getSchemaVersion() {
        return schemaVersion;
    }

    /**
     * @param schemaVersion the schemaVersion to set
     */
    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    /**
     * @return the metadata
     */
    public V8Metadata getMetadata() {
        return metadata;
    }

    /**
     * @param metadata the metadata to set
     */
    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    /**
     * @return the virtualMediaRepository
     */
    public V8VirtualMediaRepository getVirtualMediaRepository() {
        return virtualMediaRepository;
    }

    /**
     * @param virtualMediaRepository the virtualMediaRepository to set
     */
    public void setVirtualMediaRepository(V8VirtualMediaRepository virtualMediaRepository) {
        this.virtualMediaRepository = virtualMediaRepository;
    }

    public V8MediaRepositories() {
        super();
    }

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }

}
