package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "NetworkBridge")
public class V8NetworkBridge {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "failoverEnabled")
    private String failoverEnabled;

    @XmlElement(name = "LoadBalancingEnabled")
    private String loadBalancingEnabled;

    @XmlElement(name = "LoadGroups")
    private V8LoadGroups LoadGroups;

    @XmlElement(name = "PortVLANID")
    private String portVLANID;

    @XmlElement(name = "SharedEthernetAdapters")
    private V8SharedEthernetAdapters sharedEthernetAdapters;

    @XmlElement(name = "UniqueDeviceID")
    private String uniqueDeviceID;

    @XmlElement(name = "VirtualNetworks")
    private V8VirtualNetworks virtualNetworks;

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public V8LoadGroups getLoadGroups() {
        return LoadGroups;
    }

    public void setLoadGroups(V8LoadGroups loadGroups) {
        LoadGroups = loadGroups;
    }

    public String getFailoverEnabled() {
        return failoverEnabled;
    }

    public void setFailoverEnabled(String failoverEnabled) {
        this.failoverEnabled = failoverEnabled;
    }

    public String getLoadBalancingEnabled() {
        return loadBalancingEnabled;
    }

    public void setLoadBalancingEnabled(String loadBalancingEnabled) {
        this.loadBalancingEnabled = loadBalancingEnabled;
    }

    public String getPortVLANID() {
        return portVLANID;
    }

    public void setPortVLANID(String portVLANID) {
        this.portVLANID = portVLANID;
    }

    public V8SharedEthernetAdapters getSharedEthernetAdapters() {
        return sharedEthernetAdapters;
    }

    public void setSharedEthernetAdapters(V8SharedEthernetAdapters sharedEthernetAdapters) {
        this.sharedEthernetAdapters = sharedEthernetAdapters;
    }

    public String getUniqueDeviceID() {
        return uniqueDeviceID;
    }

    public void setUniqueDeviceID(String uniqueDeviceID) {
        this.uniqueDeviceID = uniqueDeviceID;
    }

    public V8VirtualNetworks getVirtualNetworks() {
        return virtualNetworks;
    }

    public void setVirtualNetworks(V8VirtualNetworks virtualNetworks) {
        this.virtualNetworks = virtualNetworks;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }

}
