package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "PartitionCapabilities")
public class V8PartitionCapabilities {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "DynamicLogicalPartitionIOCapable")
    private String dynamicLogicalPartitionIOCapable;

    @XmlElement(name = "DynamicLogicalPartitionMemoryCapable")
    private String dynamicLogicalPartitionMemoryCapable;

    @XmlElement(name = "DynamicLogicalPartitionProcessorCapable")
    private String dynamicLogicalPartitionProcessorCapable;

    @XmlElement(name = "InternalAndExternalIntrusionDetectionCapable")
    private String internalAndExternalIntrusionDetectionCapable;

    @XmlElement(name = "ResourceMonitoringControlOperatingSystemShutdownCapable")
    private String resourceMonitoringControlOperatingSystemShutdownCapable;

    public V8PartitionCapabilities() {
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getDynamicLogicalPartitionIOCapable() {
        return dynamicLogicalPartitionIOCapable;
    }

    public void setDynamicLogicalPartitionIOCapable(String dynamicLogicalPartitionIOCapable) {
        this.dynamicLogicalPartitionIOCapable = dynamicLogicalPartitionIOCapable;
    }

    public String getDynamicLogicalPartitionMemoryCapable() {
        return dynamicLogicalPartitionMemoryCapable;
    }

    public void setDynamicLogicalPartitionMemoryCapable(String dynamicLogicalPartitionMemoryCapable) {
        this.dynamicLogicalPartitionMemoryCapable = dynamicLogicalPartitionMemoryCapable;
    }

    public String getDynamicLogicalPartitionProcessorCapable() {
        return dynamicLogicalPartitionProcessorCapable;
    }

    public void setDynamicLogicalPartitionProcessorCapable(String dynamicLogicalPartitionProcessorCapable) {
        this.dynamicLogicalPartitionProcessorCapable = dynamicLogicalPartitionProcessorCapable;
    }

    public String getInternalAndExternalIntrusionDetectionCapable() {
        return internalAndExternalIntrusionDetectionCapable;
    }

    public void setInternalAndExternalIntrusionDetectionCapable(String internalAndExternalIntrusionDetectionCapable) {
        this.internalAndExternalIntrusionDetectionCapable = internalAndExternalIntrusionDetectionCapable;
    }

    public String getResourceMonitoringControlOperatingSystemShutdownCapable() {
        return resourceMonitoringControlOperatingSystemShutdownCapable;
    }

    public void setResourceMonitoringControlOperatingSystemShutdownCapable(
            String resourceMonitoringControlOperatingSystemShutdownCapable) {
        this.resourceMonitoringControlOperatingSystemShutdownCapable = resourceMonitoringControlOperatingSystemShutdownCapable;
    }

    @Override
    public String toString() {
        return "PartitionCapabilities [metadata=" + metadata + ", dynamicLogicalPartitionIOCapable="
                + dynamicLogicalPartitionIOCapable + ", dynamicLogicalPartitionMemoryCapable="
                + dynamicLogicalPartitionMemoryCapable + ", dynamicLogicalPartitionProcessorCapable="
                + dynamicLogicalPartitionProcessorCapable + ", internalAndExternalIntrusionDetectionCapable="
                + internalAndExternalIntrusionDetectionCapable
                + ", resourceMonitoringControlOperatingSystemShutdownCapable="
                + resourceMonitoringControlOperatingSystemShutdownCapable + "]";
    }

}
