package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "PartitionIOConfiguration")
public class V8PartitionIOConfiguration {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "MaximumVirtualIOSlots")
    private String maximumVirtualIOSlots;

    @XmlElement(name = "ProfileIOSlots")
    private V8ProfileIOSlots profileIOSlots;

    @XmlElement(name = "CurrentMaximumVirtualIOSlots")
    private String currentMaximumVirtualIOSlots;

    public V8PartitionIOConfiguration() {
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getMaximumVirtualIOSlots() {
        return maximumVirtualIOSlots;
    }

    public void setMaximumVirtualIOSlots(String maximumVirtualIOSlots) {
        this.maximumVirtualIOSlots = maximumVirtualIOSlots;
    }

    public V8ProfileIOSlots getProfileIOSlots() {
        return profileIOSlots;
    }

    public void setProfileIOSlots(V8ProfileIOSlots profileIOSlots) {
        this.profileIOSlots = profileIOSlots;
    }

    public String getCurrentMaximumVirtualIOSlots() {
        return currentMaximumVirtualIOSlots;
    }

    public void setCurrentMaximumVirtualIOSlots(String currentMaximumVirtualIOSlots) {
        this.currentMaximumVirtualIOSlots = currentMaximumVirtualIOSlots;
    }

    @Override
    public String toString() {
        return "PartitionIOConfiguration [metadata=" + metadata + ", maximumVirtualIOSlots=" + maximumVirtualIOSlots
                + ", profileIOSlots=" + profileIOSlots + ", currentMaximumVirtualIOSlots="
                + currentMaximumVirtualIOSlots + "]";
    }

}
