package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "PartitionProcessorConfiguration")
public class V8PartitionProcessorConfiguration {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "DedicatedProcessorConfiguration")
    private V8DedicatedProcessorConfiguration dedicatedProcessorConfiguration;

    @XmlElement(name = "HasDedicatedProcessors")
    private String hasDedicatedProcessors;

    @XmlElement(name = "SharedProcessorConfiguration")
    private V8SharedProcessorConfiguration sharedProcessorConfiguration;

    @XmlElement(name = "SharingMode")
    private String sharingMode;

    @XmlElement(name = "CurrentHasDedicatedProcessors")
    private String currentHasDedicatedProcessors;

    @XmlElement(name = "CurrentSharingMode")
    private String currentSharingMode;

    @XmlElement(name = "CurrentDedicatedProcessorConfiguration")
    private V8CurrentDedicatedProcessorConfiguration currentDedicatedProcessorConfiguration;

    @XmlElement(name = "RuntimeHasDedicatedProcessors")
    private String runtimeHasDedicatedProcessors;

    @XmlElement(name = "CurrentSharedProcessorConfiguration")
    private V8CurrentSharedProcessorConfiguration currentSharedProcessorConfiguration;

    public V8PartitionProcessorConfiguration() {
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getHasDedicatedProcessors() {
        return hasDedicatedProcessors;
    }

    public void setHasDedicatedProcessors(String hasDedicatedProcessors) {
        this.hasDedicatedProcessors = hasDedicatedProcessors;
    }

    public String getSharingMode() {
        return sharingMode;
    }

    public void setSharingMode(String sharingMode) {
        this.sharingMode = sharingMode;
    }

    public String getCurrentHasDedicatedProcessors() {
        return currentHasDedicatedProcessors;
    }

    public void setCurrentHasDedicatedProcessors(String currentHasDedicatedProcessors) {
        this.currentHasDedicatedProcessors = currentHasDedicatedProcessors;
    }

    public String getCurrentSharingMode() {
        return currentSharingMode;
    }

    public void setCurrentSharingMode(String currentSharingMode) {
        this.currentSharingMode = currentSharingMode;
    }

    public String getRuntimeHasDedicatedProcessors() {
        return runtimeHasDedicatedProcessors;
    }

    public void setRuntimeHasDedicatedProcessors(String runtimeHasDedicatedProcessors) {
        this.runtimeHasDedicatedProcessors = runtimeHasDedicatedProcessors;
    }

    public V8SharedProcessorConfiguration getSharedProcessorConfiguration() {
        return sharedProcessorConfiguration;
    }

    public void setSharedProcessorConfiguration(V8SharedProcessorConfiguration sharedProcessorConfiguration) {
        this.sharedProcessorConfiguration = sharedProcessorConfiguration;
    }

    public V8CurrentSharedProcessorConfiguration getCurrentSharedProcessorConfiguration() {
        return currentSharedProcessorConfiguration;
    }

    public void setCurrentSharedProcessorConfiguration(
            V8CurrentSharedProcessorConfiguration currentSharedProcessorConfiguration) {
        this.currentSharedProcessorConfiguration = currentSharedProcessorConfiguration;
    }

    /**
     * @return the dedicatedProcessorConfiguration
     */
    public V8DedicatedProcessorConfiguration getDedicatedProcessorConfiguration() {
        return dedicatedProcessorConfiguration;
    }

    /**
     * @param dedicatedProcessorConfiguration the dedicatedProcessorConfiguration to set
     */
    public void setDedicatedProcessorConfiguration(V8DedicatedProcessorConfiguration dedicatedProcessorConfiguration) {
        this.dedicatedProcessorConfiguration = dedicatedProcessorConfiguration;
    }

    /**
     * @return the currentDedicatedProcessorConfiguration
     */
    public V8CurrentDedicatedProcessorConfiguration getCurrentDedicatedProcessorConfiguration() {
        return currentDedicatedProcessorConfiguration;
    }

    /**
     * @param currentDedicatedProcessorConfiguration the currentDedicatedProcessorConfiguration to set
     */
    public void setCurrentDedicatedProcessorConfiguration(
            V8CurrentDedicatedProcessorConfiguration currentDedicatedProcessorConfiguration) {
        this.currentDedicatedProcessorConfiguration = currentDedicatedProcessorConfiguration;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this, true);
    }

}
