package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "PhysicalFibreChannelAdapter")
public class V8PhysicalFibreChannelAdapter {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "AdapterID")
    private String adapterID;

    @XmlElement(name = "Description")
    private String description;

    @XmlElement(name = "DeviceName")
    private String deviceName;

    @XmlElement(name = "DynamicReconfigurationConnectorName")
    private String dynamicReconfigurationConnectorName;

    @XmlElement(name = "PhysicalLocation")
    private String physicalLocation;

    @XmlElement(name = "PhysicalFibreChannelPorts")
    private V8PhysicalFibreChannelPorts physicalFibreChannelPorts;

    public V8PhysicalFibreChannelAdapter() {
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getAdapterID() {
        return adapterID;
    }

    public void setAdapterID(String adapterID) {
        this.adapterID = adapterID;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDeviceName() {
        return deviceName;
    }

    public void setDeviceName(String deviceName) {
        this.deviceName = deviceName;
    }

    public String getDynamicReconfigurationConnectorName() {
        return dynamicReconfigurationConnectorName;
    }

    public void setDynamicReconfigurationConnectorName(String dynamicReconfigurationConnectorName) {
        this.dynamicReconfigurationConnectorName = dynamicReconfigurationConnectorName;
    }

    public String getPhysicalLocation() {
        return physicalLocation;
    }

    public void setPhysicalLocation(String physicalLocation) {
        this.physicalLocation = physicalLocation;
    }

    public V8PhysicalFibreChannelPorts getPhysicalFibreChannelPorts() {
        return physicalFibreChannelPorts;
    }

    public void setPhysicalFibreChannelPorts(V8PhysicalFibreChannelPorts physicalFibreChannelPorts) {
        this.physicalFibreChannelPorts = physicalFibreChannelPorts;
    }

    @Override
    public String toString() {
        return "IOAdapter [metadata=" + metadata + ", adapterID=" + adapterID + ", description=" + description
                + ", deviceName=" + deviceName + ", dynamicReconfigurationConnectorName="
                + dynamicReconfigurationConnectorName + ", physicalLocation=" + physicalLocation
                + ", physicalFibreChannelPorts=" + physicalFibreChannelPorts + "]";
    }
}
