package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "ProcessorAttributes")
public class V8ProcessorAttributes {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "DedicatedProcessorConfiguration")
    private V8DedicatedProcessorConfiguration dedicatedProcessorConfiguration;

    @XmlElement(name = "HasDedicatedProcessors")
    private String hasDedicatedProcessors;

    @XmlElement(name = "SharedProcessorConfiguration")
    private V8SharedProcessorConfiguration sharedProcessorConfiguration;

    @XmlElement(name = "SharingMode")
    private String sharingMode;

    public V8ProcessorAttributes() {
    }

    /**
     * @return the schemaVersion
     */
    public String getSchemaVersion() {
        return schemaVersion;
    }

    /**
     * @param schemaVersion the schemaVersion to set
     */
    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getHasDedicatedProcessors() {
        return hasDedicatedProcessors;
    }

    public void setHasDedicatedProcessors(String hasDedicatedProcessors) {
        this.hasDedicatedProcessors = hasDedicatedProcessors;
    }

    public V8SharedProcessorConfiguration getSharedProcessorConfiguration() {
        return sharedProcessorConfiguration;
    }

    public void setSharedProcessorConfiguration(V8SharedProcessorConfiguration sharedProcessorConfiguration) {
        this.sharedProcessorConfiguration = sharedProcessorConfiguration;
    }

    public String getSharingMode() {
        return sharingMode;
    }

    public void setSharingMode(String sharingMode) {
        this.sharingMode = sharingMode;
    }

    /**
     * @return the dedicatedProcessorConfiguration
     */
    public V8DedicatedProcessorConfiguration getDedicatedProcessorConfiguration() {
        return dedicatedProcessorConfiguration;
    }

    /**
     * @param dedicatedProcessorConfiguration the dedicatedProcessorConfiguration to set
     */
    public void setDedicatedProcessorConfiguration(V8DedicatedProcessorConfiguration dedicatedProcessorConfiguration) {
        this.dedicatedProcessorConfiguration = dedicatedProcessorConfiguration;
    }

    @Override
    public String toString() {
        return "ProcessorAttributes [metadata=" + metadata + ", hasDedicatedProcessors=" + hasDedicatedProcessors
                + ", sharedProcessorConfiguration=" + sharedProcessorConfiguration
                + ", dedicatedProcessorConfiguration=" + dedicatedProcessorConfiguration + ", sharingMode="
                + sharingMode + "]";
    }

}
