package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

/**
 * 客户机虚拟光纤通道适配器
 *
 * @author sxp
 * @since Jun 29, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "ProfileVirtualFibreChannelClientAdapter")
public class V8ProfileVirtualFibreChannelClientAdapter {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "VirtualSlotNumber")
    private String virtualSlotNumber;

    @XmlElement(name = "IsRequired")
    private String isRequired;

    /**
     * 适配器类型
     */
    @XmlElement(name = "AdapterType")
    private String adapterType = "Client";

    /**
     * 所属逻辑分区的标识
     */
    @XmlElement(name = "LocalPartitionID")
    private String localPartitionID;

    /**
     * 连接的虚拟插槽的编号
     */
    @XmlElement(name = "ConnectingVirtualSlotNumber")
    private String connectingVirtualSlotNumber;

    /**
     * 连接的服务器分区标识(一般选择类型为VIOS)
     */
    @XmlElement(name = "ConnectingPartitionID")
    private String connectingPartitionID;

    /**
     * World Wide Port Name, 是对于FC HBA卡上的一个端口的全球唯一标识符。
     * <p>
     * 多个wwpn号之间用空格间隔，该字段不需要设置，创建时系统自动生成
     * </p>
     */
    @XmlElement(name = "WWPNs")
    private String wwpns;

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getVirtualSlotNumber() {
        return virtualSlotNumber;
    }

    public void setVirtualSlotNumber(String virtualSlotNumber) {
        this.virtualSlotNumber = virtualSlotNumber;
    }

    public String getIsRequired() {
        return isRequired;
    }

    public void setIsRequired(String isRequired) {
        this.isRequired = isRequired;
    }

    public String getAdapterType() {
        return adapterType;
    }

    public void setAdapterType(String adapterType) {
        this.adapterType = adapterType;
    }

    public String getLocalPartitionID() {
        return localPartitionID;
    }

    public void setLocalPartitionID(String localPartitionID) {
        this.localPartitionID = localPartitionID;
    }

    public String getConnectingVirtualSlotNumber() {
        return connectingVirtualSlotNumber;
    }

    public void setConnectingVirtualSlotNumber(String connectingVirtualSlotNumber) {
        this.connectingVirtualSlotNumber = connectingVirtualSlotNumber;
    }

    public String getConnectingPartitionID() {
        return connectingPartitionID;
    }

    public void setConnectingPartitionID(String connectingPartitionID) {
        this.connectingPartitionID = connectingPartitionID;
    }

    public String getWwpns() {
        return wwpns;
    }

    public void setWwpns(String wwpns) {
        this.wwpns = wwpns;
    }

}
