package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Atom;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "ServerAdapter")
public class V8ServerAdapter {
    @XmlAttribute(name = "schemaVersion")
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "AdapterType")
    private String adapterType;

    @XmlElement(name = "DynamicReconfigurationConnectorName")
    private String dynamicReconfigurationConnectorName;

    @XmlElement(name = "LocationCode")
    private String locationCode;

    @XmlElement(name = "LocalPartitionID")
    private String localPartitionId;

    @XmlElement(name = "RequiredAdapter")
    private String requiredAdapter;

    @XmlElement(name = "VariedOn")
    private String variedOn;

    @XmlElement(name = "VirtualSlotNumber")
    private String virtualSlotNumber;

    @XmlElement(name = "AdapterName")
    private String adapterName;

    @XmlElement(name = "ConnectingPartitionID")
    private String connectingPartitionID;

    @XmlElement(name = "ConnectingVirtualSlotNumber")
    private String connectingVirtualSlotNumber;

    @XmlElement(name = "BackingDeviceName")
    private String backingDeviceName;

    @XmlElement(name = "RemoteLogicalPartitionID")
    private String remoteLogicalPartitionId;

    @XmlElement(name = "RemoteSlotNumber")
    private String remoteSlotNumber;

    @XmlElement(name = "ServerLocationCode")
    private String serverLocationCode;

    @XmlElement(name = "UniqueDeviceID")
    private String uniqueDeviceId;

    @XmlElement(name = "MapPort")
    private String mapPort;

    @XmlElement(name = "PhysicalPort")
    private V8PhysicalPort physicalPort;

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getAdapterType() {
        return adapterType;
    }

    public void setAdapterType(String adapterType) {
        this.adapterType = adapterType;
    }

    public String getDynamicReconfigurationConnectorName() {
        return dynamicReconfigurationConnectorName;
    }

    public void setDynamicReconfigurationConnectorName(String dynamicReconfigurationConnectorName) {
        this.dynamicReconfigurationConnectorName = dynamicReconfigurationConnectorName;
    }

    public String getLocationCode() {
        return locationCode;
    }

    public void setLocationCode(String locationCode) {
        this.locationCode = locationCode;
    }

    public String getLocalPartitionId() {
        return localPartitionId;
    }

    public void setLocalPartitionId(String localPartitionId) {
        this.localPartitionId = localPartitionId;
    }

    public String getRequiredAdapter() {
        return requiredAdapter;
    }

    public void setRequiredAdapter(String requiredAdapter) {
        this.requiredAdapter = requiredAdapter;
    }

    public String getVariedOn() {
        return variedOn;
    }

    public void setVariedOn(String variedOn) {
        this.variedOn = variedOn;
    }

    public String getVirtualSlotNumber() {
        return virtualSlotNumber;
    }

    public void setVirtualSlotNumber(String virtualSlotNumber) {
        this.virtualSlotNumber = virtualSlotNumber;
    }

    public String getRemoteLogicalPartitionId() {
        return remoteLogicalPartitionId;
    }

    public void setRemoteLogicalPartitionId(String remoteLogicalPartitionId) {
        this.remoteLogicalPartitionId = remoteLogicalPartitionId;
    }

    public String getRemoteSlotNumber() {
        return remoteSlotNumber;
    }

    public void setRemoteSlotNumber(String remoteSlotNumber) {
        this.remoteSlotNumber = remoteSlotNumber;
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    /**
     * @return the adapterName
     */
    public String getAdapterName() {
        return adapterName;
    }

    /**
     * @param adapterName the adapterName to set
     */
    public void setAdapterName(String adapterName) {
        this.adapterName = adapterName;
    }

    /**
     * @return the backingDeviceName
     */
    public String getBackingDeviceName() {
        return backingDeviceName;
    }

    /**
     * @param backingDeviceName the backingDeviceName to set
     */
    public void setBackingDeviceName(String backingDeviceName) {
        this.backingDeviceName = backingDeviceName;
    }

    /**
     * @return the serverLocationCode
     */
    public String getServerLocationCode() {
        return serverLocationCode;
    }

    /**
     * @param serverLocationCode the serverLocationCode to set
     */
    public void setServerLocationCode(String serverLocationCode) {
        this.serverLocationCode = serverLocationCode;
    }

    /**
     * @return the uniqueDeviceId
     */
    public String getUniqueDeviceId() {
        return uniqueDeviceId;
    }

    /**
     * @param uniqueDeviceId the uniqueDeviceId to set
     */
    public void setUniqueDeviceId(String uniqueDeviceId) {
        this.uniqueDeviceId = uniqueDeviceId;
    }

    public V8ServerAdapter() {
    }

    public V8ServerAdapter(String localPartitionId, String remoteLogicalPartitionId, String requiredAdapter) {
        this.metadata = new V8Metadata(new V8Atom());
        this.adapterType = "Server";
        this.localPartitionId = localPartitionId;
        this.remoteLogicalPartitionId = remoteLogicalPartitionId;
        this.requiredAdapter = requiredAdapter;
    }

    public String getConnectingPartitionID() {
        return connectingPartitionID;
    }

    public void setConnectingPartitionID(String connectingPartitionID) {
        this.connectingPartitionID = connectingPartitionID;
    }

    public String getConnectingVirtualSlotNumber() {
        return connectingVirtualSlotNumber;
    }

    public void setConnectingVirtualSlotNumber(String connectingVirtualSlotNumber) {
        this.connectingVirtualSlotNumber = connectingVirtualSlotNumber;
    }

    public String getMapPort() {
        return mapPort;
    }

    public void setMapPort(String mapPort) {
        this.mapPort = mapPort;
    }

    public V8PhysicalPort getPhysicalPort() {
        return physicalPort;
    }

    public void setPhysicalPort(V8PhysicalPort physicalPort) {
        this.physicalPort = physicalPort;
    }

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }

}
