package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "SharedEthernetAdapter")
public class V8SharedEthernetAdapter {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "BackingDeviceChoice")
    private V8BackingDeviceChoice backingDeviceChoice;

    @XmlElement(name = "HighAvailabilityMode")
    private String highAvailabilityMode;

    @XmlElement(name = "DeviceName")
    private String deviceName;

    @XmlElement(name = "JumboFramesEnabled")
    private String jumboFramesEnabled;

    @XmlElement(name = "PortVLANID")
    private String portVLANID;

    @XmlElement(name = "QualityOfServiceMode")
    private String qualityOfServiceMode;

    @XmlElement(name = "QueueSize")
    private String queueSize;

    @XmlElement(name = "ThreadModeEnabled")
    private String threadModeEnabled;

    @XmlElement(name = "TrunkAdapters")
    private V8TrunkAdapters trunkAdapters;

    @XmlElement(name = "IPInterface")
    private V8IpInterface ipInterface;

    @XmlElement(name = "UniqueDeviceID")
    private String uniqueDeviceID;

    @XmlElement(name = "LargeSend")
    private String largeSend;

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public V8BackingDeviceChoice getBackingDeviceChoice() {
        return backingDeviceChoice;
    }

    public void setBackingDeviceChoice(V8BackingDeviceChoice backingDeviceChoice) {
        this.backingDeviceChoice = backingDeviceChoice;
    }

    public String getHighAvailabilityMode() {
        return highAvailabilityMode;
    }

    public void setHighAvailabilityMode(String highAvailabilityMode) {
        this.highAvailabilityMode = highAvailabilityMode;
    }

    public String getDeviceName() {
        return deviceName;
    }

    public void setDeviceName(String deviceName) {
        this.deviceName = deviceName;
    }

    public String getJumboFramesEnabled() {
        return jumboFramesEnabled;
    }

    public void setJumboFramesEnabled(String jumboFramesEnabled) {
        this.jumboFramesEnabled = jumboFramesEnabled;
    }

    public String getPortVLANID() {
        return portVLANID;
    }

    public void setPortVLANID(String portVLANID) {
        this.portVLANID = portVLANID;
    }

    public String getQualityOfServiceMode() {
        return qualityOfServiceMode;
    }

    public void setQualityOfServiceMode(String qualityOfServiceMode) {
        this.qualityOfServiceMode = qualityOfServiceMode;
    }

    public String getQueueSize() {
        return queueSize;
    }

    public void setQueueSize(String queueSize) {
        this.queueSize = queueSize;
    }

    public String getThreadModeEnabled() {
        return threadModeEnabled;
    }

    public void setThreadModeEnabled(String threadModeEnabled) {
        this.threadModeEnabled = threadModeEnabled;
    }

    public V8TrunkAdapters getTrunkAdapters() {
        return trunkAdapters;
    }

    public void setTrunkAdapters(V8TrunkAdapters trunkAdapters) {
        this.trunkAdapters = trunkAdapters;
    }

    public V8IpInterface getIpInterface() {
        return ipInterface;
    }

    public void setIpInterface(V8IpInterface ipInterface) {
        this.ipInterface = ipInterface;
    }

    public String getUniqueDeviceID() {
        return uniqueDeviceID;
    }

    public void setUniqueDeviceID(String uniqueDeviceID) {
        this.uniqueDeviceID = uniqueDeviceID;
    }

    public String getLargeSend() {
        return largeSend;
    }

    public void setLargeSend(String largeSend) {
        this.largeSend = largeSend;
    }

}
