package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

/**
 * 版本信息
 *
 * @author sxp
 * @since May 4, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "VersionInfo")
public class V8VersionInfo {
    @XmlAttribute
    private String kb;

    @XmlAttribute
    private String kxe;

    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "BuildLevel")
    private V8BuildLevel buildLevel;

    @XmlElement(name = "Maintenance")
    private V8Maintenance maintenance;

    @XmlElement(name = "Minor")
    private V8Minor minor;

    @XmlElement(name = "Release")
    private V8Release release;

    @XmlElement(name = "ServicePackName")
    private V8ServicePackName servicePackName;

    @XmlElement(name = "Version")
    private V8Version version;

    public V8VersionInfo() {
    }

    public String getKb() {
        return kb;
    }

    public void setKb(String kb) {
        this.kb = kb;
    }

    public String getKxe() {
        return kxe;
    }

    public void setKxe(String kxe) {
        this.kxe = kxe;
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public V8BuildLevel getBuildLevel() {
        return buildLevel;
    }

    public void setBuildLevel(V8BuildLevel buildLevel) {
        this.buildLevel = buildLevel;
    }

    public V8Maintenance getMaintenance() {
        return maintenance;
    }

    public void setMaintenance(V8Maintenance maintenance) {
        this.maintenance = maintenance;
    }

    public V8Minor getMinor() {
        return minor;
    }

    public void setMinor(V8Minor minor) {
        this.minor = minor;
    }

    public V8Release getRelease() {
        return release;
    }

    public void setRelease(V8Release release) {
        this.release = release;
    }

    public V8ServicePackName getServicePackName() {
        return servicePackName;
    }

    public void setServicePackName(V8ServicePackName servicePackName) {
        this.servicePackName = servicePackName;
    }

    public V8Version getVersion() {
        return version;
    }

    public void setVersion(V8Version version) {
        this.version = version;
    }

    @Override
    public String toString() {
        return "VersionInfo [kb=" + kb + ", kxe=" + kxe + ", schemaVersion=" + schemaVersion + ", metadata=" + metadata
                + ", buildLevel=" + buildLevel + ", maintenance=" + maintenance + ", minor=" + minor + ", release="
                + release + ", servicePackName=" + servicePackName + ", version=" + version + "]";
    }

}
