package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

/**
 * 虚拟IO服务器
 *
 * @author sxp
 * @since May 11, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "VirtualIOServer")
public class V8VirtualIOServer {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "AllowPerformanceDataCollection")
    private String allowPerformanceDataCollection;

    @XmlElement(name = "AssociatedPartitionProfile")
    private V8AssociatedPartitionProfile associatedPartitionProfile;

    @XmlElement(name = "AvailabilityPriority")
    private String availabilityPriority;

    @XmlElement(name = "CurrentAllocatedBarrierSynchronizationRegisterArrays")
    private String currentAllocatedBarrierSynchronizationRegisterArrays;

    @XmlElement(name = "CurrentProcessorCompatibilityMode")
    private String currentProcessorCompatibilityMode;

    @XmlElement(name = "CurrentProfileSync")
    private String currentProfileSync;

    @XmlElement(name = "IsCallHomeEnabled")
    private String isCallHomeEnabled;

    @XmlElement(name = "IsConnectionMonitoringEnabled")
    private String isConnectionMonitoringEnabled;

    @XmlElement(name = "IsOperationInProgress")
    private String isOperationInProgress;

    @XmlElement(name = "IsRedundantErrorPathReportingEnabled")
    private String isRedundantErrorPathReportingEnabled;

    @XmlElement(name = "IsTimeReferencePartition")
    private String isTimeReferencePartition;

    @XmlElement(name = "IsVirtualServiceAttentionLEDOn")
    private String isVirtualServiceAttentionLEDOn;

    @XmlElement(name = "KeylockPosition")
    private String keylockPosition;

    @XmlElement(name = "LogicalSerialNumber")
    private String logicalSerialNumber;

    @XmlElement(name = "OperatingSystemVersion")
    private String operatingSystemVersion;

    @XmlElement(name = "PartitionCapabilities")
    private V8PartitionCapabilities partitionCapabilities;

    @XmlElement(name = "PartitionID")
    private String partitionID;

    @XmlElement(name = "PartitionIOConfiguration")
    private V8PartitionIOConfiguration partitionIOConfiguration;

    @XmlElement(name = "PartitionMemoryConfiguration")
    private V8PartitionMemoryConfiguration partitionMemoryConfiguration;

    @XmlElement(name = "PartitionName")
    private String partitionName;

    @XmlElement(name = "PartitionProcessorConfiguration")
    private V8PartitionProcessorConfiguration partitionProcessorConfiguration;

    @XmlElement(name = "PartitionProfiles")
    private V8PartitionProfiles partitionProfiles;

    @XmlElement(name = "PartitionState")
    private String partitionState;

    @XmlElement(name = "PartitionType")
    private String partitionType;

    @XmlElement(name = "PartitionUUID")
    private String partitionUUID;

    @XmlElement(name = "PendingProcessorCompatibilityMode")
    private String pendingProcessorCompatibilityMode;

    @XmlElement(name = "ProcessorPool")
    private V8ProcessorPool processorPool;

    @XmlElement(name = "ProgressState")
    private String progressState;

    @XmlElement(name = "ResourceMonitoringControlState")
    private String resourceMonitoringControlState;

    @XmlElement(name = "ResourceMonitoringIPAddress")
    private String resourceMonitoringIPAddress;

    @XmlElement(name = "AssociatedManagedSystem")
    private V8AssociatedManagedSystem associatedManagedSystem;

    @XmlElement(name = "HostEthernetAdapterLogicalPorts")
    private V8HostEthernetAdapterLogicalPorts hostEthernetAdapterLogicalPorts;

    @XmlElement(name = "MACAddressPrefix")
    private String macAddressPrefix;

    @XmlElement(name = "IsServicePartition")
    private String isServicePartition;

    @XmlElement(name = "ReferenceCode")
    private String referenceCode;

    @XmlElement(name = "AssignAllResources")
    private V8AssignAllResources assignAllResources;

    @XmlElement(name = "PowerOnWithHypervisor")
    private V8PowerOnWithHypervisor powerOnWithHypervisor;

    @XmlElement(name = "APICapable")
    private String apiCapable;

    @XmlElement(name = "ManagerPassthroughCapable")
    private String managerPassthroughCapable;

    @XmlElement(name = "MediaRepositories")
    private V8MediaRepositories mediaRepositories;

    @XmlElement(name = "MoverServicePartition")
    private String moverServicePartition;

    @XmlElement(name = "PhysicalVolumes")
    private V8PhysicalVolumes physicalVolumes;

    @XmlElement(name = "SharedEthernetAdapters")
    private V8SharedEthernetAdapters sharedEthernetAdapters;

    @XmlElement(name = "StoragePools")
    private V8StoragePools storagePools;

    @XmlElement(name = "TrunkAdapters")
    private V8TrunkAdapters trunkAdapters;

    @XmlElement(name = "VirtualIOServerLicenseAccepted")
    private String virtualIoServerLicenseAccepted;

    @XmlElement(name = "VirtualFibreChannelMappings")
    private V8VirtualFibreChannelMappings virtualFibreChannelMappings;

    @XmlElement(name = "VirtualSCSIMappings")
    private V8VirtualSCSIMappings virtualSCSIMappings;

    @XmlElement(name = "FreeIOAdaptersForLinkAggregation")
    private V8FreeIOAdaptersForLinkAggregation freeIOAdaptersForLinkAggregation;

    @XmlElement(name = "FreeEthenetBackingDevicesForSEA")
    private V8FreeEthenetBackingDevicesForSEA freeEthenetBackingDevicesForSEA;


    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getAllowPerformanceDataCollection() {
        return allowPerformanceDataCollection;
    }

    public void setAllowPerformanceDataCollection(String allowPerformanceDataCollection) {
        this.allowPerformanceDataCollection = allowPerformanceDataCollection;
    }

    public V8AssociatedPartitionProfile getAssociatedPartitionProfile() {
        return associatedPartitionProfile;
    }

    public void setAssociatedPartitionProfile(V8AssociatedPartitionProfile associatedPartitionProfile) {
        this.associatedPartitionProfile = associatedPartitionProfile;
    }

    public String getAvailabilityPriority() {
        return availabilityPriority;
    }

    public void setAvailabilityPriority(String availabilityPriority) {
        this.availabilityPriority = availabilityPriority;
    }

    public String getCurrentAllocatedBarrierSynchronizationRegisterArrays() {
        return currentAllocatedBarrierSynchronizationRegisterArrays;
    }

    public void setCurrentAllocatedBarrierSynchronizationRegisterArrays(
            String currentAllocatedBarrierSynchronizationRegisterArrays) {
        this.currentAllocatedBarrierSynchronizationRegisterArrays = currentAllocatedBarrierSynchronizationRegisterArrays;
    }

    public String getCurrentProcessorCompatibilityMode() {
        return currentProcessorCompatibilityMode;
    }

    public void setCurrentProcessorCompatibilityMode(String currentProcessorCompatibilityMode) {
        this.currentProcessorCompatibilityMode = currentProcessorCompatibilityMode;
    }

    public String getCurrentProfileSync() {
        return currentProfileSync;
    }

    public void setCurrentProfileSync(String currentProfileSync) {
        this.currentProfileSync = currentProfileSync;
    }

    public String getIsCallHomeEnabled() {
        return isCallHomeEnabled;
    }

    public void setIsCallHomeEnabled(String isCallHomeEnabled) {
        this.isCallHomeEnabled = isCallHomeEnabled;
    }

    public String getIsConnectionMonitoringEnabled() {
        return isConnectionMonitoringEnabled;
    }

    public void setIsConnectionMonitoringEnabled(String isConnectionMonitoringEnabled) {
        this.isConnectionMonitoringEnabled = isConnectionMonitoringEnabled;
    }

    public String getIsOperationInProgress() {
        return isOperationInProgress;
    }

    public void setIsOperationInProgress(String isOperationInProgress) {
        this.isOperationInProgress = isOperationInProgress;
    }

    public String getIsRedundantErrorPathReportingEnabled() {
        return isRedundantErrorPathReportingEnabled;
    }

    public void setIsRedundantErrorPathReportingEnabled(String isRedundantErrorPathReportingEnabled) {
        this.isRedundantErrorPathReportingEnabled = isRedundantErrorPathReportingEnabled;
    }

    public String getIsTimeReferencePartition() {
        return isTimeReferencePartition;
    }

    public void setIsTimeReferencePartition(String isTimeReferencePartition) {
        this.isTimeReferencePartition = isTimeReferencePartition;
    }

    public String getIsVirtualServiceAttentionLEDOn() {
        return isVirtualServiceAttentionLEDOn;
    }

    public void setIsVirtualServiceAttentionLEDOn(String isVirtualServiceAttentionLEDOn) {
        this.isVirtualServiceAttentionLEDOn = isVirtualServiceAttentionLEDOn;
    }

    public String getKeylockPosition() {
        return keylockPosition;
    }

    public void setKeylockPosition(String keylockPosition) {
        this.keylockPosition = keylockPosition;
    }

    public String getLogicalSerialNumber() {
        return logicalSerialNumber;
    }

    public void setLogicalSerialNumber(String logicalSerialNumber) {
        this.logicalSerialNumber = logicalSerialNumber;
    }

    public String getOperatingSystemVersion() {
        return operatingSystemVersion;
    }

    public void setOperatingSystemVersion(String operatingSystemVersion) {
        this.operatingSystemVersion = operatingSystemVersion;
    }

    public V8PartitionCapabilities getPartitionCapabilities() {
        return partitionCapabilities;
    }

    public void setPartitionCapabilities(V8PartitionCapabilities partitionCapabilities) {
        this.partitionCapabilities = partitionCapabilities;
    }

    public String getPartitionID() {
        return partitionID;
    }

    public void setPartitionID(String partitionID) {
        this.partitionID = partitionID;
    }

    public V8PartitionIOConfiguration getPartitionIOConfiguration() {
        return partitionIOConfiguration;
    }

    public void setPartitionIOConfiguration(V8PartitionIOConfiguration partitionIOConfiguration) {
        this.partitionIOConfiguration = partitionIOConfiguration;
    }

    public V8PartitionMemoryConfiguration getPartitionMemoryConfiguration() {
        return partitionMemoryConfiguration;
    }

    public void setPartitionMemoryConfiguration(V8PartitionMemoryConfiguration partitionMemoryConfiguration) {
        this.partitionMemoryConfiguration = partitionMemoryConfiguration;
    }

    public String getPartitionName() {
        return partitionName;
    }

    public void setPartitionName(String partitionName) {
        this.partitionName = partitionName;
    }

    public V8PartitionProcessorConfiguration getPartitionProcessorConfiguration() {
        return partitionProcessorConfiguration;
    }

    public void setPartitionProcessorConfiguration(V8PartitionProcessorConfiguration partitionProcessorConfiguration) {
        this.partitionProcessorConfiguration = partitionProcessorConfiguration;
    }

    public V8PartitionProfiles getPartitionProfiles() {
        return partitionProfiles;
    }

    public void setPartitionProfiles(V8PartitionProfiles partitionProfiles) {
        this.partitionProfiles = partitionProfiles;
    }

    public String getPartitionState() {
        return partitionState;
    }

    public void setPartitionState(String partitionState) {
        this.partitionState = partitionState;
    }

    public String getPartitionType() {
        return partitionType;
    }

    public void setPartitionType(String partitionType) {
        this.partitionType = partitionType;
    }

    public String getPartitionUUID() {
        return partitionUUID;
    }

    public void setPartitionUUID(String partitionUUID) {
        this.partitionUUID = partitionUUID;
    }

    public String getPendingProcessorCompatibilityMode() {
        return pendingProcessorCompatibilityMode;
    }

    public void setPendingProcessorCompatibilityMode(String pendingProcessorCompatibilityMode) {
        this.pendingProcessorCompatibilityMode = pendingProcessorCompatibilityMode;
    }

    public V8ProcessorPool getProcessorPool() {
        return processorPool;
    }

    public void setProcessorPool(V8ProcessorPool processorPool) {
        this.processorPool = processorPool;
    }

    public String getProgressState() {
        return progressState;
    }

    public void setProgressState(String progressState) {
        this.progressState = progressState;
    }

    public String getResourceMonitoringControlState() {
        return resourceMonitoringControlState;
    }

    public void setResourceMonitoringControlState(String resourceMonitoringControlState) {
        this.resourceMonitoringControlState = resourceMonitoringControlState;
    }

    public String getResourceMonitoringIPAddress() {
        return resourceMonitoringIPAddress;
    }

    public void setResourceMonitoringIPAddress(String resourceMonitoringIPAddress) {
        this.resourceMonitoringIPAddress = resourceMonitoringIPAddress;
    }

    public V8AssociatedManagedSystem getAssociatedManagedSystem() {
        return associatedManagedSystem;
    }

    public void setAssociatedManagedSystem(V8AssociatedManagedSystem associatedManagedSystem) {
        this.associatedManagedSystem = associatedManagedSystem;
    }

    public V8HostEthernetAdapterLogicalPorts getHostEthernetAdapterLogicalPorts() {
        return hostEthernetAdapterLogicalPorts;
    }

    public void setHostEthernetAdapterLogicalPorts(V8HostEthernetAdapterLogicalPorts hostEthernetAdapterLogicalPorts) {
        this.hostEthernetAdapterLogicalPorts = hostEthernetAdapterLogicalPorts;
    }

    public String getMacAddressPrefix() {
        return macAddressPrefix;
    }

    public void setMacAddressPrefix(String macAddressPrefix) {
        this.macAddressPrefix = macAddressPrefix;
    }

    public String getIsServicePartition() {
        return isServicePartition;
    }

    public void setIsServicePartition(String isServicePartition) {
        this.isServicePartition = isServicePartition;
    }

    public String getReferenceCode() {
        return referenceCode;
    }

    public void setReferenceCode(String referenceCode) {
        this.referenceCode = referenceCode;
    }

    public V8PowerOnWithHypervisor getPowerOnWithHypervisor() {
        return powerOnWithHypervisor;
    }

    public void setPowerOnWithHypervisor(V8PowerOnWithHypervisor powerOnWithHypervisor) {
        this.powerOnWithHypervisor = powerOnWithHypervisor;
    }

    public String getApiCapable() {
        return apiCapable;
    }

    public void setApiCapable(String apiCapable) {
        this.apiCapable = apiCapable;
    }

    public String getManagerPassthroughCapable() {
        return managerPassthroughCapable;
    }

    public void setManagerPassthroughCapable(String managerPassthroughCapable) {
        this.managerPassthroughCapable = managerPassthroughCapable;
    }

    public V8MediaRepositories getMediaRepositories() {
        return mediaRepositories;
    }

    public void setMediaRepositories(V8MediaRepositories mediaRepositories) {
        this.mediaRepositories = mediaRepositories;
    }

    public String getMoverServicePartition() {
        return moverServicePartition;
    }

    public void setMoverServicePartition(String moverServicePartition) {
        this.moverServicePartition = moverServicePartition;
    }

    public V8PhysicalVolumes getPhysicalVolumes() {
        return physicalVolumes;
    }

    public void setPhysicalVolumes(V8PhysicalVolumes physicalVolumes) {
        this.physicalVolumes = physicalVolumes;
    }

    public V8SharedEthernetAdapters getSharedEthernetAdapters() {
        return sharedEthernetAdapters;
    }

    public void setSharedEthernetAdapters(V8SharedEthernetAdapters sharedEthernetAdapters) {
        this.sharedEthernetAdapters = sharedEthernetAdapters;
    }

    public V8StoragePools getStoragePools() {
        return storagePools;
    }

    public void setStoragePools(V8StoragePools storagePools) {
        this.storagePools = storagePools;
    }

    public V8TrunkAdapters getTrunkAdapters() {
        return trunkAdapters;
    }

    public void setTrunkAdapters(V8TrunkAdapters trunkAdapters) {
        this.trunkAdapters = trunkAdapters;
    }

    public String getVirtualIoServerLicenseAccepted() {
        return virtualIoServerLicenseAccepted;
    }

    public void setVirtualIoServerLicenseAccepted(String virtualIoServerLicenseAccepted) {
        this.virtualIoServerLicenseAccepted = virtualIoServerLicenseAccepted;
    }

    public V8VirtualFibreChannelMappings getVirtualFibreChannelMappings() {
        return virtualFibreChannelMappings;
    }

    public void setVirtualFibreChannelMappings(V8VirtualFibreChannelMappings virtualFibreChannelMappings) {
        this.virtualFibreChannelMappings = virtualFibreChannelMappings;
    }

    public V8VirtualSCSIMappings getVirtualSCSIMappings() {
        return virtualSCSIMappings;
    }

    public void setVirtualSCSIMappings(V8VirtualSCSIMappings virtualSCSIMappings) {
        this.virtualSCSIMappings = virtualSCSIMappings;
    }

    public V8FreeIOAdaptersForLinkAggregation getFreeIOAdaptersForLinkAggregation() {
        return freeIOAdaptersForLinkAggregation;
    }

    public void setFreeIOAdaptersForLinkAggregation(V8FreeIOAdaptersForLinkAggregation freeIOAdaptersForLinkAggregation) {
        this.freeIOAdaptersForLinkAggregation = freeIOAdaptersForLinkAggregation;
    }

    public V8FreeEthenetBackingDevicesForSEA getFreeEthenetBackingDevicesForSEA() {
        return freeEthenetBackingDevicesForSEA;
    }

    public void setFreeEthenetBackingDevicesForSEA(V8FreeEthenetBackingDevicesForSEA freeEthenetBackingDevicesForSEA) {
        this.freeEthenetBackingDevicesForSEA = freeEthenetBackingDevicesForSEA;
    }


    public V8AssignAllResources getAssignAllResources() {
        return assignAllResources;
    }

    public void setAssignAllResources(V8AssignAllResources assignAllResources) {
        this.assignAllResources = assignAllResources;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this, true);
    }

}
