package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

/**
 * 虚拟网络
 *
 * @author sxp
 * @since Jun 25, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "VirtualNetwork")
public class V8VirtualNetwork {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "AssociatedSwitch")
    private V8AssociatedSwitch associatedSwitch;

    @XmlElement(name = "NetworkName")
    private String networkName;

    @XmlElement(name = "NetworkVLANID")
    private String networkVlanId;

    @XmlElement(name = "VswitchID")
    private String vswitchId;

    @XmlElement(name = "TaggedNetwork")
    private String taggedNetwork;

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public V8AssociatedSwitch getAssociatedSwitch() {
        return associatedSwitch;
    }

    public void setAssociatedSwitch(V8AssociatedSwitch associatedSwitch) {
        this.associatedSwitch = associatedSwitch;
    }

    public String getNetworkName() {
        return networkName;
    }

    public void setNetworkName(String networkName) {
        this.networkName = networkName;
    }

    public String getNetworkVlanId() {
        return networkVlanId;
    }

    public void setNetworkVlanId(String networkVlanId) {
        this.networkVlanId = networkVlanId;
    }

    public String getVswitchId() {
        return vswitchId;
    }

    public void setVswitchId(String vswitchId) {
        this.vswitchId = vswitchId;
    }

    public String getTaggedNetwork() {
        return taggedNetwork;
    }

    public void setTaggedNetwork(String taggedNetwork) {
        this.taggedNetwork = taggedNetwork;
    }

}
