package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

/**
 * 虚拟SCSI客户端适配器
 *
 * @author sxp
 * @since Jun 27, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "VirtualSCSIClientAdapter")
public class V8VirtualSCSIClientAdapter {
    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "AdapterType")
    private String adapterType;

    @XmlElement(name = "DynamicReconfigurationConnectorName")
    private String dynamicReconfigurationConnectorName;

    @XmlElement(name = "LocationCode")
    private String locationCode;

    @XmlElement(name = "LocalPartitionID")
    private String localPartitionID;

    @XmlElement(name = "RequiredAdapter")
    private String requiredAdapter;

    @XmlElement(name = "VariedOn")
    private String variedOn;

    @XmlElement(name = "VirtualSlotNumber")
    private String virtualSlotNumber;

    @XmlElement(name = "RemoteLogicalPartitionID")
    private String remoteLogicalPartitionID;

    @XmlElement(name = "RemoteSlotNumber")
    private String remoteSlotNumber;

    @XmlElement(name = "ServerLocationCode")
    private String serverLocationCode;

    @XmlElement(name = "ServerAdapter")
    private V8ServerAdapter serverAdapter;

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public String getAdapterType() {
        return adapterType;
    }

    public void setAdapterType(String adapterType) {
        this.adapterType = adapterType;
    }

    public String getDynamicReconfigurationConnectorName() {
        return dynamicReconfigurationConnectorName;
    }

    public void setDynamicReconfigurationConnectorName(String dynamicReconfigurationConnectorName) {
        this.dynamicReconfigurationConnectorName = dynamicReconfigurationConnectorName;
    }

    public String getLocationCode() {
        return locationCode;
    }

    public void setLocationCode(String locationCode) {
        this.locationCode = locationCode;
    }

    public String getLocalPartitionID() {
        return localPartitionID;
    }

    public void setLocalPartitionID(String localPartitionID) {
        this.localPartitionID = localPartitionID;
    }

    public String getRequiredAdapter() {
        return requiredAdapter;
    }

    public void setRequiredAdapter(String requiredAdapter) {
        this.requiredAdapter = requiredAdapter;
    }

    public String getVariedOn() {
        return variedOn;
    }

    public void setVariedOn(String variedOn) {
        this.variedOn = variedOn;
    }

    public String getVirtualSlotNumber() {
        return virtualSlotNumber;
    }

    public void setVirtualSlotNumber(String virtualSlotNumber) {
        this.virtualSlotNumber = virtualSlotNumber;
    }

    public String getRemoteLogicalPartitionID() {
        return remoteLogicalPartitionID;
    }

    public void setRemoteLogicalPartitionID(String remoteLogicalPartitionID) {
        this.remoteLogicalPartitionID = remoteLogicalPartitionID;
    }

    public String getRemoteSlotNumber() {
        return remoteSlotNumber;
    }

    public void setRemoteSlotNumber(String remoteSlotNumber) {
        this.remoteSlotNumber = remoteSlotNumber;
    }

    public String getServerLocationCode() {
        return serverLocationCode;
    }

    public void setServerLocationCode(String serverLocationCode) {
        this.serverLocationCode = serverLocationCode;
    }

    public V8ServerAdapter getServerAdapter() {
        return serverAdapter;
    }

    public void setServerAdapter(V8ServerAdapter serverAdapter) {
        this.serverAdapter = serverAdapter;
    }

}
