package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Atom;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "VirtualSCSIMapping")
public class V8VirtualSCSIMapping {
    @XmlAttribute(name = "schemaVersion")
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "AssociatedLogicalPartition")
    private V8Link associatedLogicalPartition;

    @XmlElement(name = "ClientAdapter")
    private V8ClientAdapter clientAdapter;

    @XmlElement(name = "ServerAdapter")
    private V8ServerAdapter serverAdapter;

    @XmlElement(name = "Storage")
    private V8Storage storage;

    @XmlElement(name = "TargetDevice")
    private V8TargetDevice targetDevice;

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public V8Link getAssociatedLogicalPartition() {
        return associatedLogicalPartition;
    }

    public void setAssociatedLogicalPartition(V8Link associatedLogicalPartition) {
        this.associatedLogicalPartition = associatedLogicalPartition;
    }

    public V8ClientAdapter getClientAdapter() {
        return clientAdapter;
    }

    public void setClientAdapter(V8ClientAdapter clientAdapter) {
        this.clientAdapter = clientAdapter;
    }

    public V8ServerAdapter getServerAdapter() {
        return serverAdapter;
    }

    public void setServerAdapter(V8ServerAdapter serverAdapter) {
        this.serverAdapter = serverAdapter;
    }

    public V8Storage getStorage() {
        return storage;
    }

    public void setStorage(V8Storage storage) {
        this.storage = storage;
    }

    public V8TargetDevice getTargetDevice() {
        return targetDevice;
    }

    public void setTargetDevice(V8TargetDevice targetDevice) {
        this.targetDevice = targetDevice;
    }

    public V8VirtualSCSIMapping() {
    }

    public V8VirtualSCSIMapping(V8ServerAdapter serverAdapter, V8Storage storage, V8TargetDevice targetDevice) {
        super();
        this.metadata = new V8Metadata(new V8Atom());
        this.serverAdapter = serverAdapter;
        this.storage = storage;
        this.targetDevice = targetDevice;
    }

    public V8VirtualSCSIMapping(V8ServerAdapter serverAdapter, V8Storage storage) {
        super();
        this.metadata = new V8Metadata(new V8Atom());
        this.serverAdapter = serverAdapter;
        this.storage = storage;
    }

    public V8VirtualSCSIMapping(V8ClientAdapter clientAdapter, V8ServerAdapter serverAdapter, V8Storage storage,
                                V8TargetDevice targetDevice) {
        super();
        this.metadata = new V8Metadata(new V8Atom());
        this.clientAdapter = clientAdapter;
        this.serverAdapter = serverAdapter;
        this.storage = storage;
        this.targetDevice = targetDevice;
    }

    public V8VirtualSCSIMapping(V8ClientAdapter clientAdapter, V8ServerAdapter serverAdapter, V8Storage storage) {
        super();
        this.metadata = new V8Metadata(new V8Atom());
        this.clientAdapter = clientAdapter;
        this.serverAdapter = serverAdapter;
        this.storage = storage;
    }

    public V8VirtualSCSIMapping(V8Storage storage, V8TargetDevice targetDevice) {
        super();
        this.metadata = new V8Metadata(new V8Atom());
        this.storage = storage;
        this.targetDevice = targetDevice;
    }

    @Override
    public String toString() {
        return JSON.toJSONString(this);
    }

}
