package com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.common.V8Metadata;

import javax.xml.bind.annotation.*;

/**
 * WEB对象模型版本
 *
 * @author sxp
 * @since May 4, 2018
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlRootElement(name = "WebObjectModelVersion")
public class V8WebObjectModelVersion {
    @XmlAttribute
    private String kxe;

    @XmlAttribute
    private String kb;

    @XmlAttribute
    private String schemaVersion = HmcSdkConstant.SCHEMA_VERSION_V120;

    @XmlElement(name = "Metadata")
    private V8Metadata metadata;

    @XmlElement(name = "MinorVersion")
    private V8MinorVersion minorVersion;

    @XmlElement(name = "SchemaNamespace")
    private V8SchemaNamespace schemaNamespace;

    public V8WebObjectModelVersion() {
    }

    public String getKxe() {
        return kxe;
    }

    public void setKxe(String kxe) {
        this.kxe = kxe;
    }

    public String getKb() {
        return kb;
    }

    public void setKb(String kb) {
        this.kb = kb;
    }

    public String getSchemaVersion() {
        return schemaVersion;
    }

    public void setSchemaVersion(String schemaVersion) {
        this.schemaVersion = schemaVersion;
    }

    public V8Metadata getMetadata() {
        return metadata;
    }

    public void setMetadata(V8Metadata metadata) {
        this.metadata = metadata;
    }

    public V8MinorVersion getMinorVersion() {
        return minorVersion;
    }

    public void setMinorVersion(V8MinorVersion minorVersion) {
        this.minorVersion = minorVersion;
    }

    public V8SchemaNamespace getSchemaNamespace() {
        return schemaNamespace;
    }

    public void setSchemaNamespace(V8SchemaNamespace schemaNamespace) {
        this.schemaNamespace = schemaNamespace;
    }

    @Override
    public String toString() {
        return "WebObjectModelVersion [kxe=" + kxe + ", kb=" + kb + ", schemaVersion=" + schemaVersion + ", metadata="
                + metadata + ", minorVersion=" + minorVersion + ", schemaNamespace=" + schemaNamespace + "]";
    }

}
