package com.bocloud.cmp.provider.hmc.sdk.util;

import com.bocloud.cmp.provider.hmc.sdk.model.HmcSdkConstant;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.nio.charset.Charset;

/**
 * 资源文件工具类
 *
 * @author sxp
 * @since 2018/6/7
 */
public class ResourceUtils {
    private static final Logger logger = LoggerFactory.getLogger(ResourceUtils.class);

    /**
     * 读取资源文件的内容至一个列表
     *
     * @author sxp
     * @since 2018/6/7
     */
    public static String readContent(String resourcePath, Charset charset) {
        StringBuilder stringBuilder = new StringBuilder();
        try (InputStream inputStream = ResourceUtils.class.getClassLoader().getResourceAsStream(resourcePath);
             BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream, charset))
        ) {
            String line;
            while ((line = bufferedReader.readLine()) != null) {
                stringBuilder.append(line).append(HmcSdkConstant.NEW_LINE);
            }
        } catch (IOException e) {
            logger.error(e.getMessage(), e);
        }
        return stringBuilder.toString();
    }
}
