package com.bocloud.cmp.provider.hmc.v7;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.HmcAccessableProvider;
import com.bocloud.cmp.provider.hmc.CommonProvider;
import com.bocloud.cmp.provider.hmc.sdk.api.v7.V7JobService;
import com.bocloud.common.model.BocloudResult;

/**
 * HMC通用Provider
 * 
 * @author sxp
 * @since Nov 20, 2018
 */
public class HmcCommonProvider extends HmcAccessableProvider implements CommonProvider {

    public HmcCommonProvider(Butler butler) {
        super(butler);
    }
    
    /**
     * 获取任务执行状态
     * 
     * @author sxp
     * @since Nov 20, 2018
     */
    @Override
    public BocloudResult getJobStatus(String jobId) {
        return V7JobService.getJobStatus(this.getAuth(), jobId, V7JobService.DEFAULT_TIMEOUT_SECONDS);
    }
    
    /**
     * 获取任务执行状态-带超时时间
     * 
     * @author sxp
     * @since Nov 20, 2018
     */
    @Override
    public BocloudResult getJobStatus(String jobId, long timeout){
        return V7JobService.getJobStatus(this.getAuth(), jobId, timeout);
    }

}
