package com.bocloud.cmp.provider.hmc.v7;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.hmc.sdk.module.VirtualNetworkBridgeResponse;
import com.bocloud.cmp.provider.HmcAccessableProvider;
import com.bocloud.cmp.provider.hmc.NetworkBridgeProvider;
import com.bocloud.cmp.provider.hmc.sdk.api.v7.V7VirtualNetworkBridgeService;
import com.bocloud.cmp.provider.hmc.sdk.model.v7.sdk.module.V7VirtualNetworkBridgeResponse;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class HmcNetworkBridgeProvider extends HmcAccessableProvider implements NetworkBridgeProvider {

    private static Logger logger = LoggerFactory.getLogger(HmcNetworkBridgeProvider.class);

    public HmcNetworkBridgeProvider(Butler bulter) {
        super(bulter);
    }

    @Override
    public BocloudResult getNetworkBridge(String ManagedSystemUuid) {
        BocloudResult result = V7VirtualNetworkBridgeService.get(getAuth(), ManagedSystemUuid);
        if (result.isFailed()) {
            return result;
        }
        V7VirtualNetworkBridgeResponse responseV7 = (V7VirtualNetworkBridgeResponse) result.getData();
        VirtualNetworkBridgeResponse response = JSON.parseObject(JSON.toJSONString(responseV7), VirtualNetworkBridgeResponse.class);
        return new BocloudResult(true, response, "执行成功");
    }
}
