package com.bocloud.cmp.provider.hmc.v8;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.hmc.sdk.module.VirtualNetworkBridgeResponse;
import com.bocloud.cmp.provider.HmcAccessableProvider;
import com.bocloud.cmp.provider.hmc.NetworkBridgeProvider;
import com.bocloud.cmp.provider.hmc.sdk.api.v8.V8VirtualNetworkBridgeService;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module.V8VirtualNetworkBridgeResponse;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class HmcNetworkBridgeProvider extends HmcAccessableProvider implements NetworkBridgeProvider {

    private static Logger logger = LoggerFactory.getLogger(HmcNetworkBridgeProvider.class);

    public HmcNetworkBridgeProvider(Butler bulter) {
        super(bulter);
    }

    @Override
    public BocloudResult getNetworkBridge(String ManagedSystemUuid) {
        BocloudResult result = V8VirtualNetworkBridgeService.get(getAuth(), ManagedSystemUuid);
        if (result.isFailed()) {
            return result;
        }
        V8VirtualNetworkBridgeResponse responseV8 = (V8VirtualNetworkBridgeResponse) result.getData();
        VirtualNetworkBridgeResponse response = JSON.parseObject(JSON.toJSONString(responseV8), VirtualNetworkBridgeResponse.class);
        return new BocloudResult(true, response, "执行成功");
    }
}
