package com.bocloud.sdk.hmc;

import com.alibaba.fastjson.JSONObject;
import com.emc.storageos.model.host.HostRestRep;
import com.emc.storageos.model.project.ProjectRestRep;
import com.emc.vipr.client.ClientConfig;
import com.emc.vipr.client.ViPRCoreClient;
import com.emc.vipr.client.core.filters.HostTypeFilter;
import org.junit.Test;

import java.util.List;

/**
 * vipr的java客户端代码的测试类
 * 
 * 使用参考: https://community.emc.com/docs/DOC-33847
 * 
 * Release Note: https://community.emc.com/docs/DOC-33848
 * 
 * github: https://github.com/emcvipr/controller-client-java
 * 
 * others: https://community.emc.com/community/products/vipr#developer
 * 
 * @author lkx007
 *
 */
public class ViprTest {

    @Test
    public void usage() {
        ViPRCoreClient client = new ViPRCoreClient(new ClientConfig().withHost("192.168.2.40")
                .withIgnoringCertificates(true).withMediaType("application/json")).withLogin("root", "Boyun@v587");
        List<ProjectRestRep> projects = client.projects().getByUserTenant();
        JSONObject.toJSONString(projects);
        List<HostRestRep> hosts = client.hosts().getByUserTenant(HostTypeFilter.ESX.not());
        JSONObject.toJSONString(hosts, true);
    }
}
