package com.bocloud.sdk.hmc.api;

import com.bocloud.cmp.provider.hmc.sdk.api.v8.V8ManagementConsoleService;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.sdk.hmc.api.base.BaseTest;
import org.junit.Assert;
import org.junit.Test;

/**
 * Test for ManagementConsoleService
 * 
 * @author sxp
 * @since May 4, 2018
 */
public class V8ManagementConsoleServiceTest extends BaseTest {
	@Test
	public void get() {
		BocloudResult result = V8ManagementConsoleService.get(auth);
		Assert.assertTrue(result.getMessage(), result.isSuccess());
		System.out.println(result.getData());
	}

	@Test
	public void getByUuid() {
		BocloudResult result = V8ManagementConsoleService.getByUuid(auth, "8bd4c92f-ac79-3880-a982-be8f27687d98");
		Assert.assertTrue(result.getMessage(), result.isSuccess());
		System.out.println(result.getData());
	}

	//@Test
	public void removeManagedSystemConnection() {
		String managedSystemUuid = "25cc2a4e-b946-3b98-acaa-cdf90628809a";
		BocloudResult result = V8ManagementConsoleService.removeManagedSystemConnection(auth,
				"8bd4c92f-ac79-3880-a982-be8f27687d98", managedSystemUuid);
		Assert.assertTrue(result.getMessage(), result.isSuccess());
		System.out.println(result.getData());
	}

	//@Test
	public void addManagedSystem() {
		String hostIp = "192.168.1.29";
		String psd = "admin";
		BocloudResult result = V8ManagementConsoleService.addManagedSystem(auth, "8bd4c92f-ac79-3880-a982-be8f27687d98",
				hostIp, psd);
		Assert.assertTrue(result.getMessage(), result.isSuccess());
		System.out.println(result.getData());
	}
}
