package com.bocloud.sdk.hmc.api;

import com.bocloud.cmp.model.hmc.sdk.module.VirtualSwitchEntry;
import com.bocloud.cmp.model.hmc.sdk.module.VirtualSwitchResponse;
import com.bocloud.cmp.provider.hmc.sdk.api.v8.V8VirtualSwitchService;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module.V8VirtualSwitch;
import com.bocloud.cmp.provider.hmc.sdk.model.v8.sdk.module.V8VirtualSwitchForUpdate;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.sdk.hmc.api.base.BaseTest;
import org.junit.Assert;
import org.junit.Test;

public class V8VirtualSwitchServiceTest extends BaseTest {
	private static String virtualSwitchUuid;

	@Test
	public void testGet() {
		BocloudResult result = V8VirtualSwitchService.get(auth, "25cc2a4e-b946-3b98-acaa-cdf90628809a");
		Assert.assertTrue(result.getMessage(), result.isSuccess());
		VirtualSwitchResponse response = (VirtualSwitchResponse) result.getData();
		System.out.println(response);
		System.out.println(response.getEntries().get(0).getContent().getVirtualSwitch().getSwitchName());
		System.out.println(response.getEntries().get(0).getContent().getVirtualSwitch().getSwitchId());
	}

	@Test
	public void testGetByUuid() {
		BocloudResult result = V8VirtualSwitchService.getByUuid(auth, "25cc2a4e-b946-3b98-acaa-cdf90628809a",
				"533ebdb1-fe29-33d0-b22c-e11cc31aa42e");
		Assert.assertTrue(result.getMessage(), result.isSuccess());
		System.out.println(result.getData());
	}

	@Test
	public void testCreate() {
		V8VirtualSwitch virtualSwitch = new V8VirtualSwitch();
		virtualSwitch.setSwitchName("switch_test");

		BocloudResult result = V8VirtualSwitchService.create(auth, "25cc2a4e-b946-3b98-acaa-cdf90628809a", virtualSwitch);
		Assert.assertTrue(result.getMessage(), result.isSuccess());

		VirtualSwitchEntry entry = (VirtualSwitchEntry) result.getData();
		Assert.assertTrue(entry != null);
		virtualSwitchUuid = entry.getId();

		System.out.println(entry);
	}

	@Test
	public void testUpdate() {
		if (virtualSwitchUuid == null) {
			testCreate();
		}
		V8VirtualSwitchForUpdate updateSwitch = new V8VirtualSwitchForUpdate();
		updateSwitch.setSwitchName("new_switch");

		BocloudResult result = V8VirtualSwitchService.update(auth, "25cc2a4e-b946-3b98-acaa-cdf90628809a",
				virtualSwitchUuid, updateSwitch);
		Assert.assertTrue(result.getMessage(), result.isSuccess());
		System.out.println(result.getData());
	}

	@Test
	public void testDelete() {
		if (virtualSwitchUuid == null) {
			testCreate();
		}
		BocloudResult result = V8VirtualSwitchService.delete(auth, "25cc2a4e-b946-3b98-acaa-cdf90628809a",
				virtualSwitchUuid);
		Assert.assertTrue(result.getMessage(), result.isSuccess());
		virtualSwitchUuid = null;
	}
}
