package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.VmwareHorizonProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

/**
 * horizon认证操作类
 * 
 * @author wangyu
 * @version 1.0
 * @since 2020年2月26日
 *
 */
@Provider("bocloud.cmp.horizon")
public class VmwareHorizonAuthProvider extends VmwareHorizonProvider implements AuthProvider {

	public VmwareHorizonAuthProvider(Butler butler) {
		super(butler);
	}

	@Override
	public BocloudResult auth() {
		if (this.accessable()) {
			return new BocloudResult(true, "连接成功");
		}
		return new BocloudResult(false, "连接失败：地址、用户名或密码输入错误");
	}

}
