package com.bocloud.cmp.provider.utils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.alibaba.fastjson.JSONObject;

/**
 * json工具类
 * 
 * @author HP
 *
 */
public class JsonUtils {

	private static Pattern humpPattern = Pattern.compile("[A-Z]");
	private static Pattern linePattern = Pattern.compile("_(\\w)");

	/**
	 * 下划线转驼峰
	 * 
	 * @param str
	 * @return
	 */
	public static String lineToHump(String json) {
		json = json.toLowerCase();
		Matcher matcher = linePattern.matcher(json);
		StringBuffer sb = new StringBuffer();
		while (matcher.find()) {
			matcher.appendReplacement(sb, matcher.group(1).toUpperCase());
		}
		matcher.appendTail(sb);
		return sb.toString();
	}

	/**
	 * 驼峰转下划线
	 * 
	 * @param str
	 * @return
	 */
	public static String humpToLine(String json) {
		Matcher matcher = humpPattern.matcher(json);
		StringBuffer sb = new StringBuffer();
		while (matcher.find()) {
			matcher.appendReplacement(sb, "_" + matcher.group(0).toLowerCase());
		}
		matcher.appendTail(sb);
		return sb.toString();
	}

	public static void main(String[] args) {
		String str = "{\"id\":\"4cec406d-c708-4f61-b3cd-44b936487abe\",\"name\":\"farm_auto\",\"display_name\":\"farm_auto\",\"description\":\"farm_auto\",\"enabled\":true,\"type\":\"AUTOMATED\",\"source\":\"INSTANT_CLONE\",\"settings\":{\"delete_in_progess\":false,\"server_error_threshold\":0,\"session_settings\":{\"disconnected_session_timeout_policy\":\"NEVER\",\"empty_session_timeout_policy\":\"AFTER\",\"empty_session_timeout_minutes\":1,\"logoff_after_timeout\":false,\"pre_launch_session_timeout_policy\":\"AFTER\",\"pre_launch_session_timeout_minutes\":10},\"load_balancer_settings\":{\"custom_script_in_use\":false,\"lb_metric_settings\":{\"include_session_count\":true,\"cpu_threshold\":0,\"memory_threshold\":0,\"disk_queue_length_threshold\":0,\"disk_read_latency_threshold\":0,\"disk_write_latency_threshold\":0}},\"display_protocol_settings\":{\"default_display_protocol\":\"PCOIP\",\"allow_display_protocol_override\":true,\"html_access_enabled\":true,\"session_collaboration_enabled\":false,\"grid_vgpus_enabled\":false}}}"
				+ "";
		str = lineToHump(str);
//		System.out.println(str);
		JSONObject object = JSONObject.parseObject(str);
		object.keySet().forEach(key -> System.out.println(key + "\t"));
//		object.keySet().forEach(key -> {
//			System.out.println("@Column(\"" + key + "\")\t");
//		});
	}
}