package com.bocloud.cmp.huaweiconvertor;

import java.util.ArrayList;
import java.util.List;
import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.model.BackupPolicyModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.cbr.v1.model.Policy;

/**
 * 
 * @ClassName: BackupPolicyConvertor.java
 * @Description: 备份策略转换
 *
 * @author: ymh
 * @date: 2021年3月19日 上午10:59:25
 */
public class BackupPolicyConvertor implements BeanConvertor<BackupPolicyModel, Policy> {

	@Override
	public List<BackupPolicyModel> convertList(List<? extends Policy> objects) {
		List<BackupPolicyModel> backupPolicyModels = new ArrayList<>();
		for (Policy object : objects) {
			backupPolicyModels.add(convertModel(object));
		}
		return backupPolicyModels;
	}

	@Override
	public BackupPolicyModel convertModel(Policy info) {
		BackupPolicyModel backupPolicyModel = new BackupPolicyModel();
		if (null != info) {
			backupPolicyModel.setBackupPolicyUuid(info.getId());
			backupPolicyModel.setName(info.getName());
			backupPolicyModel.setEnabled(info.getEnabled());
			backupPolicyModel.setOperationType(info.getOperationType().getValue());
			backupPolicyModel.setOperationDefinition(JSON.toJSONString(info.getOperationDefinition()));
			backupPolicyModel.setTrigger(JSON.toJSONString(info.getTrigger().getProperties()));
			backupPolicyModel.setAssociatedVaults(JSON.toJSONString(info.getAssociatedVaults()));
		}
		return backupPolicyModel;
	}

}
