package com.bocloud.cmp.huaweiconvertor;

import com.bocloud.cmp.model.FloatingIpModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.eip.v2.model.FloatingIpResp;

import java.util.ArrayList;
import java.util.List;

public class FloatingIpConvertor implements BeanConvertor<FloatingIpModel, FloatingIpResp> {

    @Override
    public List<FloatingIpModel> convertList(List<? extends FloatingIpResp> objects) {
        List<FloatingIpModel> regionModels = new ArrayList<FloatingIpModel>();
        for (FloatingIpResp object : objects) {
            regionModels.add(convertModel(object));
        }
        return regionModels;
    }

    @Override
    public FloatingIpModel convertModel(FloatingIpResp info) {
        FloatingIpModel floatingIpModel = new FloatingIpModel();
        if (null != info) {
            floatingIpModel.setFloatingNetworkUuid(info.getFloatingNetworkId());
            floatingIpModel.setFixedIpAddress(info.getFixedIpAddress());
            floatingIpModel.setFloatingIpAddress(info.getFloatingIpAddress());
            floatingIpModel.setPortUuid(info.getPortId());
            floatingIpModel.setFloatingIpUuid(info.getId());
        }
        return floatingIpModel;
    }
}
