package com.bocloud.cmp.huaweiconvertor;

import com.bocloud.cmp.model.KeypairModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.ecs.v2.model.NovaKeypair;
import com.huaweicloud.sdk.ecs.v2.model.NovaKeypairDetail;
import com.huaweicloud.sdk.ecs.v2.model.NovaListKeypairsResult;

import java.util.ArrayList;
import java.util.List;

/**
 * 华为私有云密钥数据转换器
 *
 * @author wangyu
 * @version 3.0.0-SNAPSHOT
 * @since 2018/9/21
 */

public class KeypairConvertor implements BeanConvertor<KeypairModel, NovaListKeypairsResult> {

    @Override
    public List<KeypairModel> convertList(List<? extends NovaListKeypairsResult> objects) {
        List<KeypairModel> keypairModels = new ArrayList<KeypairModel>();
        for (NovaListKeypairsResult object : objects) {
            keypairModels.add(convertModel(object));
        }
        return keypairModels;
    }

    @Override
    public KeypairModel convertModel(NovaListKeypairsResult key) {
        KeypairModel model = new KeypairModel();
        model.setFingerprint(key.getKeypair().getFingerprint());
        model.setName(key.getKeypair().getName());
        model.setPublicKey(key.getKeypair().getPublicKey());
        return model;
    }

    public KeypairModel convertModelDetail(NovaKeypairDetail key) {
        KeypairModel model = new KeypairModel();
        model.setFingerprint(key.getFingerprint());
        model.setName(key.getName());
        model.setPublicKey(key.getPublicKey());
        return model;
    }

    public KeypairModel convertModelPair(NovaKeypair key) {
        KeypairModel model = new KeypairModel();
        model.setFingerprint(key.getFingerprint());
        model.setName(key.getName());
        model.setPublicKey(key.getPublicKey());
        model.setPrivateKey(key.getPrivateKey());
        return model;
    }

}
