package com.bocloud.cmp.huaweiconvertor;

import com.bocloud.cmp.model.HealthMonitorModel;
import com.bocloud.cmp.model.LbListenerModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.elb.v2.model.HealthmonitorResp;
import com.huaweicloud.sdk.elb.v2.model.ListenerResp;
import com.huaweicloud.sdk.elb.v2.model.ResourceList;
import org.apache.commons.collections.CollectionUtils;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;


public class LbHealthMonitorConvertor implements BeanConvertor<HealthMonitorModel, HealthmonitorResp> {

    @Override
    public List<HealthMonitorModel> convertList(List<? extends HealthmonitorResp> objects) {
        List<HealthMonitorModel> volumeModels = new ArrayList<>();
        for (HealthmonitorResp object : objects) {
            volumeModels.add(convertModel(object));
        }
        return volumeModels;
    }

    @Override
    public HealthMonitorModel convertModel(HealthmonitorResp info) {
        HealthMonitorModel model = new HealthMonitorModel();
        if (null != info) {

            model.setName(info.getName());
            model.setHealthUuid(info.getId());
            model.setType(info.getType().getValue());
            model.setTimeout(info.getTimeout());
            model.setDelay(info.getDelay());
            model.setAdminStateUp(info.getAdminStateUp());
            model.setMaxRetries(info.getMaxRetries());
            model.setHttpMethod(info.getHttpMethod());
            model.setUrlPath(info.getUrlPath());
            model.setExpectedCodes(info.getExpectedCodes());
            model.setDomainName(info.getDomainName());
            model.setMonitorPort(info.getMonitorPort());
            List<ResourceList> pools = info.getPools();

            if(CollectionUtils.isNotEmpty(pools)){

                model.setPoolUuid(pools.get(0).getId());
                /*
                List<String> poolList = new ArrayList<>();
                for(ResourceList resource:pools){
                    poolList.add(resource.getId());
                }

                model.setPools(poolList);*/
            }

        }
        return model;
    }

}
