package com.bocloud.cmp.huaweiconvertor;

import com.bocloud.cmp.model.LbListenerPolicyModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.elb.v2.model.L7policyResp;
import com.huaweicloud.sdk.elb.v2.model.ResourceList;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.collections.CollectionUtils;

public class LbL7policyConvertor implements BeanConvertor<LbListenerPolicyModel, L7policyResp> {

	@Override
	public List<LbListenerPolicyModel> convertList(List<? extends L7policyResp> objects) {
		List<LbListenerPolicyModel> volumeModels = new ArrayList<>();
		for (L7policyResp object : objects) {
			volumeModels.add(convertModel(object));
		}
		return volumeModels;
	}

	@Override
	public LbListenerPolicyModel convertModel(L7policyResp info) {
		LbListenerPolicyModel model = new LbListenerPolicyModel();
		if (null != info) {
			model.setPolicyUuid(info.getId());
			model.setName(info.getName());
			model.setRemark(info.getDescription());
			model.setAction(info.getAction().getValue());
			model.setAdminStateUp(info.getAdminStateUp());
			model.setTenantUuid(info.getTenantId());
			model.setProjectUuid(info.getProjectId());
			model.setListenerUuid(info.getListenerId());
			model.setProvisioningStatus(info.getProvisioningStatus());
			model.setRedirectListenerUuid(info.getRedirectListenerId());
			model.setRedirectPoolUuid(info.getRedirectPoolId());
			model.setRedirectUrl(info.getRedirectUrl());
			model.setPosition(info.getPosition());

			List<ResourceList> rules = info.getRules();
			if (!CollectionUtils.isEmpty(rules)) {
				String ruleUuid = "";
				for (ResourceList rule : rules) {
					ruleUuid += rule.getId() + ",";
				}
				model.setRuleUuids(ruleUuid.substring(0, ruleUuid.length() - 1));
			}
		}
		return model;
	}

}
