package com.bocloud.cmp.huaweiconvertor;

import com.bocloud.cmp.model.LbListenerRuleModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.elb.v2.model.L7ruleResp;

import java.util.ArrayList;
import java.util.List;


public class LbL7ruleConvertor implements BeanConvertor<LbListenerRuleModel, L7ruleResp> {

    @Override
    public List<LbListenerRuleModel> convertList(List<? extends L7ruleResp> objects) {
        List<LbListenerRuleModel> volumeModels = new ArrayList<>();
        for (L7ruleResp object : objects) {
            volumeModels.add(convertModel(object));
        }
        return volumeModels;
    }

    @Override
    public LbListenerRuleModel convertModel(L7ruleResp info) {
        LbListenerRuleModel model = new LbListenerRuleModel();
        if (null != info) {
            model.setRuleUuid(info.getId());
            model.setAdminStateUp(info.getAdminStateUp());
            model.setTenantUuid(info.getTenantId());
            model.setProjectUuid(info.getProjectId());
            model.setProvisioningStatus(info.getProvisioningStatus());
            model.setType(info.getType().getValue());
            model.setCompareType(info.getCompareType());
            model.setInvert(info.getInvert());
            model.setRuleKey(info.getKey());
            model.setRuleValue(info.getValue());
        }
        return model;
    }

}
