package com.bocloud.cmp.huaweiconvertor;

import com.bocloud.cmp.model.LbMemberModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.elb.v2.model.MemberResp;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;


public class LbMemberConvertor implements BeanConvertor<LbMemberModel, MemberResp> {

    @Override
    public List<LbMemberModel> convertList(List<? extends MemberResp> objects) {
        List<LbMemberModel> volumeModels = new ArrayList<>();
        for (MemberResp object : objects) {
            volumeModels.add(convertModel(object));
        }
        return volumeModels;
    }

    @Override
    public LbMemberModel convertModel(MemberResp info) {
        LbMemberModel model = new LbMemberModel();
        if (null != info) {

            model.setName(info.getName());
            model.setMemberUuid(info.getId());
            model.setSubnetUuid(info.getSubnetId());

            model.setAddress(info.getAddress());
            model.setAdminStateUp(info.getAdminStateUp());

            model.setPort(info.getProtocolPort());
            model.setWeight(info.getWeight());
           // model.setPoolUuid(info.get);
           // model.setLbUuid();

        }
        return model;
    }


}
