package com.bocloud.cmp.huaweiconvertor;

import com.bocloud.cmp.model.FloatingIpModel;
import com.bocloud.cmp.model.NatGatewayModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.eip.v2.model.FloatingIpResp;
import com.huaweicloud.sdk.nat.v2.model.NatGatewayResponseBody;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class NatGatewayConvertor implements BeanConvertor<NatGatewayModel, NatGatewayResponseBody> {

    @Override
    public List<NatGatewayModel> convertList(List<? extends NatGatewayResponseBody> objects) {
        List<NatGatewayModel> regionModels = new ArrayList<NatGatewayModel>();
        for (NatGatewayResponseBody object : objects) {
            regionModels.add(convertModel(object));
        }
        return regionModels;
    }

    @Override
    public NatGatewayModel convertModel(NatGatewayResponseBody info) {
        NatGatewayModel natGatewayModel = new NatGatewayModel();
        if (null != info) {
            natGatewayModel.setUuid(info.getId());
            natGatewayModel.setName(info.getName());
            natGatewayModel.setRemark(info.getDescription());
            natGatewayModel.setSpec(info.getSpec().getValue());
            natGatewayModel.setStatus(info.getStatus().getValue()); // ACTIVE PENDING_CREATE PENDING_UPDATE PENDING_DELETE INACTIVE
            natGatewayModel.setAdminStateUp(info.getAdminStateUp());
            natGatewayModel.setVpcUuid(info.getRouterId());
            natGatewayModel.setSubnetUuid(info.getInternalNetworkId());
            String format = info.getCreatedAt().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            try {
                natGatewayModel.setGmtCreate(formatter.parse(format));
            } catch (Exception e) {
                natGatewayModel.setGmtCreate(new Date());
            }
        }
        return natGatewayModel;
    }
}
