package com.bocloud.cmp.huaweiconvertor;

import com.bocloud.cmp.model.NatGatewayDnatRuleModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.nat.v2.model.NatGatewayDnatRuleResponseBody;
import com.huaweicloud.sdk.nat.v2.model.NatGatewayResponseBody;
import com.huaweicloud.sdk.nat.v2.model.NatGatewaySnatRuleResponseBody;

import java.text.SimpleDateFormat;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class NatGatewayDnatRuleConvertor implements BeanConvertor<NatGatewayDnatRuleModel, NatGatewayDnatRuleResponseBody> {

    @Override
    public List<NatGatewayDnatRuleModel> convertList(List<? extends NatGatewayDnatRuleResponseBody> objects) {
        List<NatGatewayDnatRuleModel> regionModels = new ArrayList<NatGatewayDnatRuleModel>();
        for (NatGatewayDnatRuleResponseBody object : objects) {
            regionModels.add(convertModel(object));
        }
        return regionModels;
    }

    @Override
    public NatGatewayDnatRuleModel convertModel(NatGatewayDnatRuleResponseBody info) {
        NatGatewayDnatRuleModel natGatewayModel = new NatGatewayDnatRuleModel();
        if (null != info) {
            natGatewayModel.setUuid(info.getId());
            natGatewayModel.setRemark(info.getDescription());
            natGatewayModel.setPortUuid(info.getPortId());
            natGatewayModel.setPrivateIp(info.getPrivateIp());
            natGatewayModel.setInternalServicePort(info.getInternalServicePort());
            natGatewayModel.setNatGatewayId(info.getNatGatewayId());
            natGatewayModel.setFloatingIpId(info.getFloatingIpId());
            natGatewayModel.setFloatingIpAddress(info.getFloatingIpAddress());
            natGatewayModel.setExternalServicePort(info.getExternalServicePort());
            natGatewayModel.setStatus(info.getStatus().getValue()); // ACTIVE PENDING_CREATE PENDING_UPDATE PENDING_DELETE INACTIVE
            natGatewayModel.setAdminStateUp(info.getAdminStateUp());
            natGatewayModel.setInternalServicePortRange(info.getInternalServicePortRange());
            natGatewayModel.setExternalServicePortRange(info.getExternalServicePortRange());
            natGatewayModel.setProtocol(info.getProtocol().getValue().toUpperCase());
            String format = info.getCreatedAt().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            try {
                natGatewayModel.setGmtCreate(formatter.parse(format));
            } catch (Exception e) {
                natGatewayModel.setGmtCreate(new Date());
            }
        }
        return natGatewayModel;
    }
}
