package com.bocloud.cmp.huaweiconvertor;

import com.bocloud.cmp.model.NatGatewayDnatRuleModel;
import com.bocloud.cmp.model.NatGatewaySnatRuleModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.nat.v2.model.NatGatewayDnatRuleResponseBody;
import com.huaweicloud.sdk.nat.v2.model.NatGatewaySnatRuleResponseBody;

import java.text.SimpleDateFormat;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class NatGatewaySnatRuleConvertor implements BeanConvertor<NatGatewaySnatRuleModel, NatGatewaySnatRuleResponseBody> {

    @Override
    public List<NatGatewaySnatRuleModel> convertList(List<? extends NatGatewaySnatRuleResponseBody> objects) {
        List<NatGatewaySnatRuleModel> regionModels = new ArrayList<NatGatewaySnatRuleModel>();
        for (NatGatewaySnatRuleResponseBody object : objects) {
            regionModels.add(convertModel(object));
        }
        return regionModels;
    }

    @Override
    public NatGatewaySnatRuleModel convertModel(NatGatewaySnatRuleResponseBody info) {
        NatGatewaySnatRuleModel natGatewayModel = new NatGatewaySnatRuleModel();
        if (null != info) {
            natGatewayModel.setUuid(info.getId());
            natGatewayModel.setRemark(info.getDescription());
            natGatewayModel.setNatGatewayId(info.getNatGatewayId());
            natGatewayModel.setCidr(info.getCidr());
            natGatewayModel.setSourceType(info.getSourceType());
            natGatewayModel.setFloatingIpId(info.getFloatingIpId());
            natGatewayModel.setSubnetUuid(info.getNetworkId()); // 子网
            natGatewayModel.setFloatingIpAddress(info.getFloatingIpAddress());
            natGatewayModel.setFreezedIpAddress(info.getFreezedIpAddress());
            natGatewayModel.setStatus(info.getStatus().getValue()); // ACTIVE PENDING_CREATE PENDING_UPDATE PENDING_DELETE INACTIVE
            natGatewayModel.setAdminStateUp(info.getAdminStateUp());
            String format = info.getCreatedAt().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            try {
                natGatewayModel.setGmtCreate(formatter.parse(format));
            } catch (Exception e) {
                natGatewayModel.setGmtCreate(new Date());
            }
        }
        return natGatewayModel;
    }
}
