package com.bocloud.cmp.huaweiconvertor;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.bocloud.cmp.model.RegionModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.iam.v3.model.ProjectResult;

/**
 * 华为云域数据转换器
 *
 * @author wangyu
 * @version 3.0.0-SNAPSHOT
 * @since 2018/9/21
 */
public class RegionConvertor implements BeanConvertor<RegionModel, ProjectResult> {

	// 开发 暂时 屏蔽 其他地域
	private static String[] EXCLUDE = { "cn-north-1", "cn-east-2" };


	@Override
	public List<RegionModel> convertList(List<? extends ProjectResult> objects) {
		List<RegionModel> regionModels = new ArrayList<RegionModel>();
		for (ProjectResult object : objects) {
			if (!"MOS".equalsIgnoreCase(object.getName())) {
				regionModels.add(convertModel(object));
			}
		}
		return regionModels;
	}

	@Override
	public RegionModel convertModel(ProjectResult project) {
		RegionModel model = new RegionModel();
		String name = project.getName();
		if (null != name && !"".equals(name)) {
			model.setCode(name);
			model.setRegionId(name);
			model.setProjectId(project.getId());
		}
		return model;
	}
}
