package com.bocloud.cmp.huaweiconvertor;

import java.util.ArrayList;
import java.util.List;

import com.bocloud.cmp.model.SecurityGroupRuleModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.vpc.v2.model.SecurityGroupRule;


public class SecurityGroupRuleConvertor implements BeanConvertor<SecurityGroupRuleModel, SecurityGroupRule> {

    @Override
    public List<SecurityGroupRuleModel> convertList(List<? extends SecurityGroupRule> objects) {
        List<SecurityGroupRuleModel> volumeModels = new ArrayList<>();
        for (SecurityGroupRule object : objects) {
            volumeModels.add(convertModel(object));
        }
        return volumeModels;
    }

    @Override
    public SecurityGroupRuleModel convertModel(SecurityGroupRule info) {
        SecurityGroupRuleModel model = new SecurityGroupRuleModel();
        if (null != info) {
            model.setPortMin(info.getPortRangeMin()); // 起始端口
            model.setPortMax(info.getPortRangeMax()); // 终止端口
            model.setName(info.getId());
            model.setGroupUuid(info.getSecurityGroupId());
            model.setRuleUuid(info.getId());
            String protocol = info.getProtocol(); // 协议类型：tcp、udp、icmp
            if (null != protocol) {
                model.setProtocol(protocol.toUpperCase());
            }
            model.setRemoteIpPrefix(info.getRemoteIpPrefix());
            model.setDirection(info.getDirection());
            model.setEtherType(info.getEthertype());
        }
        return model;
    }

}
