package com.bocloud.cmp.huaweiconvertor;

import java.util.ArrayList;
import java.util.List;
import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.model.SubnetModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.vpc.v2.model.Subnet;


public class SubnetConvertor implements BeanConvertor<SubnetModel, Subnet> {

	@Override
	public List<SubnetModel> convertList(List<? extends Subnet> objects) {
		List<SubnetModel> subnetModels = new ArrayList<SubnetModel>();
		for (Subnet object : objects) {
			subnetModels.add(convertModel(object));
		}
		return subnetModels;
	}

	@Override
	public SubnetModel convertModel(Subnet model) {
		SubnetModel subnet = new SubnetModel();
		subnet.setSubnetUuid(model.getId());
		subnet.setNetworkUuid(model.getVpcId());
		subnet.setVpcUuid(model.getVpcId());
		subnet.setName(model.getName());
		// 最新版本无找到相应字段
		/*subnet.setTenantName(model.getTenantId());
		subnet.setIpVersion(model.getIpVersion() + "");*/
		subnet.setGateway(model.getGatewayIp());
		subnet.setDnsNames(JSON.toJSONString(model.getDnsList()));
		subnet.setDhcpEnabled(model.getDhcpEnable()); // 默认 true
		subnet.setCidr(model.getCidr());
		// subnet.setIpPools(JSON.toJSONString(model.getAllocationPools())); 最新版本无ipPool
		//subnet.setIpVersion("V4"); // 华为云子网允许开启ipv6，故没有IP的版本
		subnet.setIpv6Cidr(model.getCidrV6());
		subnet.setIpVersion("V4");
		subnet.setNeutronSubnetUuid(model.getNeutronSubnetId());
		subnet.setNeutronSubnetV6Uuid(model.getNeutronSubnetIdV6());
		subnet.setStatus(model.getStatus().getValue()); // ACTIVE;UNKNOWN;ERROR
		subnet.setZone(model.getAvailabilityZone());
		return subnet;
	}

}
