package com.bocloud.cmp.huaweiconvertor;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.VpcModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.vpc.v2.model.Vpc;

/**
 * Vpc 转换
 *
 * @author ymh
 * @时间 2018年11月22日
 */
public class VpcConvertor implements BeanConvertor<VpcModel, Vpc> {

	@Override
	public List<VpcModel> convertList(List<? extends Vpc> objects) {
		List<VpcModel> models = new ArrayList<VpcModel>();
		for (Vpc object : objects) {
			models.add(convertModel(object));
		}
		return models;
	}

	@Override
	public VpcModel convertModel(Vpc info) {
		VpcModel model = new VpcModel();
		if (null != info) {
			model.setVpcId(info.getId());
			model.setName(info.getName());
			model.setCidr(info.getCidr());
			String status = info.getStatus().getValue(); // CREATING;OK;
			if (null != status && "OK".equalsIgnoreCase(status)) {
				model.setStatus("ACTIVE");
			} else {
				model.setStatus(status);
			}
			String enterpriseProjectId = info.getEnterpriseProjectId();
			if (!StringUtils.isEmpty(enterpriseProjectId)) {
				model.setTenantUuid(enterpriseProjectId);
			}
		}
		return model;
	}
}
