package com.bocloud.cmp.huaweiconvertor;

import java.util.ArrayList;
import java.util.List;
import com.bocloud.cmp.model.ZoneModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.huaweicloud.sdk.ecs.v2.model.NovaAvailabilityZone;

/**
 * 华为云域数据转换器
 *
 * @author wangyu
 * @version 3.0.0-SNAPSHOT
 * @since 2018/9/21
 */
public class ZoneConvertor implements BeanConvertor<ZoneModel, NovaAvailabilityZone> {

    @Override
    public List<ZoneModel> convertList(List<? extends NovaAvailabilityZone> objects) {
        List<ZoneModel> regionModels = new ArrayList<>();
        for (NovaAvailabilityZone object : objects) {
            if (object.getZoneState().getAvailable()) {
                regionModels.add(convertModel(object));
            }
        }
        return regionModels;
    }

    @Override
    public ZoneModel convertModel(NovaAvailabilityZone object) {
        ZoneModel model = new ZoneModel();
        String zoneName = object.getZoneName();
        if (null != zoneName && !"".equals(zoneName)) {
            model.setZoneId(object.getZoneName());
            this.getNames(zoneName, model);
        }
        return model;
    }

    private void getNames(String zoneName, ZoneModel model) {
        if (zoneName.endsWith("a") || zoneName.endsWith("1")) {
            model.setName("可用区1");
        }
        if (zoneName.endsWith("b") || zoneName.endsWith("2")) {
            model.setName("可用区2");
        }
        if (zoneName.endsWith("c") || zoneName.endsWith("3")) {
            model.setName("可用区3");
        }
        if (zoneName.endsWith("d") || zoneName.endsWith("4")) {
            model.setName("可用区4");
        }
        if (zoneName.endsWith("e") || zoneName.endsWith("5")) {
            model.setName("可用区5");
        }
        if (zoneName.endsWith("f") || zoneName.endsWith("6")) {
            model.setName("可用区6");
        }
        if (zoneName.endsWith("g") || zoneName.endsWith("7")) {
            model.setName("可用区7");
        }
    }
}
