package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.EnterpriseProjectModel;
import com.bocloud.cmp.model.OSTenantModel;
import com.bocloud.cmp.provider.HuaweiProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 华为云验证
 * 
 * @author ymh
 * @时间 2018年11月29日
 */
@Provider("bocloud.cmp.huawei")
public class HuaweiAuthProvider extends HuaweiProvider implements AuthProvider {

	private static Logger logger = LoggerFactory.getLogger(HuaweiAuthProvider.class);

	private Butler butler;

	public HuaweiAuthProvider(Butler butler) {
		super(butler);
		this.butler = butler;
	}

	@Override
	public BocloudResult auth() {
		logger.info("认证。。");
		if (this.accessable()) {
			return new BocloudResult(true, "" + this.accessable());
		}
		return new BocloudResult(this.accessable(), "认证信息失败");
	}

	@Override
	public BocloudResult modifyProject(OSTenantModel model) {
		HuaweiEnterpriseProvider enterpriseProvider = new HuaweiEnterpriseProvider(butler);
		EnterpriseProjectModel enterpriseProjectModel = new EnterpriseProjectModel();
		enterpriseProjectModel.setEnterpriseProjectUuid(model.getTenantUuid());
		enterpriseProjectModel.setName(model.getName());
		enterpriseProjectModel.setRemark(model.getRemark());
		return enterpriseProvider.modifyEnterpriseProject(enterpriseProjectModel);
	}
}
