package com.bocloud.cmp.provider.network;

import com.bocloud.cmp.api.model.HuaweiIndex;
import com.bocloud.cmp.huaweiconvertor.FloatingIpConvertor;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.FloatingIpModel;
import com.bocloud.cmp.provider.HuaweiProvider;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import com.huaweicloud.sdk.eip.v2.EipClient;
import com.huaweicloud.sdk.eip.v2.model.FloatingIpResp;
import com.huaweicloud.sdk.eip.v2.model.NeutronListFloatingIpsRequest;
import com.huaweicloud.sdk.eip.v2.model.NeutronListFloatingIpsResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Floating
 *
 * @author ymh
 * @时间 2018年12月11日
 */

@Provider("bocloud.cmp.huawei")
public class HuaweiFloatingIpProvider extends HuaweiProvider implements FloatingIPProvider {

    public HuaweiFloatingIpProvider(Butler butler) {
        super(butler);
    }

    private static Logger logger = LoggerFactory.getLogger(HuaweiFloatingIpProvider.class);

    private BeanConvertor<FloatingIpModel, FloatingIpResp> convetor = new FloatingIpConvertor();

    @Override
    public BocloudResult list() {
        try {
            EipClient client = (EipClient) getClient(HuaweiIndex.service.EIP);
            NeutronListFloatingIpsRequest request = new NeutronListFloatingIpsRequest();
            NeutronListFloatingIpsResponse response = client.neutronListFloatingIps(request);
            return new BocloudResult(true, convetor.convertList(response.getFloatingips()), "查询列表成功");
        } catch (Exception e) {
            logger.error("查询列表失败： " + e);
            return new BocloudResult(false, "查询列表失败", e.getMessage());
        }
    }

    @Override
    public BocloudResult create(FloatingIpModel model) {
        return null;
    }

    @Override
    public BocloudResult remove(String fipId) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public BocloudResult detail(String fipId) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public BocloudResult associate(String fipId, String portId) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public BocloudResult disassociate(String fipId) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public BocloudResult associate(FloatingIpModel modeld) {
        // TODO Auto-generated method stub
        return null;
    }

}
