//package com.bocloud.cmp.provider.network;
//
//import java.util.List;
//
//import com.bocloud.cmp.api.model.HuaweiIndex;
//import com.bocloud.cmp.huaweiconvertor.RouterConvertor;
//import com.bocloud.cmp.model.Butler;
//import com.bocloud.cmp.model.RouterModel;
//import com.bocloud.cmp.provider.HuaweiProvider;
//import com.bocloud.cmp.provider.convertor.BeanConvertor;
//import com.bocloud.common.annotations.Provider;
//import com.bocloud.common.model.BocloudResult;
//import com.huawei.openstack4j.api.Builders;
//import com.huawei.openstack4j.model.common.ActionResponse;
//import com.huawei.openstack4j.model.network.AttachInterfaceType;
//import com.huawei.openstack4j.model.network.Router;
//import com.huawei.openstack4j.model.network.RouterInterface;
//import com.huawei.openstack4j.model.network.builder.RouterBuilder;
//import com.huawei.openstack4j.openstack.networking.domain.NeutronRouter;
//
//@Provider("bocloud.cmp.huawei")
//public class HuaweiRouterProvider extends HuaweiProvider implements RouterProvider {
//
//    private Butler butler;
//
//    public HuaweiRouterProvider(Butler butler) {
//        super(butler);
//        this.butler = butler;
//    }
//
//    private BeanConvertor<RouterModel, Router> convertor = new RouterConvertor();
//
//    @Override
//    public BocloudResult create(RouterModel model) {
//        try {
//            RouterBuilder routerBuilder = Builders.router().name(model.getName()).adminStateUp(true); // model.getAdminStateup()
//            Router router = this.getClient().networking().router().create(routerBuilder.build());
//            RouterModel convertModel = convertor.convertModel(router);
//            convertModel.setRegionId(this.getRegionId());
//            return new BocloudResult(true, convertModel, "创建成功");
//        } catch (Exception e) {
//            return new BocloudResult(false, "创建失败", e.getMessage());
//        }
//    }
//
//    @Override
//    public BocloudResult remove(String routerId) {
//        try {
//            ActionResponse actionResponse = this.getClient().networking().router().delete(routerId);
//            if (actionResponse.isSuccess()) {
//                return new BocloudResult(true, actionResponse.getCode(), "删除成功");
//            } else {
//                return new BocloudResult(false, "删除失败", actionResponse.getFault());
//            }
//        } catch (Exception e) {
//            return new BocloudResult(false, "删除失败", e.getMessage());
//        }
//    }
//
//    @Override
//    public BocloudResult detail(String routerId) {
//        try {
//            Router router = this.getClient().networking().router().get(routerId);
//            RouterModel convertModel = convertor.convertModel(router);
//            convertModel.setRegionId(this.getRegionId());
//            return new BocloudResult(true, convertModel, "查询详情成功");
//        } catch (Exception e) {
//            return new BocloudResult(false, "查询详情失败", e.getMessage());
//        }
//    }
//
//    @Override
//    public BocloudResult modify(RouterModel model) {
//        try {
//            Router paramRouter = new NeutronRouter();
//            RouterBuilder builder = paramRouter.toBuilder();
//            builder.id(model.getRouterUuid());
//            builder.name(model.getName()).adminStateUp(true);
//            Router router = this.getClient().networking().router().update(builder.build());
//            RouterModel convertModel = convertor.convertModel(router);
//            convertModel.setRegionId(this.getRegionId());
//            return new BocloudResult(true, convertModel, "修改成功");
//        } catch (Exception e) {
//            return new BocloudResult(false, "修改失败", e.getMessage());
//        }
//    }
//
//    @Override
//    public BocloudResult attach(RouterModel model) {
//        try {
//            String portOrSubnetId = "";
//            AttachInterfaceType paramAttachInterfaceType = null;
//            String subnetId = model.getSubnetUuid();
//            if (null != subnetId && !"".equals(subnetId)) {
//                portOrSubnetId = subnetId;
//                paramAttachInterfaceType = AttachInterfaceType.SUBNET;
//            } else {
//                portOrSubnetId = model.getPortUuid();
//                paramAttachInterfaceType = AttachInterfaceType.PORT;
//            }
//            RouterInterface attachInterface = this.getClient().networking().router()
//                    .attachInterface(model.getRouterUuid(), paramAttachInterfaceType, portOrSubnetId);
//            return new BocloudResult(true, portDetail(attachInterface.getPortId()), "修改成功");
//        } catch (Exception e) {
//            return new BocloudResult(false, "修改失败", e.getMessage());
//        }
//    }
//
//    private Object portDetail(String portId) {
//        HuaweiPortProvider prot = new HuaweiPortProvider(this.butler);
//        BocloudResult detail = prot.detail(portId);
//        return detail.getData();
//    }
//
//    @Override
//    public BocloudResult detach(RouterModel model) {
//        try {
//            RouterInterface detachInterface = this.getClient().networking().router()
//                    .detachInterface(model.getRouterUuid(), model.getSubnetUuid(), model.getPortUuid());
//            return new BocloudResult(true, detachInterface.getId(), "修改成功");
//        } catch (Exception e) {
//            return new BocloudResult(false, "修改失败", e.getMessage());
//        }
//    }
//
//    @Override
//    public BocloudResult config(RouterModel model) {
//        return null;
//    }
//
//    @Override
//    public BocloudResult clear(String routerId) {
//        return null;
//    }
//
//    @Override
//    public BocloudResult list() {
//        try {
//            List<? extends Router> list = this.getClient().networking().router().list();
//            return new BocloudResult(true, convertor.convertList(list), "查询成功");
//        } catch (Exception e) {
//            return new BocloudResult(false, "查询失败", e.getMessage());
//        }
//    }
//
//}
