package com.huaweicloud.sdk.ecs.v2.model;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonInclude.Include;
import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.function.Consumer;

public class PrePaidServerNic {
	@JsonInclude(Include.NON_NULL)
	@JsonProperty("subnet_id")
	private String subnetId;
	@JsonInclude(Include.NON_NULL)
	@JsonProperty("port_id")
	private String portId;
	@JsonInclude(Include.NON_NULL)
	@JsonProperty("ip_address")
	private String ipAddress;
	@JsonInclude(Include.NON_NULL)
	@JsonProperty("ipv6_enable")
	private Boolean ipv6Enable;
	@JsonInclude(Include.NON_NULL)
	@JsonProperty("ipv6_bandwidth")
	private PrePaidServerIpv6Bandwidth ipv6Bandwidth = null;

	public PrePaidServerNic() {
	}

	public PrePaidServerNic withSubnetId(String subnetId) {
		this.subnetId = subnetId;
		return this;
	}

	public PrePaidServerNic withIpAddress(String ipAddress) {
		this.ipAddress = ipAddress;
		return this;
	}

	public String getIpAddress() {
		return this.ipAddress;
	}

	public void setIpAddress(String ipAddress) {
		this.ipAddress = ipAddress;
	}

	public PrePaidServerNic withIpv6Enable(Boolean ipv6Enable) {
		this.ipv6Enable = ipv6Enable;
		return this;
	}

	public Boolean getIpv6Enable() {
		return this.ipv6Enable;
	}

	public void setIpv6Enable(Boolean ipv6Enable) {
		this.ipv6Enable = ipv6Enable;
	}

	public PrePaidServerNic withIpv6Bandwidth(PrePaidServerIpv6Bandwidth ipv6Bandwidth) {
		this.ipv6Bandwidth = ipv6Bandwidth;
		return this;
	}

	public PrePaidServerNic withIpv6Bandwidth(Consumer<PrePaidServerIpv6Bandwidth> ipv6BandwidthSetter) {
		if (this.ipv6Bandwidth == null) {
			this.ipv6Bandwidth = new PrePaidServerIpv6Bandwidth();
			ipv6BandwidthSetter.accept(this.ipv6Bandwidth);
		}

		return this;
	}

	public PrePaidServerIpv6Bandwidth getIpv6Bandwidth() {
		return this.ipv6Bandwidth;
	}

	public void setIpv6Bandwidth(PrePaidServerIpv6Bandwidth ipv6Bandwidth) {
		this.ipv6Bandwidth = ipv6Bandwidth;
	}

	public PrePaidServerNic withportId(String portId) {
		this.portId = portId;
		return this;
	}

	public String getPortId() {
		return portId;
	}

	public void setPortId(String portId) {
		this.portId = portId;
	}

}
