package com.huaweicloud.sdk.ecs.v2.model;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonInclude.Include;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

public class PrePaidServerSchedulerHints {
    @JsonInclude(Include.NON_NULL)
    @JsonProperty("group")
    private String group;
    @JsonInclude(Include.NON_NULL)
    @JsonProperty("tenancy")
    private PrePaidServerSchedulerHints.TenancyEnum tenancy;
    @JsonInclude(Include.NON_NULL)
    @JsonProperty("dedicated_host_id")
    private String dedicatedHostId;
    @JsonInclude(Include.NON_NULL)
    @JsonProperty("aggr:ipv6_enable")
    private PrePaidServerSchedulerHints.Ipv6EnableEnum ipv6Enable;

    public PrePaidServerSchedulerHints() {
    }

    public PrePaidServerSchedulerHints withGroup(String group) {
        this.group = group;
        return this;
    }

    public String getGroup() {
        return this.group;
    }

    public void setGroup(String group) {
        this.group = group;
    }

    public PrePaidServerSchedulerHints withTenancy(PrePaidServerSchedulerHints.TenancyEnum tenancy) {
        this.tenancy = tenancy;
        return this;
    }

    public PrePaidServerSchedulerHints.TenancyEnum getTenancy() {
        return this.tenancy;
    }

    public void setTenancy(PrePaidServerSchedulerHints.TenancyEnum tenancy) {
        this.tenancy = tenancy;
    }

    public PrePaidServerSchedulerHints withDedicatedHostId(String dedicatedHostId) {
        this.dedicatedHostId = dedicatedHostId;
        return this;
    }

    public String getDedicatedHostId() {
        return this.dedicatedHostId;
    }

    public void setDedicatedHostId(String dedicatedHostId) {
        this.dedicatedHostId = dedicatedHostId;
    }

    public PrePaidServerSchedulerHints withIpv6Enable(Ipv6EnableEnum ipv6Enable) {
        this.ipv6Enable = ipv6Enable;
        return this;
    }

    public Ipv6EnableEnum getIpv6Enable() {
        return ipv6Enable;
    }

    public void setIpv6Enable(Ipv6EnableEnum ipv6Enable) {
        this.ipv6Enable = ipv6Enable;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        } else if (o != null && this.getClass() == o.getClass()) {
            PrePaidServerSchedulerHints prePaidServerSchedulerHints = (PrePaidServerSchedulerHints) o;
            return Objects.equals(this.group, prePaidServerSchedulerHints.group) && Objects.equals(this.tenancy, prePaidServerSchedulerHints.tenancy) && Objects.equals(this.dedicatedHostId, prePaidServerSchedulerHints.dedicatedHostId) && Objects.equals(this.ipv6Enable, prePaidServerSchedulerHints.ipv6Enable);
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return Objects.hash(new Object[]{this.group, this.tenancy, this.dedicatedHostId, this.ipv6Enable});
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class PrePaidServerSchedulerHints {\n");
        sb.append("    group: ").append(this.toIndentedString(this.group)).append("\n");
        sb.append("    tenancy: ").append(this.toIndentedString(this.tenancy)).append("\n");
        sb.append("    dedicatedHostId: ").append(this.toIndentedString(this.dedicatedHostId)).append("\n");
        sb.append("    ipv6Enable: ").append(this.toIndentedString(this.ipv6Enable)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    private String toIndentedString(Object o) {
        return o == null ? "null" : o.toString().replace("\n", "\n    ");
    }

    public static final class TenancyEnum {
        public static final PrePaidServerSchedulerHints.TenancyEnum SHARED = new PrePaidServerSchedulerHints.TenancyEnum("shared");
        public static final PrePaidServerSchedulerHints.TenancyEnum DEDICATED = new PrePaidServerSchedulerHints.TenancyEnum("dedicated");
        private static final Map<String, PrePaidServerSchedulerHints.TenancyEnum> STATIC_FIELDS = createStaticFields();
        private String value;

        private static Map<String, PrePaidServerSchedulerHints.TenancyEnum> createStaticFields() {
            Map<String, PrePaidServerSchedulerHints.TenancyEnum> map = new HashMap();
            map.put("shared", SHARED);
            map.put("dedicated", DEDICATED);
            return Collections.unmodifiableMap(map);
        }

        TenancyEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return String.valueOf(this.value);
        }

        @Override
        public String toString() {
            return String.valueOf(this.value);
        }

        @JsonCreator
        public static PrePaidServerSchedulerHints.TenancyEnum fromValue(String value) {
            if (value == null) {
                return null;
            } else {
                PrePaidServerSchedulerHints.TenancyEnum result = (PrePaidServerSchedulerHints.TenancyEnum) STATIC_FIELDS.get(value);
                if (result == null) {
                    result = new PrePaidServerSchedulerHints.TenancyEnum(value);
                }

                return result;
            }
        }

        public static PrePaidServerSchedulerHints.TenancyEnum valueOf(String value) {
            if (value == null) {
                return null;
            } else {
                PrePaidServerSchedulerHints.TenancyEnum result = (PrePaidServerSchedulerHints.TenancyEnum) STATIC_FIELDS.get(value);
                if (result != null) {
                    return result;
                } else {
                    throw new IllegalArgumentException("Unexpected value '" + value + "'");
                }
            }
        }

        @Override
        public boolean equals(Object obj) {
            return obj != null && obj instanceof PrePaidServerSchedulerHints.TenancyEnum ? this.value.equals(((PrePaidServerSchedulerHints.TenancyEnum) obj).value) : false;
        }

        @Override
        public int hashCode() {
            return this.value.hashCode();
        }
    }


    public static final class Ipv6EnableEnum {
        public static final PrePaidServerSchedulerHints.Ipv6EnableEnum TRUE = new PrePaidServerSchedulerHints.Ipv6EnableEnum("true");
        public static final PrePaidServerSchedulerHints.Ipv6EnableEnum FALSE = new PrePaidServerSchedulerHints.Ipv6EnableEnum("false");
        private static final Map<String, PrePaidServerSchedulerHints.Ipv6EnableEnum> STATIC_FIELDS = createStaticFields();
        private String value;

        private static Map<String, PrePaidServerSchedulerHints.Ipv6EnableEnum> createStaticFields() {
            Map<String, PrePaidServerSchedulerHints.Ipv6EnableEnum> map = new HashMap();
            map.put("true", TRUE);
            map.put("false", FALSE);
            return Collections.unmodifiableMap(map);
        }

        Ipv6EnableEnum(String value) {
            this.value = value;
        }

        @JsonValue
        public String getValue() {
            return String.valueOf(this.value);
        }

        @Override
        public String toString() {
            return String.valueOf(this.value);
        }

        @JsonCreator
        public static PrePaidServerSchedulerHints.Ipv6EnableEnum fromValue(String value) {
            if (value == null) {
                return null;
            } else {
                PrePaidServerSchedulerHints.Ipv6EnableEnum result = (PrePaidServerSchedulerHints.Ipv6EnableEnum) STATIC_FIELDS.get(value);
                if (result == null) {
                    result = new PrePaidServerSchedulerHints.Ipv6EnableEnum(value);
                }

                return result;
            }
        }
    }
}
