package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.JdCloudProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.utils.ListTool;
import com.jdcloud.sdk.service.vm.model.DescribeInstanceTypesRequest;
import com.jdcloud.sdk.service.vm.model.DescribeInstanceTypesResponse;
import com.jdcloud.sdk.service.vm.model.DescribeInstanceTypesResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author : guopeng create at: 2018/11/15 3:10 PM
 * @description:
 */
@Provider("bocloud.cmp.jdcloud")
public class JdCloudAuthProvider extends JdCloudProvider implements AuthProvider {

    private static Logger logger = LoggerFactory.getLogger(JdCloudAuthProvider.class);

    /**
     * 构造方法，所有的云平台驱动都必须要实现或重写该构造方法
     *
     * @param butler 云平台认证信息
     */
    public JdCloudAuthProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult auth() {
        DescribeInstanceTypesRequest instTypeRequest = new DescribeInstanceTypesRequest();
        instTypeRequest.setRegionId(this.getRegionId());
        DescribeInstanceTypesResponse instTypeResponse = this.getVmClient().describeInstanceTypes(instTypeRequest);
        DescribeInstanceTypesResult instTypeResult = instTypeResponse.getResult();
        if (ListTool.isEmpty(instTypeResult.getInstanceTypes())) {
            logger.warn("认证失败！");
            return new BocloudResult(false, "fail");
        }
        return new BocloudResult(true, "success");
    }

}
