package com.bocloud.cmp.provider.jdconvertor;

import java.util.ArrayList;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.bocloud.cmp.model.ElasticIpModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;
import com.jdcloud.sdk.service.vpc.model.ElasticIp;

/**
 * VPC转换器
 * 
 * @author ymh
 * @时间 2018年11月16日
 */
public class ElasticIpConvertor implements BeanConvertor<ElasticIpModel, ElasticIp> {

    private static Logger logger = LoggerFactory.getLogger(ElasticIpConvertor.class);

    @Override
    public List<ElasticIpModel> convertList(List<? extends ElasticIp> objects) {
        List<ElasticIpModel> imageModels = new ArrayList<ElasticIpModel>();
        for (ElasticIp object : objects) {
            imageModels.add(convertModel(object));
        }
        return imageModels;
    }

    @Override
    public ElasticIpModel convertModel(ElasticIp vpc) {
        ElasticIpModel model = null;
        if (null != vpc) {
            model = new ElasticIpModel();
            model.setElasticIpUuid(vpc.getElasticIpId());
            model.setPublicIp(vpc.getElasticIpAddress());
            model.setBandwidth(String.valueOf(vpc.getBandwidthMbps()));
            model.setProvider(vpc.getProvider());
            model.setPrivateIpAddress(vpc.getPrivateIpAddress());
            model.setNetworkInterfaceId(vpc.getNetworkInterfaceId());
            model.setInstanceId(vpc.getInstanceId());
            model.setInstanceType(vpc.getInstanceType());
            String creationTime = vpc.getCreatedTime();
            if (null != creationTime && !"".equals(creationTime)) {
                model.setCreateTime(DateTools.transfer("yyyy-MM-dd'T'HH:mmZ", creationTime, "Z"));
            }
        }
        return model;
    }

}
