package com.bocloud.cmp.provider.jdconvertor;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.model.FlavorModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.google.api.client.util.Lists;
import com.jdcloud.sdk.service.vm.model.InstanceType;
import com.jdcloud.sdk.service.vm.model.InstanceTypeState;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @author : guopeng create at: 2018/11/15 3:29 PM
 * @description:
 */
public class InstanceTypeConvertor implements BeanConvertor<FlavorModel, InstanceType> {

  @Override
  public List<FlavorModel> convertList(List<? extends InstanceType> instanceTypes) {
    List<FlavorModel> models = Lists.newArrayList();
    for (InstanceType instanceType : instanceTypes) {
      FlavorModel convertModel = convertModel(instanceType);
      List<String> parseArray = JSON.parseArray(convertModel.getZone(), String.class);
      if (null != parseArray && parseArray.size() > 0) { // 4.2优化
        models.add(convertModel);
      }
    }
    return models;
  }

  @Override
  public FlavorModel convertModel(InstanceType instanceType) {
    FlavorModel flavorModel = new FlavorModel();
    flavorModel.setName(instanceType.getInstanceType());
    flavorModel.setFlavorUuid(instanceType.getInstanceType());
    flavorModel.setMemory(
        BigDecimal.valueOf(instanceType.getMemoryMB()).divide(BigDecimal.valueOf(1024), 2, BigDecimal.ROUND_HALF_UP));
    flavorModel.setCpu(instanceType.getCpu());
    flavorModel.setFamily(instanceType.getFamily());
    List<InstanceTypeState> state = instanceType.getState();
    if (null != state && state.size() > 0) {
      List<String> zoneList = new ArrayList<>();
      for (InstanceTypeState instanceTypeState : state) {
        if (instanceTypeState.getInStock() && null != instanceTypeState.getAz()
            && !"".equals(instanceTypeState.getAz())) {
          zoneList.add(instanceTypeState.getAz());
        }
      }
      flavorModel.setZone(JSON.toJSONString(zoneList));
    }
    return flavorModel;
  }
}
