package com.bocloud.cmp.provider.jdconvertor;

import com.bocloud.cmp.model.ImageModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.google.api.client.util.Lists;
import com.jdcloud.sdk.service.vm.model.Image;

import java.util.List;

/**
 * @author : guopeng create at: 2018/11/15 3:00 PM
 * @description:
 */
public class JdImageConvertor implements BeanConvertor<ImageModel, Image> {
    @Override
    public List<ImageModel> convertList(List<? extends Image> images) {
        List<ImageModel> models = Lists.newArrayList();
        for (Image image : images) {
            models.add(convertModel(image));
        }
        return models;
    }

    @Override
    public ImageModel convertModel(Image image) {
        ImageModel imageModel = new ImageModel();
        imageModel.setName(image.getName());
        imageModel.setStatus(convertStatus(image.getStatus()));
        imageModel.setRemark(image.getDesc());
        imageModel.setOsCategory(image.getOsType());
        imageModel.setOsName(image.getPlatform());
        imageModel.setOsType(image.getOsType());
        imageModel.setOsVersion(image.getOsVersion());
        imageModel.setImageUuid(image.getImageId());
        imageModel.setArchitecture(image.getArchitecture());
        imageModel.setImageType(image.getImageSource() == null ? null : image.getImageSource().toUpperCase());
        imageModel.setSize(Double.valueOf(image.getSystemDiskSizeGB()));
        imageModel.setMinDisk(Long.parseLong(image.getSystemDiskSizeGB() + ""));
        return imageModel;
    }

    /**
     * 状态转换
     *
     * @param status
     * @return
     */
    public String convertStatus(String status) {
        if ("pending".equalsIgnoreCase(status)) {// 等待中
            return "BUILDING";
        } else if ("ok".equalsIgnoreCase(status) || "ready".equalsIgnoreCase(status)) {// 正常
            return "ACTIVE";
        } else if ("invalid".equalsIgnoreCase(status)) {// 无效
            return "ERROR";
        } else {
            return "ERROR";
        }
    }
}
