package com.bocloud.cmp.provider.jdconvertor;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.bocloud.cmp.model.SnapshotModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.google.api.client.util.Lists;
import com.jdcloud.sdk.service.disk.model.Snapshot;

/**
 * 快照
 */
public class JdSnapshotConvertor implements BeanConvertor<SnapshotModel, Snapshot> {

    private static Logger logger = LoggerFactory.getLogger(JdSnapshotConvertor.class);

    @Override
    public List<SnapshotModel> convertList(List<? extends Snapshot> disks) {
        List<SnapshotModel> models = Lists.newArrayList();
        if (null == disks || disks.size() <= 0) {
            return models;
        }
        return models;
    }

    @Override
    public SnapshotModel convertModel(Snapshot disk) {
        SnapshotModel model = new SnapshotModel();
        if (null != disk) {
            model.setSnapshotUuid(disk.getSnapshotId());
            model.setSnapshotSource(disk.getSnapshotSource());
            model.setRemark(disk.getDescription());
            // 创建快照的云硬盘ID(snapshotSource为others时不展示)
            model.setVolumeUuid(disk.getDiskId());
            model.setSize(disk.getSnapshotSizeGB());
            model.setName(disk.getName());
            String status = disk.getStatus();
            if (null != status) {
                model.setStatus(disk.getStatus().toUpperCase());
            }
            try {
                String createTime = disk.getCreateTime();
                if (null != createTime && !"".equals(createTime)) {
                    model.setCreateTime(new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss").parse(createTime));
                }
            } catch (ParseException e) {
                logger.error("时间转换ERROR : " + e);
            }
            model.setEncrypted(disk.getEncrypted());
        }
        return model;
    }

}
