package com.bocloud.cmp.provider.jdconvertor;

import com.bocloud.cmp.model.KeypairModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.ListTool;
import com.google.api.client.util.Lists;
import com.jdcloud.sdk.service.vm.model.Keypair;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * @ClassName: KeypairConvertor
 * @Description: 秘钥
 * @Author lxy
 * @Date 2021/6/18 10:29
 */
public class KeypairConvertor implements BeanConvertor<KeypairModel, Keypair> {
    private static Logger logger = LoggerFactory.getLogger(KeypairConvertor.class);

    @Override
    public List<KeypairModel> convertList(List<? extends Keypair> keypairs) {
        List<KeypairModel> models = Lists.newArrayList();
        for (Keypair keypair : keypairs) {
            models.add(convertModel(keypair));
        }
        return models;
    }

    @Override
    public KeypairModel convertModel(Keypair keypair) {
        KeypairModel keypairModel = new KeypairModel();
        keypairModel.setName(keypair.getKeyName());
        keypairModel.setFingerprint(keypair.getKeyFingerprint());
        if (!ListTool.isEmpty(keypair.getInstanceIds())) {
            keypairModel.setInstanceIds(keypair.getInstanceIds());
        }
        //创建时间没做存储
        return keypairModel;
    }


    @Override
    public KeypairModel convertModelParams(final Keypair keypair, final String... privateKey) {
        KeypairModel keypairModel = new KeypairModel();
        keypairModel.setName(keypair.getKeyName());
        keypairModel.setFingerprint(keypair.getKeyFingerprint());
        keypairModel.setPrivateKey(privateKey[0]);
        //创建时间没做存储
        return keypairModel;
    }
}
