package com.bocloud.cmp.provider.jdconvertor;

import java.util.ArrayList;
import java.util.List;
import com.bocloud.cmp.model.RegionModel;
import com.bocloud.cmp.model.ZoneModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.google.api.client.util.Lists;
import com.jdcloud.sdk.service.cps.model.Az;
import com.jdcloud.sdk.service.cps.model.Region;

/**
 * 区域转换
 * 
 * @author ymh
 * @时间 2019年1月31日
 */
public class RegionConvertor implements BeanConvertor<RegionModel, Region> {

	@Override
	public List<RegionModel> convertList(List<? extends Region> objects) {
		List<RegionModel> models = Lists.newArrayList();
		for (Region disk : objects) {
			models.add(convertModel(disk));
		}
		return models;
	}

	@Override
	public RegionModel convertModel(Region region) {
		RegionModel model = new RegionModel();
		if (null != region) {
			model.setRegionId(region.getRegion());
			model.setCode(region.getRegion());
			model.setName(region.getRegionName());
			List<Az> azs = region.getAzs();
			if (null != azs && azs.size() > 0) {
				List<ZoneModel> zones = new ArrayList<>();
				ZoneModel zoneModel = null;
				for (Az az : azs) {
					zoneModel = new ZoneModel();
					zoneModel.setName(region.getRegionName() + " " +az.getAzName());
					zoneModel.setRegionId(az.getRegion());
					zoneModel.setZoneId(az.getAz());
					zones.add(zoneModel);
				}
				model.setZones(zones);
			}
		}
		return model;
	}

}
