package com.bocloud.cmp.provider.common;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.KubernetesProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

@Provider("bocloud.cmp.kubernetes")
public class KubernetesAuthProvider extends KubernetesProvider implements AuthProvider {

  public KubernetesAuthProvider(Butler butler) {
    super(butler);
  }

  private static Logger logger = LoggerFactory.getLogger(KubernetesAuthProvider.class);

  @Override
  public boolean accessable() {
    return auth().isSuccess();
  }

  @Override
  public BocloudResult auth() {
    try {
      this.getClient().namespaces().list();
      return new BocloudResult(true, "平台认证成功！");
    } catch (Exception e) {
      logger.error("平台认证失败: " + e.getMessage());
      return new BocloudResult(false, e.getMessage());
    }
  }

}
