package com.bocloud.cmp.provider.convertor;

import java.util.ArrayList;
import java.util.List;

import com.bocloud.cmp.model.kubernetes.NamespaceModel;
import com.bocloud.common.utils.DateTools;

import io.fabric8.kubernetes.api.model.Namespace;
import io.fabric8.kubernetes.api.model.NamespaceStatus;
import io.fabric8.kubernetes.api.model.ObjectMeta;

/**
 * 转换类
 * 
 * @时间 2019年8月21日
 */
public class NamespaceConvertor implements BeanConvertor<NamespaceModel, Namespace> {

	@Override
	public List<NamespaceModel> convertList(List<? extends Namespace> objects) {
		List<NamespaceModel> regionModels = new ArrayList<>();
		for (Namespace object : objects) {
			NamespaceModel convertModel = convertModel(object);
			if (null != convertModel) {
				NamespaceStatus status = object.getStatus();
				if (!"TERMINATING".equalsIgnoreCase(status.getPhase())) {
					regionModels.add(convertModel);
				}
			}
		}
		return regionModels;
	}

	@Override
	public NamespaceModel convertModel(Namespace info) {
		NamespaceModel model = null;
		if (null != info) {
			model = new NamespaceModel();
			model.setKind(info.getKind());
			model.setApiVersion(info.getApiVersion());
			ObjectMeta metadata = info.getMetadata();
			String creationTimestamp = metadata.getCreationTimestamp();
			if (null != creationTimestamp && !"".equals(creationTimestamp)) {
				model.setCreationTime(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", creationTimestamp, "Z"));
			}
			model.setUid(metadata.getUid());
			model.setName(metadata.getName());
			model.setInstanceId(metadata.getUid());
			NamespaceStatus status = info.getStatus();
			model.setStatus(status.getPhase() == null ? null : status.getPhase().toUpperCase());
		}
		return model;
	}
}
