package com.bocloud.cmp.provider.utils;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.yaml.snakeyaml.Yaml;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;

public class CommonUtils {

	private CommonUtils() {
		throw new IllegalStateException("Utility class");
	}

	private static Logger logger = LoggerFactory.getLogger(CommonUtils.class);

	public static String yamlAnalysis(String yamlText) {
		try {
			if (StringUtils.isEmpty(yamlText)) {
				return yamlText;
			}
			Yaml yaml = new Yaml();
			Object result = yaml.load(yamlText);
			JSONObject object = JSON.parseObject(JSON.toJSONString(result));
			JSONObject metadata = object.getJSONObject("metadata");
			if (null == metadata) {
				metadata = new JSONObject();
			}
			String key = "namespace";
			if (!metadata.containsKey(key) || StringUtils.isEmpty(metadata.getString(key))) {
				metadata.put(key, "default");
			}
			return object.toString();
		} catch (Exception e) {
			logger.error("yaml内容解析异常：" + e.getMessage());
			return yamlText;
		}
	}

	public static String getMessage(String message) {
		String msgKey = "Message: ";
		String statusKey = "Received status";
		if (message.contains(msgKey) && message.contains(statusKey)) {
			String substring = message.substring(message.indexOf(msgKey) + msgKey.length(), message.indexOf(statusKey));
			message = substring;
		}
		return message;
	}

}
