package com.bocloud.cmp.kingconvertor;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.model.FlavorModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.ksc.kec.model.AvailabilityZoneInfo;
import com.ksc.kec.model.InstanceTypeConfig;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * 区域转换
 * 
 * @author ymh
 * @时间 2019年9月12日
 */
public class FlavorConvertor implements BeanConvertor<FlavorModel, InstanceTypeConfig> {

    @Override
    public List<FlavorModel> convertList(List<? extends InstanceTypeConfig> objects) {
        List<FlavorModel> regionModels = new ArrayList<>();
        for (InstanceTypeConfig object : objects) {
            regionModels.add(convertModel(object));
        }
        return regionModels;
    }

    @Override
    public FlavorModel convertModel(InstanceTypeConfig info) {
        FlavorModel model = new FlavorModel();
        if (null != info) {
            model.setCpu(info.getCPU());
            model.setFamily(info.getInstanceFamily());
            model.setMemory(new BigDecimal(info.getMemory()));
            model.setFamily(info.getInstanceFamily());
            model.setName(info.getInstanceType());
            model.setFlavorUuid(info.getInstanceType());
            model.setDataDiskMax(info.getDataDiskMax());
            model.setDataDiskMin(info.getDataDiskMin());
            model.setDisk(info.getDataDiskMax());
            List<String> zoneList = new ArrayList<>();
            List<AvailabilityZoneInfo> availabilityZoneSet = info.getAvailabilityZoneSet();
            if (null != availabilityZoneSet && !availabilityZoneSet.isEmpty()) {
                for (AvailabilityZoneInfo availabilityZoneInfo : availabilityZoneSet) {
                    zoneList.add(availabilityZoneInfo.getAzCode());
                }
            }
            model.setZone(JSON.toJSONString(zoneList));
        }
        return model;
    }
}
