package com.bocloud.cmp.kingconvertor;

import com.bocloud.cmp.model.ImageModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;
import com.ksc.kec.model.Image;
import java.util.ArrayList;
import java.util.List;

/**
 * @author ymh
 * @时间 2019年9月12日
 */
public class ImageConvertor implements BeanConvertor<ImageModel, Image> {

    @Override
    public List<ImageModel> convertList(List<? extends Image> objects) {
        List<ImageModel> regionModels = new ArrayList<>();
        for (Image object : objects) {
            regionModels.add(convertModel(object));
        }
        return regionModels;
    }

    @Override
    public ImageModel convertModel(Image info) {
        ImageModel model = new ImageModel();
        if (null != info) {
            model.setImageUuid(info.getImageId());
            String creationTime = info.getCreationDate();
            if (null != creationTime && !"".equals(creationTime)) {
                model.setGmtCreate(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", creationTime, "Z"));
            }
            model.setStatus(info.getImageState() == null ? null : info.getImageState().toUpperCase());
            model.setImageType(info.getIsPublic() ? "PUBLIC" : "PRIVATE");
            model.setName(info.getName());
            model.setMinDisk(Long.parseLong(info.getSysDisk()));
            String platform = info.getPlatform();
            if (null != platform) {
                model.setOsName(platform);
                String[] split = platform.split("-");
                model.setOsType(split[0].toUpperCase());
            }
        }
        return model;
    }

}
