package com.bocloud.cmp.kingconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.KeypairModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.ArrayList;
import java.util.List;

/**
 * 秘钥
 * 
 * @author ymh
 * @时间 2019年9月25日
 */
public class KeypairConvertor implements BeanConvertor<KeypairModel, JSONObject> {

    @Override
    public List<KeypairModel> convertList(List<? extends JSONObject> objects) {
        List<KeypairModel> regionModels = new ArrayList<>();
        for (JSONObject object : objects) {
            regionModels.add(convertModel(object));
        }
        return regionModels;
    }

    @Override
    public KeypairModel convertModel(JSONObject info) {
        KeypairModel model = new KeypairModel();
        if (null != info) {
            model.setFingerprint(info.getString("KeyId"));
            String creationTime = info.getString("CreateTime");
            if (null != creationTime && !"".equals(creationTime)) {
                model.setGmtCreate(DateTools.stringToDateTime(creationTime));
            }
            model.setName(info.getString("KeyName"));
            model.setPublicKey(info.getString("PublicKey"));
        }
        return model;
    }

}
