package com.bocloud.cmp.kingconvertor;

import com.bocloud.cmp.model.VolumeModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;
import com.ksc.kec.model.LocalVolume;
import java.util.ArrayList;
import java.util.List;

/**
 * @author ymh
 * @时间 2019年9月12日
 */
public class LocalVolumeConvertor implements BeanConvertor<VolumeModel, LocalVolume> {

    @Override
    public List<VolumeModel> convertList(List<? extends LocalVolume> objects) {
        List<VolumeModel> models = new ArrayList<>();
        for (LocalVolume object : objects) {
            models.add(convertModel(object));
        }
        return models;
    }

    /**
     * "creationDate":"2019-09-26T14:05:56Z",
     * "instanceId":"f8e14d76-4612-481f-95ed-1b7885326d47",
     * "instanceName":"KSC-IN-D9D3459572", "instanceState":"active",
     * "localVolumeCategory":"system",
     * "localVolumeId":"f8e14d76-4612-481f-95ed-1b7885326d47-a",
     * "localVolumeName":"ksc-f8e14d76-4612-481f-95ed-1b7885326d47-vda",
     * "localVolumeSize":20, "localVolumeState":"attached",
     * "localVolumeType":"SSD"
     */
    @Override
    public VolumeModel convertModel(LocalVolume info) {
        VolumeModel model = new VolumeModel();
        if (null != info) {
            model.setVolumeUuid(info.getLocalVolumeId());
            String createTime = info.getCreationDate();
            if (null != createTime && !"".equals(createTime)) {
                model.setCreateTime(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createTime, "Z"));
            }
            String instanceId = info.getInstanceId();
            if (null != instanceId) {
                model.setInstanceId(instanceId);
            }
            String localVolumeCategory = info.getLocalVolumeCategory();
            model.setCategory(localVolumeCategory);
            if ("system".equalsIgnoreCase(localVolumeCategory)) {
                model.setBootVolume(true);
            } else {
                model.setBootVolume(false);
            }
            model.setDeleteWithInstance(true);
            model.setType(info.getLocalVolumeType());
            model.setName(info.getLocalVolumeName());
            model.setSize(info.getLocalVolumeSize());
            String localVolumeState = info.getLocalVolumeState();
            if (null != localVolumeState && "attached".equalsIgnoreCase(localVolumeState)) {
                model.setStatus("IN_USE");
            } else {
                model.setStatus("AVAILABLE");
            }
            model.setVolumeType("LOCAL"); // 区分本地硬盘 和 云硬盘 CLOUD
        }
        return model;
    }
}
