package com.bocloud.cmp.kingconvertor;

import com.bocloud.cmp.model.RegionModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.ksc.kec.model.Region;

import java.util.ArrayList;
import java.util.List;

/**
 * @author ymh
 * @时间 2019年9月12日
 */
public class RegionConvertor implements BeanConvertor<RegionModel, Region> {

    @Override
    public List<RegionModel> convertList(List<? extends Region> objects) {
        List<RegionModel> regionModels = new ArrayList<>();
        for (Region object : objects) {
            regionModels.add(convertModel(object));
        }
        return regionModels;
    }

    @Override
    public RegionModel convertModel(Region info) {
        RegionModel model = new RegionModel();
        if (null != info) {
            String region = info.getRegion();
            model.setRegionId(region);
            model.setCode(region);
            String regionName = info.getRegionName();
            if (null != regionName && regionName.indexOf("(") > -1) {
                regionName = regionName.substring(0, regionName.indexOf("("));
            }
            model.setName(regionName);
        }
        return model;
    }
}
