package com.bocloud.cmp.kingconvertor;

import com.bocloud.cmp.model.SnapshotModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.ksc.kec.model.LocalVolumeSnapshot;

import java.util.ArrayList;
import java.util.List;

/**
 * @author ymh
 * @时间 2019年9月12日
 */
public class SnapshotConvertor implements BeanConvertor<SnapshotModel, LocalVolumeSnapshot> {

    @Override
    public List<SnapshotModel> convertList(List<? extends LocalVolumeSnapshot> objects) {
        List<SnapshotModel> regionModels = new ArrayList<SnapshotModel>();
        for (LocalVolumeSnapshot object : objects) {
            regionModels.add(convertModel(object));
        }
        return regionModels;
    }

    @Override
    public SnapshotModel convertModel(LocalVolumeSnapshot info) {
        SnapshotModel model = new SnapshotModel();
        if (null != info) {
            model.setSnapshotUuid(info.getLocalVolumeSnapshotId());
            model.setRemark(info.getLocalVolumeSnapshotDesc());
            model.setVolumeUuid(info.getSourceLocalVolumeId());
            model.setStatus(info.getState() == null ? null : info.getState().toUpperCase());
            model.setVolumeType("LOCAL");
        }
        return model;
    }

}
