package com.bocloud.cmp.kingconvertor;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.model.SubnetModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;
import com.ksc.network.vpc.model.subnet.Subnet;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

/**
 * @author ymh
 * @时间 2019年9月12日
 */
public class SubnetConvertor implements BeanConvertor<SubnetModel, Subnet> {

    @Override
    public List<SubnetModel> convertList(List<? extends Subnet> objects) {
        List<SubnetModel> models = new ArrayList<SubnetModel>();
        for (Subnet object : objects) {
            models.add(convertModel(object));
        }
        return models;
    }

    @Override
    public SubnetModel convertModel(Subnet info) {
        SubnetModel model = new SubnetModel();
        if (null != info) {
            model.setSubnetUuid(info.getSubnetId());
            model.setCidr(info.getCidrBlock());
            model.setGateway(info.getGatewayIp());
            String dhcpIpFrom = info.getDhcpIpFrom();
            String dhcpIpTo = info.getDhcpIpTo();
            model.setIpPools(JSON.toJSONString(new String[] { dhcpIpFrom + "-" + dhcpIpTo }));
            model.setName(info.getSubnetName());
            model.setVpcUuid(info.getVpcId());
            String creationTime = info.getCreateTime();
            if (null != creationTime && !"".equals(creationTime)) {
                model.setGmtCreate(DateTools.stringToDateTime(creationTime));
            }
            List<String> dnsList = new ArrayList<>();
            String dns1 = info.getDns1();
            if (StringUtils.isNotEmpty(dns1)) {
                dnsList.add(dns1);
            }
            String dns2 = info.getDns2();
            if (StringUtils.isNotEmpty(dns2)) {
                dnsList.add(dns2);
            }
            model.setDnsNames(JSON.toJSONString(dnsList));
            model.setZone(info.getAvailabilityZoneName());
        }
        return model;
    }
}
