package com.bocloud.cmp.kingconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.VolumeModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;
import java.util.ArrayList;
import java.util.List;

/**
 * @author ymh
 * @时间 2019年9月12日
 */
public class VolumeConvertor implements BeanConvertor<VolumeModel, JSONObject> {

    @Override
    public List<VolumeModel> convertList(List<? extends JSONObject> objects) {
        List<VolumeModel> models = new ArrayList<VolumeModel>();
        for (JSONObject object : objects) {
            models.add(convertModel(object));
        }
        return models;
    }

    @Override
    public VolumeModel convertModel(JSONObject info) {
        VolumeModel model = new VolumeModel();
        if (null != info) {
            model.setVolumeUuid(info.getString("VolumeId"));
            model.setName(info.getString("VolumeName"));
            model.setSize(info.getInteger("Size"));
            String status = info.getString("VolumeStatus") == null ? null
                    : info.getString("VolumeStatus").toUpperCase();
            model.setStatus(status);
            model.setType(info.getString("VolumeType"));
            model.setCategory(info.getString("VolumeCategory"));
            model.setInstanceId(info.getString("InstanceId"));
            model.setZone(info.getString("AvailabilityZone"));
            model.setRemark(info.getString("VolumeDesc"));
            String creationTime = info.getString("CreateTime");
            if (null != creationTime && !"".equals(creationTime)) {
                model.setCreateTime(DateTools.stringToDateTime(creationTime));
            }
            model.setVolumeType("CLOUD"); // 金山云硬盘 分为本地 和 云硬盘 CLOUD云硬盘 LOCAL本地硬盘
            String attachment = info.getString("Attachment");
            List<JSONObject> attachmentList = JSONObject.parseArray(attachment, JSONObject.class);
            if (null != attachmentList && attachmentList.size() > 0) {
                JSONObject jsonObject = attachmentList.get(0);
                model.setDeviceName(jsonObject.getString("MountPoint"));
                model.setDeleteWithInstance(jsonObject.getBoolean("DeleteWithInstance"));
            }
        }
        return model;
    }
}
