package com.bocloud.cmp.kingconvertor;

import com.bocloud.cmp.model.VpcModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;
import com.ksc.network.vpc.model.vpc.Vpc;
import java.util.ArrayList;
import java.util.List;

/**
 * @author ymh
 * @时间 2019年9月12日
 */
public class VpcConvertor implements BeanConvertor<VpcModel, Vpc> {

    @Override
    public List<VpcModel> convertList(List<? extends Vpc> objects) {
        List<VpcModel> models = new ArrayList<VpcModel>();
        for (Vpc object : objects) {
            models.add(convertModel(object));
        }
        return models;
    }

    @Override
    public VpcModel convertModel(Vpc info) {
        VpcModel model = new VpcModel();
        if (null != info) {
            model.setCidr(info.getCidrBlock());
            model.setDefaultVpc(info.getDefault());
            model.setVpcId(info.getVpcId());
            model.setName(info.getVpcName());
            String creationTime = info.getCreateTime();
            if (null != creationTime && !"".equals(creationTime)) {
                model.setGmtCreate(DateTools.stringToDateTime(creationTime));
            }
            model.setStatus("ACTIVE");
        }
        return model;
    }
}
