package com.bocloud.cmp.kingconvertor;

import com.bocloud.cmp.model.ZoneModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.ksc.kec.model.AvailabilityZone;
import java.util.ArrayList;
import java.util.List;

/**
 * @author ymh
 * @时间 2019年9月12日
 */
public class ZoneConvertor implements BeanConvertor<ZoneModel, AvailabilityZone> {

    @Override
    public List<ZoneModel> convertList(List<? extends AvailabilityZone> objects) {
        List<ZoneModel> models = new ArrayList<ZoneModel>();
        for (AvailabilityZone object : objects) {
            models.add(convertModel(object));
        }
        return models;
    }

    @Override
    public ZoneModel convertModel(AvailabilityZone info) {
        ZoneModel model = new ZoneModel();
        if (null != info) {
            String zoneName = info.getAvailabilityZone();
            if (null != zoneName && !"".equals(zoneName)) {
                model.setZoneId(zoneName);
                // TODO 有待完善
                if (zoneName.endsWith("a") || zoneName.endsWith("1")) {
                    model.setName("可用区1");
                } else if (zoneName.endsWith("b") || zoneName.endsWith("2")) {
                    model.setName("可用区2");
                } else if (zoneName.endsWith("c") || zoneName.endsWith("3")) {
                    model.setName("可用区3");
                } else if (zoneName.endsWith("d") || zoneName.endsWith("4")) {
                    model.setName("可用区4");
                } else if (zoneName.endsWith("e") || zoneName.endsWith("5")) {
                    model.setName("可用区5");
                } else if (zoneName.endsWith("f") || zoneName.endsWith("6")) {
                    model.setName("可用区6");
                } else if (zoneName.endsWith("g") || zoneName.endsWith("7")) {
                    model.setName("可用区7");
                } else if (zoneName.endsWith("h") || zoneName.endsWith("8")) {
                    model.setName("可用区8");
                } else {
                    model.setName(zoneName);
                }
            }
            model.setRegionId(info.getRegion());
        }
        return model;
    }
}
