package com.bocloud.cmp.common.model;

import java.util.Date;
import java.util.List;

import com.alibaba.fastjson.annotation.JSONField;

/**
 * 华为manage one会话Token
 * 
 * @author wangyu
 * @version 1.0
 * @since 2018年9月16日
 *
 */
public class ManageOneToken {

	private String token;
	@JSONField(format = "yyyy-MM-dd'T'HH:mm:ss.SSS")
	private Date expiresAt;
	private List<String> methods;
	private List<ManageOneCatalog> catalog;
	private List<ManageOneRole> roles;
	private ManageOneProject project;
	@JSONField(format = "yyyy-MM-dd'T'HH:mm:ss.SSS")
	private Date issuedAt;
	private ManageOneUser user;

	/**
	 * 
	 */
	public ManageOneToken() {
		super();
	}

	/**
	 * @param token
	 * @param expiresAt
	 * @param methods
	 * @param catalog
	 * @param roles
	 * @param project
	 * @param issuedAt
	 * @param user
	 */
	public ManageOneToken(String token, Date expiresAt, List<String> methods, List<ManageOneCatalog> catalog,
			List<ManageOneRole> roles, ManageOneProject project, Date issuedAt, ManageOneUser user) {
		super();
		this.token = token;
		this.expiresAt = expiresAt;
		this.methods = methods;
		this.catalog = catalog;
		this.roles = roles;
		this.project = project;
		this.issuedAt = issuedAt;
		this.user = user;
	}

	/**
	 * @return the token
	 */
	public String getToken() {
		return token;
	}

	/**
	 * @param token
	 *            the token to set
	 */
	public void setToken(String token) {
		this.token = token;
	}

	/**
	 * @return the expiresAt
	 */
	@JSONField(format = "yyyy-MM-dd HH:mm:ss")
	public Date getExpiresAt() {
		return expiresAt;
	}

	/**
	 * @param expiresAt
	 *            the expiresAt to set
	 */
	public void setExpiresAt(Date expiresAt) {
		this.expiresAt = expiresAt;
	}

	/**
	 * @return the methods
	 */
	public List<String> getMethods() {
		return methods;
	}

	/**
	 * @param methods
	 *            the methods to set
	 */
	public void setMethods(List<String> methods) {
		this.methods = methods;
	}

	/**
	 * @return the catalog
	 */
	public List<ManageOneCatalog> getCatalog() {
		return catalog;
	}

	/**
	 * @param catalog
	 *            the catalog to set
	 */
	public void setCatalog(List<ManageOneCatalog> catalog) {
		this.catalog = catalog;
	}

	/**
	 * @return the roles
	 */
	public List<ManageOneRole> getRoles() {
		return roles;
	}

	/**
	 * @param roles
	 *            the roles to set
	 */
	public void setRoles(List<ManageOneRole> roles) {
		this.roles = roles;
	}

	/**
	 * @return the project
	 */
	public ManageOneProject getProject() {
		return project;
	}

	/**
	 * @param project
	 *            the project to set
	 */
	public void setProject(ManageOneProject project) {
		this.project = project;
	}

	/**
	 * @return the issuedAt
	 */
	@JSONField(format = "yyyy-MM-dd HH:mm:ss")
	public Date getIssuedAt() {
		return issuedAt;
	}

	/**
	 * @param issuedAt
	 *            the issuedAt to set
	 */
	public void setIssuedAt(Date issuedAt) {
		this.issuedAt = issuedAt;
	}

	/**
	 * @return the user
	 */
	public ManageOneUser getUser() {
		return user;
	}

	/**
	 * @param user
	 *            the user to set
	 */
	public void setUser(ManageOneUser user) {
		this.user = user;
	}

}
