package com.bocloud.cmp.manageoneconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.FirewallModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.ListTool;

import java.util.ArrayList;
import java.util.List;

/**
 * 防火墙转换类
 * 
 * @author admin
 *
 */
public class FirewallConvertor implements BeanConvertor<FirewallModel, JSONObject> {

	@Override
	public List<FirewallModel> convertList(List<? extends JSONObject> models) {
		List<FirewallModel> flavorModels = new ArrayList<FirewallModel>();
		for (JSONObject model : models) {
			flavorModels.add(convertModel(model));
		}
		return flavorModels;
	}

	@Override
	public FirewallModel convertModel(JSONObject model) {
		FirewallModel firewallModel = new FirewallModel();
		if (null != model) {
			firewallModel.setFirewallUuid(model.getString("id"));
			firewallModel.setName(model.getString("name"));
			firewallModel.setStatus(model.getString("status"));
			firewallModel.setAdminStateUp(model.getBoolean("admin_state_up"));
			firewallModel.setPolicyUuid(model.getString("firewall_policy_id"));
			firewallModel.setTenantUuid(model.getString("tenant_id"));
			List<String> parseArray = JSONObject.parseArray(model.getString("router_ids"), String.class);
			if (!ListTool.isEmpty(parseArray)) {
				firewallModel.setRouterUuids(parseArray);
			}
			String description = model.getString("description");
			try {
				JSONObject descriptionObject = JSONObject.parseObject(description);
				if (null != descriptionObject) {
					firewallModel.setRemark(descriptionObject.getString("description"));
					firewallModel.setRegionId(descriptionObject.getString("region_id"));
				}
			} catch (Exception e) {
				firewallModel.setRemark(description);
			}
		}
		return firewallModel;
	}
}
