package com.bocloud.cmp.manageoneconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.FirewallPolicyModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.ListTool;

import java.util.ArrayList;
import java.util.List;

/**
 * 防火墙策略转换类
 * 
 * @author admin
 *
 */
public class FirewallPolicyConvertor implements BeanConvertor<FirewallPolicyModel, JSONObject> {

	@Override
	public List<FirewallPolicyModel> convertList(List<? extends JSONObject> models) {
		List<FirewallPolicyModel> flavorModels = new ArrayList<FirewallPolicyModel>();
		for (JSONObject model : models) {
			flavorModels.add(convertModel(model));
		}
		return flavorModels;
	}

	@Override
	public FirewallPolicyModel convertModel(JSONObject model) {
		FirewallPolicyModel firewallPolicyModel = new FirewallPolicyModel();
		if (null != model) {
			firewallPolicyModel.setTenantUuid(model.getString("tenant_id"));
			firewallPolicyModel.setShared(model.getBoolean("shared"));
			firewallPolicyModel.setName(model.getString("name"));
			firewallPolicyModel.setRemark(model.getString("description"));
			firewallPolicyModel.setPolicyUuid(model.getString("id"));
			firewallPolicyModel.setAudited(model.getBoolean("audited"));
			List<String> rules = JSONObject.parseArray(model.getString("firewall_rules"), String.class);
			if (!ListTool.isEmpty(rules)) {
				firewallPolicyModel.setRuleUuids(rules);
			}
		}
		return firewallPolicyModel;
	}
}
