package com.bocloud.cmp.manageoneconvertor;

import java.util.ArrayList;
import java.util.List;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.ClusterModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

/**
 * @Date: Created in 2018/9/20
 * @Author: guopeng
 * @Description:
 */
public class HostAggregateConvertor implements BeanConvertor<ClusterModel, JSONObject> {
	@Override
	public List<ClusterModel> convertList(List<? extends JSONObject> models) {
		List<ClusterModel> clusterModels = new ArrayList<ClusterModel>();
		for (JSONObject model : models) {
			clusterModels.add(convertModel(model));
		}
		return clusterModels;
	}

	@Override
	public ClusterModel convertModel(JSONObject model) {
		ClusterModel clusterModel = new ClusterModel();
		clusterModel.setUuid(model.getString("id"));
		clusterModel.setName(model.getString("name"));
		clusterModel.setPolicies(JSONArray.parseArray(model.getString("policies"), String.class));
		clusterModel.setHostNames(JSONArray.parseArray(model.getString("members"), String.class));
		clusterModel.setRemark(JSONObject.toJSONString(model.getJSONObject("metadata")));
		return clusterModel;
	}
}
