package com.bocloud.cmp.manageoneconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.NetworkModel;
import com.bocloud.cmp.model.SubnetModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * @Date: Created in 2018/9/19
 * @Author: guopeng
 * @Description:
 */
public class NetworkConvertor implements BeanConvertor<NetworkModel, JSONObject> {

    @Override
    public List<NetworkModel> convertList(List<? extends JSONObject> models) {
        List<NetworkModel> networkModels = new ArrayList<NetworkModel>();
        for (JSONObject model : models) {
            networkModels.add(convertModel(model));
        }
        return networkModels;
    }

    @Override
    public NetworkModel convertModel(JSONObject model) {
        NetworkModel networkModel = new NetworkModel();
        networkModel.setStatus(model.getString("status"));

        List<String> subnets = JSONArray.parseArray(model.getString("subnets"), String.class);
        List<SubnetModel> subnetModels = new ArrayList<>();
        if (subnets.size() != 0) {
            for (int i = 0; i < subnets.size(); i++) {
                SubnetModel subnetModel = new SubnetModel();
                subnetModel.setSubnetUuid(subnets.get(i));
                subnetModels.add(subnetModel);
            }
        }
        networkModel.setSubnets(subnetModels);
        networkModel.setIsRouterExternal(model.getBoolean("router:external"));
        networkModel.setShared(model.getBoolean("shared"));
        networkModel.setName(model.getString("name"));
        networkModel.setAdminStateup(model.getBoolean("admin_state_up"));
        networkModel.setTenant(model.getString("tenant_id"));
        networkModel.setNetworkUuid(model.getString("id"));

        return networkModel;
    }
}
