package com.bocloud.cmp.manageoneconvertor;

import java.util.ArrayList;
import java.util.List;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.ManageOneProjectModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

/**
 * 项目转换类
 * 
 * @author admin
 *
 */
public class ProjectConvertor implements BeanConvertor<ManageOneProjectModel, JSONObject> {

	@Override
	public List<ManageOneProjectModel> convertList(List<? extends JSONObject> objects) {
		List<ManageOneProjectModel> manageOneProjectModels = new ArrayList<ManageOneProjectModel>();
		for (JSONObject object : objects) {
			manageOneProjectModels.add(convertModel(object));
		}
		return manageOneProjectModels;
	}

	@Override
	public ManageOneProjectModel convertModel(JSONObject object) {
		ManageOneProjectModel model = new ManageOneProjectModel();
		if (null != object) {
			model.setProjectUuid(object.getString("id"));
			model.setName(object.getString("name"));
			model.setDomainId(object.getString("domain_id"));
			model.setDescription(object.getString("description"));
			model.setEnabled(object.getBoolean("enabled"));
		}
		return model;
	}
}
