package com.bocloud.cmp.manageoneconvertor;

import java.util.ArrayList;
import java.util.List;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.StorageModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

/**
 * 存储池转换类
 * 
 * @author admin
 *
 */
public class StoragePoolConvertor implements BeanConvertor<StorageModel, JSONObject> {

	@Override
	public List<StorageModel> convertList(List<? extends JSONObject> objects) {
		List<StorageModel> storageModels = new ArrayList<StorageModel>();
		for (JSONObject object : objects) {
			storageModels.add(convertModel(object));
		}
		return storageModels;
	}

	@Override
	public StorageModel convertModel(JSONObject object) {
		StorageModel model = new StorageModel();
		if (null != object) {
			// 接口返回值没有uuid 暂时使用name
			model.setStorageUuid(object.getString("name"));
			JSONObject capabilities = JSONObject.parseObject(object.getString("capabilities"), JSONObject.class);
			model.setName(capabilities.getString("volume_backend_name"));
			model.setPoolName(capabilities.getString("pool_name"));
			double totalCapacityGb = capabilities.getDoubleValue("total_capacity_gb");
			model.setTotalCapacity(totalCapacityGb);
			double provisionedCapacityGb = capabilities.getDoubleValue("provisioned_capacity_gb");
			model.setUsedCapacity(provisionedCapacityGb);
			model.setFreeCapaticy(totalCapacityGb - provisionedCapacityGb);

			model.setHddTotalCapacity(totalCapacityGb);
			double freeCapacityGb = capabilities.getDoubleValue("free_capacity_gb");
			model.setHddFreeCapaticy(freeCapacityGb);
			model.setHddUsedCapacity(totalCapacityGb - freeCapacityGb);
			model.setType(capabilities.getString("type"));
		}
		return model;
	}
}
