package com.bocloud.cmp.manageoneconvertor;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.manageone.VdcModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

/**
 * vdc数据转换器
 * 
 * @author wangyu
 * @version 1.0
 * @since 2020年6月17日
 *
 */
public class VdcConvertor implements BeanConvertor<VdcModel, JSONObject> {

	@Override
	public List<VdcModel> convertList(List<? extends JSONObject> models) {
		List<VdcModel> vdcModels = new ArrayList<>();
		for (JSONObject model : models) {
			vdcModels.add(convertModel(model));
		}
		return vdcModels;
	}

	@Override
	public VdcModel convertModel(JSONObject model) {
		VdcModel vdcModel = new VdcModel();
		if(null == model) {
			return vdcModel;
		}
		vdcModel.setCreateUserId(model.getString("create_user_id"));
		vdcModel.setUpperVdcId(model.getString("upper_vdc_id"));
		vdcModel.setCreateUserName(model.getString("create_user_name"));
		vdcModel.setLevel(model.getInteger("level"));
		vdcModel.setRemark(model.getString("description"));
		vdcModel.setEnabled(model.getBoolean("enabled"));
		vdcModel.setDomainId(model.getString("domain_id"));
		vdcModel.setDomainName(model.getString("domain_name"));
		vdcModel.setName(model.getString("name"));
		vdcModel.setVdcId(model.getString("id"));
		vdcModel.setTag(model.getString("tag"));
		vdcModel.setCreateAt(new Date(model.getLong("create_at")));
		vdcModel.setThirdType(model.getString("third_type"));
		return vdcModel;
	}

}
