package com.bocloud.cmp.manageoneconvertor;

import java.util.ArrayList;
import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.VolumeTypeModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

public class VolumeTypeConvertor implements BeanConvertor<VolumeTypeModel, JSONObject> {

	@Override
	public List<VolumeTypeModel> convertList(List<? extends JSONObject> objects) {
		List<VolumeTypeModel> volumeTypeModels = new ArrayList<VolumeTypeModel>();
		for (JSONObject object : objects) {
			volumeTypeModels.add(convertModel(object));
		}
		return volumeTypeModels;
	}

	@Override
	public VolumeTypeModel convertModel(JSONObject jsonObject) {
		VolumeTypeModel volumeTypeModel = new VolumeTypeModel();
		volumeTypeModel.setVolumeTypeUuid(jsonObject.getString("id"));
		volumeTypeModel.setName(jsonObject.getString("name"));
		volumeTypeModel.setExtraSpecs(jsonObject.getString("extra_specs"));
		return volumeTypeModel;
	}

}
