package com.bocloud.cmp.manageoneconvertor;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.VpcModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

/**
 * vpc 转换
 * 
 * @author admin
 *
 */
public class VpcConvertor implements BeanConvertor<VpcModel, JSONObject> {

	@Override
	public List<VpcModel> convertList(List<? extends JSONObject> objects) {
		List<VpcModel> imageModels = new ArrayList<VpcModel>();
		for (JSONObject object : objects) {
			imageModels.add(convertModel(object));
		}
		return imageModels;
	}

	@Override
	public VpcModel convertModel(JSONObject object) {
		VpcModel model = new VpcModel();
		String status = object.getString("status");
		if (!StringUtils.isEmpty(status) && "ok".equalsIgnoreCase(status)) {
			status = "ACTIVE";
		}
		model.setStatus(status);
		model.setName(object.getString("name"));
		model.setTenantUuid(object.getString("project_id"));
		model.setVpcId(object.getString("id"));
		if (object.containsKey("external_gateway_info")) {
			JSONObject externalGatewayInfo = object.getJSONObject("external_gateway_info");
			model.setNetworkUuid(externalGatewayInfo.getString("network_id"));
			model.setEnableSnat(externalGatewayInfo.getBoolean("enable_snat"));
		}
		return model;
	}
}
