package com.bocloud.cmp.provider.listener;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.ManageOneClientFactory;

/**
 * manage one云供应商监听器，用来实时监听缓存的butler信息
 *
 * @author wangyu
 * @version 4.1.0-SNAPSHOT
 * @since 2018/11/21
 */
public class ManageOneButlerListener implements ButlerEventListener {

	private String code;

	public ManageOneButlerListener(String code) {
		this.code = code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	@Override
	public String getCode() {
		return code;
	}

	@Override
	public void onRemoved(Butler butler) {
		ManageOneClientFactory.getInstance().removeToken(butler.getUuid());
	}

	@Override
	public void onChanged(Butler butler) {
		ManageOneClientFactory.getInstance().updateToken(butler);
	}
}
