package com.bocloud.cmp.provider.convertor;

import java.util.List;

import org.openstack4j.model.network.ext.Firewall;

import com.bocloud.cmp.model.FirewallModel;
import com.bocloud.cmp.provider.utils.StatusConverter;
import com.google.common.collect.Lists;

/**
 * Openstack防火墙数据转换器
 *
 * @author weiwei
 */
public class FirewallConvertor implements BeanConvertor<FirewallModel, Firewall> {

    @Override
    public List<FirewallModel> convertList(List<? extends Firewall> firewalls) {
        List<FirewallModel> models = Lists.newArrayList();
        for (Firewall firewall : firewalls) {
            models.add(convertModel(firewall));
        }
        return models;
    }

    @Override
    public FirewallModel convertModel(Firewall firewall) {
        FirewallModel model = new FirewallModel();
        model.setFirewallUuid(firewall.getId());
        model.setName(firewall.getName());
        model.setRemark(firewall.getDescription());
        model.setPolicyUuid(firewall.getPolicy());
        model.setStatus(StatusConverter.Network.converter(firewall.getStatus().name()));
        model.setTenantUuid(firewall.getTenantId());
        model.setShared(firewall.isShared());
        model.setAdminStateUp(firewall.isAdminStateUp());
        model.setRouterUuids(firewall.getRouterIds());
        return model;
    }

}
