package com.bocloud.cmp.provider.convertor;

import java.util.List;

import org.openstack4j.model.network.ext.FirewallRule;

import com.bocloud.cmp.model.FirewallRuleModel;
import com.google.common.collect.Lists;

/**
 * Openstack防火墙规则数据转换器
 * 
 * @author weiwei
 *
 */
public class FirewallRuleConvertor implements BeanConvertor<FirewallRuleModel, FirewallRule> {

	@Override
	public List<FirewallRuleModel> convertList(List<? extends FirewallRule> firewallRules) {
		List<FirewallRuleModel> models = Lists.newArrayList();
		for (FirewallRule firewallRule : firewallRules) {
			models.add(convertModel(firewallRule));
		}
		return models;
	}

	@Override
	public FirewallRuleModel convertModel(FirewallRule firewallRule) {
		FirewallRuleModel model = new FirewallRuleModel();
		model.setRuleUuid(firewallRule.getId());
		model.setName(firewallRule.getName());
		model.setTenantUuid(firewallRule.getTenantId());
		model.setRemark(firewallRule.getDescription());
		model.setPolicyUuid(firewallRule.getPolicy());
		model.setShared(firewallRule.isShared());
		model.setProtocol(null == firewallRule.getProtocol() ? null : firewallRule.getProtocol().name());
		model.setIpVersion(null == firewallRule.getIpVersion() ? null : firewallRule.getIpVersion().name());
		model.setSourceIp(firewallRule.getSourceIpAddress());
		model.setDestIp(firewallRule.getDestinationIpAddress());
		model.setSourcePort(firewallRule.getSourcePort());
		model.setDestPort(firewallRule.getDestinationPort());
		model.setPosition(firewallRule.getPosition());
		model.setAction(firewallRule.getAction().name());
		model.setEnabled(firewallRule.isEnabled());
		return model;
	}

}
