package com.bocloud.cmp.provider.convertor;

import java.util.List;

import org.openstack4j.model.network.NetFloatingIP;

import com.bocloud.cmp.model.FloatingIpModel;
import com.bocloud.cmp.provider.utils.StatusConverter;
import com.google.common.collect.Lists;

/**
 * OpenStack浮动IP数据转换器
 *
 * @author wangyu
 * @version 1.0
 * @since 2017年8月28日
 */
public class FloatingIpConvertor implements BeanConvertor<FloatingIpModel, NetFloatingIP> {

    @Override
    public List<FloatingIpModel> convertList(List<? extends NetFloatingIP> netFloatingIPs) {
        List<FloatingIpModel> models = Lists.newArrayList();
        for (NetFloatingIP netFloatingIP : netFloatingIPs) {
            models.add(convertModel(netFloatingIP));
        }
        return models;
    }

    @Override
    public FloatingIpModel convertModel(NetFloatingIP netFloatingIP) {
        FloatingIpModel model = new FloatingIpModel();
        model.setFloatingIpUuid(netFloatingIP.getId());
        model.setRouterUuid(netFloatingIP.getRouterId());
        model.setTenantUuid(netFloatingIP.getTenantId());
        model.setFloatingNetworkUuid(netFloatingIP.getFloatingNetworkId());
        model.setFloatingIpAddress(netFloatingIP.getFloatingIpAddress());
        model.setFixedIpAddress(netFloatingIP.getFixedIpAddress());
        model.setPortUuid(netFloatingIP.getPortId());
        model.setStatus(StatusConverter.Network.converter(netFloatingIP.getStatus()));
        return model;
    }

}
