package com.bocloud.cmp.provider.convertor;

import java.util.List;

import org.openstack4j.model.compute.Keypair;

import com.bocloud.cmp.model.KeypairModel;
import com.google.common.collect.Lists;

/**
 * Openstack秘钥据转换器
 * 
 * @author weiwei
 *
 */
public class KeypairConvertor implements BeanConvertor<KeypairModel, Keypair> {

	@Override
	public List<KeypairModel> convertList(List<? extends Keypair> keypairs) {
		List<KeypairModel> keypairModels = Lists.newArrayList();
		for (Keypair keypair : keypairs) {
			keypairModels.add(convertModel(keypair));
		}
		return keypairModels;
	}

	@Override
	public KeypairModel convertModel(Keypair keypair) {
		if (null == keypair) {
			return null;
		}
		KeypairModel model = new KeypairModel();
		model.setName(keypair.getName());
		model.setFingerprint(keypair.getFingerprint());
		model.setPublicKey(keypair.getPublicKey());
		model.setPrivateKey(keypair.getPrivateKey());
		if (null != keypair.getUserId()) {
			model.setUserUuid(keypair.getUserId());
		}
		if (null != keypair.getCreatedAt()) {
			model.setGmtCreate(keypair.getCreatedAt());// 密钥的创建时间
		}
		return model;
	}
}
