package com.bocloud.cmp.provider.convertor;

import java.util.List;

import org.openstack4j.model.network.ext.ListenerV2;

import com.bocloud.cmp.model.LbListenerModel;
import com.google.common.collect.Lists;

/**
 * OpenStack负载均衡数据listener转换器
 *
 * @author weiwei
 */
public class LbListenerConvertor implements BeanConvertor<LbListenerModel, ListenerV2> {

    @Override
    public List<LbListenerModel> convertList(List<? extends ListenerV2> listeners) {
        List<LbListenerModel> models = Lists.newArrayList();
        for (ListenerV2 listener : listeners) {
            models.add(convertModel(listener));
        }
        return models;
    }

    @Override
    public LbListenerModel convertModel(ListenerV2 listener) {
        LbListenerModel model = new LbListenerModel();
        model.setListenerUuid(listener.getId());
        model.setName(listener.getName());
        model.setConnLimit(listener.getConnectionLimit());
        model.setDefaultPoolUuid(listener.getDefaultPoolId());
        model.setRemark(listener.getDescription());
        model.setProtocol(listener.getProtocol().name());
        model.setPort(listener.getProtocolPort());
        model.setTenantUuid(listener.getTenantId());
        model.setAdminStateUp(listener.isAdminStateUp());
        model.setDefTlsContainerRef(listener.getDefaultTlsContainerRef());
        model.setSnicontainerRefs(listener.getSniContainerRefs());
        return model;
    }
}
