package com.bocloud.cmp.provider.convertor;

import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.GwQosModel;
import com.bocloud.common.utils.DateTools;
import com.google.common.collect.Lists;

/**
 * qos policy convertor
 * 
 * @author ymh
 * @时间 2019年11月12日
 */
public class QosPolicyConvertor implements BeanConvertor<GwQosModel, JSONObject> {

    @Override
    public List<GwQosModel> convertList(List<? extends JSONObject> models) {
        List<GwQosModel> gwQosModels = Lists.newArrayList();
        for (JSONObject model : models) {
            gwQosModels.add(convertModel(model));
        }
        return gwQosModels;
    }

    @Override
    public GwQosModel convertModel(JSONObject object) {
        GwQosModel model = new GwQosModel();
        if (null != object) {
            model.setPolicyUuid(object.getString("id"));
            model.setName(object.getString("name"));
            model.setRemark(object.getString("description"));
            model.setIsDefault(object.getBoolean("is_default"));
            model.setRevisionNumber(object.getInteger("revision_number"));
            model.setShared(object.getBoolean("shared"));
            model.setTags(object.getString("tags"));
            String createdAt = object.getString("created_at");
            if (null != createdAt && !"".equals(createdAt)) {
                model.setCreatedAt(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdAt, "Z"));
            }
            String updatedAt = object.getString("updated_at");
            if (null != updatedAt && !"".equals(updatedAt)) {
                model.setUpdatedAt(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", updatedAt, "Z"));
            }
            String projectId = object.getString("project_id");
            if (null != projectId) {
                model.setTenantUuid(projectId);
            }
        }
        return model;
    }
}
