package com.bocloud.cmp.provider.convertor;

import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.GwQosModel;
import com.google.common.collect.Lists;

/**
 * qos rule convertor
 * 
 * @author ymh
 * @时间 2019年11月12日
 */
public class QosRuleConvertor implements BeanConvertor<GwQosModel, JSONObject> {

    @Override
    public List<GwQosModel> convertList(List<? extends JSONObject> models) {
        List<GwQosModel> gwQosModels = Lists.newArrayList();
        for (JSONObject model : models) {
            gwQosModels.add(convertModel(model));
        }
        return gwQosModels;
    }

    @Override
    public GwQosModel convertModel(JSONObject jsonObject) {
        GwQosModel model = new GwQosModel();
        if (null != jsonObject) {
            model.setRuleUuid(jsonObject.getString("id"));
            model.setMaxBurstKbps(jsonObject.getInteger("max_burst_kbps") == null ? null
                    : jsonObject.getInteger("max_burst_kbps") / 1000);
            model.setMaxKbps(
                    jsonObject.getInteger("max_kbps") == null ? null : jsonObject.getInteger("max_kbps") / 1000);
            model.setDirection(jsonObject.getString("direction"));
        }
        return model;
    }
}
