package com.bocloud.cmp.provider.convertor;

import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.openstack4j.model.storage.block.VolumeSnapshot;

import com.bocloud.cmp.model.SnapshotModel;
import com.google.common.collect.Lists;

/**
 * Openstack快照数据转换器
 * 
 * @author weiwei
 *
 */
public class SnapshotConvertor implements BeanConvertor<SnapshotModel, VolumeSnapshot> {

	@Override
	public List<SnapshotModel> convertList(List<? extends VolumeSnapshot> snapshots) {
		List<SnapshotModel> models = Lists.newArrayList();
		for (VolumeSnapshot snapshot : snapshots) {
			models.add(convertModel(snapshot));
		}
		return models;
	}

	@SuppressWarnings("deprecation")
	@Override
	public SnapshotModel convertModel(VolumeSnapshot snapshot) {
		if (null == snapshot) {
			return null;
		}
		SnapshotModel model = new SnapshotModel();
		String name = snapshot.getName();
		if (StringUtils.isEmpty(name)) {
			name = snapshot.getDisplayName();
		}
		model.setName(name);
		model.setSize(snapshot.getSize());
		model.setSnapshotUuid(snapshot.getId());
		model.setVolumeUuid(snapshot.getVolumeId());
		model.setRemark(snapshot.getDescription());
		if ("CREATING" == snapshot.getStatus().name()) {
			model.setStatus("BUILDING");
		} else {
			model.setStatus(snapshot.getStatus().name());
		}
		model.setCreateTime(snapshot.getCreated());
		return model;
	}
}
