package com.bocloud.cmp.provider.convertor;

import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.VpnConnModel;
import com.google.common.collect.Lists;

/**
 * vpn转换器
 * 
 * @author Administrator
 *
 */
public class VpnConnConvertor implements BeanConvertor<VpnConnModel, JSONObject> {

	@Override
	public List<VpnConnModel> convertList(List<? extends JSONObject> objects) {
		List<VpnConnModel> vpnConnModels = Lists.newArrayList();
		for (JSONObject object : objects) {
			vpnConnModels.add(convertModel(object));
		}
		return vpnConnModels;
	}

	@Override
	public VpnConnModel convertModel(JSONObject object) {
		if (null == object) {
			return null;
		}
		VpnConnModel model = new VpnConnModel();
		String status = object.getString("status");
		if (null != status && "ACTIVE".equalsIgnoreCase(status)) {
			model.setStatus("RUNNING");
		} else {
			model.setStatus(status);
		}
		model.setPsk(object.getString("psk"));
		model.setInitiator(object.getString("initiator"));
		model.setName(object.getString("name"));
		model.setAdminStateUp(object.getBoolean("admin_state_up"));
		model.setAuthMode(object.getString("auth_mode"));
		model.setPeerCidrs(object.getString("peer_cidrs"));
		model.setMtu(object.getString("mtu"));
		model.setPeerEpGroupId(object.getString("peer_ep_group_id"));
		model.setIkeUuid(object.getString("ikepolicy_id"));
		model.setVpnUuid(object.getString("vpnservice_id"));
		model.setDpd(object.getString("dpd"));
		model.setRouteMode(object.getString("route_mode"));
		model.setIpsecUuid(object.getString("ipsecpolicy_id"));
		model.setLocalEpGroupId(object.getString("local_ep_group_id"));
		model.setPeerAddress(object.getString("peer_address"));
		model.setPeerId(object.getString("peer_id"));
		model.setRemark(object.getString("description"));
		model.setVpnConnUuid(object.getString("id"));

		model.setTenantUuid(object.getString("tenant_id"));
		return model;
	}
}
