package com.bocloud.cmp.provider.convertor;

import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.VpnModel;
import com.google.common.collect.Lists;

/**
 * vpn转换器
 * 
 * @author Administrator
 *
 */
public class VpnConvertor implements BeanConvertor<VpnModel, JSONObject> {

	@Override
	public List<VpnModel> convertList(List<? extends JSONObject> objects) {
		List<VpnModel> vpnModels = Lists.newArrayList();
		for (JSONObject object : objects) {
			vpnModels.add(convertModel(object));
		}
		return vpnModels;
	}

	@Override
	public VpnModel convertModel(JSONObject object) {
		if (null == object) {
			return null;
		}
		VpnModel model = new VpnModel();
		model.setRouterUuid(object.getString("router_id"));
		model.setSubnetUuid(object.getString("subnet_id"));
		model.setName(object.getString("name"));
		model.setStatus(object.getString("status"));
		model.setIpV4(object.getString("external_v4_ip"));
		model.setIpV6(object.getString("external_v6_ip"));
		model.setAdminStateUp(object.getBoolean("admin_state_up"));
		model.setVpnUuid(object.getString("id"));
		model.setRemark(object.getString("description"));
		model.setTenantUuid(object.getString("tenant_id"));
		return model;
	}
}
