package com.bocloud.cmp.provider.listener;

import org.apache.commons.lang3.StringUtils;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.OpenStackClientFactory;

/**
 * openstack云供应商监听器，用来实时监听缓存的butler信息
 *
 * @author wangyu
 * @version 4.1.0-SNAPSHOT
 * @since 2018/11/21
 */
public class OpenStackButlerListener implements ButlerEventListener {

    private String code;

    public OpenStackButlerListener(String code) {
        this.code = code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Override
    public String getCode() {
        return code;
    }

    @Override
    public void onRemoved(Butler butler) {
        String projectName = butler.getProjectName();
        if (StringUtils.isEmpty(projectName)) {
            projectName = butler.getTenant();
        }
        OpenStackClientFactory.getInstance().removeToken(butler.getUuid(), projectName);
    }

    @Override
    public void onChanged(Butler butler) {
        OpenStackClientFactory.getInstance().updateToken(butler);
    }
}
