package com.bocloud.cmp.provider.monitor;

import java.util.List;

import org.openstack4j.model.telemetry.Alarm;

import com.bocloud.cmp.model.AlarmModel;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.OpenStackProvider;
import com.bocloud.cmp.provider.convertor.AlarmConvertor;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import com.google.common.collect.Lists;

/**
 * openstack告警操作类
 *
 * @author wangyu
 * @version 4.1.0-SNAPSHOT
 * @since 2018/11/14
 */
@Provider("bocloud.cmp.openstack")
public class OpenStackAlarmProvider extends OpenStackProvider implements AlarmProvider {

    public OpenStackAlarmProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult sync() {
        List<? extends Alarm> alarms = Lists.newArrayList();
        alarms = this.getClient().telemetry().alarms().list();
        List<AlarmModel> models = Lists.newArrayList();
        if (null != alarms) {
            BeanConvertor<AlarmModel, Alarm> convertAlarm = new AlarmConvertor();
            models = convertAlarm.convertList(alarms);
            return new BocloudResult(true, models, "success");
        }
        return new BocloudResult(false, "failed");
    }

    @Override
    public BocloudResult create(AlarmModel alarmModel) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public BocloudResult update(AlarmModel alarmModel) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public BocloudResult confirm(AlarmModel alarmModel) {
        // TODO Auto-generated method stub
        return null;
    }

}
