package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.PowervcProvider;
import com.bocloud.cmp.provider.powervc4j.impl.identity.Authenticator;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

/**
 * 验证是否能连接上PowerVC
 *
 * @author sxp
 * @since Mar 27, 2018
 */
@Provider("bocloud.cmp.powervc")
public class PowervcAuthProvider extends PowervcProvider implements AuthProvider {

    public PowervcAuthProvider(Butler butler) {
        super(butler);
    }


    @Override
    public BocloudResult auth() {
        if (this.isAccessable()) {
            return new BocloudResult(true, "认证成功");
        }
        return new BocloudResult(false, "认证失败");
    }

    @Override
    public BocloudResult removeAuthFromMemory(String endpoint, String username) {
        Authenticator.removeToken(endpoint);
        return new BocloudResult(true,"删除成功");
    }
}
