package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.powervc.PowervcWebEventModel;
import com.bocloud.cmp.provider.PowervcProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * 验证环境实现
 *
 * @author lkx007
 */
@Provider("bocloud.cmp.powervc")
public class PowervcValidateProvider extends PowervcProvider implements ValidateProvider {
    private static Logger logger = LoggerFactory.getLogger(PowervcValidateProvider.class);

    public PowervcValidateProvider(Butler bulter) {
        super(bulter);
    }

    @Override
    public BocloudResult validate() {
        return this.getClient().ttv(getVersion()).validateService(getVersion()).validate();
    }

    @Override
    public BocloudResult result() {
        return this.getClient().ttv(getVersion()).validateService(getVersion()).result();
    }

    @Override
    public BocloudResult events() {
        List<PowervcWebEventModel> models = this.getClient().notify(getVersion()).webEventService(getVersion()).list();
        return new BocloudResult(true, models, "查询成功");
    }
}
