package com.bocloud.cmp.provider.compute;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.powervc.PowervcViosGroupModel;
import com.bocloud.cmp.provider.PowervcProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * 存储器链接组
 */
@Provider("bocloud.cmp.powervc")
public class PowervcStorageConnGroupProvider extends PowervcProvider implements StorageConnGroupProvider  {

    private static Logger logger = LoggerFactory.getLogger(PowervcStorageConnGroupProvider.class);

    public PowervcStorageConnGroupProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult list() {
        List<PowervcViosGroupModel> list = this.getClient().compute(getVersion()).viosGroup(getVersion()).list();
        return new BocloudResult(true, list, "查询成功");
    }
}
