package com.bocloud.cmp.provider.powervc4j.api;

import com.bocloud.cmp.model.powervc.PowervcConstant;

;

/**
 * PowerVC API 提供者
 * 
 * @author sxp
 * @since Mar 20, 2018
 */
public interface APIProvider {

    /**
     * 初始化
     */
    void initialize();

    /**
     * 获取指定接口类型的实现类
     *
     * @param <T>
     *            PowerVC API的类型
     * @param api
     *            API接口
     * @return T类型API的实现
     */
    <T> T get(Class<T> api, PowervcConstant.Version version);

    /**
     * 获取指定接口类型的从属的顶层接口类
     * 
     * @param api
     *            API接口
     * @return 从属的顶层接口类
     */
    Class<?> getTop(Class<?> api);

}
