package com.bocloud.cmp.provider.powervc4j.api.compute;

import com.bocloud.cmp.model.powervc.PowervcConstant;
import com.bocloud.cmp.provider.powervc4j.api.compute.ext.HypervisorService;

;

/**
 * Compute(Nova)服务接口
 *
 * @author sxp
 * @since Mar 20, 2018
 */
public interface ComputeService {

    /**
     * 获取宿主机服务
     *
     * @author sxp
     * @since Mar 20, 2018
     */
    HypervisorService hypervisors(PowervcConstant.Version version);

    /**
     * 获取云主机服务
     *
     * @author sxp
     * @since Mar 20, 2018
     */
    ServerService servers(PowervcConstant.Version version);

    /**
     * 获取FlavorService(配置规则)服务
     *
     * @author sxp
     * @since Mar 27, 2018
     */
    FlavorService flavors(PowervcConstant.Version version);

    /**
     * 获取FlavorService(配置规则扩展信息)服务
     *
     * @author sxp
     * @since Mar 27, 2018
     */
    FlavorExtraService flavorExtras(PowervcConstant.Version version);

    /**
     * 获取另一个宿主机服务
     *
     * @author sxp
     * @since Mar 28, 2018
     */
    HostService host(PowervcConstant.Version version);

    /**
     * 获取一个hmc连接服务
     * @return
     */
    HmcService hmcs(PowervcConstant.Version version);

    OsHostService oshost(PowervcConstant.Version version);

    MessageService message(PowervcConstant.Version version);

    /**
     * 获取一个主机组服务
     * @return
     */
    OsAggregateService osAggregate(PowervcConstant.Version version);

    /**
     * 获取一个主机的sea
     *
     * @return
     */
    HostSeaService hostSea(PowervcConstant.Version version);

    /**
     * 获取存储器链接组
     *
     * @return
     */
    ViosGroupService viosGroup(PowervcConstant.Version version);

}
