package com.bocloud.cmp.provider.powervc4j.api.compute;

import com.bocloud.cmp.model.FlavorModel;
import com.bocloud.cmp.provider.powervc4j.api.base.BaseService;
import com.bocloud.common.model.BocloudResult;

import java.util.List;

/**
 * FlavorService(配置规格)服务接口
 *
 * @author sxp
 * @since Mar 27, 2018
 */
public interface FlavorService extends BaseService<FlavorModel> {

    /**
     * 获取配置规格列表信息
     *
     * @author sxp
     * @since Mar 27, 2018
     */
    List<FlavorModel> list(boolean showDetail);

    /**
     * 查询某个指定的配置规格
     *
     * @author sxp
     * @since Mar 28, 2018
     */
    FlavorModel get(String id);

    /**
     * 创建配置规格
     *
     * @author sxp
     * @since Mar 28, 2018
     */
    BocloudResult create(FlavorModel flavor);

    /**
     * 删除配置规则
     *
     * @author sxp
     * @since Mar 28, 2018
     */
    BocloudResult delete(String flavorId);

}
