package com.bocloud.cmp.provider.powervc4j.api.compute;

import com.bocloud.cmp.model.HmcHostModel;
import com.bocloud.cmp.model.OsHosts;
import com.bocloud.cmp.provider.powervc4j.api.base.BaseService;
import com.bocloud.common.model.BocloudResult;

public interface HmcService extends BaseService<HmcHostModel> {

    /**
     * 向powervc里添加hmc
     *
     * @param host
     * @return
     */
    BocloudResult create(HmcHostModel host);

    /**
     * 向powervc里修改hmc
     *
     * @param host
     * @return
     */
    BocloudResult modify(HmcHostModel host);

    /**
     * 获取powervc里面hmc的详情
     *
     * @param uuid
     * @return
     */
    HmcHostModel get(String uuid);

    /**
     * 从powervc里面移除hmc
     *
     * @param uuid
     * @return
     */
    BocloudResult delete(String uuid);

    /**
     * 查询指定hmc上的小型机器
     *
     * @param uuid
     * @return
     */
    OsHosts getHosts(String uuid);

}
