package com.bocloud.cmp.provider.powervc4j.api.image;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.ImageModel;
import com.bocloud.cmp.provider.powervc4j.api.base.BaseService;
import com.bocloud.common.model.BocloudResult;

/**
 * PowerVC镜像服务接口
 *
 * @author sxp
 * @since Mar 27, 2018
 */
public interface PowervcImageService extends BaseService<ImageModel> {

    /**
     * 获取指定唯一标识的镜像信息
     *
     * @param imageId 镜像的唯一标识
     * @author sxp
     * @since Mar 28, 2018
     */
    ImageModel get(String imageId);

    /**
     * 删除镜像
     *
     * @param imageId 镜像的唯一标识
     * @author sxp
     * @since Mar 28, 2018
     */
    BocloudResult delete(String imageId);

    /**
     * 从存储卷导入一个镜像
     *
     * @param imageModel
     * @return
     */
    BocloudResult create(JSONObject imageModel);

    /**
     * 更新image的file信息
     *
     * @param imageId
     * @return
     */
    BocloudResult file(String imageId);
}
