package com.bocloud.cmp.provider.powervc4j.api.networking;

import com.bocloud.cmp.model.NetworkModel;
import com.bocloud.cmp.provider.powervc4j.api.base.BaseService;
import com.bocloud.common.model.BocloudResult;

/**
 * PowerVC网络服务接口
 *
 * @author sxp
 * @since Mar 21, 2018
 */
public interface NetworkService extends BaseService<NetworkModel> {

    /**
     * 新增网络
     *
     * @author sxp
     * @since Mar 29, 2018
     */
    BocloudResult create(NetworkModel model);

    /**
     * 查询指定网络
     *
     * @author sxp
     * @since Mar 29, 2018
     */
    NetworkModel get(String networkId);

    /**
     * 删除指定网络
     *
     * @author sxp
     * @since Mar 29, 2018
     */
    BocloudResult delete(String networkId);

    /**
     * 修改网络
     *
     * @author sxp
     * @since Mar 29, 2018
     */
    BocloudResult update(NetworkModel model);

}
