package com.bocloud.cmp.provider.powervc4j.api.networking;

import com.bocloud.cmp.model.SubnetModel;
import com.bocloud.cmp.provider.powervc4j.api.base.BaseService;
import com.bocloud.common.model.BocloudResult;

/**
 * PowerVC子网服务接口
 *
 * @author sxp
 * @since Mar 21, 2018
 */
public interface SubnetService extends BaseService<SubnetModel> {

    /**
     * 根据子网唯一标识获取子网
     *
     * @author sxp
     * @since Mar 21, 2018
     */
    SubnetModel get(String subnetId);

    /**
     * 创建子网
     *
     * @author sxp
     * @since Apr 3, 2018
     */
    BocloudResult create(SubnetModel model);

    /**
     * 修改子网信息
     *
     * @author sxp
     * @since Apr 4, 2018
     */
    BocloudResult update(SubnetModel subnet);

    /**
     * 删除子网信息
     *
     * @author sxp
     * @since Apr 4, 2018
     */
    BocloudResult delete(String subnetId);
}
