package com.bocloud.cmp.provider.powervc4j.impl.compute.v14;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.powervc.PowervcViosGroupModel;
import com.bocloud.cmp.provider.powervc4j.api.Apis;
import com.bocloud.cmp.provider.powervc4j.api.compute.ViosGroupService;
import com.bocloud.cmp.provider.powervc4j.exception.DriverException;
import com.bocloud.cmp.provider.powervc4j.impl.base.BaseServiceImpl;
import com.bocloud.common.model.BocloudResult;
import org.springframework.util.StringUtils;

import java.util.ArrayList;
import java.util.List;

public class ViosGroupServiceImpl extends BaseServiceImpl<PowervcViosGroupModel> implements ViosGroupService {

    @Override
    public BocloudResult create(PowervcViosGroupModel model) {
        return new BocloudResult(false, "尚未实现");
    }

    @Override
    public BocloudResult modify(PowervcViosGroupModel model) {
        return new BocloudResult(false, "尚未实现");
    }

    @Override
    public PowervcViosGroupModel get(String uuid) {
        if (StringUtils.isEmpty(uuid)) {
            throw new DriverException("查询存储器链接组信息时，唯一标识不能为空");
        }
        List<PowervcViosGroupModel> models = list();
        for (PowervcViosGroupModel model : models) {
            if (uuid.equals(model.getUuid())) {
                return model;
            }
        }
        return null;
    }

    @Override
    public BocloudResult delete(String uuid) {
        return new BocloudResult(false, "尚未实现");
    }

    @Override
    public List<PowervcViosGroupModel> list() {
        return doList("/storage-connectivity-groups/detail?include_ports=true");
    }

    @Override
    protected Class<?> initServiceType() {
        return Apis.getTop(ViosGroupService.class);
    }

    @Override
    protected List<PowervcViosGroupModel> processListResult(String message) {
        JSONArray groups = JSON.parseObject(message).getJSONArray("storage_connectivity_groups");
        List<PowervcViosGroupModel> models = new ArrayList<>();
        for (int i = 0; i < groups.size(); i++) {
            models.add(convert(groups.getJSONObject(i)));
        }
        return models;
    }

    @Override
    protected PowervcViosGroupModel processGetResult(String message) {
        return null;
    }

    private PowervcViosGroupModel convert(JSONObject object) {
        PowervcViosGroupModel model = new PowervcViosGroupModel();
        model.setUuid(object.getString("id"));
        model.setName(object.getString("display_name"));
        model.setBootHealth(object.get("health_status") == null ? null : object.getJSONObject("health_status").getString("boot_health"));
        model.setDataHealth(object.get("health_status") == null ? null : object.getJSONObject("health_status").getString("data_health"));
        model.setEnabled(object.getBoolean("enabled"));
        return model;
    }
}
