package com.bocloud.cmp.provider.powervc4j.impl.validation.v14;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.provider.powervc4j.api.Apis;
import com.bocloud.cmp.provider.powervc4j.api.validation.PowervcValidateService;
import com.bocloud.cmp.provider.powervc4j.api.validation.ValidateService;
import com.bocloud.cmp.provider.powervc4j.impl.base.BaseServiceImpl;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.Result;

import java.util.List;

/**
 * PowerVC ttv服务实现类
 * <p>
 * 验证环境使用
 *
 * @author lkx007
 */
public class PowervcValidateServiceImpl extends BaseServiceImpl<JSONObject> implements PowervcValidateService {
    @Override
    public BocloudResult validate() {
        String apiSuffix = "/validate";
        Result result = doCreate(apiSuffix, null);
        return new BocloudResult(result.isSuccess(), result.getMessage());
    }

    @Override
    public BocloudResult result() {
        String apiSuffix = "/validate/result";
        JSONObject object = customGet(JSONObject.class, apiSuffix);
        if (object == null) {
            return new BocloudResult(false, "请求powervc获取验证环境结果失败");
        }
        return new BocloudResult(true, object, "请求powervc获取验证环境结果成功");
    }

    @Override
    public List<JSONObject> list() {
        return null;
    }

    @Override
    protected Class<?> initServiceType() {
        return Apis.getTop(ValidateService.class);
    }

    @Override
    protected List<JSONObject> processListResult(String message) {
        return null;
    }

    @Override
    protected JSONObject processGetResult(String message) {
        return null;
    }
}
