package com.bocloud.cmp.provider.powervc4j.utils;

import org.apache.commons.lang3.StringUtils;

/**
 * @author luyanchao
 * @since 2019/2/13 15:51
 */
public class CapacityUtils {

    /**
     * 将文字描述的容量转换成数字，数字单位GB
     * @param capacity
     * @return
     */
    public static Double transportCapacity(String capacity) {
        if (StringUtils.isEmpty(capacity)) {
            return null;
        }
        capacity = capacity.toUpperCase();
        if (capacity.endsWith("KB") || capacity.endsWith("K")) {
            capacity = capacity.replace("KB", "").replace("K", "");
            return Double.parseDouble(capacity) / 1024 / 1024;
        } else if (capacity.endsWith("MB") || capacity.endsWith("M")) {
            capacity = capacity.replace("MB", "").replace("M", "");
            return Double.parseDouble(capacity) / 1024;
        } else if (capacity.endsWith("GB") || capacity.endsWith("G")) {
            capacity = capacity.replace("GB", "").replace("G", "");
            return Double.parseDouble(capacity);
        } else if (capacity.endsWith("TB") || capacity.endsWith("T")) {
            capacity = capacity.replace("TB", "").replace("T", "");
            return Double.parseDouble(capacity) * 1024;
        } else if (capacity.endsWith("PB") || capacity.endsWith("P")) {
            capacity = capacity.replace("PB", "").replace("P", "");
            return Double.parseDouble(capacity) * 1024 * 1024;
        } else if (capacity.endsWith("EB") || capacity.endsWith("E")) {
            capacity = capacity.replace("EB", "").replace("E", "");
            return Double.parseDouble(capacity) * 1024 * 1024 * 1024;
        } else if (capacity.endsWith("ZB") || capacity.endsWith("Z")) {
            capacity = capacity.replace("ZB", "").replace("Z", "");
            return Double.parseDouble(capacity) * 1024 * 1024 * 1024;
        } else {
            return Double.parseDouble(capacity);
        }
    }

}
