package com.bocloud.cmp.provider.storage;


import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.SanFabricModel;
import com.bocloud.cmp.provider.PowervcProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

@Provider("bocloud.cmp.powervc")
public class PowervcFabricProvider extends PowervcProvider implements FabricProvider {
    private static Logger logger = LoggerFactory.getLogger(PowervcFabricProvider.class);

    public PowervcFabricProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult list() {
        List<SanFabricModel> list = this.getClient().blockStorage(getVersion()).fabrics(getVersion()).list();
        return new BocloudResult(true, list, "查询成功");
    }

    @Override
    public BocloudResult create(SanFabricModel sanFc) {
        return this.getClient().blockStorage(getVersion()).fabrics(getVersion()).create(sanFc);
    }

    @Override
    public BocloudResult modify(SanFabricModel sanFc) {
        return this.getClient().blockStorage(getVersion()).fabrics(getVersion()).modify(sanFc);
    }

    @Override
    public BocloudResult remove(String name) {
        return this.getClient().blockStorage(getVersion()).fabrics(getVersion()).remove(name);
    }

    @Override
    public BocloudResult detail(String name) {
        return this.getClient().blockStorage(getVersion()).fabrics(getVersion()).detail(name);
    }
}
