package com.bocloud.cmp.provider.storage;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.VolumePoolModel;
import com.bocloud.cmp.provider.PowervcProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * @author luyanchao
 * @since 2019/2/13 15:41
 */
@Provider("bocloud.cmp.powervc")
public class PowervcVolumePoolProvider extends PowervcProvider implements VolumePoolProvider {
    private static Logger logger = LoggerFactory.getLogger(PowervcVolumePoolProvider.class);

    public PowervcVolumePoolProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult list(String storageHostName) {
        try {
            List<VolumePoolModel> pools = this.listVolumePool(storageHostName);
            return new BocloudResult(pools != null, pools, "");
        } catch (Exception e) {
            String msg = "查询存储卷列表信息失败，" + e.getMessage();
            logger.error(msg, e);
            return new BocloudResult(false, msg);
        }
    }
}
