package com.bocloud.cmp.driver.common.util;

import com.bocloud.cmp.provider.powervc4j.common.util.DateUtils;
import org.junit.Assert;
import org.junit.Test;

import java.util.Date;

public class DateUtilsTest {

    @Test
    public void testGetDateFromUTCString() {
        String utcStr = "2018-03-19T01:37:41.037174Z";
        Date localDate = DateUtils.getDateFromUTCString(utcStr);
        String localStr = DateUtils.dateToString(localDate, "yyyy-MM-dd HH:mm:ss");
        Assert.assertEquals("2018-03-19 09:37:41", localStr);
    }

    @Test
    public void testGetUTCStringFromLocalDate() {
        Date localDate = DateUtils.stringToDate("2018-03-19 09:37:41", "yyyy-MM-dd HH:mm:ss");
        String utcStr = DateUtils.getUTCStringFromLocalDate(localDate);
        Assert.assertEquals("2018-03-19T01:37:41.000000000Z", utcStr);
    }

}
