package com.bocloud.cmp.driver.provider.powervc;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.model.HostModel;
import com.bocloud.cmp.model.powervc.PowervcConstant;
import com.bocloud.cmp.provider.PowervcProvider;
import com.bocloud.cmp.provider.powervc4j.api.PVClient;
import org.junit.BeforeClass;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

;

/**
 * Test for PowervcProvider
 *
 * @author sxp
 * @since Apr 4, 2018
 */
public class PowervcBaseDriverTest extends BaseDriverTest {
    private static Logger logger = LoggerFactory.getLogger(PowervcBaseDriverTest.class);
    private static PowervcProvider instance;

    @BeforeClass
    public static void setUp() {
        instance = new PowervcProvider(bulter);
    }

    @Test
    public void test() {
        try {
            if (!instance.isPrepared()) {
                logger.error(instance.getError());
                return;
            }

            PVClient client = instance.getClient();
            List<HostModel> hypervisors = client.compute(PowervcConstant.Version.v13).hypervisors(PowervcConstant.Version.v13).list();

            System.out.println(JSON.toJSONString(hypervisors, true));
        } catch (Exception e) {
            String errorMsg = "获取数据失败:" + e.getMessage();
            logger.error(errorMsg, e);
        }
    }

}
