package com.bocloud.cmp.driver.provider.powervc;

import com.bocloud.cmp.model.SanFabricModel;
import com.bocloud.cmp.provider.storage.PowervcFabricProvider;
import com.bocloud.common.model.BocloudResult;
import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Test;

public class PowervcFabricProviderTest extends BaseDriverTest {

    private static PowervcFabricProvider instance;

    @BeforeClass
    public static void setUp() {
        instance = new PowervcFabricProvider(bulter);
    }


    @Test
    public void testlListFC() {
        BocloudResult result = instance.list();
        System.out.println("result = " + result);
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testCreateFC() {
        SanFabricModel sanFabrics = new SanFabricModel();
        sanFabrics.setIp("192.168.0.7");
        sanFabrics.setAddKey(true);
        sanFabrics.setNickName("lkx");
        sanFabrics.setUsername("admin");
        sanFabrics.setPassword("password");
        sanFabrics.setType("brocade");
        sanFabrics.setPolicy("initiator");
        BocloudResult result = instance.create(sanFabrics);
        System.out.println("result = " + result);

        if (result.isSuccess()) {
            SanFabricModel sanFabricsOut = (SanFabricModel) result.getData();
            // name为唯一标识，创建后由powervc返回
            System.out.println("sanFabricsOut name = " + sanFabricsOut.getName());
            System.out.println("sanFabricsOut protocol = " + sanFabricsOut.getProtocol());
            System.out.println("sanFabricsOut display name = " + sanFabricsOut.getNickName());
        }
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testDetailFC() {
        BocloudResult result = instance.detail("A");
        System.out.println("result = " + result);
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testRemoveFC() {
        BocloudResult result = instance.remove("A");
        System.out.println("result = " + result);
        Assert.assertTrue(result.isSuccess());
    }
}
