package com.bocloud.cmp.driver.provider.powervc;

import com.bocloud.cmp.model.HmcHostModel;
import com.bocloud.cmp.model.OsHosts;
import com.bocloud.cmp.provider.compute.PowervcHmcProvider;
import com.bocloud.common.model.BocloudResult;
import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Test;

import java.util.List;

public class PowervcHmcDriverTest extends BaseDriverTest {
    private static PowervcHmcProvider instance;

    @BeforeClass
    public static void setUp() {
        instance = new PowervcHmcProvider(bulter);
    }

    @Test
    public void testList() {
        BocloudResult result = instance.list();
        if (result.isFailed()) {
            System.out.println(result.getMessage());
        } else {
            System.out.println(result.getData().toString());
        }
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testCreate() {
        HmcHostModel hmc = new HmcHostModel();
        hmc.setIp("192.168.2.69");
        hmc.setUsername("hscroot");
        hmc.setPassword("password");
        //hmc.setAddCert(true);
        hmc.setName("cmp");
        BocloudResult result = instance.create(hmc);
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testDelete() {
        BocloudResult getResult = instance.list();
        if (getResult.isSuccess()) {
            List<HmcHostModel> hosts = (List<HmcHostModel>) getResult.getData();
            for (HmcHostModel host : hosts) {
                if ("cmp".equals(host.getName())) {
                    BocloudResult deleteResult = instance.delete(host.getUuid());
                    Assert.assertTrue(deleteResult.isSuccess());
                }
            }
        }
    }

    @Test
    public void testDetail() {
        BocloudResult result = instance.get("88713e01-5962-35dc-a69a-589f503d04d1");
        if (result.isSuccess()) {
            HmcHostModel model = (HmcHostModel) result.getData();
            System.out.println("model ip = " + model.getIp());
            System.out.println("model status = " + model.getStatus().getStatus());
        }
    }

    @Test
    public void testGetOsHost() {
        BocloudResult result = instance.getHosts("388e77cb-0afe-36b2-bc17-49e6150ad4fd");
        if (result.isFailed()) {
            System.out.println(result.getMessage());
        } else {
            OsHosts hosts = (OsHosts) result.getData();
            System.out.println(hosts.getHosts().get(0).getMtms());
            System.out.println(hosts.getHosts().get(0).getName());
            System.out.println("hosts.getHosts().get(0) = " + hosts.getHosts().get(0));
        }
        Assert.assertTrue(result.isSuccess());
    }
}
