package com.bocloud.cmp.driver.provider.powervc;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.model.HostOperateModel;
import com.bocloud.cmp.provider.compute.PowervcHyperVisorProvider;
import com.bocloud.common.model.BocloudResult;
import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Test;

public class PowervcHyperVisorProviderTest extends BaseDriverTest {
    private static PowervcHyperVisorProvider instance;

    @BeforeClass
    public static void setUp() {
        instance = new PowervcHyperVisorProvider(bulter);
    }

    @Test
    public void testList() {
        BocloudResult result = instance.list();

        if (result.isFailed()) {
            System.out.println(result.getMessage());
        } else {
            System.out.println(JSON.toJSONString(result.getData(), true));
        }
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testListPerf() {
        BocloudResult result = instance.listPerf();

        if (result.isFailed()) {
            System.out.println(result.getMessage());
        } else {
            System.out.println(JSON.toJSONString(result.getData(), true));
        }
        Assert.assertTrue(result.isSuccess());
    }


    @Test
    public void testDetail() {
        HostOperateModel model = new HostOperateModel();
        model.setUuid("23");
        BocloudResult result = instance.detail(model);

        if (result.isFailed()) {
            System.out.println(result.getMessage());
        } else {
            System.out.println(JSON.toJSONString(result.getData(), true));
        }
        Assert.assertTrue(result.isSuccess());
    }

}
