package com.bocloud.cmp.driver.provider.powervc;

import com.bocloud.cmp.model.ConsoleMessage;
import com.bocloud.cmp.provider.compute.PowervcMessageProvider;
import com.bocloud.common.model.BocloudResult;
import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Test;

import java.util.List;

public class PowervcMessageDriverTest extends BaseDriverTest {

    private static PowervcMessageProvider instance;

    @BeforeClass
    public static void setUp() {
        instance = new PowervcMessageProvider(bulter);
    }

    @Test
    public void testList() {
        BocloudResult result = instance.list();
        if (result.isFailed()) {
            System.out.println(result.getMessage());
        } else {
            List<ConsoleMessage> messages = (List<ConsoleMessage>) result.getData();
            System.out.println(messages.get(0).getPayload());
        }
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testDelete() {
        BocloudResult result = instance.delete(295);
        System.out.println("result = " + result);
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testDeleteAll() {
        BocloudResult result = instance.deleteAll();
        System.out.println("result = " + result);
        Assert.assertTrue(result.isSuccess());
    }


}
