package com.bocloud.cmp.driver.provider.powervc;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.network.PowervcPortProvider;
import com.bocloud.common.model.BocloudResult;
import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Test;

public class PvPortDriverTest extends BaseDriverTest {
    private static PowervcPortProvider instance;

    @BeforeClass
    public static void setUp() {
        instance = new PowervcPortProvider(bulter);
    }

    @Test
    public void testSync() {
        BocloudResult result = instance.sync();

        if (result.isFailed()) {
            System.out.println(result.getMessage());
        } else {
            System.out.println(JSON.toJSONString(result.getData(), true));
        }
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testDetail() {
        String portId = "461a48cf-a4d8-443e-8100-788fbc3e0706";
        BocloudResult result = instance.detail(portId);

        if (result.isFailed()) {
            System.out.println(result.getMessage());
        } else {
            System.out.println(JSON.toJSONString(result.getData(), true));
        }
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testRemove() {
        String portId = "a20b205a-c8d2-4380-8385-497992f003b7";
        BocloudResult result = instance.remove(portId);

        if (result.isFailed()) {
            System.out.println(result.getMessage());
        } else {
            System.out.println(JSON.toJSONString(result.getData(), true));
        }
        Assert.assertTrue(result.isSuccess());
    }

}
