package com.bocloud.cmp.driver.provider.powervc;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.model.StorageModel;
import com.bocloud.cmp.provider.storage.PowervcStorageProvider;
import com.bocloud.cmp.provider.storage.PowervcVolumeTemplateProvider;
import com.bocloud.common.model.BocloudResult;
import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Test;

public class PvStorageDriverTest extends BaseDriverTest {
    private static PowervcStorageProvider instance;

    @BeforeClass
    public static void setUp() {
        instance = new PowervcStorageProvider(bulter);
    }

    @Test
    public void testList() {
        BocloudResult result = instance.list();

        if (result.isFailed()) {
            System.out.println(result.getMessage());
        } else {
            System.out.println(JSON.toJSONString(result.getData(), true));
        }
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testConnect() {
        StorageModel model = new StorageModel();
        model.setIp("192.168.0.8");
        model.setType("svc");
        model.setUsername("superuser");
        model.setPassword("passw0rd");
        BocloudResult result = instance.connect(model);
        System.out.println("result = " + result);
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testCreate() {
        StorageModel model = new StorageModel();
        model.setIp("192.168.0.8");
        model.setType("svc");
        model.setUsername("superuser");
        model.setPassword("passw0rd");
        model.setVolumePool("mdiskgrp1");
        model.setName("v7000");
        BocloudResult result = instance.create(model);
        System.out.println("result = " + result);
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testGet() {
        BocloudResult result =  instance.detail("9");
        System.out.println("result = " + result);
        Assert.assertTrue(result.isSuccess());
    }

    @Test
    public void testModify() {


    }

    @Test
    public void testRemove() {
        BocloudResult result = instance.remove("192_168_0_8");
        System.out.println("result = " + result);
        Assert.assertTrue(result.isSuccess());
    }


}

