package com.bocloud.cmp.pqcloudconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.FlavorModel;
import com.bocloud.cmp.model.ServerModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: FlavorConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/28 16:53
 */
public class FlavorConvertor implements BeanJsonConvertor<FlavorModel> {


    @Override
    public List<FlavorModel> convertList(JSONArray array) {
        List<FlavorModel> list = new ArrayList<>();
        for (int i = 0; i < array.size(); i++) {
            list.add(convertModel(array.getJSONObject(i)));
        }
        return list;
    }

    @Override
    public FlavorModel convertModel(JSONObject object) {
        FlavorModel model = new FlavorModel();
        model.setZone(object.getString("zone_id"));
        model.setFlavorUuid(object.getString("instance_type_id"));
        model.setCpu(object.getInteger("vcpus_current"));
        model.setMemory(BigDecimal.valueOf(object.getInteger("memory_current")));
        String instanceTypeName = object.getString("instance_type_name");
        if (null == instanceTypeName) {
            instanceTypeName = object.getString("instance_type_id");
        }
        model.setName(instanceTypeName);
        model.setStatus(object.getString("status") == null ? "" : object.getString("status").toUpperCase());
        model.setRegionId(object.getString("zone_id"));
        return model;
    }
}
