package com.bocloud.cmp.pqcloudconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.FloatingIpModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: FloatingIpConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/11/12 17:08
 */
public class FloatingIpConvertor implements BeanJsonConvertor<FloatingIpModel> {
    @Override
    public List<FloatingIpModel> convertList(JSONArray array) {
        List<FloatingIpModel> list = new ArrayList<>();
        for (int i = 0; i < array.size(); i++) {
            list.add(convertModel(array.getJSONObject(i)));
        }
        return list;
    }

    @Override
    public FloatingIpModel convertModel(JSONObject object) {
        FloatingIpModel model = new FloatingIpModel();
        String createdTime = object.getString("create_time");
        Date date = DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdTime, "Z");
        model.setGmtCreate(date);
        model.setBandwidth(object.getInteger("bandwidth") + "");
        model.setFloatingIpAddress(object.getString("eip_addr"));
        model.setFloatingIpUuid(object.getString("eip_id"));
        model.setName(object.getString("eip_name"));
        model.setStatus(object.getString("status") == null ? "" : object.getString("status").toUpperCase());
        model.setNeedIcp(object.getInteger("need_icp"));
        return model;
    }
}
