package com.bocloud.cmp.pqcloudconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.ImageModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: ImageConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/28 16:47
 */
public class ImageConvertor implements BeanJsonConvertor<ImageModel> {


    @Override
    public List<ImageModel> convertList(JSONArray array) {
        List<ImageModel> list = new ArrayList<>();
        for (int i = 0; i < array.size(); i++) {
            list.add(convertModel(array.getJSONObject(i)));
        }
        return list;
    }

    @Override
    public ImageModel convertModel(JSONObject object) {
        ImageModel model = new ImageModel();
        model.setRemark(object.getString("description"));
        model.setOsType(object.getString("os_family"));
        model.setOsVersion(object.getString("processor_type"));
        model.setOsCategory(object.getString("platform"));
        model.setName(object.getString("image_name"));
        String createdTime = object.getString("create_time");
        Date date = DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdTime, "Z");
        model.setGmtCreate(date);
        if (object.getString("visibility").equalsIgnoreCase("private")) {
            model.setImageType("PRIVATE");
        } else if (object.getString("visibility").equalsIgnoreCase("public")) {
            model.setImageType("PUBLIC");
        } else {
            model.setImageType(object.getString("visibility").toUpperCase());
        }
        model.setSize(Double.valueOf(object.getInteger("size")));
        String status = object.getString("status");
        if ("available".equalsIgnoreCase(status)) {
            model.setStatus("ACTIVE");
        } else {
            model.setStatus(status);
        }
        return model;
    }
}
