package com.bocloud.cmp.pqcloudconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.PqcloudJobModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: JobConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/11/13 14:14
 */
public class JobConvertor implements BeanJsonConvertor<PqcloudJobModel> {
    @Override
    public List<PqcloudJobModel> convertList(JSONArray array) {
        List<PqcloudJobModel> list = new ArrayList<>();
        for (int i = 0; i < array.size(); i++) {
            list.add(convertModel(array.getJSONObject(i)));
        }
        return list;
    }

    @Override
    public PqcloudJobModel convertModel(JSONObject object) {
        PqcloudJobModel model = new PqcloudJobModel();
        String createdTime = object.getString("create_time");
        Date createTime = DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdTime, "Z");
        model.setCreateTime(createTime);
        model.setJobId(object.getString("job_id"));
        String statusdTime = object.getString("status_time");
        Date statusTime = DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", statusdTime, "Z");
        model.setStatusTime(statusTime);
        model.setErrorCodes(object.getString("error_codes"));
        model.setResourceIds(object.getString("resource_ids"));
        model.setStatus(object.getString("status")); //successful
        model.setJobAction(object.getString("job_action"));
        return model;
    }
}
