package com.bocloud.cmp.pqcloudconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.KeypairModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: KeypairConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/28 16:47
 */
public class KeypairConvertor implements BeanJsonConvertor<KeypairModel> {


    @Override
    public List<KeypairModel> convertList(JSONArray array) {
        List<KeypairModel> list = new ArrayList<>();
        for (int i = 0; i < array.size(); i++) {
            list.add(convertModel(array.getJSONObject(i)));
        }
        return list;
    }

    @Override
    public KeypairModel convertModel(JSONObject object) {
        KeypairModel model = new KeypairModel();
        String createdTime = object.getString("create_time");
        Date date = DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdTime, "Z");
        model.setGmtCreate(date);
        model.setRemark(object.getString("description"));
        model.setName(object.getString("keypair_name"));
        model.setPublicKey(object.getString("pub_key"));
        model.setPrivateKey(object.getString("priv_key"));
        model.setKeyId(object.getString("keypair_id"));
        return model;
    }
}
