package com.bocloud.cmp.pqcloudconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.SecurityGroupModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.utils.DateTools;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: SecurityGroupConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/28 16:47
 */
public class SecurityGroupConvertor implements BeanJsonConvertor<SecurityGroupModel> {

    private static Logger logger = LoggerFactory.getLogger(SecurityGroupConvertor.class);

    @Override
    public List<SecurityGroupModel> convertList(JSONArray array) {
        List<SecurityGroupModel> list = new ArrayList<>();
        for (int i = 0; i < array.size(); i++) {
            list.add(convertModel(array.getJSONObject(i)));
        }
        return list;
    }

    @Override
    public SecurityGroupModel convertModel(JSONObject object) {
        SecurityGroupModel model = new SecurityGroupModel();
        String createdTime = object.getString("create_time");
        Date date = DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdTime, "Z");
        model.setCreateTime(date);
        model.setRemark(object.getString("description"));
        model.setName(object.getString("security_group_name"));
        model.setGroupUuid(object.getString("security_group_id"));
        return model;
    }
}
