package com.bocloud.cmp.pqcloudconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.SnapshotModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: SnapshotConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/28 16:47
 */
public class SnapshotConvertor implements BeanJsonConvertor<SnapshotModel> {


    @Override
    public List<SnapshotModel> convertList(JSONArray array) {
        List<SnapshotModel> list = new ArrayList<>();
        for (int i = 0; i < array.size(); i++) {
            list.add(convertModel(array.getJSONObject(i)));
        }
        return list;
    }

    @Override
    public SnapshotModel convertModel(JSONObject object) {
        SnapshotModel model = new SnapshotModel();
        String createdTime = object.getString("create_time");
        Date date = DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdTime, "Z");
        model.setCreateTime(date);
        model.setSnapshotUuid(object.getString("snapshot_id"));
        model.setName(object.getString("snapshot_name"));
        model.setRemark(object.getString("description"));
        model.setSize(object.getInteger("size"));
        model.setStatus(object.getString("status"));
//        object.getString("snapshot_type");
        return model;
    }
}
