package com.bocloud.cmp.pqcloudconvertor;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.SubnetModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.utils.DateTools;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: SubnetConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/28 16:47
 */
public class SubnetConvertor implements BeanJsonConvertor<SubnetModel> {

    private static Logger logger = LoggerFactory.getLogger(SubnetConvertor.class);

    @Override
    public List<SubnetModel> convertList(JSONArray array) {
        List<SubnetModel> list = new ArrayList<>();
        for (int i = 0; i < array.size(); i++) {
            list.add(convertModel(array.getJSONObject(i)));
        }
        return list;
    }

    @Override
    public SubnetModel convertModel(JSONObject object) {
        SubnetModel model = new SubnetModel();
        model.setVpcUuid(object.getString("vpc_router_id"));
        model.setName(object.getString("vxnet_name"));
        model.setSubnetUuid(object.getString("vxnet_id"));
        JSONObject router = object.getJSONObject("router");
        if (null != router) {
            model.setCidr(router.getString("ip_network"));
            model.setIpPools(
                    JSON.toJSONString(new String[]{router.getString("dYNIPStart") + "-" + router.getString("dYNIPEnd")}));
            model.setVpcName(router.getString("router_name"));
            model.setGateway(router.getString("manager_ip"));
        }
        String createdTime = object.getString("create_time");
        Date date = DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdTime, "Z");
        model.setGmtCreate(date);
        model.setRemark(object.getString("description"));
        model.setRegionId(object.getString("zone_id"));
        model.setStatus("ACTIVE");
        return model;
    }
}
