package com.bocloud.cmp.pqcloudconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.VolumeModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: VolumeConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/28 16:47
 */
public class VolumeConvertor implements BeanJsonConvertor<VolumeModel> {


    @Override
    public List<VolumeModel> convertList(JSONArray array) {
        List<VolumeModel> list = new ArrayList<>();
        for (int i = 0; i < array.size(); i++) {
            list.add(convertModel(array.getJSONObject(i)));
        }
        return list;
    }

    @Override
    public VolumeModel convertModel(JSONObject object) {
        VolumeModel model = new VolumeModel();
        model.setVolumeUuid(object.getString("volume_id"));
        model.setInstanceId(object.getJSONObject("instance").getString("instance_id"));
        model.setRemark(object.getString("description"));
        model.setName(object.getString("volume_name"));
        model.setZone(object.getString("zone_id"));
        String createdTime = object.getString("create_time");
        Date date = DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdTime, "Z");
        model.setCreateTime(date);
        model.setSize(object.getInteger("size"));
        model.setBootVolume(false);
        model.setDeleteWithInstance(false);
        String diskState = object.getString("status");
        if ("in-use".equalsIgnoreCase(diskState)) {
            model.setStatus("IN_USE");
        } else if ("available".equalsIgnoreCase(diskState)) {
            model.setStatus("AVAILABLE");
        } else {
            model.setStatus(diskState);
        }
        model.setRegionId(object.getString("zone_id"));
        return model;
    }
}
