package com.bocloud.cmp.pqcloudconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.VpcModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.utils.DateTools;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: VpcConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/28 16:47
 */
public class VpcConvertor implements BeanJsonConvertor<VpcModel> {

    private static Logger logger = LoggerFactory.getLogger(VpcConvertor.class);

    @Override
    public List<VpcModel> convertList(JSONArray array) {
        List<VpcModel> list = new ArrayList<>();
        for (int i = 0; i < array.size(); i++) {
            if ("ACTIVE".equalsIgnoreCase(array.getJSONObject(i).getString("status"))) {
                list.add(convertModel(array.getJSONObject(i)));
            }
        }
        return list;
    }

    @Override
    public VpcModel convertModel(JSONObject object) {
        VpcModel model = new VpcModel();
        String createdTime = object.getString("create_time");
        Date date = DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdTime, "Z");
        model.setGmtCreate(date);
        model.setSecurityGroupId(object.getString("security_group_id"));
        model.setRemark(object.getString("description"));
        model.setName(object.getString("router_name"));
        model.setPrivateIp(object.getString("private_ip"));
        model.setVpcId(object.getString("router_id"));
        JSONObject eip = object.getJSONObject("eip");
        if (null != eip) {
            model.setEip(eip.getString("eip_id"));
        }
        model.setStatus(object.getString("status"));
        return model;
    }
}
