package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.provider.PqcloudRestApiProvider;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.Butler;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.TreeMap;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: QcloudAuthProvider
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/28 16:47
 */
@Provider("bocloud.cmp.pqcloud")
public class PqcloudAuthProvider extends PqcloudRestApiProvider implements AuthProvider {

    private static Logger logger = LoggerFactory.getLogger(PqcloudAuthProvider.class);

    private Butler butler;

    public PqcloudAuthProvider(Butler butler) {
        super(butler);
        this.butler = butler;
    }

    @Override
    public BocloudResult auth() {
        TreeMap<String, Object> params = new TreeMap<String, Object>();
        JSONObject object = this.connection("DescribeZones", params);
        if (object.getInteger("ret_code") == 0) {
            return new BocloudResult(true, "认证成功");
        } else {
            logger.error("auth error ： " + object.getString("message"));
            return new BocloudResult(false, "认证失败", object.getString("message"));
        }
    }
}
