package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.pqcloudconvertor.FlavorConvertor;
import com.bocloud.cmp.provider.PqcloudRestApiProvider;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.FlavorModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;
import java.util.TreeMap;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: QcloudFlavorProvider
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/10/28 16:47
 */
@Provider("bocloud.cmp.pqcloud")
public class PqcloudFlavorProvider extends PqcloudRestApiProvider implements FlavorProvider {

    private static Logger logger = LoggerFactory.getLogger(PqcloudFlavorProvider.class);


    private BeanJsonConvertor<FlavorModel> convertor = new FlavorConvertor();

    public PqcloudFlavorProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult sync() {
        return null;
    }


    @Override
    public BocloudResult list(String zone) {
        TreeMap<String, Object> params = new TreeMap<String, Object>();
        JSONObject object = this.connection("DescribeInstanceTypes", zone, params);
        if (object.getInteger("ret_code") == 0) {
            List<FlavorModel> flavorModels = convertor.convertList(object.getJSONArray("instance_type_set"));
            return new BocloudResult(true, flavorModels, "查询成功");
        } else {
            logger.error("list flavor error ： " + object.getString("message"));
            return new BocloudResult(false, "查询失败", object.getString("message"));
        }
    }

    @Override
    public BocloudResult create(FlavorModel flavor) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public BocloudResult remove(String flavorId) {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public BocloudResult update(FlavorModel flavorModel) {
        // TODO Auto-generated method stub
        return null;
    }

}
