package com.bocloud.cmp.provider.qcloudconvertor;

import com.bocloud.cmp.model.FlavorModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.qingcloud.sdk.service.Types;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * 规格转换
 *
 * @author wangyu
 * @时间 2019年10月24日
 */
public class FlavorConvertor implements BeanConvertor<FlavorModel, Types.InstanceTypeModel> {

    @Override
    public List<FlavorModel> convertList(List<? extends Types.InstanceTypeModel> objects) {
        List<FlavorModel> regionModels = new ArrayList<FlavorModel>();
        for (Types.InstanceTypeModel object : objects) {
            if ("available".equalsIgnoreCase(object.getStatus()) && object.getMemoryCurrent() > 0
                    && object.getVCPUsCurrent() > 0) {
                regionModels.add(convertModel(object));
            }
        }
        return regionModels;
    }

    @Override
    public FlavorModel convertModel(Types.InstanceTypeModel typeModel) {
        FlavorModel model = new FlavorModel();
        if (null != typeModel) {
            model.setCpu(typeModel.getVCPUsCurrent());
            model.setMemory(BigDecimal.valueOf(typeModel.getMemoryCurrent() / 1024));
            String instanceTypeName = typeModel.getInstanceTypeName();
            if (null == instanceTypeName) {
                instanceTypeName = typeModel.getInstanceTypeID();
            }
            model.setName(instanceTypeName);
            model.setFlavorUuid(typeModel.getInstanceTypeID());
            model.setStatus(typeModel.getStatus() == null ? "" : typeModel.getStatus().toUpperCase());
            model.setZone(typeModel.getZoneID());
        }
        return model;
    }
}
