package com.bocloud.cmp.provider.qcloudconvertor;

import com.bocloud.cmp.model.KeypairModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;
import com.qingcloud.sdk.service.Types;

import java.util.ArrayList;
import java.util.List;

/**
 * 密钥转换
 *
 * @author wangyu
 * @时间 2019年10月24日
 */
public class KeypairConvertor implements BeanConvertor<KeypairModel, Types.KeyPairModel> {

    @Override
    public List<KeypairModel> convertList(List<? extends Types.KeyPairModel> objects) {
        List<KeypairModel> regionModels = new ArrayList<>();
        for (Types.KeyPairModel object : objects) {
            regionModels.add(convertModel(object));
        }
        return regionModels;
    }

    @Override
    public KeypairModel convertModel(Types.KeyPairModel info) {
        KeypairModel model = new KeypairModel();
        if (null != info) {
            model.setKeyId(info.getKeyPairID());
            model.setFingerprint(info.getKeyPairID());
            model.setName(info.getKeyPairName());
            model.setPublicKey(info.getPubKey());
            model.setPrivateKey(info.getPrivKey());
            model.setRemark(info.getDescription());
            String createdTime = info.getCreateTime();
            if (null != createdTime && !"".equals(createdTime)) {
                model.setGmtCreate(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdTime, "Z"));
                model.setCreateTime(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdTime, "Z"));
            }
        }
        return model;
    }
}
