
package com.bocloud.cmp.provider.qcloudconvertor;

import com.bocloud.cmp.model.SecurityGroupModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;
import com.qingcloud.sdk.service.Types;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.List;

public class SecurityGroupConvertor implements BeanConvertor<SecurityGroupModel, Types.SecurityGroupModel> {

    private static Logger logger = LoggerFactory.getLogger(SecurityGroupConvertor.class);

    @Override
    public List<SecurityGroupModel> convertList(List<? extends Types.SecurityGroupModel> objects) {
        List<SecurityGroupModel> groupModels = new ArrayList<>();
        for (Types.SecurityGroupModel object : objects) {
        	Integer isApplied = object.getIsApplied();
        	if(null != isApplied && isApplied == 0 && "default security group".equalsIgnoreCase(object.getSecurityGroupName())) {
        		continue;
        	}
            groupModels.add(convertModel(object));
        }
        return groupModels;
    }

    @Override
    public SecurityGroupModel convertModel(Types.SecurityGroupModel info) {
        SecurityGroupModel model = new SecurityGroupModel();
        if (null != info) {
            try {
                model.setName(info.getSecurityGroupName());
                model.setRemark(info.getDescription());
                model.setGroupUuid(info.getSecurityGroupID());
                model.setCreateTime(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", info.getCreateTime(), "Z"));
            } catch (Exception e) {
                logger.error("时间转换error : " + e);
            }
        }
        return model;
    }

}

