
package com.bocloud.cmp.provider.qcloudconvertor;

import com.bocloud.cmp.model.SnapshotModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;
import com.qingcloud.sdk.service.Types;

import java.util.ArrayList;
import java.util.List;

public class SnapshotConvertor implements BeanConvertor<SnapshotModel, Types.SnapshotModel> {

    @Override
    public List<SnapshotModel> convertList(List<? extends Types.SnapshotModel> objects) {
        List<SnapshotModel> snapshotModels = new ArrayList<>();
        for (Types.SnapshotModel object : objects) {
            snapshotModels.add(convertModel(object));
        }
        return snapshotModels;
    }

    @Override
    public SnapshotModel convertModel(Types.SnapshotModel snapshot) {
        SnapshotModel model = new SnapshotModel();
        if (null != snapshot) {
            model.setSize(snapshot.getSize());
            model.setName(snapshot.getSnapshotName());
            model.setSnapshotUuid(snapshot.getSnapshotID());
            String snapshotState = snapshot.getStatus();
            model.setStatus(snapshotState);
            model.setRemark(snapshot.getDescription());
            String createdTime = snapshot.getCreateTime();
            if (null != createdTime && !"".equals(createdTime)) {
                model.setCreateTime(DateTools.transfer("yyyy-MM-dd'T'HH:mm:ssZ", createdTime, "Z"));
            }
        }
        return model;
    }

}

