
package com.bocloud.cmp.provider.qcloudconvertor;

import com.bocloud.cmp.model.ZoneModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.qingcloud.sdk.service.Types;

import java.util.ArrayList;
import java.util.List;


/**
 * 地域 转换
 *
 * @author wangyu
 * @时间 2019年10月24日
 */
public class ZoneConvertor implements BeanConvertor<ZoneModel, Types.ZoneModel> {

    @Override
    public List<ZoneModel> convertList(List<? extends Types.ZoneModel> objects) {
        List<ZoneModel> regionModels = new ArrayList<>();
        for (Types.ZoneModel object : objects) {
            if ("active".equalsIgnoreCase(object.getStatus())) {
                regionModels.add(convertModel(object));
            }
        }
        return regionModels;
    }

    @Override
    public ZoneModel convertModel(Types.ZoneModel info) {
        ZoneModel model = new ZoneModel();
        if (null != info) {
            model.setZoneId(info.getZoneID());
            model.setName(this.getName(info.getZoneID()));
            model.setResources(info.getZoneID());
        }
        return model;
    }

    private String getName(String zoneId) {
        String name = zoneId;
        switch (zoneId) {
            case "sh1b":
                name = "上海1区-B";
                break;
            case "sh1a":
                name = "上海1区-A";
                break;
            case "ap2a":
                name = "亚太2区-A";
                break;
            case "gd2b":
                name = "广东2区-B";
                break;
            case "gd2a":
                name = "广东2区-A";
                break;
            case "pek3b":
                name = "北京3区-B";
                break;
            case "pek3c":
                name = "北京3区-C";
                break;
            case "pek3d":
                name = "北京3区-D";
                break;
            default:
                break;
        }
        return name;
    }
}

