package com.bocloud.cmp.provider.v68.common;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.SangforProvider;
import com.bocloud.cmp.provider.common.AuthProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.Result;
import org.apache.commons.lang3.StringUtils;

@Provider("bocloud.cmp.sangfor.v68")
public class SangforAuthProvider extends SangforProvider implements AuthProvider {
    public SangforAuthProvider(Butler butler) {
        super(butler);
    }

    @Override
    public boolean accessable() {
        return super.accessable();
    }

    @Override
    public BocloudResult auth() {
        Result result = this.doGet("/janus/20180725/system/version", null);
        if (result.isSuccess() && !StringUtils.isEmpty(result.getMessage())) {
            JSONObject returnData = JSON.parseObject(result.getMessage());
            if (null != returnData && returnData.getInteger("code") == 0) {
                return new BocloudResult(true, "认证成功");
            }
        }
        return new BocloudResult(false, "认证失败");
    }
}
