package com.bocloud.cmp.provider.v68.model;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;

/**
 * 任务查询结果实体类
 *
 * @author sxp
 * @since 2023/5/29
 */
@Data
public class TaskResponseModel {
    @JSONField(name = "task_id")
    private String taskId;

    private String action; // "启动云主机"

    /**
     * 状态
     * <pre>
     * waiting 排队，对应进度为：-2
     * failure 失败，对应进度为：-1
     * doing 正在执行，对应进度：0~99
     * finish 完成，对应进度为：100
     * canceling 正在取消
     * canceled 已取消
     * </pre>
     */
    private String status;

    /**
     * 进度
     * 其中：-2表示正在排队，-1表示失败，取值范围0~100，0~99表示正在执行，100表示成功
     */
    private Integer progress;

    @JSONField(name = "object_type")
    private String objectType;// "云主机"

    @JSONField(name = "object_name")
    private String objectName;// "bocloud-sxp-centos"

    @JSONField(name = "begin_time")
    private String beginTime;// "2023-05-29T14:41:53.000000"

    @JSONField(name = "end_time")
    private String endTime;// "2023-05-29T14:41:56.000000"

    private String description;
    private JSONObject entities;




}
