package com.bocloud.cmp.provider.v68.storage;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.VolumeModel;
import com.bocloud.cmp.model.sangfor.SangForStoragePolicyModel;
import com.bocloud.cmp.provider.SangforProvider;
import com.bocloud.cmp.provider.storage.VolumeProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.List;

@Slf4j
@Provider("bocloud.cmp.sangfor.v68")
public class SangforVolumeProvider extends SangforProvider implements VolumeProvider {
    public SangforVolumeProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult list() {
        return new BocloudResult(false, "暂不支持");
    }


    @Override
    public BocloudResult create(VolumeModel volume) {
        return new BocloudResult(false, "暂不支持");
    }


    @Override
    public BocloudResult extend(String instanceId, Integer newSize) {
        return new BocloudResult(false, "暂不支持");
    }

    @Override
    public BocloudResult listPolicy(String volumeUuid) {
        List<SangForStoragePolicyModel> policyModels = new ArrayList<>();
        return new BocloudResult(true, policyModels, "SCP6.8没有存储策略的概念");
    }
}
