package com.bocloud.cmp.provider;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.smart.sdk.session.SessionManager;
import com.bocloud.cmp.provider.smart.sdk.session.SessionParams;
import com.bocloud.cmp.provider.smart.sdk.session.SessionParamsAdapter;

public class SmartProvider extends GenericProvider implements SuperProvider {

    private final Butler butler;

    public SmartProvider(Butler butler) {
        super(butler);
        this.butler = butler;
    }

    protected SessionParams getSessionParams() {
        return new SessionParamsAdapter(this.butler);
    }

    public Butler getButler() {
        return butler;
    }

    @Override
    public boolean accessable() {
        return new SessionManager().getSession(this.getSessionParams()) != null;
    }
}
