package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.SmartProvider;
import com.bocloud.cmp.provider.smart.sdk.session.SessionManager;
import com.bocloud.cmp.provider.smart.sdk.session.SessionToken;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@Provider("bocloud.cmp.smartx")
public class SmartAuthProvider extends SmartProvider implements AuthProvider {

    private static final Logger logger = LoggerFactory.getLogger(SmartAuthProvider.class);
    
    public SmartAuthProvider(Butler butler) {
        super(butler);
    }

    @Override
    @SuppressWarnings("unchecked")
    public BocloudResult auth() {
        try {
            SessionToken token = new SessionManager().getSession(this.getSessionParams());
            return new BocloudResult(token != null, token, "success");
        } catch (Exception e) {
            logger.error("Smart-X auth failed: {}", e.getMessage(), e);
            return new BocloudResult(false, e.getMessage());
        }
    }
}
