package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.TaskMsgModel;
import com.bocloud.cmp.provider.SmartProvider;
import com.bocloud.cmp.provider.smart.sdk.api.JobApi;
import com.bocloud.cmp.provider.smart.sdk.convert.JobConvert;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

import java.util.List;

@Provider("bocloud.cmp.smartx")
public class SmartTaskMsgProvider extends SmartProvider implements TaskMsgProvider {

    private final JobApi jobApi;
    private final JobConvert jobConvert = new JobConvert();

    public SmartTaskMsgProvider(Butler butler) {
        super(butler);
        jobApi = new JobApi(this.getSessionParams());
    }

    @Override
    public BocloudResult<TaskMsgModel> get(String uuid) {
        TaskMsgModel taskMsgModel = jobConvert.convert(jobApi.get(uuid));
        return new BocloudResult<>(true, taskMsgModel, "success");
    }

    @Override
    public BocloudResult<List<TaskMsgModel>> list() {
        List<TaskMsgModel> taskMsgModels = jobConvert.convert(jobApi.list());
        return new BocloudResult<>(true, taskMsgModels, "success");
    }
}
