package com.bocloud.cmp.provider.smart.sdk.api;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.smart.sdk.constant.Constant;
import com.bocloud.cmp.provider.smart.sdk.model.HostModel;
import com.bocloud.cmp.provider.smart.sdk.session.SessionParams;
import org.apache.http.HttpEntity;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;

import java.util.Collections;
import java.util.List;
import java.util.Map;

public class HostApi extends SmartApi {

    public HostApi(SessionParams sessionParams) {
        super(sessionParams);
    }

    public List<HostModel> list() {
        String url = this.getSessionParams().getHost() + Constant.URL_HOSTS;
        String response = this.getDefaultHttpInvoke().request(url, "GET");
        return JSON.parseArray(response, HostModel.class);
    }

    public void modifyHostName(String uuid, String hostname) {
        String url = this.getSessionParams().getHost() + String.format(Constant.URL_HOST_CHANGE_HOSTNAME, uuid);
        Map<String, String> params = Collections.singletonMap("hostname", hostname);
        HttpEntity entity = new StringEntity(JSON.toJSONString(params), ContentType.APPLICATION_JSON);
        this.getDefaultHttpInvoke().request(url, "PUT", entity);
    }
}
