package com.bocloud.cmp.provider.smart.sdk.api;

import com.bocloud.cmp.provider.smart.sdk.http.*;
import com.bocloud.cmp.provider.smart.sdk.session.SessionParams;

public class SmartApi {

    private final SessionParams sessionParams;

    @SuppressWarnings("unchecked")
    public SmartApi(SessionParams sessionParams) {
        this.sessionParams = sessionParams;
    }

    public HttpInvoker getDefaultHttpInvoke() {
        String debug = System.getProperty("smart.debug", Boolean.FALSE.toString());
        if (Boolean.TRUE.toString().equals(debug)) {
            return  new SmartInvoke(
                    new ThrowsInvoke(
                    new LoggingInvoker(
                    new DebugInvoke())));
        } else {
            return  new SmartInvoke(
                    new SessionInvoker(
                    new ThrowsInvoke(
                    new LoggingInvoker(
                    new ClientInvoker())), this.sessionParams));
        }
    }

    public SessionParams getSessionParams() {
        return sessionParams;
    }

}
