package com.bocloud.cmp.provider.smart.sdk.api;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.smart.sdk.constant.Constant;
import com.bocloud.cmp.provider.smart.sdk.model.StoragePolicyModel;
import com.bocloud.cmp.provider.smart.sdk.model.create.StoragePolicyCreateModel;
import com.bocloud.cmp.provider.smart.sdk.model.modify.StoragePolicyModifyModel;
import com.bocloud.cmp.provider.smart.sdk.session.SessionParams;
import org.apache.http.HttpEntity;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;

import java.util.List;

public class StoragePolicyApi extends SmartApi {

    public StoragePolicyApi(SessionParams sessionParams) {
        super(sessionParams);
    }

    public List<StoragePolicyModel> list() {
        String url = this.getSessionParams().getHost() + Constant.URL_STORAGE_POLICIES;
        String response = this.getDefaultHttpInvoke().request(url, "GET");
        return JSON.parseArray(response, StoragePolicyModel.class);
    }

    public StoragePolicyModel get(String uuid) {
        String url = this.getSessionParams().getHost() + String.format(Constant.URL_STORAGE_POLICY, uuid);
        String response = this.getDefaultHttpInvoke().request(url, "GET");
        return JSON.parseObject(response, StoragePolicyModel.class);
    }

    public StoragePolicyModel create(StoragePolicyCreateModel param) {
        String url = this.getSessionParams().getHost() + Constant.URL_STORAGE_POLICIES;
        HttpEntity entity = new StringEntity(JSON.toJSONString(param), ContentType.APPLICATION_JSON);
        String response = this.getDefaultHttpInvoke().request(url, "POST", entity);
        return JSON.parseObject(response, StoragePolicyModel.class);
    }

    public void modify(String uuid, StoragePolicyModifyModel param) {
        String url = this.getSessionParams().getHost() + String.format(Constant.URL_STORAGE_POLICY, uuid);
        HttpEntity entity = new StringEntity(JSON.toJSONString(param), ContentType.APPLICATION_JSON);
        this.getDefaultHttpInvoke().request(url, "PUT", entity);
    }

    public void remove(String uuid) {
        String url = this.getSessionParams().getHost() + String.format(Constant.URL_STORAGE_POLICY, uuid);
        this.getDefaultHttpInvoke().request(url, "DELETE");
    }
}
