package com.bocloud.cmp.provider.smart.sdk.api;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.smart.sdk.constant.Constant;
import com.bocloud.cmp.provider.smart.sdk.model.AvailableNicModel;
import com.bocloud.cmp.provider.smart.sdk.model.VdsModel;
import com.bocloud.cmp.provider.smart.sdk.model.create.VdsCreateModel;
import com.bocloud.cmp.provider.smart.sdk.model.modify.VdsModifyModel;
import com.bocloud.cmp.provider.smart.sdk.session.SessionParams;
import org.apache.http.HttpEntity;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;

import java.util.List;

public class VdsApi extends SmartApi {

    public VdsApi(SessionParams sessionParams) {
        super(sessionParams);
    }

    public List<VdsModel> list() {
        String url = this.getSessionParams().getHost() + Constant.URL_VDSES;
        String response = this.getDefaultHttpInvoke().request(url, "GET");
        return JSON.parseArray(response, VdsModel.class);
    }

    public VdsModel get(String uuid) {
        String url = this.getSessionParams().getHost() + String.format(Constant.URL_VDS, uuid);
        String response = this.getDefaultHttpInvoke().request(url, "GET");
        return JSON.parseObject(response, VdsModel.class);
    }

    public List<AvailableNicModel> listAvailableNic() {
        String url = this.getSessionParams().getHost() + Constant.URL_AVAILABLE_NICS;
        String response = this.getDefaultHttpInvoke().request(url, "GET");
        return JSON.parseArray(response, AvailableNicModel.class);
    }

    public String create(VdsCreateModel param) {
        String url = this.getSessionParams().getHost() + Constant.URL_VDSES;
        HttpEntity entity = new StringEntity(JSON.toJSONString(param), ContentType.APPLICATION_JSON);
        String response = this.getDefaultHttpInvoke().request(url, "POST", entity);
        return JSON.parseObject(response).getString("job_id");
    }

    public String modify(String uuid, VdsModifyModel param) {
        String url = this.getSessionParams().getHost() + String.format(Constant.URL_VDS, uuid);
        HttpEntity entity = new StringEntity(JSON.toJSONString(param), ContentType.APPLICATION_JSON);
        String response = this.getDefaultHttpInvoke().request(url, "PUT", entity);
        return JSON.parseObject(response).getString("job_id");
    }

    public String remove(String uuid) {
        String url = this.getSessionParams().getHost() + String.format(Constant.URL_VDS, uuid);
        String response = this.getDefaultHttpInvoke().request(url, "DELETE");
        return JSON.parseObject(response).getString("job_id");
    }
}
