package com.bocloud.cmp.provider.smart.sdk.convert;

import com.bocloud.cmp.provider.smart.sdk.model.ClusterModel;

import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

public class ClusterConvert {

    public List<com.bocloud.cmp.model.ClusterModel> convert(List<ClusterModel> params) {
        return params.stream().map(this::convert).collect(Collectors.toList());
    }

    public com.bocloud.cmp.model.ClusterModel convert(ClusterModel param) {
        com.bocloud.cmp.model.ClusterModel result = new com.bocloud.cmp.model.ClusterModel();
        result.setUuid(param.getId());
        result.setName(param.getDispayName());
        result.setStatus(param.getStatus());
        Optional.of(param).map(ClusterModel::getSummary).map(ClusterModel.Summary::getHostCount)
                .map(Long::intValue).ifPresent(result::setHostNum);
        Optional.of(param).map(ClusterModel::getSummary).map(ClusterModel.Summary::getVmCount)
                .map(Long::intValue).ifPresent(result::setVmNum);
        return result;
    }
}
