package com.bocloud.cmp.provider.smart.sdk.convert;

import com.bocloud.cmp.model.storage.StorageDiskModel;
import com.bocloud.cmp.provider.smart.sdk.model.HostModel;

import java.util.List;
import java.util.stream.Collectors;

public class HostDiskConvert {

    public List<StorageDiskModel> convert(List<HostModel.Disk> params) {
        return params.stream().map(this::convert).collect(Collectors.toList());
    }

    public StorageDiskModel convert(HostModel.Disk params) {
        StorageDiskModel result = new StorageDiskModel();
        result.setDiskUuid(params.getId());
        result.setName(params.getName());
        result.setStatus(params.getIsHealthy() ? "healthy": "unhealthy");
        result.setType(params.getType());
        result.setPath(params.getPath());
        result.setCapacity(params.getSize());
        result.setProductId(params.getSerial());

        result.setPartitions(new PartitionConvert().convert(params.getPartitions()));
        return result;
    }
}
