package com.bocloud.cmp.provider.smart.sdk.convert;

import com.bocloud.cmp.provider.smart.sdk.model.ImageModel;

import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

public class ImageConvert {

    public List<com.bocloud.cmp.model.ImageModel> convert(List<ImageModel> params) {
        return params.stream().map(this::convert).collect(Collectors.toList());
    }

    public com.bocloud.cmp.model.ImageModel convert(ImageModel param) {
        com.bocloud.cmp.model.ImageModel result = new com.bocloud.cmp.model.ImageModel();
        result.setImageUuid(param.getUuid());
        result.setName(param.getName());
        result.setImageType(param.getType());
        result.setFilePath(param.getPath());
        result.setSize(Math.round(param.getSize() / 1024D / 1024D / 1024D * 1000D) / 1000D);
        result.setGmtCreate(new Date(param.getTime() * 1000));
        result.setOsVersion(param.getOs());
        result.setStatus(param.getResourceState());
        result.setRemark(param.getDescription());
        return result;
    }
}
