package com.bocloud.cmp.provider.smart.sdk.convert;

import com.bocloud.cmp.provider.smart.sdk.model.VdsModel;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class VdsConvert {

    public List<com.bocloud.cmp.model.SwitcherModel> convert(List<VdsModel> params) {
        return params.stream().map(this::convert).collect(Collectors.toList());
    }

    public com.bocloud.cmp.model.SwitcherModel convert(VdsModel params) {
        com.bocloud.cmp.model.SwitcherModel result = new com.bocloud.cmp.model.SwitcherModel();
        result.setUuid(params.getUuid());
        result.setName(params.getName());
        result.setBondName(params.getBondName());
        result.setBondMode(params.getBondMode());
        result.setOvsbrName(params.getOvsbrName());
        result.setRemark(params.getDescription());

        Map<String, List<String>> hostNetworkCards = new HashMap<>();
        params.getHostsAssociated().forEach(o -> hostNetworkCards.put(o.getHostUuid(), o.getNicsAssociated()));
        result.setHostNetworkCards(hostNetworkCards);
        return result;
    }
}
