package com.bocloud.cmp.provider.smart.sdk.convert;

import com.bocloud.cmp.provider.smart.sdk.model.VmModel;

import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

public class VmDiskConvert {

    public List<com.bocloud.cmp.model.VolumeModel> convert(VmModel.VmType vmType, List<VmModel.Disk> params) {
        return params.stream().map(v -> this.convert(vmType, v)).collect(Collectors.toList());
    }

    public com.bocloud.cmp.model.VolumeModel convert(VmModel.VmType vmType, VmModel.Disk params) {
        com.bocloud.cmp.model.VolumeModel result = new com.bocloud.cmp.model.VolumeModel();
        result.setBootIndex(params.getBoot());
        result.setType(params.getType());
        result.setBus(params.getBus());
        result.setPath(params.getPath());
        result.setVolumeUuid(params.getVolumeUuid());
        result.setTemplateUuid(params.getVolumeTemplateUuid());
        result.setVolumeTemplateUuid(params.getStoragePolicyUuid());
        result.setDisabled(params.getDisabled());
        result.setKey(params.getKey());

        if (vmType.equals(VmModel.VmType.VM)) {
            result.setName(params.getName());
            result.setBlockSize(1D);
            result.setBlockCount(params.getSize());
            Optional.of(params).map(VmModel.Disk::getSize).map(s -> s / 1024 / 1024 / 1024)
                    .map(Long::intValue).ifPresent(result::setSize);
        } else if (vmType.equals(VmModel.VmType.VM_TEMPLATE)) {
            result.setName(params.getName());
            result.setBlockSize(1D);
            result.setBlockCount(params.getSize());
            Optional.of(params).map(VmModel.Disk::getSize).map(s -> s / 1024 / 1024 / 1024)
                    .map(Long::intValue).ifPresent(result::setSize);
        } else if (vmType.equals(VmModel.VmType.VM_SNAPSHOT)) {
            // do nothing
        }
        return result;
    }
}
