package com.bocloud.cmp.provider.smart.sdk.convert;

import com.bocloud.cmp.model.IpModel;
import com.bocloud.cmp.model.NetworkCardModel;
import com.bocloud.cmp.provider.smart.sdk.model.VmModel;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

public class VmNicConvert {

    public List<com.bocloud.cmp.model.NetworkCardModel> convertToNetworkCard(List<VmModel.Nic> params) {
        List<com.bocloud.cmp.model.NetworkCardModel> results = new ArrayList<>();
        for (int i = 0; i < params.size(); i++) {
            NetworkCardModel result = this.convertToNetworkCard(params.get(i));
            result.setLabel("nic" + i);
            results.add(result);
        }
        return results;
    }

    public List<com.bocloud.cmp.model.IpModel> convertToIp(List<VmModel.Nic> params) {
        return params.stream().map(this::convertToIp).collect(Collectors.toList());
    }

    public com.bocloud.cmp.model.NetworkCardModel convertToNetworkCard(VmModel.Nic param) {
        com.bocloud.cmp.model.NetworkCardModel result = new com.bocloud.cmp.model.NetworkCardModel();
        result.setNetworkcardUuid(param.getUuid());
        result.setNetworkUuid(param.getVlanUuid());
        result.setSubnetUuid(param.getVlanUuid());
        result.setIpAddress(param.getIpAddress());
        result.setMac(param.getMacAddress());
        result.setNetmask(param.getSubnetMask());
        result.setGateway(param.getGateway());
        result.setUsed("up".equals(param.getLink()));
        result.setModel(param.getModel());

        Optional.of(param).map(VmModel.Nic::getVlans).flatMap(vlans -> vlans.stream().findFirst())
                .map(VmModel.Nic.Vlan::getVlanId).ifPresent(result::setVlan);

        return result;
    }

    public com.bocloud.cmp.model.IpModel convertToIp(VmModel.Nic param) {
        IpModel result = new IpModel();
        result.setNetworkUuid(param.getVlanUuid());
        result.setSubnetUuid(param.getVlanUuid());
        result.setMac(param.getMacAddress());
        result.setIp(param.getIpAddress());
        result.setMask(param.getSubnetMask());
        result.setGateway(param.getGateway());
        return result;
    }
}
