package com.bocloud.cmp.provider.smart.sdk.convert;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.provider.smart.sdk.model.VmModel;

import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

public class VmSnapshotConvert {

    public List<com.bocloud.cmp.model.SnapshotModel> convert(List<VmModel> params) {
        return params.stream().map(this::convert).collect(Collectors.toList());
    }

    public com.bocloud.cmp.model.SnapshotModel convert(VmModel params) {
        com.bocloud.cmp.model.SnapshotModel result = new com.bocloud.cmp.model.SnapshotModel();
        result.setSnapshotUuid(params.getUuid());
        result.setName(params.getName());
        result.setSnapshotType("VM");
        result.setStatus("AVAILABLE");
        result.setSizeByte(params.getUniqueSize());
        result.setSize((int) (params.getUniqueSize() / 1024 / 1024 / 1024));
        result.setInstanceId(params.getVmUuid());
        result.setVmName(params.getVmName());
        result.setVmValue(JSON.toJSONString(params));
        result.setCreateTime(new Date(params.getCreateTime() * 1000));
        result.setRemark(params.getDescription());
        return result;
    }
}
