package com.bocloud.cmp.provider.smart.sdk.convert;

import com.bocloud.cmp.provider.smart.sdk.model.VolumeModel;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

public class VolumeConvert {

    public List<com.bocloud.cmp.model.VolumeModel> convert(List<VolumeModel> params) {
        return params.stream().map(this::convert).collect(Collectors.toList());
    }

    public com.bocloud.cmp.model.VolumeModel convert(VolumeModel params) {
        com.bocloud.cmp.model.VolumeModel result = new com.bocloud.cmp.model.VolumeModel();
        result.setVolumeUuid(params.getUuid());
        result.setName(params.getName());
        result.setType(params.getType());
        result.setPath(params.getPath());
        result.setDevice(params.getPath());
        if (params.getMounting() == null) {
            result.setStatus("AVAILABLE");
        } else if (params.getMounting()) {
            result.setStatus("IN-USE");
        } else {
            result.setStatus("AVAILABLE");
        }
        result.setRemark(params.getDescription());
        result.setBlockSize(1D);
        result.setBlockCount(params.getSizeInByte());
        result.setSize((int) (params.getSizeInByte() / 1024 / 1024 / 1024));
        result.setMultiattach(params.getSharing());
        result.setVolumeTemplateUuid(params.getStoragePolicyUuid());
        Optional.of(params).map(VolumeModel::getCreateTime).map(t -> t * 1000).map(Date::new).ifPresent(result::setCreateTime);

        List<VolumeModel.MountVm> mountVms = Optional.of(params).map(VolumeModel::getMountingVmList).orElseGet(ArrayList::new);
        result.setServerUuids(mountVms.stream().map(VolumeModel.MountVm::getUuid).collect(Collectors.toList()));
        return result;
    }
}
