package com.bocloud.cmp.provider.smart.sdk.convert;

import com.bocloud.cmp.provider.smart.sdk.model.VolumeModel;

import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

public class VolumeSnapshotConvert {

    public List<com.bocloud.cmp.model.SnapshotModel> convert(List<VolumeModel> params) {
        return params.stream().map(this::convert).collect(Collectors.toList());
    }

    public com.bocloud.cmp.model.SnapshotModel convert(VolumeModel params) {
        com.bocloud.cmp.model.SnapshotModel result = new com.bocloud.cmp.model.SnapshotModel();
        result.setSnapshotUuid(params.getUuid());
        result.setName(params.getName());
        result.setSnapshotType("VOLUME");
        result.setStatus("AVAILABLE");
        result.setVolumeUuid(params.getVolumeUuid());
        result.setVolumeName(params.getVolumeName());
        result.setSizeByte(params.getUniqueSize());
        if(-1!=params.getUniqueSize()){
            result.setSize((int)(params.getUniqueSize()/1024/1024/1024));
        }else{
            result.setSize(-1);
        }
        result.setCreateTime(new Date(params.getCreateTime() * 1000));
        result.setRemark(params.getDescription());
        return result;
    }
}
