package com.bocloud.cmp.provider.smart.sdk.exception;

import com.bocloud.cmp.provider.smart.sdk.model.ResultModel;
import org.apache.http.Header;
import org.apache.http.HttpEntity;

public class SmartException extends RuntimeException {

    private final String url;
    private final String method;
    private final Header[] headers;
    private final HttpEntity entity;
    private final ResultModel result;

    public SmartException( String url, String method, Header[] headers, HttpEntity entity, ResultModel result) {
        this.url = url;
        this.method = method;
        this.headers = headers;
        this.entity = entity;
        this.result = result;
    }

    public ResultModel getResult() {
        return result;
    }

    public String getUrl() {
        return url;
    }

    public String getMethod() {
        return method;
    }

    public HttpEntity getEntity() {
        return entity;
    }

    public Header[] getHeaders() {
        return headers;
    }

    @Override
    public String getMessage() {
        return String.format("[%s] %s", this.result.getEc(), this.result.getError());
    }
}
