package com.bocloud.cmp.provider.smart.sdk.http;

import org.apache.http.Header;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.util.EntityUtils;

import java.io.IOException;

public interface HttpInvoker {

    HttpResponse invoke(String url, String method, Header[] headers, HttpEntity entity);

    default HttpResponse invoke(String url, String method, HttpEntity entity) {
        return this.invoke(url, method, null, entity);
    }

    default HttpResponse invoke(String url, String method) {
        return this.invoke(url, method, null, null);
    }

    default String request(String url, String method, Header[] headers, HttpEntity entity) {
        HttpResponse response = this.invoke(url, method, headers, entity);
        if (response.getEntity() == null) {
            return null;
        }
        try {
            return EntityUtils.toString(response.getEntity());
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    default String request(String url, String method, HttpEntity entity) {
        return this.request(url, method, null, entity);
    }

    default String request(String url, String method) {
        return this.request(url, method, null, null);
    }

}
