package com.bocloud.cmp.provider.smart.sdk.http;

import com.bocloud.cmp.provider.smart.sdk.exception.HttpException;
import org.apache.http.Header;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;

import java.util.Arrays;

public class ThrowsInvoke implements HttpInvoker {

    private final HttpInvoker target;
    private int[] acceptCodes = new int[]{200, 201, 202, 204};

    public ThrowsInvoke(HttpInvoker target) {
        this.target = target;
    }

    public ThrowsInvoke(HttpInvoker target, int[] acceptCodes) {
        this.target = target;
        this.acceptCodes = acceptCodes;
    }

    public void setAcceptCodes(int[] acceptCodes) {
        this.acceptCodes = acceptCodes;
    }

    @Override
    public HttpResponse invoke(String url, String method, Header[] headers, HttpEntity entity) {
        HttpResponse response = target.invoke(url, method, headers, entity);
        int statusCode = response.getStatusLine().getStatusCode();
        if (Arrays.binarySearch(acceptCodes, statusCode) < 0) {
            throw new HttpException(response);
        }
        return response;
    }
}
