package com.bocloud.cmp.provider.smart.sdk.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
public class AvailableNicModel {

    @JSONField(name = "host_uuid")
    private String hostUuid;
    @JSONField(name = "host")
    private String host;

    @JSONField(name = "management_ip")
    private String managementIp;
    @JSONField(name = "access_ip")
    private String accessIp;
    @JSONField(name = "vmotion_ip")
    private String vmotionIp;
    @JSONField(name = "data_ip")
    private String dataIp;

    private List<Nic> nics;
    @JSONField(name = "ovsbr_nics")
    private List<Ovsbr> ovsbrNics;

    @Data
    @NoArgsConstructor
    public static class Ovsbr {

        private String name;
        private List<Nic> nics;

    }

    @Data
    @NoArgsConstructor
    public static class Nic{
        private String name;
        private String usage;
        private Boolean running;
        private Boolean up;

        @JSONField(name = "bonding_detail")
        private String bondingDetail;
        @JSONField(name = "bonding_master")
        private String bondingMaster;
        @JSONField(name = "bonding_mode")
        private String bondingMode;

        @JSONField(name = "is_physical")
        private Boolean isPhysical;

        private String hwaddr;
        private String ipaddr;
        private String netmask;
        private String gateway;
        private Integer vlan;
        private Long mtu;
        private Long speed;
    }
}
