package com.bocloud.cmp.provider.smart.sdk.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
public class ClusterModel{

    private String id;
    @JSONField(name = "display_name")
    private String dispayName;
    private String status;
    private String role;
    @JSONField(name = "management_ip")
    private String managementIp;
    @JSONField(name = "management_port")
    private String managementPort;
    @JSONField(name = "ca_crt_setted")
    private Boolean caCrtSetted;
    @JSONField(name = "ca_crt")
    private String caCrt;
    private String hypervisor;
    private String version;
    private Authentication authentication;
    private Summary summary;

    @Data
    @NoArgsConstructor
    public static class Summary {

        @JSONField(name = "host_count")
        private Long hostCount;
        @JSONField(name = "vm_count")
        private Long vmCount;

        @JSONField(name = "info_alert_count")
        private Long infoAlertCount;
        @JSONField(name = "notice_alert_count")
        private Long noticeAlertCount;
        @JSONField(name = "critical_alert_count")
        private Long criticalAlertCount;

        @JSONField(name = "used_space_bytes")
        private Long usedSpaceBytes;
        @JSONField(name = "total_space_bytes")
        private Long totalSpaceBytes;
        @JSONField(name = "failure_space_bytes")
        private Long failureSpaceBytes;
    }

    @Data
    @NoArgsConstructor
    public static class Authentication{

        @JSONField(name = "login_info")
        private LoginInfo loginInfo;

        @Data
        @NoArgsConstructor
        public static class LoginInfo{
            private String username;
            private String password;
        }
    }

}
