package com.bocloud.cmp.provider.smart.sdk.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
public class ComputeSummaryModel {

    private Long hz;

    @JSONField(name = "total_cpu_cores")
    private Integer totalCpuCores;
    @JSONField(name = "provisioned_cpu_cores")
    private Integer provisionedCpuCores;
    @JSONField(name = "provisioned_cpu_cores_for_active_vm")
    private Integer provisionedCpuCoresCorActiveVm;

    @JSONField(name = "total_memory")
    private Long totalMemory;
    @JSONField(name = "total_memory_in_byte")
    private Long totalMemoryInByte;
    @JSONField(name = "used_memory")
    private Long usedMemory;
    @JSONField(name = "used_memory_in_byte")
    private Long usedMemoryInByte;
    @JSONField(name = "provisioned_memory")
    private Long provisionedMemory;
    @JSONField(name = "provisioned_memory_in_byte")
    private Long provisionedMemoryInByte;
    @JSONField(name = "provisioned_memory_for_active_vm")
    private Long provisionedMemoryForActiveVm;
    @JSONField(name = "provisioned_memory_in_byte_for_active_vm")
    private Long provisionedMemoryInByteForActiveVm;

    @JSONField(name = "total_vms")
    private Integer totalVms;

    @JSONField(name = "vms_state")
    private VmStat vmStat;

    @Data
    @NoArgsConstructor
    public static class VmStat {
        private Integer poweredOff;
        private Integer poweredOn;
        private Integer suspended;
    }


}
