package com.bocloud.cmp.provider.smart.sdk.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
public class ImageStatsModel {

    private Long count;

    private List<Vm> vms;
    @JSONField(name = "vms_count")
    private Long vmsCount;

    @JSONField(name = "vm_snapshots")
    private List<VmSnapshot> vmSnapshots;
    @JSONField(name = "vm_snapshots_count")
    private Long vmSnapshotsCount;

    @JSONField(name = "vm_templates")
    private List<VmTemplate> vmTemplates;
    @JSONField(name = "vm_templates_count")
    private Long vmTemplatesCount;

    @Data
    @NoArgsConstructor
    public static class VmSnapshot {
        private String uuid;
        private String name;
        @JSONField(name = "create_time")
        private Long createTime;
    }

    @Data
    @NoArgsConstructor
    public static class VmTemplate {
        private String uuid;
        private String name;
        @JSONField(name = "create_time")
        private Long createTime;
    }

    @Data
    @NoArgsConstructor
    public static class Vm {
        private String uuid;
        @JSONField(name = "vm_name")
        private String vmName;
        private String status;
        @JSONField(name = "create_time")
        private Long createTime;
    }
}
