package com.bocloud.cmp.provider.smart.sdk.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.NoArgsConstructor;

import java.util.List;
import java.util.Map;

@lombok.Data
@NoArgsConstructor
public class JobModel {

    @JSONField(name = "job_id")
    private String jobId;
    private String state; // pending processing done failed
    @JSONField(name = "life_cycle")
    private String lifeCycle; // run
    private String description;
    private String type; // schedule定时job action一般job
    private String user; // root
    private Long ctime;
    private Long ftime;
    private String queue;
    private String handler;
    private Event event;
    @JSONField(name = "task_list")
    private List<Task> taskList;
    @JSONField(name = "resource_group")
    private String resourceGroup;
    private String resources;

    @lombok.Data
    @NoArgsConstructor
    public static class Event {
        @JSONField(name = "event_name")
        private String eventName;
        private String batch;
        private Data data;
        private Language detail;
        private Language message;
        private Map<String, String> resources;
        @JSONField(name = "user_name")
        private String userName;
        @JSONField(name = "user_role")
        private String userRole;
        @JSONField(name = "user_type")
        private String userType;

        @lombok.Data
        @NoArgsConstructor
        public static class Data {

            private String uuid;
            private String name;

            @JSONField(name = "vm_id")
            private String vmId;
            @JSONField(name = "vm_name")
            private String vmName;

            @JSONField(name = "vm_snapshot_id")
            private String vmSnapshotId;
            @JSONField(name = "vm_snapshot_name")
            private String vmSnapshotName;

            @JSONField(name = "vm_template_id")
            private String vmTemplateId;
            @JSONField(name = "vm_template_name")
            private String vmTemplateName;

            @JSONField(name = "volume_id")
            private String volumeId;
            @JSONField(name = "volume_name")
            private String volumeName;

            @JSONField(name = "volume_snapshot_id")
            private String volumeSnapshotId;
            @JSONField(name = "volume_snapshot_name")
            private String volumeSnapshotName;

            @JSONField(name = "data_ip")
            private String dataIp;
            private String hostname;

        }

        @lombok.Data
        @NoArgsConstructor
        public static class Language {
            @JSONField(name = "en_US")
            private String enUS;
            @JSONField(name = "zh_CN")
            private String zhCN;
        }
    }

    @lombok.Data
    @NoArgsConstructor
    public static class Task {
        private String uuid;
        private String data;
        @JSONField(name = "error_code")
        private String errorCode;
        @JSONField(name = "error_msg")
        private String errorMessage;
        @JSONField(name = "follower_name")
        private String followerName;
        private String handler;
        private String msg;
        private String queue;
        private String reference;
        private String state;
        private Long time;
    }
}
