package com.bocloud.cmp.provider.smart.sdk.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Collections;
import java.util.List;
import java.util.Optional;

@Data
@NoArgsConstructor
public class MetricModel {

    private Vector vector;

    @Data
    @NoArgsConstructor
    public static class Vector {

        private List<Sample> samples;

        @Data
        @NoArgsConstructor
        public static class Sample {

            private Labels labels;
            private Point point;

            @Data
            @NoArgsConstructor
            public static class Labels {
                private String instance;
                private String job;
                @JSONField(name = "__name__")
                private String name;
                @JSONField(name = "_cluster")
                private String cluster;

            }

            @Data
            @NoArgsConstructor
            public static class Point {
                private String t;
                private Double v;
            }

        }
    }

    public Double getValue() {
        return Optional.ofNullable(vector).map(Vector::getSamples).orElse(Collections.emptyList())
                .stream().findFirst().map(Vector.Sample::getPoint).map(Vector.Sample.Point::getV).orElse(0.0);

    }
}
