package com.bocloud.cmp.provider.smart.sdk.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
public class StorageSummaryModel {

    @JSONField(name = "cluster_uuid")
    private String clusterUuid;
    @JSONField(name = "cluster_name")
    private String clusterName;
    @JSONField(name = "is_stretched")
    private Boolean stretched; // 是否为双活集群

    @JSONField(name = "total_data_capacity")
    private Long totalDataCapacity; // 集群数据空间
    @JSONField(name = "used_data_space")
    private Long usedDataSpace; // 已使用数据空间
    @JSONField(name = "failure_data_space")
    private Long failureDataSpace; // 集群失效数据空间
    @JSONField(name = "valid_data_space")
    private Long validDataSpace; // 集群可用数据空间
    @JSONField(name = "provisioned_data_space")
    private Long provisionedDataSpace; // 已分配数据空间

    @JSONField(name = "total_cache_capacity")
    private Long totalCacheCapacity; // 集群缓存空间
    @JSONField(name = "used_cache_space")
    private Long usedCacheSpace; // 已使用缓存空间
    @JSONField(name = "failure_cache_space")
    private Long failureCacheSpace; // 集群失效缓存空间
    @JSONField(name = "valid_cache_space")
    private Long validCacheSpace; // 集群可用缓存空间
    @JSONField(name = "dirty_cache_space")
    private Long dirtyCacheSpace; // 集群脏缓存空间

    @JSONField(name = "recover_space")
    private Long recoverSpace; // 待恢复数据空间
    @JSONField(name = "recycle_space")
    private Long recycleSpace; // 待回收数据空间
    @JSONField(name = "migrate_space")
    private Long migrateSpace; // 待迁数据空间

    private List<Host> hosts; // 主机空间信息

    @Data
    @NoArgsConstructor
    public static class Host {
        private String host;
        private String ec;
        @JSONField(name = "management_ip")
        private String management_ip;
        private Dataa data;

        @Data
        @NoArgsConstructor
        public static class Dataa {
            @JSONField(name = "chunk_space")
            private Long chunkSpace; // 节点空间
            @JSONField(name = "physical_space")
            private Long physicalSpace; // 物理空间

            @JSONField(name = "data_space")
            private Long dataSpace; // 数据空间
            @JSONField(name = "valid_data_space")
            private Long validDataSpace; // 可用数据空间
            @JSONField(name = "used_data_space")
            private Long usedDataSpace; // 已使用数据空间
            @JSONField(name = "failure_data_space")
            private Long failureDataSpace; // 失效数据空间

            @JSONField(name = "cache_space")
            private Long cacheSpace; // 缓存空间
            @JSONField(name = "valid_cache_space")
            private Long validCacheSpace; // 可用缓存空间
            @JSONField(name = "failure_cache_space")
            private Long failureCacheSpace; // 失效缓存空间
            @JSONField(name = "dirty_cache_space")
            private Long dirtyCacheSpace; // 脏缓存空间
        }
    }
}
