package com.bocloud.cmp.provider.smart.sdk.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
public class VdsModel {

    private String uuid;
    private String name;
    @JSONField(name = "ovsbr_name")
    private String ovsbrName;
    @JSONField(name = "bond_name")
    private String bondName;
    @JSONField(name = "bond_mode")
    private String bondMode;
    private String description;
    @JSONField(name = "vlans_count")
    private Long vlansCount;
    @JSONField(name = "hosts_associated")
    private List<HostAssociated> hostsAssociated;
    @JSONField(name = "hosts_initialized")
    private List<String> hostsInitialized;

    @Data
    @NoArgsConstructor
    public static class HostAssociated {
        private String host;
        @JSONField(name = "host_uuid")
        private String hostUuid;
        @JSONField(name = "data_ip")
        private String dataIp;
        @JSONField(name = "management_ip")
        private String managementIp;
        @JSONField(name = "nics_associated")
        private List<String> nicsAssociated;
        @JSONField(name = "bond_mode")
        private String bondMode;
    }
}
