package com.bocloud.cmp.provider.smart.sdk.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;
import java.util.Map;

@Data
@NoArgsConstructor
public class VlanModel {

    private String uuid;
    private String name;
    private Integer type;
    private String gateway;
    private String subnetmask;
    @JSONField(name = "vds_uuid")
    private String vdsUuid;
    @JSONField(name = "vlan_id")
    private Integer vlanId;
    @JSONField(name = "original_hosts")
    private Map<String, Host> originHosts;
    @JSONField(name = "_hosts")
    private List<Host> hosts;
    @JSONField(name = "dhcp_config")
    private DhcpConfig dhcpConfig;

    @JSONField(name = "vm_snapshots_count")
    private Long vmSnapshotsCount;
    @JSONField(name = "vm_templates_count")
    private Long vmTemplatesCount;
    @JSONField(name = "vms_count")
    private Long vmsCount;

    @Data
    @NoArgsConstructor
    public static class Host {
        private String name;
        @JSONField(name = "host_uuid")
        private String hostUuid;
        @JSONField(name = "management_ip")
        private String managementIp;
        @JSONField(name = "access_ip")
        private String accessIp;
        @JSONField(name = "data_ip")
        private String dataIp;
    }

    @Data
    @NoArgsConstructor
    public static class DhcpConfig {
        @JSONField(name = "ip_ranges")
        private List<IpRange> ipRanges;
        @JSONField(name = "gateway_ip")
        private String gatewayIp;
        private String cidr;
        @JSONField(name = "dhcp_interface_ip")
        private String dhcpInterfaceIp;
        @JSONField(name = "dns_servers")
        private List<String> dnsServers;

        @Data
        @NoArgsConstructor
        public static class IpRange {
            @JSONField(name = "start_ip")
            private String startIp;
            @JSONField(name = "end_ip")
            private String endIp;
        }
    }
}
