package com.bocloud.cmp.provider.smart.sdk.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
public class VolumeModel {

    private VolumeType volumeType;
    /**
     * 卷：卷uuid
     * 快照：快照uuid
     */
    private String uuid;
    /**
     * 卷：卷名称
     * 快照：快照名称
     */
    private String name;
    /**
     * 卷：未用
     * 快照：卷名称
     */
    @JSONField(name = "volume_name")
    private String volumeName;
    private String path;
    private String type;
    private String status;
    private String description;
    /**
     * 卷：卷大小
     * 快照：快照大小
     */
    private Long size;
    /**
     * 卷：未用
     * 快照：卷大小
     */
    @JSONField(name = "volume_size")
    private String volumeSize;
    @JSONField(name = "size_in_byte")
    private Long sizeInByte;
    @JSONField(name = "lun_id")
    private String lunId;
    @JSONField(name = "volume_uuid")
    private String volumeUuid;
    private Boolean sharing;
    @JSONField(name = "shared_size")
    private Long sharedSize; // 卷快照使用
    @JSONField(name = "unique_size")
    private Long uniqueSize; // 卷快照使用
    private Boolean mounting;
    @JSONField(name = "mounting_vm_list")
    private List<MountVm> mountingVmList;
    @JSONField(name = "create_time")
    private Long createTime;
    @JSONField(name = "super_type")
    private String superType;
    @JSONField(name = "target_name")
    private String targetName;
    @JSONField(name = "resource_state")
    private String resourceState;
    @JSONField(name = "from_export_name")
    private String fromExportName;
    @JSONField(name = "snapshot_count")
    private Long snapshotVount;
    @JSONField(name = "zbs_volume_id")
    private String zbsVolumeId; // 卷使用
    @JSONField(name = "zbs_snapshot_uuid")
    private String zbsSnapshotUuid; // 卷快照使用
    @JSONField(name = "storage_policy_uuid")
    private String storagePolicyUuid;

    @Data
    @NoArgsConstructor
    public static class MountVm {
        private String uuid;
        private String name;
    }

    public enum VolumeType {
        VOLUME, VOLUME_SNAPSHOT;
    }
}
