package com.bocloud.cmp.provider.smart.sdk.model.create;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;

import java.util.ArrayList;
import java.util.List;

@Data
@NoArgsConstructor
public class ImageCreateModel {

    private String name; // 映像的名称，默认名称是映像 UUID
    @JSONField(name = "file_name")
    private String fileName; // 映像的文件名，默认文件名是映像 UUID
    private Long size; // 必填，映像文件大小（以字节为单位）
    private String device; // 必填，iscsi 或 nfs
    private String os; // 映像的操作系统类型
    private String description; // 描述

    public List<NameValuePair> toNameValuePairs() {
        List<NameValuePair> nameValuePairs = new ArrayList<>();
        nameValuePairs.add(new BasicNameValuePair("size", size.toString()));
        nameValuePairs.add(new BasicNameValuePair("device", device));
        if (StringUtils.isNotEmpty(name)) {
            nameValuePairs.add(new BasicNameValuePair("name", name));
            nameValuePairs.add(new BasicNameValuePair("file_name", fileName));
            nameValuePairs.add(new BasicNameValuePair("os", os));
            nameValuePairs.add(new BasicNameValuePair("description", description));
        }
        return nameValuePairs;
    }

}
