package com.bocloud.cmp.provider.smart.sdk.model.create;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
public class VlanCreateModel {

    private String name;
    @JSONField(name = "vlan_id")
    private Integer vlanId;
    @JSONField(name = "dhcp_config")
    private DhcpConfig dhcpConfig;

    @Data
    @NoArgsConstructor
    public static class DhcpConfig {
        @JSONField(name = "ip_ranges")
        private List<IpRange> ipRanges;
        @JSONField(name = "gateway_ip")
        private String gatewayIp;
        private String cidr;
        @JSONField(name = "dhcp_interface_ip")
        private String dhcpInterfaceIp;
        @JSONField(name = "dns_servers")
        private List<String> dnsServers;

        @Data
        @NoArgsConstructor
        public static class IpRange {
            @JSONField(name = "start_ip")
            private String startIp;
            @JSONField(name = "end_ip")
            private String endIp;
        }
    }
}
