package com.bocloud.cmp.provider.smart.sdk.model.create;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
public class VmTemplateCreateModel {

    private String name;
    private String description;
    private Boolean ha;
    private String firmware;

    private Integer vcpu;
    private Cpu cpu;
    private Long memory;
    private List<Disk> disks;
    private List<Nic> nics;

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class Cpu {
        private Topology topology;

        @Data
        @NoArgsConstructor
        @AllArgsConstructor
        public static class Topology {
            private Long cores;
            private Long sockets;

        }
    }

    @Data
    @NoArgsConstructor
    public static class Nic {
        private String ovs;
        @JSONField(name = "vlan_uuid")
        private String vlanUuid;
        private List<Vlan> vlans;
        private String link;

        @Data
        @NoArgsConstructor
        public static class Vlan {
            @JSONField(name = "vlan_id")
            private Integer vlanId;
        }
    }

    @Data
    @NoArgsConstructor
    public static class Disk {
        private String type;
        private String name;
        private String bus;
        private String path;
        @JSONField(name = "size_in_byte")
        private Long sizeInByte;
        @JSONField(name = "storage_policy_uuid")
        private String storagePolicyUuid;
        private Boolean disabled;
    }
}
