package com.bocloud.cmp.provider.smart.sdk.model.modify;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
public class VmModifyModel {

    // 修改云主机基本信息
    @JSONField(name = "vm_name")
    private String vmName;
    private Integer vcpu;
    private Cpu cpu;
    private Long memory;
    private Boolean ha;
    private String description;

    // 挂载盘，已有的盘要保留
    private List<Disk> disks;
    // 卸载盘，要卸载的盘记得在disks中移除
    @JSONField(name = "disk_paths_del")
    private List<String> diskPathsDel;
    // 增加、删除网卡
    private List<Nic> nics;

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class Cpu {
        private Topology topology;

        @Data
        @NoArgsConstructor
        @AllArgsConstructor
        public static class Topology {
            private Long cores;
            private Long sockets;
        }
    }

    @Data
    @NoArgsConstructor
    public static class Disk {
        private String type;
        private String name;
        private String bus;
        private String path;
        @JSONField(name = "size_in_byte")
        private Long sizeInByte;
        @JSONField(name = "storage_policy_uuid")
        private String storagePolicyUuid;
        private Boolean disabled;
    }

    @Data
    @NoArgsConstructor
    public static class Nic {
        private String ovs;
        @JSONField(name = "vlan_uuid")
        private String vlanUuid;
        private List<Vlan> vlans;
        private String link;

        @Data
        @NoArgsConstructor
        public static class Vlan {
            @JSONField(name = "vlan_id")
            private Integer vlanId;
        }
    }
}




