package com.bocloud.cmp.provider.smart.sdk.model.other;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@NoArgsConstructor
public class VmSnapshotRebuildModel {

    @JSONField(name = "vm_name")
    private String vmName;
    private String status;
    private String description;
    @JSONField(name = "node_ip")
    private String nodeIp;

    private Integer vcpu;
    private Cpu cpu;
    private Long memory;
    @JSONField(name = "new_disks")
    private List<Disk> newDisks;
    @JSONField(name = "modify_disks")
    private List<Disk> modifyDisks;
    private List<Nic> nics;

    private Boolean ha;
    @JSONField(name = "auto_schedule")
    private Boolean autoSchedule;
    @JSONField(name = "cpu_model")
    private String cpuModel;
    @JSONField(name = "nested_virtualization")
    private Boolean nestedVirtualization;
    @JSONField(name = "folder_uuid")
    private String folderUuid;
    @JSONField(name = "is_full_copy")
    private Boolean isFullCopy;

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class Cpu {
        private Topology topology;

        @Data
        @NoArgsConstructor
        @AllArgsConstructor
        public static class Topology {
            private Long cores;
            private Long sockets;
        }
    }

    @Data
    @NoArgsConstructor
    public static class Nic {
        private String ovs;
        @JSONField(name = "vlan_uuid")
        private String vlanUuid;
        private List<Nic.Vlan> vlans;
        private String link;

        @Data
        @NoArgsConstructor
        public static class Vlan {
            @JSONField(name = "vlan_id")
            private Integer vlanId;
        }
    }

    @Data
    @NoArgsConstructor
    public static class Disk {
        private String type;
        private Long key;
        private String name;
        private String bus;
        private String path;
        @JSONField(name = "size_in_byte")
        private Long sizeInByte;
        @JSONField(name = "storage_policy_uuid")
        private String storagePolicyUuid;
        @JSONField(name = "snapshot_uuid")
        private String snapshotUuid;
        private Boolean disabled;
    }
}
