package com.bocloud.cmp.provider.handler;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import javax.xml.ws.handler.Handler;
import javax.xml.ws.handler.HandlerResolver;
import javax.xml.ws.handler.PortInfo;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;

@SuppressWarnings("rawtypes")
public final class HeaderHandlerResolver implements HandlerResolver {

	private final List<Handler> handlerChain = new ArrayList<Handler>();

	@Override
	public List<Handler> getHandlerChain(PortInfo arg0) {
		return Collections.unmodifiableList(handlerChain);
	}

	/**
	 * Adds a specific {@link Handler} to the handler chain
	 * 
	 * @param handler
	 */
	public void addHandler(SOAPHandler<SOAPMessageContext> handler) {
		handlerChain.add(handler);
	}

	/**
	 * Clears the current list of {@link Handler} in the handler chain
	 */
	public void clearHandlerChain() {
		handlerChain.clear();
	}
}
