package com.bocloud.cmp.provider.utils;

import java.text.SimpleDateFormat;
import java.util.Date;

import javax.xml.datatype.XMLGregorianCalendar;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.bocloud.cmp.model.pbm.PbmProfileModel;
import com.vmware.pbm.PbmProfile;

/**
 * 存储策略数据组装类
 * 
 * @author wangyu
 * @version 1.0
 * @since 2020年6月15日
 *
 */
public class PbmDataUtil {

	private static Logger logger = LoggerFactory.getLogger(PbmDataUtil.class);
	private static SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

	/**
	 * 组装策略数据
	 * 
	 * @param profile
	 * @param type
	 * @return
	 */
	public static PbmProfileModel assembleProfile(PbmProfile profile, String type) {
		PbmProfileModel model = new PbmProfileModel();
		model.setName(profile.getName());
		model.setProfileId(profile.getProfileId().getUniqueId());
		model.setRemark(profile.getDescription());
		model.setCreatedBy(profile.getCreatedBy());
		XMLGregorianCalendar calendar = profile.getCreationTime();
		if (null != calendar) {
			try {
				Date createTime = format.parse(calendar.getYear() + "-" + calendar.getMonth() + "-" + calendar.getDay()
						+ " " + calendar.getHour() + ":" + calendar.getMinute() + ":" + calendar.getSecond());
				model.setCreateTime(createTime);
			} catch (Exception e) {
				logger.error("Get error message：{}", e.getMessage());
			}
		}
		model.setType(type);
		return model;
	}
}
