package com.bocloud.cmp.provider.common;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.TianyiProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;

import com.bocloud.common.model.Result;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * 天意auth
 * 
 * @author admin
 *
 */
@Provider("bocloud.cmp.tianyi")
public class TianyiAuthProvider extends TianyiProvider implements AuthProvider {

	public TianyiAuthProvider(Butler butler) {
		super(butler);
	}

	private static Logger logger = LoggerFactory.getLogger(TianyiAuthProvider.class);

	private Butler butler;

	@Override
	public boolean accessable() {
		// TODO Auto-generated method stub
		return super.accessable();
	}

	@Override
	public BocloudResult auth() {
		try {
			String apiUrl = "/apiproxy/v3/order/getZoneConfig";
			JSONObject headers = new JSONObject();

			Result result = doGet(apiUrl, headers);
			if (result.isFailed()) {
				return new BocloudResult(false, result.getMessage());
			}
			JSONObject object = JSONObject.parseObject(result.getMessage());
			if (null == object) {
				return new BocloudResult(false, "平台认证失败");
			}
			if (!object.getInteger("statusCode").equals(SUCCESS_STATUS_CODE)) {
				return new BocloudResult(false, "平台认证失败：" + object.getString("message"));
			}
			List<JSONObject> jsonObjects = JSONArray.parseArray(object.getString("returnObj"), JSONObject.class);
			return new BocloudResult(true, "平台认证成功");
		} catch (Exception e) {
			logger.error("平台认证失败 ： " + e);
			return new BocloudResult(false, "平台认证失败", e.getMessage());
		}
	}

}
