package com.bocloud.cmp.provider.tianyiconvertor;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.ClusterModel;
import com.bocloud.cmp.model.FlavorModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Hu Wentao
 * @Description: 集群总量转换
 * @date 2020/12/30 13:59
 */
public class ClusterConvertor implements BeanConvertor<ClusterModel, JSONObject> {
    @Override
    public List<ClusterModel> convertList(List<? extends JSONObject> list) {
        List<ClusterModel> clusterModels = new ArrayList<>();
        for (JSONObject object : list) {
            clusterModels.add(convertModel(object));
        }
        return clusterModels;
    }

    @Override
    public ClusterModel convertModel(JSONObject jsonObject) {
        ClusterModel clusterModel = null;
        if (null != jsonObject) {
            clusterModel = new ClusterModel();
            clusterModel.setHostNum(jsonObject.getInteger("host_total"));
            clusterModel.setCpuUsed(jsonObject.getLong("vcpus_used"));
            clusterModel.setCpuTotal(jsonObject.getLong("vcpus_total"));
            clusterModel.setCpuCore(Math.toIntExact(jsonObject.getLong("vcpus_total")));
            clusterModel.setMemUsed(jsonObject.getDouble("memory_mb_used") / 1024);
            clusterModel.setMemTotal(jsonObject.getDouble("memory_mb_total") / 1024);
            clusterModel.setVmNum(jsonObject.getInteger("instance_total"));
            clusterModel.setName("天翼云集群");
            clusterModel.setUuid(jsonObject.getString("projectId"));
        }
        return clusterModel;
    }
}
