package com.bocloud.cmp.provider.tianyiconvertor;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.FlavorModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @author Hu Wentao
 * @create 2020-10-10 15:55
 * @Description: 规格转换
 */
public class FlavorConvertor implements BeanConvertor<FlavorModel, JSONObject> {

    @Override
    public List<FlavorModel> convertList(List<? extends JSONObject> list) {
        List<FlavorModel> flavorModels = new ArrayList<>();
        for (JSONObject object : list) {
            flavorModels.add(convertModel(object));
        }
        return flavorModels;
    }

    @Override
    public FlavorModel convertModel(JSONObject jsonObject) {
        FlavorModel flavorModel = null;
        if (null != jsonObject) {
            flavorModel = new FlavorModel();
            flavorModel.setFlavorUuid(jsonObject.getString("id"));
            flavorModel.setName(jsonObject.getString("flavorName"));
            flavorModel.setCpu(jsonObject.getInteger("cpuNum"));
            flavorModel.setMemory(jsonObject.getBigDecimal("memSize"));
            flavorModel.setFamily(jsonObject.getString("flavorType"));
            flavorModel.setStatus(jsonObject.getString("status"));
            flavorModel.setZone(JSON.toJSONString(jsonObject.getString("az").split(",")));
            flavorModel.setPerformanceType(jsonObject.getString("flavorName"));
        }
        return flavorModel;
    }
}
