package com.bocloud.cmp.provider.tianyiconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.FloatingIpModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @author Hu Wentao
 * @create 2020-10-10 16:24
 * @Description: 弹性公网
 */
public class FloatingIpConvertor implements BeanConvertor<FloatingIpModel, JSONObject> {
	@Override
	public List<FloatingIpModel> convertList(List<? extends JSONObject> list) {
		List<FloatingIpModel> floatingIpModels = new ArrayList<>();
		for (JSONObject jsonObject : list) {
			floatingIpModels.add(convertModel(jsonObject));
		}
		return floatingIpModels;
	}

	@Override
	public FloatingIpModel convertModel(JSONObject jsonObject) {
		FloatingIpModel floatingIpModel = new FloatingIpModel();
		if (null != jsonObject) {

			floatingIpModel.setName(jsonObject.getString("public_ip_address"));
			floatingIpModel.setPublicType(jsonObject.getString("type"));
			floatingIpModel.setPrivateIpAddress(jsonObject.getString("private_ip_address"));
			floatingIpModel.setFixedIpAddress(jsonObject.getString("private_ip_address"));
			floatingIpModel.setNetworkCardUuid(jsonObject.getString("port_id"));

			floatingIpModel.setFloatingIpAddress(jsonObject.getString("public_ip_address"));
			floatingIpModel.setFloatingIpUuid(jsonObject.getString("id"));
			floatingIpModel.setTenantUuid(jsonObject.getString("tenant_id"));
			floatingIpModel.setBandwidth(jsonObject.getString("bandwidth_name"));
			floatingIpModel.setBandwidthId(jsonObject.getString("bandwidth_id"));
			floatingIpModel.setPortUuid(jsonObject.getString("port_id"));
			floatingIpModel.setBandwidthSize(jsonObject.getInteger("bandwidth_size"));
			Date createTime = jsonObject.getDate("create_time");
			floatingIpModel.setGmtCreate(createTime);
			String status = jsonObject.getString("status");
			if ("ACTIVE".equalsIgnoreCase(status)) {
				floatingIpModel.setStatus("BIND");
			} else if ("DOWN".equalsIgnoreCase(status)) {
				floatingIpModel.setStatus("UNBIND");
			} else {
				floatingIpModel.setStatus(status);
			}

		}
		return floatingIpModel;
	}
}
