package com.bocloud.cmp.provider.tianyiconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.ImageModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Hu Wentao
 * @create 2020-10-12 9:24
 * @Description: 镜像转换类
 */
public class ImageConvertor implements BeanConvertor<ImageModel, JSONObject> {
	@Override
	public List<ImageModel> convertList(List<? extends JSONObject> list) {
		List<ImageModel> imageModels = new ArrayList<>();
		for (JSONObject jsonObject : list) {
			String imageType = jsonObject.getString("imageType");
			if ("gold".equalsIgnoreCase(imageType) || "Private".equalsIgnoreCase(imageType)) {
				imageModels.add(convertModel(jsonObject));
			}
		}
		return imageModels;
	}

	@Override
	public ImageModel convertModel(JSONObject jsonObject) {
		ImageModel imageModel = new ImageModel();
		if (null != jsonObject) {
			imageModel.setImageUuid(jsonObject.getString("id"));
			imageModel.setOsType(jsonObject.getString("platform"));
			imageModel.setImageSourceType(jsonObject.getString("platform"));
			imageModel.setName(jsonObject.getString("name"));
			imageModel.setSize(jsonObject.getDouble("osBit"));
			imageModel.setMinRam(jsonObject.getLong("minRam"));
			imageModel.setMinDisk(jsonObject.getLong("minDisk"));
			imageModel.setForce(jsonObject.getBoolean("virtual"));
			imageModel.setStatus(jsonObject.getString("status").toUpperCase());
			imageModel.setOsCategory(jsonObject.getString("osType"));
			imageModel.setOsName(jsonObject.getString("platform"));
			imageModel.setOsVersion(jsonObject.getString("osVersion"));

			String imageType = jsonObject.getString("imageType");
			if ("gold".equalsIgnoreCase(imageType)) {
				imageModel.setImageType("PUBLIC");
			} else if ("Private".equalsIgnoreCase(imageType)) {
				imageModel.setImageType("PRIVATE");
			} else {
				imageModel.setImageType(imageType.toUpperCase());
			}

		}
		return imageModel;
	}
}
