package com.bocloud.cmp.provider.tianyiconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.ImageModel;
import com.bocloud.cmp.model.KeypairModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Hu Wentao
 * @create 2020-10-13 10:35
 * @Description: SSH密钥转换类
 */
public class KeypairConvertor implements BeanConvertor<KeypairModel, JSONObject> {
    @Override
    public List<KeypairModel> convertList(List<? extends JSONObject> list) {
        List<KeypairModel> keypairModels = new ArrayList<>();
        for (JSONObject jsonObject : list) {
            keypairModels.add(convertModel(jsonObject));
        }
        return keypairModels;
    }

    @Override
    public KeypairModel convertModel(JSONObject jsonObject) {
        KeypairModel keypairModel = new KeypairModel();
        if (null != jsonObject) {
            keypairModel.setPublicKey(JSONObject.parseObject(jsonObject.getString("keypair")).getString("public_key"));
            keypairModel.setFingerprint(JSONObject.parseObject(jsonObject.getString("keypair")).getString("fingerprint"));
            keypairModel.setName(JSONObject.parseObject(jsonObject.getString("keypair")).getString("name"));
            keypairModel.setPrivateKey(JSONObject.parseObject(jsonObject.getString("keypair")).getString("private_key"));

        }
        return keypairModel;
    }
}
