package com.bocloud.cmp.provider.tianyiconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.NetworkCardModel;
import com.bocloud.cmp.model.NetworkInterfaceModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Hu Wentao
 * @Description: 网卡转换
 * @date 2020/10/30 11:37
 */
public class NetworkCardConvertor implements BeanConvertor<NetworkCardModel, JSONObject> {
    @Override
    public List<NetworkCardModel> convertList(List<? extends JSONObject> list) {
        List<NetworkCardModel> networkCards = new ArrayList<>();
        for (JSONObject jsonObject : list) {
            networkCards.add(convertModel(jsonObject));
        }
        return networkCards;
    }

    @Override
    public NetworkCardModel convertModel(JSONObject jsonObject) {
    	NetworkCardModel networkCard = new NetworkCardModel();
        if (null != jsonObject) {
            networkCard.setIpAddress(JSONArray.parseArray(jsonObject.getString("fixed_ips"), JSONObject.class).get(0).getString("ip_address"));
            networkCard.setSubnetUuid(JSONArray.parseArray(jsonObject.getString("fixed_ips"), JSONObject.class).get(0).getString("subnet_id"));
            networkCard.setStatus(jsonObject.getString("port_state"));
            networkCard.setMac(jsonObject.getString("mac_addr"));
            networkCard.setNetworkcardUuid(jsonObject.getString("port_id"));
        }
        return networkCard;
    }
}
