package com.bocloud.cmp.provider.tianyiconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.RegionModel;
import com.bocloud.cmp.model.ZoneModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Hu Wentao
 * @create 2020-10-13 15:05
 * @Description: 地域转换类
 */
public class RegionConvertor implements BeanConvertor<RegionModel, JSONObject> {
    @Override
    public List<RegionModel> convertList(List<? extends JSONObject> list) {
        List<RegionModel> regionModels = new ArrayList<>();
        for (JSONObject jsonObject : list) {
            regionModels.add(convertModel(jsonObject));
        }
        return regionModels;
    }

    @Override
    public RegionModel convertModel(JSONObject jsonObject) {
        RegionModel regionModel = new RegionModel();
        if (null != jsonObject) {
            regionModel.setRegionId(jsonObject.getString("regionId"));
            List<String> zoneIds = JSONArray.parseArray(jsonObject.getString("zoneId"), String.class);
            List<ZoneModel> zoneModels = new ArrayList<>();
            for (String zoneId : zoneIds) {
                ZoneModel zoneModel = new ZoneModel();
                zoneModel.setZoneId(zoneId);
                zoneModel.setName("可用区"+ zoneId.substring(zoneId.length()-1, zoneId.length()));
                zoneModel.setRegionId(jsonObject.getString("regionId"));
                zoneModels.add(zoneModel);
            }
            regionModel.setZones(zoneModels);
            regionModel.setName(jsonObject.getString("zoneName"));
            //是否可售（1是可售，0是不可售）
            regionModel.setCode(jsonObject.getString("regionId"));
        }
        return regionModel;
    }
}
