package com.bocloud.cmp.provider.tianyiconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.SecurityGroupModel;
import com.bocloud.cmp.model.SecurityGroupRuleModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

/**
 * @Package: com.bocloud.cmp.provider.tianyiconvertor
 * @ClassName: SecurityGroupConvertor
 * @Author: 胡文涛
 * @CreateTime: 2020/9/21 15:21
 * @Description: 安全组转换
 */
public class SecurityGroupConvertor implements BeanConvertor<SecurityGroupModel, JSONObject> {

	@Override
	public List<SecurityGroupModel> convertList(List<? extends JSONObject> objects) {
		List<SecurityGroupModel> volumeModels = new ArrayList<SecurityGroupModel>();
		for (JSONObject object : objects) {
			volumeModels.add(convertModel(object));
		}
		return volumeModels;
	}

	@SuppressWarnings("unchecked")
	@Override
	public SecurityGroupModel convertModel(JSONObject info) {
		SecurityGroupModel model = new SecurityGroupModel();
		if (null != info) {
			model.setGroupUuid(info.getString("resSecurityGroupId"));
			if (StringUtils.isEmpty(model.getGroupUuid())) {
				model.setGroupUuid(info.getString("id"));
			}
			model.setName(info.getString("name"));
			model.setRegionId(info.getString("regionId"));
			model.setVpcUuid(info.getString("vpcId"));
			model.setModels((List<SecurityGroupRuleModel>) info.get("security_group_rules"));
		}
		return model;
	}

}
