package com.bocloud.cmp.provider.tianyiconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.SecurityGroupRuleModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * @Package: com.bocloud.cmp.provider.tianyiconvertor
 * @ClassName: SecurityGroupRuleConvertor
 * @Author: 胡文涛
 * @CreateTime: 2020/9/21 15:22
 * @Description: 安全组规则
 */
public class SecurityGroupRuleConvertor implements BeanConvertor<SecurityGroupRuleModel, JSONObject> {

    @Override
    public List<SecurityGroupRuleModel> convertList(List<? extends JSONObject> objects) {
        List<SecurityGroupRuleModel> volumeModels = new ArrayList<>();
        for (JSONObject object : objects) {
            volumeModels.add(convertModel(object));
        }
        return volumeModels;
    }

    @Override
    public SecurityGroupRuleModel convertModel(JSONObject info) {
        SecurityGroupRuleModel model = new SecurityGroupRuleModel();
        if (null != info) {
            model.setRuleUuid(info.getString("id"));
            model.setRemark(info.getString("description"));
            model.setGroupUuid(info.getString("security_group_id"));
            model.setDirection(info.getString("direction"));
            model.setEtherType(info.getString("ethertype"));
            model.setProtocol(info.getString("protocol"));
            model.setPortMin(info.getString("port_range_min") == null ? null : Integer.valueOf(info.getString("port_range_min")));
            model.setPortMax(info.getString("port_range_max") == null ? null : Integer.valueOf(info.getString("port_range_max")));
            model.setRemoteIpPrefix(info.getString("remote_ip_prefix"));
            model.setRemoteGroupUuid(info.getString("remote_group_id"));
            model.setTenantUuid(info.getString("tenant_id"));
        }
        return model;
    }

}

