package com.bocloud.cmp.provider.tianyiconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.SnapshotBackupModel;
import com.bocloud.cmp.model.SnapshotModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import com.bocloud.common.utils.DateTools;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Hu Wentao
 * @create 2020-10-16 9:19
 * @Description: 备份
 */
public class SnapshotBackupConvertor implements BeanConvertor<SnapshotBackupModel, JSONObject> {
    @Override
    public List<SnapshotBackupModel> convertList(List<? extends JSONObject> list) {
        List<SnapshotBackupModel> snapshotBackupModels = new ArrayList<>();
        for (JSONObject jsonObject : list) {
            snapshotBackupModels.add(convertModel(jsonObject));
        }
        return snapshotBackupModels;
    }

    @Override
    public SnapshotBackupModel convertModel(JSONObject jsonObject) {
        SnapshotBackupModel snapshotBackupModel = new SnapshotBackupModel();
        if (null != jsonObject) {
            snapshotBackupModel.setStatus(jsonObject.getString("status"));
            snapshotBackupModel.setSize(jsonObject.getInteger("size"));
            snapshotBackupModel.setVolumeUuid(jsonObject.getString("volume_id"));
            snapshotBackupModel.setName(jsonObject.getString("name"));
            snapshotBackupModel.setSnapshotUuid(jsonObject.getString("snapshot_id"));
        }
        return snapshotBackupModel;
    }
}
