package com.bocloud.cmp.provider.tianyiconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.SnapshotModel;
import com.bocloud.cmp.model.VpcModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Hu Wentao
 * @create 2020-10-12 10:45
 * @Description: 快照转换类
 */
public class SnapshotConvertor implements BeanConvertor<SnapshotModel, JSONObject> {

    @Override
    public List<SnapshotModel> convertList(List<? extends JSONObject> list) {
        List<SnapshotModel> snapshotModels = new ArrayList<>();
        for (JSONObject jsonObject : list) {
            snapshotModels.add(convertModel(jsonObject));
        }
        return snapshotModels;
    }

    @Override
    public SnapshotModel convertModel(JSONObject jsonObject) {
        SnapshotModel snapshotModel = new SnapshotModel();
        if (null != jsonObject) {
            snapshotModel.setSnapshotUuid(jsonObject.getString("snapshotId"));
            snapshotModel.setSnapName(jsonObject.getString("snapshotName"));
            snapshotModel.setVolumeUuid(jsonObject.getString("vmId"));
            snapshotModel.setCreateTime(jsonObject.getDate("createDate"));
            snapshotModel.setStatus(jsonObject.getString("status"));
        }
        return snapshotModel;
    }
}
