package com.bocloud.cmp.provider.tianyiconvertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.SubnetModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;
import java.util.ArrayList;
import java.util.List;

/**
 * @Package: com.bocloud.cmp.provider.tianyiconvertor
 * @ClassName: SubnetConvertor
 * @Author: 胡文涛
 * @CreateTime: 2020/9/18 16:49
 * @Description: 子网转换
 */
public class SubnetConvertor implements BeanConvertor<SubnetModel, JSONObject> {

    @Override
    public List<SubnetModel> convertList(List<? extends JSONObject> objects) {
        List<SubnetModel> subnetModels = new ArrayList<SubnetModel>();
        for (JSONObject object : objects) {
            String name = object.getString("name");
            String vpcId = object.getString("vpcId");
            if (null != name && null != vpcId) {
                subnetModels.add(convertModel(object));
            }
        }
        return subnetModels;
    }

    @Override
    public SubnetModel convertModel(JSONObject model) {
        SubnetModel subnet = new SubnetModel();
        if (null != model) {
            subnet.setNeutronSubnetId(model.getString("neutronSubnetId"));
            subnet.setSubnetUuid(model.getString("resVlanId"));
            subnet.setName(model.getString("name"));
            subnet.setRegionId(model.getString("regionId"));
            subnet.setVpcUuid(model.getString("vpcId"));
            subnet.setZone(model.getString("zoneId"));
            subnet.setCidr(model.getString("cidr"));
            subnet.setGateway(model.getString("gateway"));
            subnet.setStatus(model.getString("vlanStatus"));
            subnet.setPrimaryDns(model.getString("firstDcn"));
            subnet.setSecondaryDns(model.getString("secondDcn"));
            JSONArray dns = new JSONArray();
            dns.add(model.getString("firstDcn"));
            dns.add(model.getString("secondDcn"));
            subnet.setDnsNames(String.valueOf(dns));
        }
        return subnet;
    }

}

