package com.bocloud.cmp.provider.tianyiconvertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.SubnetModel;
import com.bocloud.cmp.model.VpcModel;
import com.bocloud.cmp.provider.convertor.BeanConvertor;

import java.util.ArrayList;
import java.util.List;

/**
 * @Package: com.bocloud.cmp.provider.tianyiconvertor
 * @ClassName: VpcConvertor1
 * @Author: 胡文涛
 * @CreateTime: 2020/9/30 10:25
 * @Description:
 */
public class VpcConvertor implements BeanConvertor<VpcModel, JSONObject> {

	BeanConvertor<SubnetModel, JSONObject> convertor = new SubnetConvertor();

	@Override
	public List<VpcModel> convertList(List<? extends JSONObject> objects) {
		List<VpcModel> models = new ArrayList<VpcModel>();
		for (JSONObject object : objects) {
			models.add(convertModel(object));
		}
		return models;
	}

	@Override
	public VpcModel convertModel(JSONObject info) {
		VpcModel model = new VpcModel();
		if (null != info) {
			// TODO
			model.setVpcId(info.getString("resVpcId"));
			model.setName(info.getString("name"));
			model.setCidr(info.getString("cidr"));
			String vpcStatus = info.getString("vpcStatus");
			if ("OK".equalsIgnoreCase(vpcStatus)) {
				model.setStatus("AVAILABLE");
			} else {
				model.setStatus(vpcStatus == null ? "" : vpcStatus.toUpperCase());
			}
			model.setRegionId(info.getString("regionId"));
			// 子网
			model.setSubnetModels(convertor.convertList(JSONObject.parseArray(info.getString("subnets"),
					JSONObject.class)));
		}
		return model;
	}
}
