package com.bocloud.cmp.provider;

import java.net.URL;
import java.util.Iterator;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.apache.commons.lang3.StringUtils;

import com.alibaba.fastjson.JSON;
import com.bocloud.cmp.model.Butler;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.vmware.vim25.GuestNicInfo;
import com.bocloud.vmware.vim25.mo.Datacenter;
import com.bocloud.vmware.vim25.mo.Folder;
import com.bocloud.vmware.vim25.mo.InventoryNavigator;
import com.bocloud.vmware.vim25.mo.ManagedEntity;
import com.bocloud.vmware.vim25.mo.Network;
import com.bocloud.vmware.vim25.mo.ServiceInstance;
import com.bocloud.vmware.vim25.mo.Task;
import com.bocloud.vmware.vim25.mo.VirtualMachine;
import io.jsonwebtoken.lang.Assert;

/**
 * vmware测试类
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年5月13日
 */
public class VmwareTest {

	public static void main(String[] args) throws Exception {
		Butler butler = new Butler();
		butler.setUrl("10.20.2.99");
		butler.setUsername("administrator@vsphere.local");
		butler.setPassword("BeyondCMP!v587");

		URL url = new URL("https", butler.getUrl(), "/sdk");
		ServiceInstance serviceInstance = new ServiceInstance(url, butler.getUsername(), butler.getPassword(), true);
		serviceInstance.getSessionManager().setLocale("zh-CN");

		VirtualMachine virtualMachine = (VirtualMachine) serviceInstance.getSearchIndex().findByUuid(null,
				"5038b6c4-77dc-983b-295a-1c6ea0255bcc", true, true);
		
		Folder rootFolder = serviceInstance.getRootFolder();
		System.out.println(rootFolder.getName());
		
        InventoryNavigator navigator = new InventoryNavigator(rootFolder);
        
        ManagedEntity datacenter = navigator.searchManagedEntity("Datacenter", "开发中心");
        
        Assert.notNull(datacenter, "数据中心不存在！");
        Datacenter center = (Datacenter) datacenter;
        
        Map<String, Folder> vmFolderMap = new ConcurrentHashMap<>();
        // 云主机创建到指定目录下
        getVmFolder(vmFolderMap, center.getVmFolder(), rootFolder.getName());

	}
	
	private static void getVmFolder(Map<String, Folder> vmFolderMap, Folder rootFolder, String folderName) throws Exception {
        if (rootFolder.getName().equals(folderName)) {
            vmFolderMap.put(folderName, rootFolder);
            return;
        }
        ManagedEntity[] entities = rootFolder.getChildEntity();
        if (null == entities) {
            return;
        }
        for (ManagedEntity entity : entities) {
            if (entity instanceof Folder) {
                Folder childFolder = (Folder) entity;
                System.out.println(childFolder.getName());
                getVmFolder(vmFolderMap, childFolder, folderName);
            }
        }
    }
	
}
