package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.VmwareProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.vmware.vim25.mo.ServiceInstance;

/**
 * vmware认证操作类
 *
 * @author wangyu
 * @version 4.1.0-SNAPSHOT
 * @since 2018/11/14
 */
@Provider("bocloud.cmp.vmware")
public class VmwareAuthProvider extends VmwareProvider implements AuthProvider {

	public VmwareAuthProvider(Butler butler) {
		super(butler);
	}

	@Override
	public BocloudResult auth() {
		if (this.isAccessable()) {
			ServiceInstance si = this.getServiceInstance();
			// 连接成功之后返回版本信息，对平台版本进行校验
			return new BocloudResult(true, si.getAboutInfo().getVersion(), "连接成功");
		} else {
			return new BocloudResult(false, "连接失败：地址、用户名或密码输入错误");
		}
	}

}
