package com.bocloud.cmp.provider.contentlibrary;

import com.vmware.vapi.bindings.StubConfiguration;
import com.vmware.vapi.protocol.HttpConfiguration;
import lombok.extern.slf4j.Slf4j;

/**
 * vapi连接器
 *
 * @author wangyu
 * @version 5.0.0-SNAPSHOT
 * @since 2021/2/26
 */
@Slf4j
public class VapiConnector {


    /**
     * 获取cla api client
     *
     * @param server   vcenter地址
     * @param username vcenter用户名
     * @param password vcenter密码
     * @return
     */
    public static ClsApiClient getClsApiClient(String server, String username, String password) {
        try {
            VapiAuthenticationHelper vapiAuthHelper = new VapiAuthenticationHelper();
            SslUtil.trustAllHttpsCertificates();
            HttpConfiguration.SslConfiguration sslConfig = new HttpConfiguration.SslConfiguration.Builder()
                    .disableCertificateValidation()
                    .disableHostnameVerification()
                    .getConfig();
            HttpConfiguration httpConfig = new HttpConfiguration.Builder().setSslConfiguration(sslConfig).getConfig();
            StubConfiguration stubConfig = vapiAuthHelper.loginByUsernameAndPassword(
                    server, username, password, httpConfig);
            ClsApiClient clsApiClient = new ClsApiClient(vapiAuthHelper.getStubFactory(), stubConfig);
            return clsApiClient;
        } catch (Exception e) {
            log.error("Get error message:{}", e);
            return null;
        }
    }

}
