package com.bocloud.cmp.provider.utils;

/**
 * @ClassName: DateUtil
 * @Description: 时间转换工具类
 * @Author lxy
 * @Date 2021/8/26 10:14
 */
public class DateUtil {

    /**
     * @return java.lang.String
     * @Author: lxy
     * @Description: 毫秒差值转换成时分秒差值
     * @Date 2021/8/26 10:15
     * @Param ms
     * @throws:
     **/
    public static String formatTime(long ms) {
        int ss = 1000;
        int mi = ss * 60;
        int hh = mi * 60;
        int dd = hh * 24;

        long day = ms / dd;
        long hour = (ms - day * dd) / hh;
        long minute = (ms - day * dd - hour * hh) / mi;
        long second = (ms - day * dd - hour * hh - minute * mi) / ss;
        long milliSecond = ms - day * dd - hour * hh - minute * mi - second * ss;

        String strHour = String.valueOf(hour);//小时
        String strMinute = String.valueOf(minute);//分钟
        String strSecond = String.valueOf(second);//秒
        String strMilliSecond = String.valueOf(milliSecond);//毫秒
        strMilliSecond = String.valueOf(strMilliSecond);

        String res = "";
        if (!strHour.equals("0")) {
            res += strHour + "小时";
        }
        if (!strMinute.equals("0")) {
            res += strMinute + "分钟";
        }
        if (!strSecond.equals("0")) {
            res += strSecond + "秒";
        }
        res += strMilliSecond + "毫秒";
        return res;
    }
}