package com.bocloud.cmp.provider.common;

import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.provider.VolcengineProvider;
import com.bocloud.common.annotations.Provider;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @ClassName: VolcengineAuthProvider
 * @Description: 认证
 * @Author lxy
 * @Date 2021/9/15 17:53
 */
@Provider("bocloud.cmp.volcengine")
public class VolcengineAuthProvider extends VolcengineProvider implements AuthProvider {
    private static Logger logger = LoggerFactory.getLogger(VolcengineAuthProvider.class);

    /**
     * 构造方法，所有的云平台驱动都必须要实现或重写该构造方法
     *
     * @param butler 云平台认证信息
     */
    public VolcengineAuthProvider(Butler butler) {
        super(butler);
    }

    @Override
    public BocloudResult auth() {
        logger.info("认证。。");
        if (this.accessable()) {
            return new BocloudResult(true, "" + this.accessable());
        }
        return new BocloudResult(this.accessable(), "认证信息失败");
    }
}
