package com.bocloud.cmp.provider.convertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.AccessControlModel;
import com.bocloud.cmp.provider.volmodel.Acl;
import com.bocloud.cmp.provider.volmodel.Listeners;
import com.bocloud.common.utils.ListTool;

import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName: AccessControlConvertor
 * @Description:
 * @Author lxy
 * @Date 2021/10/21 15:24
 */
public class AccessControlConvertor implements BeanConvertor<AccessControlModel, Acl> {
    @Override
    public List<AccessControlModel> convertList(List<? extends Acl> list) {
        List<AccessControlModel> acls = new ArrayList<>();
        for (Acl acl : list) {
            acls.add(convertModel(acl));
        }
        return acls;
    }

    @Override
    public AccessControlModel convertModel(Acl acl) {
        AccessControlModel model = new AccessControlModel();
        if (null != acl) {
            model.setName(acl.getAclName());
            model.setAclUuId(acl.getAclId());
            model.setIPVersion(JSONObject.toJSONString(acl.getAclEntries()));
            JSONArray list = new JSONArray();
            List<Listeners> listeners = acl.getListeners();
            if (!ListTool.isEmpty(listeners)) {
                for (Listeners listener : listeners) {
                    JSONObject object = new JSONObject();
                    object.put("aclType", listener.getAclType());
                    object.put("protocol", listener.getProtocol());
                    object.put("listenerPort", listener.getPort());
                    object.put("listenerUuid", listener.getListenerId());
                    object.put("listenerName", listener.getListenerName());
                    list.add(object);
                }
                model.setListenerModels(list);
            }
            model.setRemark(acl.getDescription());
        }
        return model;
    }
}
