package com.bocloud.cmp.provider.convertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.KeypairModel;
import com.google.common.collect.Lists;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.List;

/**
 * @ClassName: VolKeyPairConvertor
 * @Description:
 * @Author lxy
 * @Date 2021/9/17 11:40
 */
public class VolKeyPairConvertor implements BeanConvertor<KeypairModel, JSONObject> {
    @Override
    public List<KeypairModel> convertList(List<? extends JSONObject> keyPairs) {
        List<KeypairModel> models = Lists.newArrayList();
        for (JSONObject keyPair : keyPairs) {
            models.add(convertModel(keyPair));
        }
        return models;
    }

    @Override
    public KeypairModel convertModel(JSONObject keyPair) {
        KeypairModel model = null;
        if (null != keyPair) {
            model = new KeypairModel();
            model.setName(keyPair.getString("KeyPairName"));
            model.setRemark(keyPair.getString("Description"));
            model.setKeyId(keyPair.getString("KeyPairId"));
            model.setFingerprint(keyPair.getString("FingerPrint"));
            String creationTime = keyPair.getString("CreatedAt");
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
            if (null != creationTime && !"".equals(creationTime)) {
                try {
                    model.setCreateTime(sdf.parse(creationTime));
                } catch (ParseException e) {
                    e.printStackTrace();
                }
            }
        }
        return model;
    }
}
