package com.bocloud.cmp.provider.convertor;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.LbListenerModel;
import com.bocloud.cmp.provider.volmodel.HealthCheck;
import com.bocloud.cmp.provider.volmodel.Listeners;
import com.google.common.collect.Lists;

import java.util.List;

/**
 * @ClassName: VolListenerConvertor
 * @Description:
 * @Author lxy
 * @Date 2021/10/12 11:12
 */
public class VolListenerConvertor implements BeanConvertor<LbListenerModel, Listeners> {
    @Override
    public List<LbListenerModel> convertList(List<? extends Listeners> list) {
        List<LbListenerModel> models = Lists.newArrayList();
        for (Listeners listeners : list) {
            models.add(convertModel(listeners));
        }
        return models;
    }

    @Override
    public LbListenerModel convertModel(Listeners listener) {
        LbListenerModel model = new LbListenerModel();
        if (listener != null) {
            model.setListenerUuid(listener.getListenerId());
            model.setName(null == listener.getListenerName() ? listener.getListenerId() : listener.getListenerName());
            model.setStatus(listener.getStatus());
            model.setProtocol(listener.getProtocol());
            model.setPort(listener.getPort());
            HealthCheck healthCheck = listener.getHealthCheck();
            if (null != healthCheck) {
                model.setHealthCheck("on".equalsIgnoreCase(healthCheck.getEnabled()));
                model.setConfiguration(JSONObject.toJSON(healthCheck));
            }
            model.setAclStatus("on".equalsIgnoreCase(listener.getAclStatus()));
            model.setAclType(listener.getAclType());
            model.setAclId(listener.getAclIds());
            model.setLbUuid(listener.getLoadBalancerId());
            model.setConnLimit(listener.getEstablishedTimeout());
            model.setLbScheduler(listener.getScheduler());
            model.setRemark(listener.getDescription());
            model.setDefaultPoolUuid(listener.getServerGroupId());
            JSONObject json = new JSONObject();
            json.put("CertificateId", listener.getCertificateId());
            JSONArray jsonArray = new JSONArray();
            jsonArray.add(json);
            model.setCertificates(jsonArray);
        }
        return model;
    }
}
