package com.bocloud.cmp.provider.convertor;

import com.bocloud.cmp.model.LbListenerRuleModel;
import com.bocloud.cmp.provider.volmodel.Rules;
import com.google.common.collect.Lists;

import java.util.List;

/**
 * @ClassName: VolListenerRuleConvertor
 * @Description:
 * @Author lxy
 * @Date 2021/10/19 14:44
 */
public class VolListenerRuleConvertor implements BeanConvertor<LbListenerRuleModel, Rules> {
    @Override
    public List<LbListenerRuleModel> convertList(List<? extends Rules> rules) {
        List<LbListenerRuleModel> models = Lists.newArrayList();
        for (Rules rule : rules) {
            models.add(convertModel(rule));
        }
        return models;
    }

    @Override
    public LbListenerRuleModel convertModel(Rules model) {
        LbListenerRuleModel ruleModel = new LbListenerRuleModel();
        if (model != null) {
            ruleModel.setPoolUuid(model.getServerGroupId());
            ruleModel.setRuleUuid(model.getRuleId());
            ruleModel.setRuleValue(model.getDomain());
            ruleModel.setUrl(model.getUrl());
        }
        return ruleModel;
    }
}

