package com.bocloud.cmp.provider.convertor;

import com.bocloud.cmp.model.RouteModel;
import com.bocloud.cmp.provider.volmodel.RouteEntries;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName: VolRouteConvertor
 * @Description:
 * @Author lxy
 * @Date 2021/9/26 14:26
 */
public class VolRouteConvertor implements BeanConvertor<RouteModel, RouteEntries> {
    @Override
    public List<RouteModel> convertList(List<? extends RouteEntries> objects) {
        List<RouteModel> routeModels = new ArrayList<>();
        for (RouteEntries object : objects) {
            routeModels.add(convertModel(object));
        }
        return routeModels;
    }

    @Override
    public RouteModel convertModel(RouteEntries routeEntries) {
        RouteModel model = null;
        if (null != routeEntries) {
            model = new RouteModel();
            model.setDestination(routeEntries.getDestinationCidrBlock());
            model.setUuid(routeEntries.getRouteEntryId());
            if (StringUtils.isEmpty(routeEntries.getRouteEntryName())) {
                model.setName(routeEntries.getRouteEntryId());
            } else {
                model.setName(routeEntries.getRouteEntryName());
            }
            model.setRouteTableUuid(routeEntries.getRouteTableId());
            model.setState(routeEntries.getStatus());
            model.setType(routeEntries.getType());
            String nextHopType = routeEntries.getNextHopType();
            model.setTargetType(nextHopType);
            String nextHopId = routeEntries.getNextHopId();
            if (StringUtils.isNotBlank(nextHopId)) {
                model.setTargetUuid(nextHopId);
            } else {
                if ("InnerSubnet".equalsIgnoreCase(nextHopType)) {
                    model.setTargetUuid("系统默认");
                } else if ("System".equalsIgnoreCase(nextHopType)) {
                    model.setTargetUuid("System");
                }
            }
        }
        return model;
    }
}
