package com.bocloud.cmp.provider.convertor;

import com.bocloud.cmp.model.RouteTableModel;
import com.bocloud.cmp.provider.volmodel.RouterTableList;
import org.apache.commons.lang3.StringUtils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName: VolRouterConvertor
 * @Description:
 * @Author lxy
 * @Date 2021/9/26 10:11
 */
public class VolRouteTableConvertor implements BeanConvertor<RouteTableModel, RouterTableList> {
    @Override
    public List<RouteTableModel> convertList(List<? extends RouterTableList> objects) {
        List<RouteTableModel> routerTableModels = new ArrayList<>();
        for (RouterTableList object : objects) {
            routerTableModels.add(convertModel(object));
        }
        return routerTableModels;
    }

    @Override
    public RouteTableModel convertModel(RouterTableList routeTable) {
        RouteTableModel model = null;
        if (null != routeTable) {
            model = new RouteTableModel();
            model.setRemark(routeTable.getDescription());
            if (StringUtils.isEmpty(routeTable.getRouteTableName())) {
                model.setName(routeTable.getRouteTableId());
            } else {
                model.setName(routeTable.getRouteTableName());
            }
            model.setType(routeTable.getRouteTableType());
            model.setVpcUuid(routeTable.getVpcId());
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
            String creationTime = routeTable.getCreationTime();
            if (null != creationTime && !"".equals(creationTime)) {
                try {
                    model.setGmtCreate(sdf.parse(creationTime));
                } catch (ParseException e) {
                    e.printStackTrace();
                }
            }
            model.setUuid(routeTable.getRouteTableId());
            model.setSubnetUuids(routeTable.getSubnetIds());
        }
        return model;
    }
}
