package com.bocloud.cmp.provider.convertor;

import com.bocloud.cmp.model.SecurityGroupRuleModel;
import com.bocloud.cmp.provider.volmodel.Permissions;
import com.google.common.collect.Lists;

import java.util.List;

/**
 * @ClassName: VolVpcConvertor
 * @Description:
 * @Author lxy
 * @Date 2021/9/14 11:09
 */
public class VolSecyrityRuleConvertor implements BeanConvertor<SecurityGroupRuleModel, Permissions> {
    @Override
    public List<SecurityGroupRuleModel> convertList(List<? extends Permissions> permissions) {
        List<SecurityGroupRuleModel> models = Lists.newArrayList();
        for (Permissions permission : permissions) {
            models.add(convertModel(permission));
        }
        return models;
    }

    @Override
    public SecurityGroupRuleModel convertModel(Permissions permission) {
        SecurityGroupRuleModel ruleModel = null;
        if (null != permission) {
            ruleModel = new SecurityGroupRuleModel();
            ruleModel.setRemark(permission.getDescription());
            ruleModel.setDirection(permission.getDirection());
            ruleModel.setProtocol(permission.getProtocol().toUpperCase());
            ruleModel.setAction(permission.getPolicy());
            ruleModel.setPortMin(permission.getPortStart());
            ruleModel.setPortMax(permission.getPortEnd());
            ruleModel.setPriority(Integer.valueOf(permission.getPriority()));
            ruleModel.setRemoteIpPrefix(permission.getCidrIp());
            ruleModel.setGroupUuid(permission.getGroupId());
        }
        return ruleModel;
    }
}
