package com.bocloud.cmp.provider.convertor;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.VpcModel;
import com.bocloud.cmp.provider.volmodel.Vpc;
import com.google.common.collect.Lists;
import org.apache.commons.lang3.StringUtils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.List;

/**
 * @ClassName: VolVpcConvertor
 * @Description:
 * @Author lxy
 * @Date 2021/9/13 14:36
 */
public class VolVpcConvertor implements BeanConvertor<VpcModel, Vpc> {
    @Override
    public List<VpcModel> convertList(List<? extends Vpc> vpcs) {
        List<VpcModel> models = Lists.newArrayList();
        for (Vpc vpc : vpcs) {
            models.add(convertModel(vpc));
        }
        return models;
    }

    @Override
    public VpcModel convertModel(Vpc vpc) {
        VpcModel vpcModel = null;
        if (null != vpc) {
            vpcModel = new VpcModel();
            vpcModel.setVpcId(vpc.getVpcId());
            if (!StringUtils.isEmpty(vpc.getVpcName())) {
                vpcModel.setName(vpc.getVpcName());
            } else {
                vpcModel.setName(vpc.getVpcId());
            }
            String status = vpc.getStatus();
            if (null != status && !"".equals(status)) {
                vpcModel.setStatus(status.toUpperCase());
            }
            String creationTime = vpc.getCreationTime();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
            if (null != creationTime && !"".equals(creationTime)) {
                try {
                    vpcModel.setGmtCreate(sdf.parse(creationTime));
                } catch (ParseException e) {
                    e.printStackTrace();
                }
            }
            vpcModel.setRemark(vpc.getDescription());
            vpcModel.setCidr(vpc.getCidrBlock());
            vpcModel.setRouterId(JSONObject.toJSONString(vpc.getRouteTableIds()));
            vpcModel.setDnsServer(JSONObject.toJSONString(vpc.getDnsServers()));
            vpcModel.setSecurityGroupId(JSONObject.toJSONString(vpc.getSecurityGroupIds()));
        }
        return vpcModel;
    }
}
