package com.bocloud.cmp.provider.utils;

/**
 * @ClassName: VolcengineConst
 * @Description: 常用常量信息
 * @Author lxy
 * @Date 2021/9/10 11:48
 */
public class VolcengineConst {

    public static final String PATH = "/";
    public static final String VERSION_20200401 = "2020-04-01";
    public static final String VERSION_20180101 = "2018-01-01";
    public static final String METHOD = "GET";
    public static final String SCHEME = "https";
    public static final String HOST = "open.volcengineapi.com";

    // esc
    //镜像
    public static final String DESCRIBEIMAGES = "DescribeImages"; //获取镜像信息
    //云硬盘
    public static final String LISTVOLUMES = "ListVolumes"; //获取硬盘信息
    public static final String CREATEVOLUME = "CreateVolume"; //创建硬盘
    public static final String MODIFYVOLUME = "ModifyVolume"; //修改硬盘
    public static final String ATTACHVOLUME = "AttachVolume"; //挂载硬盘
    public static final String DETACHVOLUME = "DetachVolume"; //卸载硬盘
    public static final String DELETEVOLUME = "DeleteVolume"; //删除硬盘
    public static final String GETVOLUME = "GetVolume"; //查询单个硬盘信息
    public static final String EXTENDVOLUME = "ExtendVolume"; //扩容硬盘
    //云主机
    public static final String DESCRIBEINSTANCES = "DescribeInstances"; //获取实例信息
    public static final String DELETEINSTANCE = "DeleteInstance"; //删除一个实例
    public static final String REBOOTINSTANCE = "RebootInstance"; //重启一台实例
    public static final String STOPINSTANCE = "StopInstance"; //停止一台实例
    public static final String STARTINSTANCE = "StartInstance"; //启动一台实例
    public static final String CREATEINSTANCES = "CreateInstances"; //启动一台实例
    public static final String RESETAUTHENTICATION = "ResetAuthentication"; //重置密码
    public static final String MODIFYINSTANCEATTRIBUTE = "ModifyInstanceAttribute"; //修改实例信息
    public static final String INNERCREATERESIZEORDER = "InnerCreateResizeOrder"; //配置变更
    //vpc
    public static final String CREATEVPC = "CreateVpc"; //创建vpc
    public static final String DESCRIBEVPCS = "DescribeVpcs"; //查询VPC的详细信息
    public static final String DELETEVPC = "DeleteVpc"; //删除指定的VPC
    public static final String MODIFYVPCATTRIBUTES = "ModifyVpcAttributes"; //修改VPC的信息，包含VPC名称、描述等信息。
    public static final String DESCRIBEVPCATTRIBUTES = "DescribeVpcAttributes"; //查询VPC的详细信息。
    //子网
    public static final String DESCRIBESUBNETS = "DescribeSubnets"; //查询指子网的列表
    public static final String DESCRIBESUBNETATTRIBUTES = "DescribeSubnetAttributes"; //查询单个子网的详细信息。
    public static final String DELETESUBNET = "DeleteSubnet"; //删除指定的子网。
    public static final String CREATESUBNET = "CreateSubnet"; //创建一个子网。
    public static final String MODIFYSUBNETATTRIBUTES = "ModifySubnetAttributes"; //修改指定子网的信息。
    //安全组
    public static final String CREATESECURITYGROUP = "CreateSecurityGroup"; //创建一个安全组
    public static final String MODIFYSECURITYGROUPATTRIBUTES = "ModifySecurityGroupAttributes"; //创建一个安全组
    public static final String DESCRIBESECURITYGROUPATTRIBUTES = "DescribeSecurityGroupAttributes"; //查询指定安全组的安全组规则
    public static final String DESCRIBESECURITYGROUPS = "DescribeSecurityGroups"; //查询安全组的基本信息。
    public static final String DELETESECURITYGROUP = "DeleteSecurityGroup"; //删除指定的安全组。
    //安全组规则
    public static final String AUTHORIZESECURITYGROUPINGRESS = "AuthorizeSecurityGroupIngress"; //为指定安全组增加一条入方向的规则
    public static final String AUTHORIZESECURITYGROUPEGRESS = "AuthorizeSecurityGroupEgress"; //增加一条安全组出方向规则
    public static final String REVOKESECURITYGROUPINGRESS = "RevokeSecurityGroupIngress"; //删除一条安全组入方向规则，可同时撤销安全组入方向的权限设置。
    public static final String REVOKESECURITYGROUPEGRESS = "RevokeSecurityGroupEgress"; //删除一条出方向安全组规则，撤销安全组出方向的访问权限。
    public static final String MODIFYSECURITYGROUPRULEDESCRIPTIONSEGRESS = "ModifySecurityGroupRuleDescriptionsEgress"; //修改安全组出方向规则的描述信息。
    public static final String MODIFYSECURITYGROUPRULEDESCRIPTIONSINGRESS = "ModifySecurityGroupRuleDescriptionsIngress"; //修改安全组入方向规则的描述信息。
    //规格
    public static final String LISTFLAVORS = "ListFlavors"; //列举规格
    //区域
    public static final String DESCRIBEZONES = "DescribeZones"; //列举区域下所有可用区
    //网卡
    public static final String DESCRIBENETWORKINTERFACES = "DescribeNetworkInterfaces"; //查询网卡的信息。
    public static final String DESCRIBENETWORKINTERFACEATTRIBUTES = "DescribeNetworkInterfaceAttributes"; //查询网卡的详细信息，包含主网卡和辅助网卡两种类型
    public static final String CREATENETWORKINTERFACE = "CreateNetworkInterface"; //创建一张辅助网卡。
    public static final String DELETENETWORKINTERFACE = "DeleteNetworkInterface"; //删除指定辅助网卡，仅状态为Available的辅助网卡才支持删除操作。
    public static final String MODIFYNETWORKINTERFACEATTRIBUTES = "ModifyNetworkInterfaceAttributes"; //修改辅助网卡的信息，包括名称、 描述及绑定的安全组。此处辅助网卡指单独创建的可随时挂载和卸载的辅助网卡。NAT网关辅助网卡仅支持修改名称和描述，负载均衡辅助网卡和VPN网关辅助网卡不支持修改。
    public static final String ATTACHNETWORKINTERFACE = "AttachNetworkInterface"; //挂载单个辅助网卡到实例上，仅状态为Available的辅助网卡才能挂载到实例上。此处辅助网卡不包含NAT网关辅助网卡、负载均衡辅助网卡、VPN网关辅助网卡。
    public static final String DETACHNETWORKINTERFACE = "DetachNetworkInterface"; //挂载单个辅助网卡到实例上，仅状态为Available的辅助网卡才能挂载到实例上。此处辅助网卡不包含NAT网关辅助网卡、负载均衡辅助网卡、VPN网关辅助网卡。
    //秘钥
    public static final String CREATEKEYPAIR = "CreateKeyPair"; //创建秘钥
    public static final String IMPORTKEYPAIR = "ImportKeyPair"; //导入公钥
    public static final String DESCRIBEKEYPAIRS = "DescribeKeyPairs"; //查询秘钥
    public static final String DELETEKEYPAIR = "DeleteKeyPair"; //删除秘钥
    //公网ip
    public static final String DESCRIBEEIPADDRESSES = "DescribeEipAddresses"; //查询已创建的EIP。
    public static final String DESCRIBEEIPADDRESSATTRIBUTES = "DescribeEipAddressAttributes"; //查看指定EIP的详情。
    public static final String ALLOCATEEIPADDRESS = "AllocateEipAddress"; //申请EIP。
    public static final String ASSOCIATEEIPADDRESS = "AssociateEipAddress"; //绑定EIP到同地域的云产品实例
    public static final String DISASSOCIATEEIPADDRESS = "DisassociateEipAddress"; //从云产品上解绑指定的EIP。
    public static final String RELEASEEIPADDRESS = "ReleaseEipAddress"; //释放指定的EIP。释放前，请确保此EIP已完成解绑。
    public static final String MODIFYEIPADDRESSATTRIBUTES = "ModifyEipAddressAttributes"; //修改指定EIP的名称、 描述信息和带宽峰值。
    //路由
    public static final String DESCRIBEROUTETABLELIST = "DescribeRouteTableList"; //接口查询路由表的信息
    public static final String CREATEROUTETABLE = "CreateRouteTable"; //创建一个路由表
    public static final String MODIFYROUTETABLEATTRIBUTES = "ModifyRouteTableAttributes"; //修改指定路由表的名称或描述
    public static final String DELETEROUTETABLE = "DeleteRouteTable"; //删除指定的路由表
    public static final String ASSOCIATEROUTETABLE = "AssociateRouteTable"; //为指定自定义路由表关联子网
    public static final String DISASSOCIATEROUTETABLE = "DisassociateRouteTable"; //将自定义路由表与子网解绑
    //路由条目
    public static final String CREATEROUTEENTRY = "CreateRouteEntry"; //为指定路由表创建路由条目
    public static final String DELETEROUTEENTRY = "DeleteRouteEntry"; //删除指定路由表的路由条目
    public static final String MODIFYROUTEENTRY = "ModifyRouteEntry"; //修改路由表的名称或描述
    public static final String DESCRIBEROUTEENTRYLIST = "DescribeRouteEntryList"; //查询指定路由表下路由条目的信息
    //负载均衡
    public static final String DESCRIBELOADBALANCERS = "DescribeLoadBalancers"; //查询负载均衡实例的列表
    public static final String DESCRIBELOADBALANCERATTRIBUTES = "DescribeLoadBalancerAttributes"; //查询指定负载均衡实例的详细信息
    public static final String CREATELOADBALANCER = "CreateLoadBalancer"; //创建一个负载均衡实例
    public static final String MODIFYLOADBALANCERATTRIBUTES = "ModifyLoadBalancerAttributes"; //修改指定负载均衡实例
    public static final String DELETELOADBALANCER = "DeleteLoadBalancer"; //删除一个负载均衡实例
    //监听器
    public static final String DESCRIBELISTENERS = "DescribeListeners"; //查询监听器列表
    public static final String DESCRIBELISTENERATTRIBUTES = "DescribeListenerAttributes"; //查询指定监听器的详细信息
    public static final String DESCRIBELISTENERHEALTH = "DescribeListenerHealth"; //查询指定监听器关联的后端服务器的健康检查信息
    public static final String CREATELISTENER = "CreateListener"; //为指定负载均衡实例创建一个监听器
    public static final String MODIFYLISTENERATTRIBUTES = "ModifyListenerAttributes"; //修改指定监听器。
    public static final String DELETELISTENER = "DeleteListener"; //删除一个监听器。
    //监听器转发规则
    public static final String DESCRIBERULES = "DescribeRules"; //查询指定HTTP/HTTPS监听器中的转发规则列表
    public static final String CREATERULES = "CreateRules"; //为指定HTTP/HTTPS监听器添加转发规则，用于将来自不同域名或不同URL的请求转发到不同的后端服务器组。
    public static final String MODIFYRULES = "ModifyRules"; //更换指定HTTP/HTTPS监听器中转发规则对应的后端服务器组或修改转发规则的描述。
    public static final String DELETERULES = "DeleteRules"; //删除指定HTTP/HTTPS监听器中的转发规则。
    //后端服务器组
    public static final String DESCRIBESERVERGROUPS = "DescribeServerGroups"; //查询后端服务器组列表
    public static final String DESCRIBESERVERGROUPATTRIBUTES = "DescribeServerGroupAttributes"; //查询指定后端服务器组的详细信息
    public static final String CREATESERVERGROUP = "CreateServerGroup"; //创建一个后端服务器组
    public static final String MODIFYSERVERGROUPATTRIBUTES = "ModifyServerGroupAttributes"; //接口修改指定后端服务器组，包括服务器组的名称、描述、以及指定服务器的相关信息
    public static final String DELETESERVERGROUP = "DeleteServerGroup"; //删除一个后端服务器组，删除服务器组的时候会同时删除组内所有后端服务器
    public static final String ADDSERVERGROUPBACKENDSERVERS = "AddServerGroupBackendServers"; //为指定后端服务器组添加后端服务器
    public static final String REMOVESERVERGROUPBACKENDSERVERS = "RemoveServerGroupBackendServers"; //为指定后端服务器组移除后端服务器
    //访问控制
    public static final String DESCRIBEACLS = "DescribeAcls"; //查询访问控制策略组列表
    public static final String DESCRIBEACLATTRIBUTES = "DescribeAclAttributes"; //查询指定访问策略控制组的详细信息
    public static final String CREATEACL = "CreateAcl"; //创建一个访问控制策略组
    public static final String MODIFYACLATTRIBUTES = "ModifyAclAttributes"; //修改指定访问策略控制组
    public static final String DELETEACL = "DeleteAcl"; //删除一个访问控制策略组
    public static final String ADDACLENTRIES = "AddAclEntries"; //为指定访问控制策略组添加IP条目
    public static final String REMOVEACLENTRIES = "RemoveAclEntries"; //为指定访问控制策略组删除IP条目

    //常用服务
    public static enum service {
        ECS, VPC, CLB
    }

}
