package com.bocloud.cmp.provider.volmodel;

import lombok.Data;

/**
 * @ClassName: EipAddresses
 * @Description: EIP的详细信息列表
 * @Author lxy
 * @Date 2021/9/17 17:17
 */
@Data
public class EipAddresses {
    //EIP所在项目的名称。  default
    private String ProjectName;
    //更新EIP的时间。  2021-07-23T11:55:12+08:00
    private String UpdatedAt;
    //EIP的ID。  eip-2zeerr***b7ucd
    private String AllocationId;
    //EIP的创建时间。  2021-07-15T21:46:15+08:00
    private String AllocationTime;
    //EIP的带宽值，单位为Mbps。  	5
    private Integer Bandwidth;
    //EIP的描述信息。   test eip
    private String Description;
    //线路类型。●BGP（存量为BGPMultiLine）：BGP多线。●ChinaMobile：中国移动。●ChinaUnicom：中国联通。●ChinaTelecom：中国电信。
    private String ISP;
    //当前绑定的实例ID。  eni-2ff1n2msawao05oxruwh2****
    private String InstanceId;
    //当前绑定的实例类型。  NetworkInterface
    private String InstanceType;
    //EIP的公网IP地址。  12.XX.XX.89
    private String EipAddress;
    //EIP的名称。  eip-test
    private String Name;
    //EIP的状态。●Attaching：绑定中。●Detaching：解绑中。●Attached：已分配。●Available：可用。
    private String Status;
    //EIP是否被锁定。●Normal: 正常●FinancialLocked: 被锁定
    private String BusinessStatus;
    //EIP被锁定的原因。●Financial: 因欠费被锁定●Security: 因安全被锁定
    private String LockReason;
    //EIP付费类型，当前仅支持按量计费。●2: 按量计费
    private Integer BillingType;
    //资源冻结时间。仅当资源因为欠费冻结，此参数才会有返回值。
    private String OverdueTime;
    //预期资源强制回收时间。仅当资源因为欠费冻结，此参数才会有返回值。
    private String DeletedTime;
    //请求ID。
    private String RequestId;
}

