package com.bocloud.cmp.provider.volmodel;

import lombok.Data;

/**
 * @ClassName: Image
 * @Description: 镜像
 * @Author lxy
 * @Date 2021/9/10 15:29
 */
@Data
public class Image {

    //镜像ID  image-3tksv4n6ay3vj******
    private String ImageId;
    //镜像名称    test
    private String ImageName;
    //镜像描述  testdescription
    private String Description;
    //镜像的容量大小，单位：Byte  32212254***
    private Long VirtualSize;
    //操作系统类型：  Linux、Windows
    private String OsType;
    //镜像的状态：  available：可用、creating：创建中、downloading：下载中、uploading：上传中、 converting：格式转换中、error：错误
    private String Status;
    //	镜像的可见性：  public：公共镜像、private：自定义镜像
    private String Visibility;
    //镜像的架构类型：  amd64：x86计算
    private String Architecture;
    //更新时间。格式满足RFC3339。  2021-07-26T21:55:12+08:00
    private String UpdatedAt;
    //创建时间。格式满足RFC3339。  2021-07-26T21:55:12+08:00
    private String CreatedAt;
    //镜像操作系统的发行版本。  CentOS、Debian、veLinux、Windows Server、 Fedora、OpenSUSE、Ubuntu
    private String Platform;
    //镜像操作系统的名称。  CentOS 7.6 64位
    private String OsName;
    //镜像是否支持Cloud-init。  true：支持。 false：不支持。
    private Boolean IsSupportCloudInit;


}
