package com.bocloud.cmp.provider.volmodel;

import lombok.Data;

import java.util.List;

/**
 * @ClassName: InstanceType
 * @Description: 实例的规格信息。
 * @Author lxy
 * @Date 2021/9/13 10:06
 */
@Data
public class InstanceType {
    //实例规格的名称 ecs.c1.xlarge
    private String Id;
    //实例规格族的名称 计算型c1
    private String InstanceTypeFamily;
    //vCPU核数 4
    private Integer Cpu;
    //内存大小，单位：MiB 8192
    private Integer Mem;
    //网络出入带宽能力，单位：Mbit/s 1.5
    private Integer NetMbpsQuota;
    //网络出入收发包能力，单位：千PPS 20
    private Integer NetKppsQuota;
    //网络连接数能力，单位：万 20
    private Integer NetSessionQuota;
    //支持挂载的网卡数量，包括1张主网卡 3
    private Integer NetworkInterfaceNumQuota;
    //CPU架构，取值：amd64 amd64
    private String Architecture;
    //支持的云盘类型，取值：PTSSD PTSSD
    private List<String> VolumeTypes;
}
