package com.bocloud.cmp.provider.volmodel;

import lombok.Data;

import java.util.List;

/**
 * @ClassName: Instances
 * @Description: 云主机实例
 * @Author lxy
 * @Date 2021/9/13 10:03
 */
@Data
public class Instances {
    //创建时间  2019-04-23T01:37:38Z
    private String CreatedAt;
    //更新时间 2019-04-25T01:37:38Z
    private String UpdatedAt;
    //实例ID	i-3ti9101aju3vj0******
    private String Id;
    //可用区ID  cn-beijing-a
    private String ZoneId;
    //镜像ID  image-3tefr6wgx63vj0******
    private String ImageId;
    //实例的状态，取值：CREATING：创建中 RUNNING：运行中STOPPING：停止中STOPPED：已停止REBOOTING: 重启中ERROR：其他
    private String Status;
    //实例名称  instance-test
    private String InstanceName;
    //实例描述  用于测试的云服务器实例
    private String Description;
    //实例主机名  instance-host-name
    private String HostName;
    //用户的自定义数据，提供一种自定义实例启动行为及传入数据的功能。
    private String UserData;
    //私有网络ID	vpc-3thbinq64t4bwb******
    private String VpcId;
    //实例的规格信息。
    private InstanceType InstanceType;
    //实例挂载的云盘信息
    private List<VolumeRes> Volumes;
    //实例挂载的网卡信息
    private List<NetworkInterfaceRes> NetworkInterfaces;
    //当查询高性能计算GPU型实例时，列表形式返回各网卡的RDMA IP地址。
    private List<String> RdmaIpAddresses;
    //密钥对名称   	kp-test-123
    private String KeyPairName;
    //密钥对ID kp-3tgh3ifp8j44kd******
    private String KeyPairId;
}
