package com.bocloud.cmp.provider.volmodel;

import lombok.Data;

/**
 * @ClassName: Listeners
 * @Description: 监听器
 * @Author lxy
 * @Date 2021/10/12 9:56
 */
@Data
public class Listeners {
    //监听器的ID。
    private String ListenerId;
    //监听器的名称。
    private String ListenerName;
    //监听器的创建时间  2021-08-11T16:37:37Z
    private String CreateTime;
    //监听器的最近操作时间。   2021-08-11T16:37:37Z
    private String UpdateTime;
    //监听器的状态。● Creating：创建中。● Active：运行中。● Deleting: 删除中。● Disabled: 已停用。
    private String Status;
    //是否启用监听器。● on：开启。● off：不开启。
    private String Enabled;
    //监听器的协议。● TCP● UDP● HTTP● HTTPS
    private String Protocol;
    //监听器接收请求使用的端口。
    private Integer Port;
    //健康检查相关的参数
    private HealthCheck HealthCheck;
    //TCP/UDP监听器关联的后端服务器组的ID。HTTP/HTTPS监听器关联的默认后端服务器组ID
    private String ServerGroupId;
    //是否开启访问控制功能。● on：开启。● off ：不开启。
    private String AclStatus;
    /**
     * 访问控制的方式。
     * ● white ：白名单方式。表示监听器仅转发来自所选访问控制策略组中设置的IP地址或地址段的请求。如果所选策略组中没有添加任何IP，则监听器不会转发任何请求。
     * ● black：黑名单方式。表示仅拒绝来自所选访问控制策略组中设置的IP地址或地址段的请求。如果所选策略组中没有添加任何IP，则监听器会转发全部请求。
     * 说明： 仅AclStatus参数为 on 时返回。
     */
    private String AclType;
    //监听器绑定的访问控制策略组ID。说明： 仅AclStatus参数为 on 时返回。
    private String AclIds;

    //监听器所属的负载均衡实例ID。
    private String LoadBalancerId;
    //监听器的连接超时时间。说明： 仅TCP/UDP监听器会返回本参数。
    private Integer EstablishedTimeout;
    /**
     * 监听器使用的调度算法。
     * ● wrr （默认值）：加权轮询，权重值越高的后端服务器，被轮询到的次数（概率）越高。
     * ● wlc：加权最小连接数，在最少连接数的基础上，根据服务器的不同处理能力，给每个服务器分配不同的权重，使其能够接受相应权值数的服务请求。
     * ● sh：源地址哈希，基于源IP地址的一致性哈希，相同的源地址会调度到相同的后端服务器。
     */
    private String Scheduler;
    //监听器的描述。
    private String Description;
    //HTTPS监听器关联的证书ID。
    private String CertificateId;


}
