package com.bocloud.cmp.provider.volmodel;

import com.alibaba.fastjson.JSONObject;
import lombok.Data;

import java.util.List;

/**
 * @ClassName: LoadBalancers
 * @Description: 负载均衡实例的详细信息
 * @Author lxy
 * @Date 2021/10/11 11:45
 */
@Data
public class LoadBalancers {
    //负载均衡实例ID。  	clb-bp1o94dp5i6ea****
    private String LoadBalancerId;
    //负载均衡实例的名称。    clb-test1
    private String LoadBalancerName;
    //负载均衡实例状态。● Active：运行中。● Provisioning：创建中。● Configuring：配置中。● Deleting：删除中。
    private String Status;
    //负载均衡实例的描述。
    private String Description;
    //负载均衡实例的创建时间。  	2021-08-11T16:37:37Z
    private String CreateTime;
    //负载均衡实例的最近操作时间。    2021-08-11T16:37:37Z
    private String UpdateTime;
    /**
     * 负载均衡实例的类型。
     * ● public：表示创建一个公网负载均衡实例，系统会分配一个公网IP地址，用于转发公网请求。
     * ● private：表示创建一个私网负载均衡实例，系统会分配一个私网IP地址，仅用于转发私网请求。
     */
    private String Type;
    //负载均衡实例所属的VPC ID。
    private String VpcId;
    //负载均衡实例所属的子网ID。
    private String SubnetId;
    /**
     * 负载均衡实例的修z`。
     * ● NonProtection：不开启修改保护功能，配置后会清空已配置的ModificationProtectionReason。
     * ● ConsoleProtection：开启控制台修改保护功能，表示禁止通过控制台修改实例或删除实例，但允许通过API接口修改或删除。
     */
    private String ModificationProtectionStatus;
    /**
     * 设置修改保护状态的原因。
     * 说明： 仅在参数ModificationProtectionStatus配置为ConsoleProtection时有效。
     */
    private String ModificationProtectionReason;
    //负载均衡实例绑定的公网IP ID。
    private String EipID;
    //负载均衡实例的私网IP地址。
    private String EniAddress;
    //负载均衡实例占用的网卡ID。
    private String EniID;
    //负载均衡实例的公网IP地址。
    private String EipAddress;
    //负载均衡实例是否被锁定。● Normal: 正常。● FinancialLocked: 被锁定。
    private String BusinessStatus;
    /**
     * 负载均衡实例被锁定的原因。该参数只有实例处于 FinancialLocked 状态时有返回值。
     * ● Financial: 因欠费被锁定。
     * ● Security: 因安全被锁定。
     */
    private String LockReason;
    //负载均衡实例被冻结的时间。该参数只有实例处于 FinancialLocked 状态时有返回值。  	2021-08-11T16:37:37Z
    private String OverdueTime;
    //负载均衡实例的预期回收时间。该参数只有实例处于 FinancialLocked 状态时有返回值。   2021-08-11T16:37:37Z
    private String DeletedTime;
    /**
     * 负载均衡实例的规格。
     * ● small_1：小型I
     * ● small_2：小型II
     * ● medium_1：中型I
     * ● meidum_2：中型II
     * ● large_1：大型I
     * ● large_2：大型II
     */
    private String LoadBalancerSpec;
    //负载均衡实例的计费类型。● 2：按量付费（默认值）
    private Integer LoadBalancerBillingType;
    //负载均衡实例的公网IP的信息
    private JSONObject Eip;
    //负载均衡实例中后端服务器组的信息
    private List<JSONObject> ServerGroups;
    //负载均衡实例中监听器的信息
    private List<JSONObject> Listeners;
    //负载均衡实例中访问日志的信息
    private JSONObject AccessLog;

}
