package com.bocloud.cmp.provider.volmodel;

import lombok.Data;

import java.util.List;

/**
 * @ClassName: NetworkInterfaceSets
 * @Description: 网卡信息
 * @Author lxy
 * @Date 2021/9/16 17:56
 */
@Data
public class NetworkInterfaceSets {
    //创建网卡的时间。  2021-04-09T08:36:47+08:00
    private String CreatedAt;
    //更新网卡的时间。	2021-04-09T08:36:47+08:00
    private String UpdatedAt;
    //网卡所有者ID。  	200015
    private String AccountId;
    //网卡所属资源组。  default
    private String ProjectName;
    //网卡描述信息。    TestDescription
    private String Description;
    //网卡ID。   eni-bpacfmxazb4p****
    private String NetworkInterfaceId;
    //网卡名称。  eniTestName
    private String NetworkInterfaceName;
    //网卡所属VPC的ID。  vpc-bpacfmxazb4p****
    private String VpcId;
    //网卡所属区域的ID。  	cn-****
    private String ZoneId;
    //网卡所属VPC的名称。	vpc-name
    private String VpcName;
    //网卡所属子网的ID。  subnet-128fhnvjjgg****
    private String SubnetId;
    //网卡的Mac地址。  XX.XX.XX.XX.XX.XX
    private String MacAddress;
    //网卡绑定实例的ID。  i-xfgf***x
    private String DeviceId;
    //网卡的类型。  Primary
    private String Type;
    //网卡的主IP地址。 	192.XX.XX.10
    private String PrimaryIpAddress;
    //网卡的绑定状态。  InUse
    private String Status;
    //网卡关联的安全组ID。  ["sg-9tczdi****mctjb","sg-3tznys4****mctjb"]
    private List<String> SecurityGroupIds;
    //是否启用Mac安全校验。true：启用false：不启用
    private Boolean PortSecurityEnabled;
    //网卡关联的公网IP的信息
    private AssociatedElasticIp AssociatedElasticIp;
    //请求ID。
    private String RequestId;
}
