package com.bocloud.cmp.provider.volmodel;

import lombok.Data;

/**
 * @ClassName: RouteEntries
 * @Description: 路由条目的详细信息
 * @Author lxy
 * @Date 2021/9/26 14:18
 */
@Data
public class RouteEntries {
    //路由条目描述。  This is the first route
    private String Description;
    //路由条目的目标网段  8.XX.XX.0/16
    private String DestinationCidrBlock;
    //路由条目ID。  rte-3tj9gw2pwq3vj******
    private String RouteEntryId;
    //路由条目名称。 test-route
    private String RouteEntryName;
    //路由条目所属路由表的ID。  vtb-fadfgegg******
    private String RouteTableId;
    //路由规则状态：●Pending：配置中●Available：可用
    private String Status;
    //路由条目类型：●Custom：自定义路由条目● System：系统路由条目
    private String Type;
    //路由条目所属私有网络的ID。
    private String VpcId;
    //下一跳资源的ID
    private String NextHopId;
    //下一跳名称。
    private String NextHopName;
    /**
     * 下一跳类型。
     * ●Instance：ECS实例
     * ●NetworkInterface：辅助网卡
     * ●NatGW：NAT网关
     * ●VpnGW：VPN网关
     */
    private String NextHopType;
}
