package com.bocloud.cmp.provider.volmodel;

import lombok.Data;

import java.util.List;

/**
 * @ClassName: RouterTableList
 * @Description: 路由表的详细信息
 * @Author lxy
 * @Date 2021/9/26 10:05
 */
@Data
public class RouterTableList {
    //路由表描述信息。  Test route table
    private String Description;
    //路由表ID。  vtb-2fdzao4h726f45******
    private String RouteTableId;
    //路由表名称。  Test-route-table
    private String RouteTableName;
    //路由表的类型：●Custom：自定义路由表。●System：系统路由表。
    private String RouteTableType;
    //路由表绑定的子网列表。  ["subnet-2fdzbgudy248w5o****","subnet-2fdzaou4liw3k5oxruv****"]
    private List<String> SubnetIds;
    //路由表所属的VPC ID。  vpc-2fdz8g5nruzuo5oxru****
    private String VpcId;
    //VPC的名称。  test
    private String VpcName;
    //创建路由表的时间。  2021-09-01T19:38:31+08:00
    private String CreationTime;
    //更新路由表的时间。  2021-09-01T19:38:31+08:00
    private String UpdateTime;
    //路由表所属账号的ID。  200000****
    private String AccountId;
    //路由表所在项目的名称。  	default
    private String ProjectName;
}
