package com.bocloud.cmp.provider.volmodel;

import lombok.Data;

import java.util.List;

/**
 * @ClassName: Vpcs
 * @Description: 私有网络
 * @Author lxy
 * @Date 2021/9/13 11:42
 */
@Data
public class Vpc {
    //VPC的ID。 vpc-bp1qpo0kug3a20qqe****
    private String VpcId;
    //VPC的状态。 Creating: 创建中Pending：配置中Available：可用
    private String Status;
    //VPC的名称。 vpc1
    private String VpcName;
    //创建VPC的时间。 2018-04-18T15:02:37+08:00
    private String CreationTime;
    //更新VPC的时间。 2019-04-25T01:37:38+08:00
    private String UpdateTime;
    //VPC的IPv4网段。 10.XX.XX.0/8
    private String CidrBlock;
    //VPC的描述信息。  This is my VPC.
    private String Description;
    //VPC中子网的列表。["subnet-2fe74yvngdukg5oxruwgq****","subnet-1g0f7rju1txj48ibuxxob****"]
    private List<String> SubnetIds;
    //VPC中创建的NAT网关的ID。说明：若VPC下没有创建NAT网关，将不会返回此参数。  ["ngw-3tjx9odz8q3vj0x1****"]
    private List<String> NatGatewayIds;
    //VPC关联的路由表ID。 	["vtb-bp1krxxzp0c29fmon****", "vtb-2fe74xo8rwn405oxruwkk****"]
    private List<String> RouteTableIds;
    //VPC中安全组的列表。  ["securitygroup178ftwt45bg****","securitygroup178ftwt23ak****"]
    private List<String> SecurityGroupIds;
    //DNS服务器。 	["172.XX.XX.1", "172.XX.XX.2"]
    private List<String> DnsServers;
    //VPC关联的CEN信息
    private AssociateCens AssociateCens;
    //VPC所属账号的ID。  21000*****
    private String AccountId;
    //VPC所在项目的名称。  default
    private String ProjectName;
    //VPC的附加网段。["10.XX.XX.0/16", "10.XX.XX.1/16"]
    private List<String> AuxiliaryCidrBlocks;
    //	请求ID。2021062415303301022514515207C4****
    private String RequestId;
}
