package com.bocloud.cmp.azureconvertor.common;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.model.RegionModel;
import com.bocloud.cmp.provider.convertor.BeanJsonConvertor;

import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: RegionConvertor
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/12/23 11:41
 */
public class RegionConvertor implements BeanJsonConvertor<RegionModel> {

    @Override
    public RegionModel convertModel(JSONObject object) {
        RegionModel model = new RegionModel();
        model.setName(getName(object.getString("name")) != null ? getName(object.getString("name")) : object.getString("displayName"));
        model.setCode(object.getString("name"));
        model.setRegionId(object.getString("name"));
        model.setGuid(object.getString("id"));
        return model;
    }

    private String getName(String key) {
        String regionJsonValue = "[{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/eastusstg\",\"name\":\"eastusstg\",\"displayName\":\"East US STG\",\"regionalDisplayName\":\"(US) East US STG\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"US\",\"longitude\":\"-79.8164\",\"latitude\":\"37.3719\",\"physicalLocation\":\"Virginia\",\"pairedRegion\":[{\"name\":\"southcentralusstg\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southcentralusstg\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southcentralusstg\",\"name\":\"southcentralusstg\",\"displayName\":\"South Central US STG\",\"regionalDisplayName\":\"(US) South Central US STG\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"US\",\"longitude\":\"-98.5\",\"latitude\":\"29.4167\",\"physicalLocation\":\"Texas\",\"pairedRegion\":[{\"name\":\"eastusstg\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/eastusstg\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/eastus\",\"name\":\"eastus\",\"displayName\":\"美国东部\",\"regionalDisplayName\":\"(US) 美国东部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"US\",\"longitude\":\"-79.8164\",\"latitude\":\"37.3719\",\"physicalLocation\":\"Virginia\",\"pairedRegion\":[{\"name\":\"westus\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/westus\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/eastus2\",\"name\":\"eastus2\",\"displayName\":\"美国东部2（弗吉尼亚州）\",\"regionalDisplayName\":\"(US) 美国东部 2\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"US\",\"longitude\":\"-78.3889\",\"latitude\":\"36.6681\",\"physicalLocation\":\"Virginia\",\"pairedRegion\":[{\"name\":\"centralus\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/centralus\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/westus2\",\"name\":\"westus2\",\"displayName\":\"美国西部2（华盛顿州）\",\"regionalDisplayName\":\"(US) 美国西部 2\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"US\",\"longitude\":\"-119.852\",\"latitude\":\"47.233\",\"physicalLocation\":\"Washington\",\"pairedRegion\":[{\"name\":\"westcentralus\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/westcentralus\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southcentralus\",\"name\":\"southcentralus\",\"displayName\":\"美国中南部\",\"regionalDisplayName\":\"(US) 美国中南部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"US\",\"longitude\":\"-98.5\",\"latitude\":\"29.4167\",\"physicalLocation\":\"Texas\",\"pairedRegion\":[{\"name\":\"northcentralus\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/northcentralus\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/australiaeast\",\"name\":\"australiaeast\",\"displayName\":\"澳大利亚东部\",\"regionalDisplayName\":\"(Asia Pacific) 澳大利亚东部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Asia Pacific\",\"longitude\":\"151.2094\",\"latitude\":\"-33.86\",\"physicalLocation\":\"New South Wales\",\"pairedRegion\":[{\"name\":\"australiasoutheast\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/australiasoutheast\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southeastasia\",\"name\":\"southeastasia\",\"displayName\":\"东南亚（新加坡）\",\"regionalDisplayName\":\"(Asia Pacific) 东南亚\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Asia Pacific\",\"longitude\":\"103.833\",\"latitude\":\"1.283\",\"physicalLocation\":\"Singapore\",\"pairedRegion\":[{\"name\":\"eastasia\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/eastasia\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/northeurope\",\"name\":\"northeurope\",\"displayName\":\"北欧\",\"regionalDisplayName\":\"(Europe) 北欧\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Europe\",\"longitude\":\"-6.2597\",\"latitude\":\"53.3478\",\"physicalLocation\":\"Ireland\",\"pairedRegion\":[{\"name\":\"westeurope\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/westeurope\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/westeurope\",\"name\":\"westeurope\",\"displayName\":\"西欧（荷兰）\",\"regionalDisplayName\":\"(Europe) 西欧\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Europe\",\"longitude\":\"4.9\",\"latitude\":\"52.3667\",\"physicalLocation\":\"Netherlands\",\"pairedRegion\":[{\"name\":\"northeurope\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/northeurope\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/uksouth\",\"name\":\"uksouth\",\"displayName\":\"英国南部\",\"regionalDisplayName\":\"(Europe) 英国南部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Europe\",\"longitude\":\"-0.799\",\"latitude\":\"50.941\",\"physicalLocation\":\"London\",\"pairedRegion\":[{\"name\":\"ukwest\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/ukwest\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/westus\",\"name\":\"westus\",\"displayName\":\"美国西部\",\"regionalDisplayName\":\"(US) 美国西部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"US\",\"longitude\":\"-122.417\",\"latitude\":\"37.783\",\"physicalLocation\":\"California\",\"pairedRegion\":[{\"name\":\"eastus\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/eastus\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/northcentralus\",\"name\":\"northcentralus\",\"displayName\":\"美国中北部\",\"regionalDisplayName\":\"(US) 美国中北部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"US\",\"longitude\":\"-87.6278\",\"latitude\":\"41.8819\",\"physicalLocation\":\"Illinois\",\"pairedRegion\":[{\"name\":\"southcentralus\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southcentralus\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/centralus\",\"name\":\"centralus\",\"displayName\":\"美国中部\",\"regionalDisplayName\":\"(US) 美国中部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"US\",\"longitude\":\"-93.6208\",\"latitude\":\"41.5908\",\"physicalLocation\":\"Iowa\",\"pairedRegion\":[{\"name\":\"eastus2\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/eastus2\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southafricanorth\",\"name\":\"southafricanorth\",\"displayName\":\"南非北部\",\"regionalDisplayName\":\"(Africa) 南非北部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Africa\",\"longitude\":\"28.218370\",\"latitude\":\"-25.731340\",\"physicalLocation\":\"Johannesburg\",\"pairedRegion\":[{\"name\":\"southafricawest\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southafricawest\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/eastasia\",\"name\":\"eastasia\",\"displayName\":\"东亚\",\"regionalDisplayName\":\"(Asia Pacific) 东亚\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Asia Pacific\",\"longitude\":\"114.188\",\"latitude\":\"22.267\",\"physicalLocation\":\"Hong Kong\",\"pairedRegion\":[{\"name\":\"southeastasia\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southeastasia\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/koreacentral\",\"name\":\"koreacentral\",\"displayName\":\"韩国中部（首尔）\",\"regionalDisplayName\":\"(Asia Pacific) 韩国中部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Asia Pacific\",\"longitude\":\"126.9780\",\"latitude\":\"37.5665\",\"physicalLocation\":\"Seoul\",\"pairedRegion\":[{\"name\":\"koreasouth\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/koreasouth\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/japaneast\",\"name\":\"japaneast\",\"displayName\":\"日本东部（东京）\",\"regionalDisplayName\":\"(Asia Pacific) 日本东部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Asia Pacific\",\"longitude\":\"139.77\",\"latitude\":\"35.68\",\"physicalLocation\":\"Tokyo, Saitama\",\"pairedRegion\":[{\"name\":\"japanwest\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/japanwest\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/centralindia\",\"name\":\"centralindia\",\"displayName\":\"印度中部（普纳）\",\"regionalDisplayName\":\"(Asia Pacific) 印度中部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Asia Pacific\",\"longitude\":\"73.9197\",\"latitude\":\"18.5822\",\"physicalLocation\":\"Pune\",\"pairedRegion\":[{\"name\":\"southindia\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southindia\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/canadacentral\",\"name\":\"canadacentral\",\"displayName\":\"加拿大中部\",\"regionalDisplayName\":\"(Canada) 加拿大中部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Canada\",\"longitude\":\"-79.383\",\"latitude\":\"43.653\",\"physicalLocation\":\"Toronto\",\"pairedRegion\":[{\"name\":\"canadaeast\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/canadaeast\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/germanywestcentral\",\"name\":\"germanywestcentral\",\"displayName\":\"德国中西部（法兰克福）\",\"regionalDisplayName\":\"(Europe) 德国中西部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Europe\",\"longitude\":\"8.682127\",\"latitude\":\"50.110924\",\"physicalLocation\":\"Frankfurt\",\"pairedRegion\":[{\"name\":\"germanynorth\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/germanynorth\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/francecentral\",\"name\":\"francecentral\",\"displayName\":\"法国中部\",\"regionalDisplayName\":\"(Europe) 法国中部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Europe\",\"longitude\":\"2.3730\",\"latitude\":\"46.3772\",\"physicalLocation\":\"Paris\",\"pairedRegion\":[{\"name\":\"francesouth\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/francesouth\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/norwayeast\",\"name\":\"norwayeast\",\"displayName\":\"挪威东部\",\"regionalDisplayName\":\"(Europe) 挪威东部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Europe\",\"longitude\":\"10.752245\",\"latitude\":\"59.913868\",\"physicalLocation\":\"Norway\",\"pairedRegion\":[{\"name\":\"norwaywest\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/norwaywest\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/switzerlandnorth\",\"name\":\"switzerlandnorth\",\"displayName\":\"瑞士北部\",\"regionalDisplayName\":\"(Europe) 瑞士北部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Europe\",\"longitude\":\"8.564572\",\"latitude\":\"47.451542\",\"physicalLocation\":\"Zurich\",\"pairedRegion\":[{\"name\":\"switzerlandwest\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/switzerlandwest\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/uaenorth\",\"name\":\"uaenorth\",\"displayName\":\"阿联酋北部（迪拜）\",\"regionalDisplayName\":\"(Middle East) 阿联酋北部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"Middle East\",\"longitude\":\"55.316666\",\"latitude\":\"25.266666\",\"physicalLocation\":\"Dubai\",\"pairedRegion\":[{\"name\":\"uaecentral\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/uaecentral\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/brazilsouth\",\"name\":\"brazilsouth\",\"displayName\":\"巴西南部（圣保罗）\",\"regionalDisplayName\":\"(South America) 巴西南部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Recommended\",\"geographyGroup\":\"South America\",\"longitude\":\"-46.633\",\"latitude\":\"-23.55\",\"physicalLocation\":\"Sao Paulo State\",\"pairedRegion\":[{\"name\":\"southcentralus\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southcentralus\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/eastus2stage\",\"name\":\"eastus2stage\",\"displayName\":\"美国东部 2 (阶段)\",\"regionalDisplayName\":\"(US) 美国东部 2 (阶段)\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"US\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/eastusstage\",\"name\":\"eastusstage\",\"displayName\":\"美国东部(阶段)\",\"regionalDisplayName\":\"(US) 美国东部(阶段)\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"US\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/westus2stage\",\"name\":\"westus2stage\",\"displayName\":\"美国西部 2 (阶段)\",\"regionalDisplayName\":\"(US) 美国西部 2 (阶段)\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"US\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/westusstage\",\"name\":\"westusstage\",\"displayName\":\"美国西部(阶段)\",\"regionalDisplayName\":\"(US) 美国西部(阶段)\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"US\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/northcentralusstage\",\"name\":\"northcentralusstage\",\"displayName\":\"美国中北部(阶段)\",\"regionalDisplayName\":\"(US) 美国中北部(阶段)\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"US\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/centralusstage\",\"name\":\"centralusstage\",\"displayName\":\"美国中部(阶段)\",\"regionalDisplayName\":\"(US) 美国中部(阶段)\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"US\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southcentralusstage\",\"name\":\"southcentralusstage\",\"displayName\":\"美国中南部(阶段)\",\"regionalDisplayName\":\"(US) 美国中南部(阶段)\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"US\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/australia\",\"name\":\"australia\",\"displayName\":\"澳大利亚\",\"regionalDisplayName\":\"澳大利亚\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/brazil\",\"name\":\"brazil\",\"displayName\":\"巴西\",\"regionalDisplayName\":\"巴西\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/canada\",\"name\":\"canada\",\"displayName\":\"加拿大\",\"regionalDisplayName\":\"加拿大\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/unitedstates\",\"name\":\"unitedstates\",\"displayName\":\"美国\",\"regionalDisplayName\":\"美国\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/europe\",\"name\":\"europe\",\"displayName\":\"欧洲\",\"regionalDisplayName\":\"欧洲\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/global\",\"name\":\"global\",\"displayName\":\"全球\",\"regionalDisplayName\":\"全球\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/japan\",\"name\":\"japan\",\"displayName\":\"日本\",\"regionalDisplayName\":\"日本\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/asiapacific\",\"name\":\"asiapacific\",\"displayName\":\"亚太\",\"regionalDisplayName\":\"亚太\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/asia\",\"name\":\"asia\",\"displayName\":\"亚洲\",\"regionalDisplayName\":\"亚洲\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/india\",\"name\":\"india\",\"displayName\":\"印度\",\"regionalDisplayName\":\"印度\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/uk\",\"name\":\"uk\",\"displayName\":\"英国\",\"regionalDisplayName\":\"英国\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southeastasiastage\",\"name\":\"southeastasiastage\",\"displayName\":\"东南亚(阶段)\",\"regionalDisplayName\":\"(Asia Pacific) 东南亚(阶段)\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Asia Pacific\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/eastasiastage\",\"name\":\"eastasiastage\",\"displayName\":\"东亚(阶段)\",\"regionalDisplayName\":\"(Asia Pacific) 东亚(阶段)\",\"metadata\":{\"regionType\":\"Logical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Asia Pacific\"}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/eastus2euap\",\"name\":\"eastus2euap\",\"displayName\":\"美国东部 2 EUAP\",\"regionalDisplayName\":\"(US) 美国东部 2 EUAP\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"US\",\"longitude\":\"-78.3889\",\"latitude\":\"36.6681\",\"pairedRegion\":[{\"name\":\"centraluseuap\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/centraluseuap\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/centraluseuap\",\"name\":\"centraluseuap\",\"displayName\":\"美国中部 EUAP\",\"regionalDisplayName\":\"(US) 美国中部 EUAP\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"US\",\"longitude\":\"-93.6208\",\"latitude\":\"41.5908\",\"pairedRegion\":[{\"name\":\"eastus2euap\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/eastus2euap\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/westcentralus\",\"name\":\"westcentralus\",\"displayName\":\"美国中西部\",\"regionalDisplayName\":\"(US) 美国中西部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"US\",\"longitude\":\"-110.234\",\"latitude\":\"40.890\",\"physicalLocation\":\"Wyoming\",\"pairedRegion\":[{\"name\":\"westus2\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/westus2\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southafricawest\",\"name\":\"southafricawest\",\"displayName\":\"南非西部\",\"regionalDisplayName\":\"(Africa) 南非西部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Africa\",\"longitude\":\"18.843266\",\"latitude\":\"-34.075691\",\"physicalLocation\":\"Cape Town\",\"pairedRegion\":[{\"name\":\"southafricanorth\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southafricanorth\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/australiasoutheast\",\"name\":\"australiasoutheast\",\"displayName\":\"澳大利亚东南部\",\"regionalDisplayName\":\"(Asia Pacific) 澳大利亚东南部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Asia Pacific\",\"longitude\":\"144.9631\",\"latitude\":\"-37.8136\",\"physicalLocation\":\"Victoria\",\"pairedRegion\":[{\"name\":\"australiaeast\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/australiaeast\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/australiacentral\",\"name\":\"australiacentral\",\"displayName\":\"澳大利亚中部\",\"regionalDisplayName\":\"(Asia Pacific) 澳大利亚中部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Asia Pacific\",\"longitude\":\"149.1244\",\"latitude\":\"-35.3075\",\"physicalLocation\":\"Canberra\",\"pairedRegion\":[{\"name\":\"australiacentral\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/australiacentral\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/australiacentral2\",\"name\":\"australiacentral2\",\"displayName\":\"澳大利亚中部 2\",\"regionalDisplayName\":\"(Asia Pacific) 澳大利亚中部 2\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Asia Pacific\",\"longitude\":\"149.1244\",\"latitude\":\"-35.3075\",\"physicalLocation\":\"Canberra\",\"pairedRegion\":[{\"name\":\"australiacentral2\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/australiacentral2\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/koreasouth\",\"name\":\"koreasouth\",\"displayName\":\"韩国南部\",\"regionalDisplayName\":\"(Asia Pacific) 韩国南部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Asia Pacific\",\"longitude\":\"129.0756\",\"latitude\":\"35.1796\",\"physicalLocation\":\"Busan\",\"pairedRegion\":[{\"name\":\"koreacentral\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/koreacentral\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/japanwest\",\"name\":\"japanwest\",\"displayName\":\"日本西部\",\"regionalDisplayName\":\"(Asia Pacific) 日本西部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Asia Pacific\",\"longitude\":\"135.5022\",\"latitude\":\"34.6939\",\"physicalLocation\":\"Osaka\",\"pairedRegion\":[{\"name\":\"japaneast\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/japaneast\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southindia\",\"name\":\"southindia\",\"displayName\":\"印度南部\",\"regionalDisplayName\":\"(Asia Pacific) 印度南部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Asia Pacific\",\"longitude\":\"80.1636\",\"latitude\":\"12.9822\",\"physicalLocation\":\"Chennai\",\"pairedRegion\":[{\"name\":\"centralindia\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/centralindia\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/westindia\",\"name\":\"westindia\",\"displayName\":\"印度西部\",\"regionalDisplayName\":\"(Asia Pacific) 印度西部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Asia Pacific\",\"longitude\":\"72.868\",\"latitude\":\"19.088\",\"physicalLocation\":\"Mumbai\",\"pairedRegion\":[{\"name\":\"southindia\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/southindia\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/canadaeast\",\"name\":\"canadaeast\",\"displayName\":\"加拿大东部\",\"regionalDisplayName\":\"(Canada) 加拿大东部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Canada\",\"longitude\":\"-71.217\",\"latitude\":\"46.817\",\"physicalLocation\":\"Quebec\",\"pairedRegion\":[{\"name\":\"canadacentral\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/canadacentral\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/germanynorth\",\"name\":\"germanynorth\",\"displayName\":\"德国北部\",\"regionalDisplayName\":\"(Europe) 德国北部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Europe\",\"longitude\":\"8.806422\",\"latitude\":\"53.073635\",\"physicalLocation\":\"Berlin\",\"pairedRegion\":[{\"name\":\"germanywestcentral\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/germanywestcentral\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/francesouth\",\"name\":\"francesouth\",\"displayName\":\"法国南部\",\"regionalDisplayName\":\"(Europe) 法国南部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Europe\",\"longitude\":\"2.1972\",\"latitude\":\"43.8345\",\"physicalLocation\":\"Marseille\",\"pairedRegion\":[{\"name\":\"francecentral\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/francecentral\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/norwaywest\",\"name\":\"norwaywest\",\"displayName\":\"挪威西部\",\"regionalDisplayName\":\"(Europe) 挪威西部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Europe\",\"longitude\":\"5.733107\",\"latitude\":\"58.969975\",\"physicalLocation\":\"Norway\",\"pairedRegion\":[{\"name\":\"norwayeast\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/norwayeast\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/switzerlandwest\",\"name\":\"switzerlandwest\",\"displayName\":\"瑞士西部\",\"regionalDisplayName\":\"(Europe) 瑞士西部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Europe\",\"longitude\":\"6.143158\",\"latitude\":\"46.204391\",\"physicalLocation\":\"Geneva\",\"pairedRegion\":[{\"name\":\"switzerlandnorth\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/switzerlandnorth\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/ukwest\",\"name\":\"ukwest\",\"displayName\":\"英国西部\",\"regionalDisplayName\":\"(Europe) 英国西部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Europe\",\"longitude\":\"-3.084\",\"latitude\":\"53.427\",\"physicalLocation\":\"Cardiff\",\"pairedRegion\":[{\"name\":\"uksouth\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/uksouth\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/uaecentral\",\"name\":\"uaecentral\",\"displayName\":\"阿联酋中部\",\"regionalDisplayName\":\"(Middle East) 阿联酋中部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"Middle East\",\"longitude\":\"54.366669\",\"latitude\":\"24.466667\",\"physicalLocation\":\"Abu Dhabi\",\"pairedRegion\":[{\"name\":\"uaenorth\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/uaenorth\"}]}},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/chinanorth\",\"name\":\"chinanorth\",\"displayName\":\"中国北部\",\"regionalDisplayName\":\"中国北部\"},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/chinanorth2\",\"name\":\"chinanorth2\",\"displayName\":\"中国北部2\",\"regionalDisplayName\":\"中国北部2\"},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/chinaeast\",\"name\":\"chinaeast\",\"displayName\":\"中国东部\",\"regionalDisplayName\":\"中国东部\"},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/chinaeast2\",\"name\":\"chinaeast2\",\"displayName\":\"中国东部2\",\"regionalDisplayName\":\"2中国东部2\"},{\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/brazilsoutheast\",\"name\":\"brazilsoutheast\",\"displayName\":\"巴西东南部\",\"regionalDisplayName\":\"(South America) 巴西东南部\",\"metadata\":{\"regionType\":\"Physical\",\"regionCategory\":\"Other\",\"geographyGroup\":\"South America\",\"longitude\":\"-43.2075\",\"latitude\":\"-22.90278\",\"physicalLocation\":\"Rio\",\"pairedRegion\":[{\"name\":\"brazilsouth\",\"id\":\"/subscriptions/66d2a4f8-6290-4d7d-ab07-d584fc31db3e/locations/brazilsouth\"}]}}]";
        JSONArray array = JSONArray.parseArray(regionJsonValue);
        Map<String, String> stringMap = array.stream().map(JSONObject::toJSONString).map(JSONObject::parseObject).collect(Collectors.toMap(obj -> obj.getString("name"), obj -> obj.getString("displayName")));
        return stringMap.get(key);

    }

}